import { DatePipe } from '@angular/common';
import { EventEmitter, OnChanges, SimpleChanges, ElementRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { NwbDatePickerComponent, NwbDatePickerEvent, NwbDatePickerOptions } from '@wizishop/ng-wizi-bulma';
import * as i0 from "@angular/core";
export declare class CalendarComponent implements OnChanges, ControlValueAccessor {
    private datePipe;
    minutes: ElementRef;
    hours: ElementRef;
    datePicker: NwbDatePickerComponent;
    label: string | null;
    boldLabel: boolean;
    type: 'input' | 'edit' | 'select';
    isRange: boolean;
    set options(options: Readonly<NwbDatePickerOptions>);
    get options(): Readonly<NwbDatePickerOptions>;
    _options: Readonly<NwbDatePickerOptions>;
    position: string;
    set dateSelected(dateSelected: Date);
    get dateSelected(): Date;
    _dateSelected: Date;
    set dateSelectedEnd(dateSelected: Date);
    get dateSelectedEnd(): Date;
    _dateSelectedEnd: Date;
    dateSelectedChange: EventEmitter<any>;
    typeDate: 'datetime' | 'datetime-local' | 'date';
    noMargin: boolean;
    disabled: boolean;
    changeData: EventEmitter<{
        startDate: Date;
        endDate: Date;
    }>;
    open: boolean;
    startLabel: string;
    endLabel: string;
    set calendarMinutes(calendarMinutes: string);
    get calendarMinutes(): string;
    set calendarHours(calendarHours: string);
    get calendarHours(): string;
    constructor(datePipe: DatePipe);
    ngOnChanges(changes: SimpleChanges): void;
    onChangeDate(selectedDates: NwbDatePickerEvent): void;
    private triggerDateSelectedChange;
    triggerChange(event: {
        startDate: Date;
        endDate: Date;
    }): void;
    openCalendar(value?: any): void;
    private setCalendarLabel;
    incrementMinutes($event: Event): void;
    decrementsMinutes($event: Event): void;
    incrementHours($event: Event): void;
    decrementHours($event: Event): void;
    private formatTime;
    private updateBulmaDatePickerOptions;
    private isBulmaDatePickerExists;
    onChange: (value: Date) => void;
    onTouch: () => void;
    writeValue(date: Date): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CalendarComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CalendarComponent, "wac-calendar", never, { "label": "label"; "boldLabel": "boldLabel"; "type": "type"; "isRange": "isRange"; "options": "options"; "position": "position"; "dateSelected": "dateSelected"; "dateSelectedEnd": "dateSelectedEnd"; "typeDate": "typeDate"; "noMargin": "noMargin"; "disabled": "disabled"; }, { "dateSelectedChange": "dateSelectedChange"; "changeData": "changeData"; }, never, never, false, never>;
}
