import { AfterViewChecked, ElementRef, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class WzEditInPlaceComponent implements ControlValueAccessor, AfterViewChecked, OnChanges {
    type: string;
    nwbOptions: object | string[];
    config: NwbEditInPlaceConfig;
    label: string;
    customChange: EventEmitter<any>;
    input: ElementRef;
    objectKeys: {
        (o: object): string[];
        (o: {}): string[];
    };
    currentValue: string | number;
    private preValue;
    inputWidth: number;
    editing: boolean;
    isLoading: boolean;
    private firstEdit;
    private initialized;
    onChange: any;
    onTouched: any;
    get value(): any;
    set value(v: any);
    writeValue(value: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    private _setValue;
    ngAfterViewChecked(): void;
    startEditing(): void;
    edit(): void;
    onSubmit(): void;
    checkAndRemoveCurrency(value: any): any;
    parseValueToNumber(value: any): number;
    parseValueToSeparator(value: any): any;
    ngOnChanges(changes: SimpleChanges): void;
    selectOption(event: any): void;
    closeSelect(event: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<WzEditInPlaceComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<WzEditInPlaceComponent, "wac-edit-in-place", never, { "type": "type"; "nwbOptions": "nwbOptions"; "config": "config"; "label": "label"; }, { "customChange": "customChange"; }, never, never, false, never>;
}
export interface NwbEditInPlaceConfig {
    /** Whether to select the whole text inside the input upon click */
    selectTextUponClick?: boolean;
    /** Data to pass as the second argument for the handler method if any **/
    data?: any;
    currency?: string;
    separator?: string;
    /**
     * handler method to call on change.
     * This allows you to perform any action before setting new value to the model
     * It has to return a boolean observable. If the returned value is true then the model will change.
     */
    handler?: (value: any, data: any) => Observable<boolean | ReturnedData>;
}
export interface ReturnedData {
    success: boolean;
    value: any;
}
