import { EventEmitter, OnChanges, SimpleChanges, TemplateRef } from '@angular/core';
import * as i0 from "@angular/core";
export type ImageSource = string;
export type ImageAlt = string;
export type MosaicImage = {
    src: ImageSource;
    alt: ImageAlt;
};
export type MosaicImages = Readonly<MosaicImage[]>;
export declare class MosaicComponent implements OnChanges {
    imagesList: MosaicImages;
    isLoading: boolean;
    numberOfColumn: number;
    hoverImageTemplate: TemplateRef<any>;
    importImageSrc: EventEmitter<string>;
    loadMoreImages: EventEmitter<void>;
    columns: MosaicImages[];
    trackColumn(index: number): number;
    trackImage(index: number, image: MosaicImage): string;
    ngOnChanges(changes: SimpleChanges): void;
    generateColumns(previousList: MosaicImages, currentList: MosaicImages, isNumberOfColumnChange: boolean): void;
    separateImagesIntoColumns(newImagesToDisplay: MosaicImages): MosaicImage[][];
    concatColumns(oldColumns: MosaicImages[], newColumns: MosaicImages[]): MosaicImage[][];
    onBottomReached(): void;
    onImportImage(src: ImageSource): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MosaicComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MosaicComponent, "wac-mosaic", never, { "imagesList": "imagesList"; "isLoading": "isLoading"; "numberOfColumn": "numberOfColumn"; "hoverImageTemplate": "hoverImageTemplate"; }, { "importImageSrc": "importImageSrc"; "loadMoreImages": "loadMoreImages"; }, never, never, false, never>;
}
