import { ChangeDetectorRef, ElementRef, EventEmitter } from '@angular/core';
import { OptionSelectionHandler } from './option-selection-handler.interface';
import * as i0 from "@angular/core";
export declare class SelectOptionDirective<TOptionValue> implements OptionSelectionHandler<TOptionValue> {
    protected contentRef: ElementRef;
    protected changeDetectorRef: ChangeDetectorRef;
    onClick(event: PointerEvent): void;
    get isOptionSelected(): boolean;
    get isOptionDisabled(): boolean;
    get cursor(): "not-allowed" | "pointer";
    disabled: boolean;
    protected disabledByParent: boolean;
    value: TOptionValue;
    selected: boolean;
    onClickEventPreventDefault: boolean;
    selectedChange: EventEmitter<boolean>;
    multiple: boolean;
    constructor(contentRef: ElementRef, changeDetectorRef: ChangeDetectorRef);
    setSelected(selected: boolean): void;
    onSelectOption(): void;
    getValue(): TOptionValue;
    setValue(value: TOptionValue): void;
    isSelected(): boolean;
    getContentRef(): ElementRef<any>;
    setDisabledState(isDisabled: boolean): void;
    setMultiple(multiple: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectOptionDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SelectOptionDirective<any>, "[wacOption]", ["wacOption"], { "disabled": "disabled"; "value": "value"; "selected": "selected"; "onClickEventPreventDefault": "onClickEventPreventDefault"; }, { "selectedChange": "selectedChange"; }, never, never, true, never>;
}
