import { ElementRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { ValueChangeService } from './value-change.service';
import { Subject } from 'rxjs';
import { SelectSearchTriggerComponent } from '../select-search-trigger/select-search-trigger.component';
import { LabelComponent } from '../../common/label/label.component';
import { SelectDirective } from './select.directive';
import * as i0 from "@angular/core";
export declare class SelectComponent<TOptionValue> extends SelectDirective<TOptionValue> implements OnInit, OnDestroy {
    protected valueChangeService: ValueChangeService<TOptionValue>;
    role: string;
    customSearchTrigger: SelectSearchTriggerComponent;
    label: LabelComponent;
    selectHeader: ElementRef;
    /** Whether the component is required. */
    get required(): boolean;
    set required(value: boolean);
    private _required;
    get selectedOptionContent(): any;
    small: boolean;
    set keepPanelOpen(keepPanelOpen: boolean);
    get keepPanelOpen(): boolean;
    private _keepPanelOpen;
    set openPanel(openPanel: boolean);
    get openPanel(): boolean;
    _openPanel: boolean;
    openPanelChange: EventEmitter<boolean>;
    tabIndex: number;
    _searchByTyping: boolean;
    isDestroyed$: Subject<void>;
    private isKeyBoardAction;
    constructor(valueChangeService: ValueChangeService<TOptionValue>);
    ngOnInit(): void;
    private closeTabOnValueChange;
    private skipIfTriggeredByKeyboardAction;
    onTogglePanel(): void;
    onClosePanel(): void;
    onKeydown(event: KeyboardEvent): void;
    handleKeyboardActionWithSearch(event: KeyboardEvent): boolean;
    /** Handles keyboard events while the select is closed. */
    private _handleClosedKeydown;
    /** Handles keyboard events when the selected is open. */
    private _handleOpenKeydown;
    onSelectTouch: (value: any) => void;
    registerOnTouched(fn: any): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SelectComponent<any>, "wac-select", never, { "required": "required"; "small": "small"; "keepPanelOpen": "keepPanelOpen"; "openPanel": "openPanel"; }, { "openPanelChange": "openPanelChange"; }, ["customSearchTrigger", "label"], ["wac-label, .wac-label", "wac-select-search-trigger", "wac-placeholder,[role=placeholder]", "wac-option-group, wac-option-call-to-action, wac-option, option, .option, [selectOption]"], false, never>;
}
