import { AfterViewInit, EventEmitter, OnDestroy, OnInit, QueryList } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Subject } from 'rxjs';
import { OptionSelectionHandler } from '../option/option-selection-handler.interface';
import { ValueChangeService } from './value-change.service';
import * as i0 from "@angular/core";
export declare class SelectDirective<TOptionValue> implements OnInit, ControlValueAccessor, AfterViewInit, OnDestroy {
    protected valueChangeService: ValueChangeService<TOptionValue>;
    get tabindex(): number;
    get isSelectDisabled(): boolean;
    /** Handles all keydown events on the select. */
    onKeydown(event: KeyboardEvent): void;
    optionChildren: QueryList<OptionSelectionHandler<TOptionValue>>;
    set value(value: TOptionValue | TOptionValue[]);
    get value(): TOptionValue | TOptionValue[];
    _value: TOptionValue | TOptionValue[];
    valueChange: EventEmitter<any>;
    get multiple(): boolean;
    set multiple(value: boolean);
    private _multiple;
    set disabled(disabled: boolean);
    get disabled(): boolean;
    _disabled: boolean;
    tabIndex: number;
    get searchByTyping(): boolean;
    set searchByTyping(value: boolean);
    _searchByTyping: boolean;
    isDestroyed$: Subject<void>;
    constructor(valueChangeService: ValueChangeService<TOptionValue>);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private handleValueChange;
    private handleOptionChildren;
    /** Handles keyboard events when the selected is open. */
    protected handleKeyboardAction(event: KeyboardEvent): void;
    onChange: (value: any) => void;
    onTouch: (value: any) => void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SelectDirective<any>, "[wacSelect]", ["wacSelect"], { "value": "value"; "multiple": "multiple"; "disabled": "disabled"; "tabIndex": "tabIndex"; "searchByTyping": "searchByTyping"; }, { "valueChange": "valueChange"; }, ["optionChildren"], never, true, never>;
}
