import { ChangeDetectorRef, OnDestroy, QueryList } from '@angular/core';
import { Subject } from 'rxjs';
import { OptionComponent } from '../option/option.component';
import * as i0 from "@angular/core";
export declare class ValueChangeService<TOptionValue> implements OnDestroy {
    private changeDetectorRef;
    valueChange$: Subject<TOptionValue | TOptionValue[]>;
    set value(value: TOptionValue | TOptionValue[]);
    get value(): TOptionValue | TOptionValue[];
    multiple: boolean;
    private _value;
    disabled: boolean;
    optionChildren: QueryList<OptionComponent<TOptionValue>>;
    selectedOptionContent: any;
    indexSelectedOption: number;
    resetListeners$: Subject<void>;
    constructor(changeDetectorRef: ChangeDetectorRef);
    handleSelectOptionsChange(optionChildren: QueryList<OptionComponent<TOptionValue>>, value: any): void;
    assignValue(value: TOptionValue | TOptionValue[]): void;
    handleValueChange(): void;
    setDisabledState(isDisabled: boolean): void;
    selectNextOption(): void;
    selectPreviousOption(): void;
    searchOptionByFirstLetter(letter: string): void;
    setMultiple(value: boolean): void;
    private indexOfMatchedOption;
    private isNotNull;
    private highestAndClosestIndex;
    private handleMultipleSelection;
    private handleInitialSelectedOption;
    private mustUpdateValueWithInitialSelectedOptionValues;
    private handleSelectedOptionsEvent;
    private updateSelectPlaceholder;
    private getSelectedOptionsContent;
    private getSelectedOptionComponents;
    private getSelectedOptionsValues;
    private optionSelectedChangeListeners;
    private changeSelectedOption;
    /**
      * May not work with objects values
    */
    private isSelectedValue;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ValueChangeService<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ValueChangeService<any>>;
}
