import { EventEmitter, OnInit, QueryList } from '@angular/core';
import { FiltersTableService } from './shared/filters-table.service';
import { TableFilters } from './shared/table-filters.model';
import { CheckBoxRow } from './directives/checkBoxRow.directive';
import { MultiSelectionService } from '../../services/multiple-selection.service';
import { TableCheckboxIdService } from './shared/table-checkbox-id.service';
import { TableRow } from './directives/raw.directive';
import * as i0 from "@angular/core";
export declare class TableComponent implements OnInit {
    private filtersTableService;
    private tableCheckboxIdService;
    private multiSelectionService;
    checkBoxRows: QueryList<CheckBoxRow>;
    tableRows: QueryList<TableRow>;
    tableFilters: TableFilters;
    tableFiltersChange: EventEmitter<TableFilters>;
    tableRoutingName: string;
    placeholder: string;
    private _tableFiltersGroup;
    /** Pass to true to display checkbox in the header table */
    checkbox: boolean;
    toggleAllCheckBox: EventEmitter<boolean>;
    checkBoxSelectionChange: EventEmitter<number[]>;
    /** Pass to true to hide search input */
    disableSearch: boolean;
    /** Pass to true to hide the pagniator */
    disablePagniation: boolean;
    isLoading: boolean;
    headerCheckBoxId: string;
    private filterGroupChangeSub;
    constructor(filtersTableService: FiltersTableService, tableCheckboxIdService: TableCheckboxIdService, multiSelectionService: MultiSelectionService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    onToggleAllCheckBox(event: any): void;
    searchChange(): void;
    pageChange(): void;
    /**
     *  Set tableFilters from routing data existing in the url
     * */
    private setTablesFilters;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TableComponent, "wac-table", never, { "tableFilters": "tableFilters"; "tableRoutingName": "tableRoutingName"; "placeholder": "placeholder"; "checkbox": "checkbox"; "disableSearch": "disableSearch"; "disablePagniation": "disablePagniation"; "isLoading": "isLoading"; }, { "tableFiltersChange": "tableFiltersChange"; "toggleAllCheckBox": "toggleAllCheckBox"; "checkBoxSelectionChange": "checkBoxSelectionChange"; }, ["checkBoxRows", "tableRows"], ["[headerCell]", ".complex-table", "[tableRow]"], false, never>;
}
