import { PipeTransform } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * Typed mapping function.
 */
export type Mapper<T, G> = (item: T, ...args: any[]) => G;
export declare class CallComponentFunctionPipe implements PipeTransform {
    /**
     * Maps object to an arbitrary result through a plan-name function
     *
     * @param value an item to transform
     * @param mapper a mapping function
     * @param args arbitrary number of additional arguments
     */
    transform<T, G>(value: T, mapper: Mapper<T, G>, ...args: any[]): G;
    static ɵfac: i0.ɵɵFactoryDeclaration<CallComponentFunctionPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<CallComponentFunctionPipe, "wacFn", true>;
}
