import * as i3 from '@wizishop/ng-wizi-bulma';
import { NwbAllModule, NwbFilterGroup } from '@wizishop/ng-wizi-bulma';
import * as i0 from '@angular/core';
import { Component, ViewEncapsulation, Input, EventEmitter, Directive, Output, HostListener, Injectable, InjectionToken, HostBinding, ContentChildren, NgModule, Inject, Pipe, TemplateRef, ChangeDetectionStrategy, ContentChild, ViewChild, forwardRef, Attribute, Optional } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule, DOCUMENT, DatePipe } from '@angular/common';
import * as i2 from '@angular/forms';
import { NG_VALUE_ACCESSOR, FormsModule, FormGroupDirective, ReactiveFormsModule } from '@angular/forms';
import * as i4 from 'ngx-perfect-scrollbar';
import { PerfectScrollbarModule } from 'ngx-perfect-scrollbar';
import { Subject, merge, takeUntil as takeUntil$1, startWith, fromEvent, ReplaySubject, BehaviorSubject, combineLatest, switchMap, distinctUntilChanged as distinctUntilChanged$1, delay, map as map$1, interval, tap as tap$1 } from 'rxjs';
import { takeUntil, debounceTime, distinctUntilChanged, tap, filter, map, takeWhile } from 'rxjs/operators';
import * as i1$1 from '@angular/cdk/overlay';
import { TAB, DOWN_ARROW, UP_ARROW, LEFT_ARROW, RIGHT_ARROW, A, Z, ZERO, NINE, ENTER, hasModifierKey, ESCAPE } from '@angular/cdk/keycodes';
import * as i1$2 from '@ngx-translate/core';
import { TranslateModule } from '@ngx-translate/core';
import { CdkTableModule } from '@angular/cdk/table';
import { trigger, transition, style, animate, state, animation, query, stagger } from '@angular/animations';
import { TagInputModule } from 'ngx-chips';
import { TemplatePortal, CdkPortalOutlet } from '@angular/cdk/portal';
import * as i3$1 from 'ngx-autosize';
import { AutosizeModule } from 'ngx-autosize';
import * as i1$3 from '@angular/router';
import { NavigationStart, RouterModule } from '@angular/router';
import * as i2$1 from 'ngx-scrollbar';
import { NgScrollbarModule } from 'ngx-scrollbar';
import * as i3$2 from 'ngx-scrollbar/reached-event';
import { NgScrollbarReachedModule } from 'ngx-scrollbar/reached-event';
import * as i2$2 from '@angular/cdk/drag-drop';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import * as i3$3 from 'ngx-color-picker';
import { ColorPickerModule } from 'ngx-color-picker';

class LoaderComponent {
    constructor() {
        this.text = '';
        this.small = false;
    }
}
LoaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: LoaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
LoaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: LoaderComponent, isStandalone: true, selector: "wac-loader", inputs: { text: "text", small: "small" }, ngImport: i0, template: "<div class=\"wac-loader\" [ngClass]=\"{ 'is-small': small }\">\r\n  <div class=\"loader loader1\">\r\n    <div>\r\n      <div>\r\n        <div>\r\n          <div>\r\n            <div>\r\n              <div></div>\r\n            </div>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <p class=\"is-textcentered\" *ngIf=\"!!text\" [innerHTML]=\"text\"></p>\r\n</div>\r\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: LoaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-loader', encapsulation: ViewEncapsulation.None, standalone: true, imports: [CommonModule], template: "<div class=\"wac-loader\" [ngClass]=\"{ 'is-small': small }\">\r\n  <div class=\"loader loader1\">\r\n    <div>\r\n      <div>\r\n        <div>\r\n          <div>\r\n            <div>\r\n              <div></div>\r\n            </div>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <p class=\"is-textcentered\" *ngIf=\"!!text\" [innerHTML]=\"text\"></p>\r\n</div>\r\n" }]
        }], propDecorators: { text: [{
                type: Input
            }], small: [{
                type: Input
            }] } });

class AbstractDebounceDirective {
    constructor() {
        this.debounceTime = 500;
        this.onEventChange = new EventEmitter();
        this.emitEvent$ = new Subject();
        this.subscription$ = new Subject();
    }
    ngOnInit() {
        this.emitEvent$
            .pipe(takeUntil(this.subscription$), debounceTime(this.debounceTime), distinctUntilChanged(), tap(value => this.emitChange(value)))
            .subscribe();
    }
    emitChange(value) {
        this.onEventChange.emit(value);
    }
    ngOnDestroy() {
        this.subscription$.next();
        this.subscription$.complete();
    }
}
AbstractDebounceDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AbstractDebounceDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
AbstractDebounceDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: AbstractDebounceDirective, selector: "AbstractDebounceDirective", inputs: { debounceTime: "debounceTime" }, outputs: { onEventChange: "onEventChange" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AbstractDebounceDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'AbstractDebounceDirective'
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { debounceTime: [{
                type: Input
            }], onEventChange: [{
                type: Output
            }] } });

class DebounceKeyupDirective extends AbstractDebounceDirective {
    constructor() {
        super();
    }
    onKeyUp(event) {
        event.preventDefault();
        this.emitEvent$.next(event);
    }
}
DebounceKeyupDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DebounceKeyupDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
DebounceKeyupDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: DebounceKeyupDirective, selector: "input[debounceKeyUp]", host: { listeners: { "keyup": "onKeyUp($event)" } }, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DebounceKeyupDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[debounceKeyUp]'
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { onKeyUp: [{
                type: HostListener,
                args: ['keyup', ['$event']]
            }] } });

class DomService {
    constructor(componentFactoryResolver, appRef, injector, overlayContainer) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.appRef = appRef;
        this.injector = injector;
        this.overlayContainer = overlayContainer;
        this.documentEventSource = new Subject();
        this.documentEventDone = this.documentEventSource.asObservable();
        this.eventInitialisation = true;
        this.documentScrollSource = new Subject();
        this.documentScrollDone = this.documentScrollSource.asObservable();
    }
    documentEvent() {
        this.setDocumentEventListener();
        return this.documentEventDone;
    }
    setDocumentEventListener() {
        if (!this.eventInitialisation) {
            return;
        }
        this.eventInitialisation = false;
        document.body.addEventListener('click', event => {
            this.documentEventSource.next(event.target);
        });
    }
    documentScroll() {
        return this.documentScrollDone;
    }
    setScrollEventListener() {
        window.onscroll = () => {
            this.documentScrollSource.next(window);
        };
    }
    attachComponentPortal(component, injector) {
        const componentRef = this.componentFactoryResolver
            .resolveComponentFactory(component)
            .create(injector ? injector : this.injector);
        this.appRef.attachView(componentRef.hostView);
        this.overlayContainer.getContainerElement().appendChild(this._getComponentRootNode(componentRef));
        return componentRef;
    }
    /** Gets the root HTMLElement for an instantiated component. */
    _getComponentRootNode(componentRef) {
        return componentRef.hostView.rootNodes[0];
    }
}
DomService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DomService, deps: [{ token: i0.ComponentFactoryResolver }, { token: i0.ApplicationRef }, { token: i0.Injector }, { token: i1$1.OverlayContainer }], target: i0.ɵɵFactoryTarget.Injectable });
DomService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DomService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DomService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i0.ComponentFactoryResolver }, { type: i0.ApplicationRef }, { type: i0.Injector }, { type: i1$1.OverlayContainer }]; } });

class AutoHideDirective {
    constructor(_elementRef, domService) {
        this._elementRef = _elementRef;
        this.domService = domService;
        this.forceOn = null;
        this.clickOutside = new EventEmitter();
    }
    ngAfterViewInit() {
        this.subscription = this.domService.documentEvent().subscribe((targetElement) => {
            const clickedInside = this._elementRef.nativeElement.contains(targetElement);
            const classNameFromElement = targetElement.getAttribute('class');
            if (!clickedInside && (classNameFromElement === null || !classNameFromElement.includes(this.triggerElement))) {
                this.clickOutside.emit(null);
            }
            if (this.forceOn != null && classNameFromElement !== null) {
                let needToClose = true;
                this.forceOn.forEach(v => {
                    if (!classNameFromElement.includes(v)) {
                        needToClose = false;
                    }
                });
                if (needToClose) {
                    this.clickOutside.emit(null);
                }
            }
        });
    }
    ngOnDestroy() {
        this.subscription.unsubscribe();
    }
}
AutoHideDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AutoHideDirective, deps: [{ token: i0.ElementRef }, { token: DomService }], target: i0.ɵɵFactoryTarget.Directive });
AutoHideDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: { triggerElement: "triggerElement", forceOn: "forceOn" }, outputs: { clickOutside: "clickOutside" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AutoHideDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wzAutoHide]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: DomService }]; }, propDecorators: { triggerElement: [{
                type: Input
            }], forceOn: [{
                type: Input
            }], clickOutside: [{
                type: Output,
                args: ['clickOutside']
            }] } });

class ZindexToggleDirective {
    set isActive(value) {
        this.isActived = value;
        this.switchToggle();
    }
    get isActive() {
        return this.isActived;
    }
    constructor(currentElement, renderer) {
        this.currentElement = currentElement;
        this.renderer = renderer;
        this.isActived = false;
    }
    ngOnInit() {
    }
    switchToggle() {
        if (this.isActived) {
            this.renderer.addClass(this.currentElement.nativeElement.parentElement.parentNode, 'zindexToggle');
            this.renderer.addClass(this.currentElement.nativeElement.parentElement.parentNode.parentNode, 'zindexToggle');
        }
        else {
            this.renderer.removeClass(this.currentElement.nativeElement.parentElement.parentNode, 'zindexToggle');
            this.renderer.removeClass(this.currentElement.nativeElement.parentElement.parentNode.parentNode, 'zindexToggle');
        }
    }
    ngOnDestroy() {
    }
}
ZindexToggleDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ZindexToggleDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
ZindexToggleDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: ZindexToggleDirective, selector: "[zIndexToggle]", inputs: { isActive: ["zIndexToggle", "isActive"] }, outputs: { onEventChange: "onEventChange" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ZindexToggleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[zIndexToggle]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { onEventChange: [{
                type: Output
            }], isActive: [{
                type: Input,
                args: ['zIndexToggle']
            }] } });

class VarDirective {
    // https://stackoverflow.com/questions/38582293/how-to-declare-a-variable-in-a-template-in-angular
    set ngVar(context) {
        this.context.$implicit = this.context.ngVar = context;
        if (!this.hasView) {
            this.vcRef.createEmbeddedView(this.templateRef, this.context);
            this.hasView = true;
        }
    }
    constructor(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
        this.context = {
            $implicit: null,
            ngVar: null,
        };
        this.hasView = false;
    }
}
VarDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: VarDirective, deps: [{ token: i0.TemplateRef }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Directive });
VarDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: VarDirective, selector: "[ngVar]", inputs: { ngVar: "ngVar" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: VarDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngVar]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }, { type: i0.ViewContainerRef }]; }, propDecorators: { ngVar: [{
                type: Input
            }] } });

class KeypressEnterDirective {
    onKeypress(event) {
        if (event.key === this.KEYPRESS_ENTER) {
            this.keypressEnter.next(true);
        }
    }
    constructor() {
        this.KEYPRESS_ENTER = "Enter";
        this.keypressEnter = new EventEmitter();
    }
}
KeypressEnterDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: KeypressEnterDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
KeypressEnterDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: KeypressEnterDirective, selector: "[keypressEnter]", outputs: { keypressEnter: "keypressEnter" }, host: { listeners: { "keypress": "onKeypress($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: KeypressEnterDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[keypressEnter]' }]
        }], ctorParameters: function () { return []; }, propDecorators: { onKeypress: [{
                type: HostListener,
                args: ['keypress', ['$event']]
            }], keypressEnter: [{
                type: Output
            }] } });

const OPTION_SELECTION_HANDLER = new InjectionToken('OPTION_SELECTION_HANDLER');

// todo create a select module and in the select-option.directive.ts
class SelectOptionDirective {
    onClick(event) {
        this.onSelectOption();
        if (this.onClickEventPreventDefault) {
            event.preventDefault();
        }
    }
    get isOptionSelected() {
        return this.selected;
    }
    get isOptionDisabled() {
        return this.disabled || this.disabledByParent;
    }
    get cursor() {
        return this.disabled || this.disabledByParent ? 'not-allowed' : 'pointer';
    }
    constructor(contentRef, changeDetectorRef) {
        this.contentRef = contentRef;
        this.changeDetectorRef = changeDetectorRef;
        this.disabled = false;
        this.disabledByParent = false;
        this.selected = false;
        this.onClickEventPreventDefault = true;
        this.selectedChange = new EventEmitter();
        this.multiple = false;
    }
    setSelected(selected) {
        this.selected = selected;
        this.changeDetectorRef.markForCheck();
    }
    onSelectOption() {
        if (this.disabled || this.disabledByParent) {
            return;
        }
        this.selected = this.multiple ? !this.selected : true; // If not multiple mode -> can not be unselected
        this.selectedChange.emit(this.selected);
        this.changeDetectorRef.markForCheck();
    }
    getValue() {
        return this.value;
    }
    setValue(value) {
        this.value = value;
        this.changeDetectorRef.markForCheck();
    }
    isSelected() {
        return this.selected;
    }
    getContentRef() {
        return this.contentRef;
    }
    setDisabledState(isDisabled) {
        this.disabledByParent = isDisabled;
        this.changeDetectorRef.markForCheck();
    }
    setMultiple(multiple) {
        this.multiple = multiple;
        this.changeDetectorRef.markForCheck();
    }
}
SelectOptionDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectOptionDirective, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive });
SelectOptionDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: SelectOptionDirective, isStandalone: true, selector: "[wacOption]", inputs: { disabled: "disabled", value: "value", selected: "selected", onClickEventPreventDefault: "onClickEventPreventDefault" }, outputs: { selectedChange: "selectedChange" }, host: { listeners: { "click": "onClick($event)" }, properties: { "class.wac-option-selected": "this.isOptionSelected", "class.wac-option-disabled": "this.isOptionDisabled", "style.cursor": "this.cursor" } }, providers: [{ provide: OPTION_SELECTION_HANDLER, useExisting: SelectOptionDirective }], exportAs: ["wacOption"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectOptionDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacOption]',
                    providers: [{ provide: OPTION_SELECTION_HANDLER, useExisting: SelectOptionDirective }],
                    exportAs: 'wacOption',
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { onClick: [{
                type: HostListener,
                args: ['click', ['$event']]
            }], isOptionSelected: [{
                type: HostBinding,
                args: ['class.wac-option-selected']
            }], isOptionDisabled: [{
                type: HostBinding,
                args: ['class.wac-option-disabled']
            }], cursor: [{
                type: HostBinding,
                args: ['style.cursor']
            }], disabled: [{
                type: Input
            }], value: [{
                type: Input
            }], selected: [{
                type: Input
            }], onClickEventPreventDefault: [{
                type: Input
            }], selectedChange: [{
                type: Output
            }] } });

const compareArrays = (a, b) => a.length === b.length && a.every((element, index) => element === b[index]);

class ValueChangeService {
    set value(value) {
        this._value = value;
        this.handleValueChange();
        this.valueChange$.next(value);
    }
    get value() {
        return this._value;
    }
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.valueChange$ = new Subject();
        this.multiple = false;
        this.indexSelectedOption = null; // todo update to array
        this.resetListeners$ = new Subject();
        this.indexOfMatchedOption = (option, index, letter) => {
            const textOption = option.getContentRef().nativeElement.textContent.trim().toLowerCase();
            return textOption.startsWith(letter) ? index : null;
        };
        this.isNotNull = (index) => {
            return index !== null;
        };
        this.highestAndClosestIndex = (index) => {
            if (isNaN(this.indexSelectedOption)) {
                return true;
            }
            if (index > this.indexSelectedOption) {
                return true;
            }
            return false;
        };
    }
    handleSelectOptionsChange(optionChildren, value) {
        this.resetListeners$.next();
        this.optionChildren = optionChildren;
        this._value = value;
        this.indexSelectedOption = null;
        this.handleMultipleSelection();
        this.handleInitialSelectedOption();
        this.handleSelectedOptionsEvent();
    }
    assignValue(value) {
        this._value = value;
        this.handleValueChange();
    }
    handleValueChange() {
        this.changeSelectedOption();
        this.updateSelectPlaceholder();
        this.changeDetectorRef.markForCheck();
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
        this.optionChildren?.forEach((option) => option.setDisabledState(isDisabled));
    }
    selectNextOption() {
        // TODO : Handle multiple selection
        if (this.indexSelectedOption + 1 >= this.optionChildren.length) {
            return;
        }
        if (this.indexSelectedOption === null) {
            this.indexSelectedOption = 0;
        }
        else {
            this.indexSelectedOption = this.indexSelectedOption + 1;
        }
        this.value = this.optionChildren.get(this.indexSelectedOption).value;
    }
    selectPreviousOption() {
        // TODO : Handle multiple selection
        if (!this.indexSelectedOption) {
            this.indexSelectedOption = null;
            this.assignValue(null);
            return;
        }
        this.indexSelectedOption = this.indexSelectedOption - 1;
        this.value = this.optionChildren.get(this.indexSelectedOption).value;
    }
    searchOptionByFirstLetter(letter) {
        // TODO : Handle multiple selectiong
        const matchedOptionsIndex = this.optionChildren
            .map((option, index) => this.indexOfMatchedOption(option, index, letter))
            .filter(this.isNotNull);
        if (!matchedOptionsIndex.length) { // reset the selection
            this.indexSelectedOption = null;
            this.value = null;
            return;
        }
        // find the next option after the current selected option, or the first option
        const validOptionIndex = matchedOptionsIndex.find(this.highestAndClosestIndex);
        this.indexSelectedOption = isNaN(validOptionIndex) ? matchedOptionsIndex[0] : validOptionIndex;
        this.value = this.optionChildren.get(this.indexSelectedOption).value;
    }
    setMultiple(value) {
        this.multiple = value;
    }
    handleMultipleSelection() {
        if (this.multiple) {
            setTimeout(() => {
                this.optionChildren.forEach((option) => option.setMultiple(true));
            }, 0);
        }
    }
    handleInitialSelectedOption() {
        setTimeout(() => {
            if (this.mustUpdateValueWithInitialSelectedOptionValues()) { // initial option value selected win against initial value or ngModel value
                this.value = this.multiple ? this.getSelectedOptionsValues() : this.getSelectedOptionsValues()[0];
            }
            if (this.disabled) {
                this.optionChildren.forEach((option) => option.setDisabledState(true));
            }
            this.handleValueChange();
        }, 0);
    }
    mustUpdateValueWithInitialSelectedOptionValues() {
        if (!this.getSelectedOptionComponents().length) {
            return false;
        }
        if (this.multiple && Array.isArray(this.value)) {
            return !compareArrays(this.value, this.getSelectedOptionsValues());
        }
        return this.value !== this.getSelectedOptionsValues()[0];
    }
    handleSelectedOptionsEvent() {
        this.optionSelectedChangeListeners().subscribe((option) => {
            const selectedOptionsValues = this.getSelectedOptionsValues();
            if (this.multiple) {
                this.value = selectedOptionsValues;
                return;
            }
            this.value = option.selected ? option.value : undefined;
        });
    }
    updateSelectPlaceholder() {
        if (!this.value && typeof this.value !== 'number') {
            this.selectedOptionContent = null;
            return;
        }
        this.selectedOptionContent = this.getSelectedOptionsContent();
    }
    getSelectedOptionsContent() {
        if (this.multiple) {
            return this.getSelectedOptionComponents().reduce((acc, option) => (acc ? acc + ', ' : '') + option.getContentRef().nativeElement.textContent.trim(), ''); // todo improve for multiple
        }
        return this.getSelectedOptionComponents()[0]?.getContentRef().nativeElement.innerHTML;
    }
    getSelectedOptionComponents() {
        return this.optionChildren.filter((option) => option.selected);
    }
    getSelectedOptionsValues() {
        return this.getSelectedOptionComponents().map((option) => option.value);
    }
    optionSelectedChangeListeners() {
        const selectedChange$ = this.optionChildren.map((option) => {
            return option.selectedChange.pipe(filter(() => !this.disabled), map(() => option));
        });
        return merge(...selectedChange$).pipe(takeUntil(this.resetListeners$));
    }
    changeSelectedOption() {
        this.optionChildren.forEach((optionComponent, index) => {
            optionComponent.setSelected(this.isSelectedValue(optionComponent.value));
            if (optionComponent.selected) {
                this.indexSelectedOption = index;
            }
        });
    }
    /**
      * May not work with objects values
    */
    isSelectedValue(value2) {
        if (this.multiple && Array.isArray(this.value)) {
            return this.value.includes(value2);
        }
        return this.value === value2;
    }
    ngOnDestroy() {
        this.resetListeners$.next();
        this.resetListeners$.complete();
    }
}
ValueChangeService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ValueChangeService, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Injectable });
ValueChangeService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ValueChangeService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ValueChangeService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; } });

class SelectDirective {
    get tabindex() {
        return this.tabIndex;
    }
    get isSelectDisabled() {
        return this.disabled;
    }
    /** Handles all keydown events on the select. */
    onKeydown(event) {
        if (event.keyCode === TAB) {
            return;
        }
        if (this.disabled) {
            return;
        }
        this.handleKeyboardAction(event);
    }
    set value(value) {
        this._value = value;
        if (!this.optionChildren) {
            return;
        }
        this.valueChangeService.assignValue(value);
    }
    get value() {
        return this._value;
    }
    get multiple() {
        return this._multiple;
    }
    set multiple(value) {
        this._multiple = value;
        this.valueChangeService.setMultiple(value);
    }
    set disabled(disabled) {
        this._disabled = disabled;
        this.valueChangeService.setDisabledState(disabled);
    }
    get disabled() {
        return this._disabled;
    }
    get searchByTyping() {
        return this._searchByTyping;
    }
    set searchByTyping(value) {
        this._searchByTyping = value;
    }
    constructor(valueChangeService) {
        this.valueChangeService = valueChangeService;
        this.valueChange = new EventEmitter();
        this._multiple = false;
        this._disabled = false;
        this.tabIndex = 0;
        this._searchByTyping = false;
        this.isDestroyed$ = new Subject();
        // ControlValueAccessor methods
        this.onChange = () => { };
        this.onTouch = () => { };
    }
    ngOnInit() {
        this.handleValueChange();
    }
    ngAfterViewInit() {
        this.handleOptionChildren();
    }
    handleValueChange() {
        this.valueChangeService.valueChange$.pipe(takeUntil$1(this.isDestroyed$)).subscribe(value => {
            this._value = value;
            this.valueChange.emit(this.value);
            this.onChange(this.value);
            this.onTouch(this.value);
        });
    }
    handleOptionChildren() {
        this.optionChildren.changes.pipe(takeUntil$1(this.isDestroyed$), startWith(this.optionChildren)).subscribe(optionChildren => {
            this.valueChangeService.handleSelectOptionsChange(optionChildren, this.value);
        });
    }
    /** Handles keyboard events when the selected is open. */
    handleKeyboardAction(event) {
        if (!this.searchByTyping) {
            return;
        }
        const keyCode = event.keyCode;
        const isArrowKey = keyCode === DOWN_ARROW ||
            keyCode === UP_ARROW ||
            keyCode === LEFT_ARROW ||
            keyCode === RIGHT_ARROW;
        const isTyping = (keyCode >= A && keyCode <= Z) || (keyCode >= ZERO && keyCode <= NINE);
        if (isArrowKey) {
            event.preventDefault(); // prevents the page from scrolling
            // select the next option on arrow key down
            if (keyCode === DOWN_ARROW || keyCode === RIGHT_ARROW) {
                this.valueChangeService.selectNextOption();
                return;
            }
            this.valueChangeService.selectPreviousOption();
            return;
        }
        if (isTyping) {
            this.valueChangeService.searchOptionByFirstLetter(event.key);
            return;
        }
    }
    writeValue(value) {
        if (typeof value === 'undefined') {
            return;
        }
        this.value = value;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouch = fn;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    ;
    ngOnDestroy() {
        this.isDestroyed$.next();
        this.isDestroyed$.complete();
    }
}
SelectDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectDirective, deps: [{ token: ValueChangeService }], target: i0.ɵɵFactoryTarget.Directive });
SelectDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: SelectDirective, isStandalone: true, selector: "[wacSelect]", inputs: { value: "value", multiple: "multiple", disabled: "disabled", tabIndex: "tabIndex", searchByTyping: "searchByTyping" }, outputs: { valueChange: "valueChange" }, host: { listeners: { "keydown": "onKeydown($event)" }, properties: { "attr.tabindex": "this.tabindex", "class.wac-select-disabled": "this.isSelectDisabled" } }, providers: [
        { provide: NG_VALUE_ACCESSOR, useExisting: SelectDirective, multi: true },
        ValueChangeService
    ], queries: [{ propertyName: "optionChildren", predicate: OPTION_SELECTION_HANDLER, descendants: true }], exportAs: ["wacSelect"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacSelect]',
                    providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: SelectDirective, multi: true },
                        ValueChangeService
                    ],
                    exportAs: 'wacSelect',
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: ValueChangeService }]; }, propDecorators: { tabindex: [{
                type: HostBinding,
                args: ['attr.tabindex']
            }], isSelectDisabled: [{
                type: HostBinding,
                args: ['class.wac-select-disabled']
            }], onKeydown: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }], optionChildren: [{
                type: ContentChildren,
                args: [OPTION_SELECTION_HANDLER, { descendants: true }]
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], multiple: [{
                type: Input
            }], disabled: [{
                type: Input
            }], tabIndex: [{
                type: Input
            }], searchByTyping: [{
                type: Input
            }] } });

class OnlyNumberDirective {
    // https://stackoverflow.com/questions/41465542/angular2-input-field-to-accept-only-numbers?page=1&tab=scoredesc#tab-top
    constructor() {
        this.wacOnlyNumber = true;
    }
    onKeyDown(event) {
        if (!this.wacOnlyNumber) {
            return;
        }
        if ([46, 8, 9, 27, 13, 110, 190].indexOf(event.keyCode) !== -1 ||
            // Allow: Ctrl+A
            (event.keyCode === 65 && (event.ctrlKey || event.metaKey)) ||
            // Allow: Ctrl+C
            (event.keyCode === 67 && (event.ctrlKey || event.metaKey)) ||
            // Allow: Ctrl+V
            (event.keyCode === 86 && (event.ctrlKey || event.metaKey)) ||
            // Allow: Ctrl+X
            (event.keyCode === 88 && (event.ctrlKey || event.metaKey)) ||
            // Allow: home, end, left, right
            (event.keyCode >= 35 && event.keyCode <= 39)) {
            // let it happen, don't do anything
            return;
        }
        // Ensure that it is a number and stop the keypress
        if ((event.shiftKey || (event.keyCode < 48 || event.keyCode > 57)) && (event.keyCode < 96 || event.keyCode > 105)) {
            event.preventDefault();
        }
    }
}
OnlyNumberDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: OnlyNumberDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
OnlyNumberDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: OnlyNumberDirective, selector: "[wacOnlyNumber]", inputs: { wacOnlyNumber: "wacOnlyNumber" }, host: { listeners: { "keydown": "onKeyDown($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: OnlyNumberDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacOnlyNumber]'
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { wacOnlyNumber: [{
                type: Input
            }], onKeyDown: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }] } });

class TwoDigitDecimalNumberDirective {
    constructor(el) {
        this.el = el;
        this.decimalSeparator = ['.', ',']; // user can put . or , char.
        // input also cannot start from , or .
        this.specialKeys = ['Backspace', 'Tab', 'End', 'Home', '-', 'ArrowLeft', 'ArrowRight', 'Del', 'Delete'];
    }
    onKeyDown(event) {
        if (this.specialKeys.includes(event.key)) {
            return;
        }
        const current = this.el.nativeElement.value;
        const position = this.el.nativeElement.selectionStart;
        const next = [current.slice(0, position), event.key == 'Decimal' ? '.' : event.key, current.slice(position)].join('');
        const regex = new RegExp(`^\\d+[${this.decimalSeparator.join('')}]?\\d{0,2}$`, 'g');
        if (next && !regex.test(next)) {
            event.preventDefault();
        }
    }
}
TwoDigitDecimalNumberDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TwoDigitDecimalNumberDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
TwoDigitDecimalNumberDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: TwoDigitDecimalNumberDirective, selector: "[wacTwoDigitDecimalNumber]", inputs: { decimalSeparator: "decimalSeparator" }, host: { listeners: { "keydown": "onKeyDown($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TwoDigitDecimalNumberDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacTwoDigitDecimalNumber]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { decimalSeparator: [{
                type: Input
            }], onKeyDown: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }] } });

class RadioLegacyDirective extends SelectOptionDirective {
    constructor(contentRef, changeDetectorRef) {
        super(contentRef, changeDetectorRef);
        this.contentRef = contentRef;
        this.changeDetectorRef = changeDetectorRef;
    }
}
RadioLegacyDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioLegacyDirective, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive });
RadioLegacyDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: RadioLegacyDirective, selector: "[wacRadio]", providers: [{ provide: OPTION_SELECTION_HANDLER, useExisting: RadioLegacyDirective }], exportAs: ["wacRadio"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioLegacyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacRadio]',
                    exportAs: 'wacRadio',
                    providers: [{ provide: OPTION_SELECTION_HANDLER, useExisting: RadioLegacyDirective }],
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }]; } });

class RadioGroupLegacyDirective extends SelectDirective {
    get multiple() {
        return false;
    }
    set multiple(value) {
        throw new Error('RadioGroupDirective does not support multiple selection');
    }
    constructor(valueChangeService) {
        super(valueChangeService);
        this.valueChangeService = valueChangeService;
    }
}
RadioGroupLegacyDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioGroupLegacyDirective, deps: [{ token: ValueChangeService }], target: i0.ɵɵFactoryTarget.Directive });
RadioGroupLegacyDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: RadioGroupLegacyDirective, selector: "[wacRadioGroup]", providers: [
        { provide: NG_VALUE_ACCESSOR, useExisting: RadioGroupLegacyDirective, multi: true },
        ValueChangeService
    ], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioGroupLegacyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacRadioGroup]',
                    providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: RadioGroupLegacyDirective, multi: true },
                        ValueChangeService
                    ],
                }]
        }], ctorParameters: function () { return [{ type: ValueChangeService }]; } });

class CopyToClipBoardDirective {
    constructor(element) {
        this.element = element;
        this.onClick = () => this.copyToClipboard(this.element.nativeElement.outerText);
        this.cursor = 'cursor:pointer';
        this.textCopy = new EventEmitter();
        this.copyToClipboard = (text) => {
            navigator.clipboard.writeText(text);
            this.textCopy.emit(text);
        };
    }
}
CopyToClipBoardDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CopyToClipBoardDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
CopyToClipBoardDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: CopyToClipBoardDirective, isStandalone: true, selector: "[wacCopyToClipboard]", outputs: { textCopy: "textCopy" }, host: { listeners: { "click": "onClick()" }, properties: { "style": "this.cursor" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CopyToClipBoardDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacCopyToClipboard]',
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { onClick: [{
                type: HostListener,
                args: ['click']
            }], cursor: [{
                type: HostBinding,
                args: ['style']
            }], textCopy: [{
                type: Output
            }] } });

class ScrollToDirective {
    constructor() {
        this.scrollConfig = { behavior: "smooth", block: "start", inline: "nearest" };
        this.cursor = 'pointer';
    }
    onClick() {
        const element = document.getElementById(this.elementId);
        element?.scrollIntoView(this.scrollConfig);
    }
}
ScrollToDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ScrollToDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
ScrollToDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: ScrollToDirective, isStandalone: true, selector: "[wacScrollTo]", inputs: { elementId: "elementId", scrollConfig: "scrollConfig" }, host: { listeners: { "click": "onClick()" }, properties: { "style.cursor": "this.cursor" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ScrollToDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacScrollTo]',
                    standalone: true,
                }]
        }], propDecorators: { elementId: [{
                type: Input
            }], scrollConfig: [{
                type: Input
            }], onClick: [{
                type: HostListener,
                args: ['click']
            }], cursor: [{
                type: HostBinding,
                args: ['style.cursor']
            }] } });

// watch dom change and fire (dom-changed) event
class DomChangedDirective {
    constructor(elRef) {
        this.elRef = elRef;
    }
    ngOnInit() {
        this.registerDomChangedEvent(this.elRef.nativeElement);
    }
    registerDomChangedEvent(el) {
        const observer = new MutationObserver(list => {
            const evt = new CustomEvent('dom-changed', { detail: list, bubbles: true });
            el.dispatchEvent(evt);
        });
        const attributes = false;
        const childList = true;
        const subtree = true;
        observer.observe(el, { attributes, childList, subtree });
    }
}
DomChangedDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DomChangedDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
DomChangedDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: DomChangedDirective, selector: "[watchDomTree]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DomChangedDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[watchDomTree]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; } });

const directives$2 = [
    DebounceKeyupDirective,
    AbstractDebounceDirective,
    AutoHideDirective,
    ZindexToggleDirective,
    VarDirective,
    KeypressEnterDirective,
    OnlyNumberDirective,
    TwoDigitDecimalNumberDirective,
    RadioLegacyDirective,
    RadioGroupLegacyDirective,
    DomChangedDirective
];
const standalone = [
    SelectDirective,
    SelectOptionDirective,
];
class SharedDirectives {
}
SharedDirectives.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SharedDirectives, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
SharedDirectives.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: SharedDirectives, declarations: [DebounceKeyupDirective,
        AbstractDebounceDirective,
        AutoHideDirective,
        ZindexToggleDirective,
        VarDirective,
        KeypressEnterDirective,
        OnlyNumberDirective,
        TwoDigitDecimalNumberDirective,
        RadioLegacyDirective,
        RadioGroupLegacyDirective,
        DomChangedDirective], imports: [CommonModule, FormsModule, CopyToClipBoardDirective, ScrollToDirective, SelectDirective,
        SelectOptionDirective], exports: [DebounceKeyupDirective,
        AbstractDebounceDirective,
        AutoHideDirective,
        ZindexToggleDirective,
        VarDirective,
        KeypressEnterDirective,
        OnlyNumberDirective,
        TwoDigitDecimalNumberDirective,
        RadioLegacyDirective,
        RadioGroupLegacyDirective,
        DomChangedDirective, CopyToClipBoardDirective, ScrollToDirective, SelectDirective,
        SelectOptionDirective] });
SharedDirectives.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SharedDirectives, imports: [CommonModule, FormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SharedDirectives, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, FormsModule, CopyToClipBoardDirective, ScrollToDirective, ...standalone],
                    declarations: directives$2,
                    exports: [...directives$2, CopyToClipBoardDirective, ScrollToDirective, ...standalone]
                }]
        }] });

class TooltipComponent {
    constructor() {
        this.tooltipText = '';
        this.tooltipLink = '';
        this.tooltipUrl = '#';
    }
    ngOnInit() {
        if (this.tooltipIcon === '') {
            this.tooltipIcon = 'fas fa-info-circle';
        }
    }
}
TooltipComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TooltipComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TooltipComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TooltipComponent, selector: "wac-tooltip", inputs: { tooltipIcon: "tooltipIcon", tooltipText: "tooltipText", tooltipLink: "tooltipLink", tooltipUrl: "tooltipUrl" }, ngImport: i0, template: "<span class=\"wac-tooltip\">\r\n  <i [class]=\"tooltipIcon\"></i>\r\n  <span class=\"tooltip-content\"\r\n    >{{ tooltipText }}\r\n    <span *ngIf=\"tooltipUrl\"\r\n      ><a [href]=\"tooltipUrl\" target=\"_blank\">{{ tooltipLink }}</a></span\r\n    >\r\n  </span>\r\n</span>\r\n", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TooltipComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-tooltip', template: "<span class=\"wac-tooltip\">\r\n  <i [class]=\"tooltipIcon\"></i>\r\n  <span class=\"tooltip-content\"\r\n    >{{ tooltipText }}\r\n    <span *ngIf=\"tooltipUrl\"\r\n      ><a [href]=\"tooltipUrl\" target=\"_blank\">{{ tooltipLink }}</a></span\r\n    >\r\n  </span>\r\n</span>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { tooltipIcon: [{
                type: Input
            }], tooltipText: [{
                type: Input
            }], tooltipLink: [{
                type: Input
            }], tooltipUrl: [{
                type: Input
            }] } });

class TooltipModule {
}
TooltipModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TooltipModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
TooltipModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: TooltipModule, declarations: [TooltipComponent], imports: [CommonModule,
        FormsModule], exports: [TooltipComponent] });
TooltipModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TooltipModule, imports: [CommonModule,
        FormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TooltipModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule
                    ],
                    exports: [TooltipComponent],
                    declarations: [TooltipComponent],
                    providers: [],
                }]
        }] });

class ProgressBarComponent {
    constructor(translateService) {
        this.translateService = translateService;
        this.valueLength = null;
        this.min = null;
        this.max = null;
    }
    progressBarClass(spanNumber = -1) {
        const length = this.valueLength;
        const min = this.min;
        const max = this.max;
        if (spanNumber === 1) {
            return {
                'is-danger': length > max,
                'is-success': length >= min && length <= max
            };
        }
        else if (spanNumber === 2) {
            return {
                'is-success': length === max,
                'is-danger': length > max
            };
        }
        else {
            return {
                'is-warning': length < min,
                'is-danger': length > max,
                'is-success': length >= min && length <= max
            };
        }
    }
    progressBarSpanPosition(index) {
        const min = this.min;
        const max = this.max;
        const maxSize = this.progressBarGetMaxSize(max);
        const successMin = (min / maxSize) * 100;
        const successMax = (max / maxSize) * 100;
        return index === 1 ? successMin : successMax;
    }
    progressBarGetMaxSize(max) {
        return max + max / 4;
    }
    progressBarGetTextInfo() {
        const length = this.valueLength;
        const min = this.min;
        const max = this.max;
        if (length < min) {
            return this.translateService.instant('wac.input.progressbar.information.too.short');
        }
        else if (length > max) {
            return this.translateService.instant('wac.input.progressbar.information.too.long');
        }
        else {
            return this.translateService.instant('wac.input.progressbar.information.good');
        }
    }
}
ProgressBarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ProgressBarComponent, deps: [{ token: i1$2.TranslateService }], target: i0.ɵɵFactoryTarget.Component });
ProgressBarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ProgressBarComponent, isStandalone: true, selector: "wac-progress-bar", inputs: { valueLength: "valueLength", min: "min", max: "max" }, ngImport: i0, template: "<div class=\"wac-progressBarContent\">\r\n  <div class=\"progressBar\">\r\n    <progress class=\"progress\" [ngClass]=\"progressBarClass()\" [max]=\"progressBarGetMaxSize(max)\" [value]=\"valueLength\"></progress>\r\n    <span [ngClass]=\"progressBarClass(1)\" [ngStyle]=\"{ 'left.%': progressBarSpanPosition(1) }\"></span>\r\n    <span [ngClass]=\"progressBarClass(2)\" [ngStyle]=\"{ 'left.%': progressBarSpanPosition(2) }\"></span>\r\n  </div>\r\n  <div class=\"size\">\r\n    <span class=\"is-size-7 wac-input__size\">\r\n      <span *ngIf=\"valueLength\">\r\n        <span [ngClass]=\"progressBarClass()\">{{ progressBarGetTextInfo() }}</span> -\r\n      </span>\r\n      <strong>{{ valueLength }}</strong> / {{ max }}\r\n    </span>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ProgressBarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-progress-bar', standalone: true, imports: [CommonModule], template: "<div class=\"wac-progressBarContent\">\r\n  <div class=\"progressBar\">\r\n    <progress class=\"progress\" [ngClass]=\"progressBarClass()\" [max]=\"progressBarGetMaxSize(max)\" [value]=\"valueLength\"></progress>\r\n    <span [ngClass]=\"progressBarClass(1)\" [ngStyle]=\"{ 'left.%': progressBarSpanPosition(1) }\"></span>\r\n    <span [ngClass]=\"progressBarClass(2)\" [ngStyle]=\"{ 'left.%': progressBarSpanPosition(2) }\"></span>\r\n  </div>\r\n  <div class=\"size\">\r\n    <span class=\"is-size-7 wac-input__size\">\r\n      <span *ngIf=\"valueLength\">\r\n        <span [ngClass]=\"progressBarClass()\">{{ progressBarGetTextInfo() }}</span> -\r\n      </span>\r\n      <strong>{{ valueLength }}</strong> / {{ max }}\r\n    </span>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: i1$2.TranslateService }]; }, propDecorators: { valueLength: [{
                type: Input
            }], min: [{
                type: Input
            }], max: [{
                type: Input
            }] } });

class InputComponent {
    constructor() {
        this.label = '';
        this.value = '';
        this.type = 'text';
        this.placeholder = ''; // todo could be handle with ng-content
        this.textInfo = null; // todo should be handle with ng-content
        this.textError = null; // todo should be handle with ng-content
        this.size = null;
        this.isNumber = null;
        this.withoutBlock = false;
        this.icon = '';
        this.big = false;
        this.medium = false;
        this.boldLabel = 'false'; // todo refacto to boolean
        this.min = null;
        this.max = null;
        this.disableMargin = false;
        this.textPrepend = null; // todo should be handle with ng-content
        this.textAppend = null; // todo should be handle with ng-content
        this.progressBar = false;
        this.extraClasses = '';
        this.keyPreventDefault = [];
        this.showTooltip = false;
        this.textTooltip = '';
        this.iconTooltip = '';
        this.urlTooltip = '';
        this.linkTooltip = '';
        this.padding = false;
        this.disabled = false;
        this.indication = ''; // todo should be handle with ng-content
        this.success = false;
        this.error = false;
        this.indicationLeft = false;
        this.keypressEnter = new EventEmitter();
        this.blurred = new EventEmitter();
        this.KEYPRESS_ENTER = "Enter";
        this.id = 'wz-input_' +
            Math.random()
                .toString(36)
                .substr(2, 9);
        this._onChange = (value) => { };
        this._onTouched = () => { };
    }
    registerOnChange(fn) {
        this._onChange = fn;
    }
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    writeValue(obj) {
        this.value = obj;
    }
    onChange(value) {
        if (this._onChange) {
            this._onChange(value);
        }
    }
    onBlur() {
        if (this._onTouched) {
            this._onTouched();
        }
        this.blurred.next();
    }
    checkNumberValue(value) {
        if (this.min && this.min > value) {
            this.value = this.min;
        }
        if (this.max && this.max < value) {
            this.value = this.max;
        }
    }
    onFocusOut() {
        if (this.type === 'number') {
            this.checkNumberValue(this.value);
        }
    }
    keyPress(event) {
        if (this.keyPreventDefault.includes(event.key)) {
            event.preventDefault();
        }
        if (event.key === this.KEYPRESS_ENTER) {
            this.keypressEnter.next(true);
        }
    }
}
InputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: InputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
InputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: InputComponent, isStandalone: true, selector: "wac-input", inputs: { label: "label", value: "value", type: "type", placeholder: "placeholder", textInfo: "textInfo", textError: "textError", size: "size", isNumber: "isNumber", withoutBlock: "withoutBlock", icon: "icon", big: "big", medium: "medium", boldLabel: "boldLabel", min: "min", max: "max", disableMargin: "disableMargin", textPrepend: "textPrepend", textAppend: "textAppend", progressBar: "progressBar", extraClasses: "extraClasses", keyPreventDefault: "keyPreventDefault", showTooltip: "showTooltip", textTooltip: "textTooltip", iconTooltip: "iconTooltip", urlTooltip: "urlTooltip", linkTooltip: "linkTooltip", padding: "padding", disabled: "disabled", indication: "indication", success: "success", error: "error", maxlength: "maxlength", minlength: "minlength", indicationLeft: "indicationLeft" }, outputs: { keypressEnter: "keypressEnter", blurred: "blurred" }, providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: InputComponent, multi: true }], ngImport: i0, template: "<div\r\n  class=\"field wac-input\"\r\n  [ngClass]=\"{ 'has-no-block': withoutBlock, 'is-big': big, 'is-medium': medium, 'with-padding': padding, 'indication-left': indicationLeft, 'with-progress-bar': progressBar }\"\r\n>\r\n  <div class=\"field-label is-normal has-text-left\" *ngIf=\"!withoutBlock\">\r\n    <label\r\n      [ngClass]=\"[boldLabel === 'true' ? 'label has-text-weight-bold' : 'label has-text-weight-normal', showTooltip ? 'label-inline' : '', size && !progressBar ? 'has-padding-right-mobile' : '']\"\r\n      [innerHTML]=\"label\"\r\n      [for]=\"id\"\r\n    ></label>\r\n    <wac-tooltip\r\n      *ngIf=\"showTooltip\"\r\n      [tooltipIcon]=\"iconTooltip\"\r\n      [tooltipText]=\"textTooltip\"\r\n      [tooltipLink]=\"linkTooltip\"\r\n      [tooltipUrl]=\"urlTooltip\"\r\n    ></wac-tooltip>\r\n    <!-- Size -->\r\n    <span *ngIf=\"size && !progressBar\" class=\"is-size-7 wac-input__size\">\r\n      <strong>{{ !value ? 0 : value.toString().length }}</strong> / {{ size }}\r\n    </span>\r\n  </div>\r\n  <div class=\"field-body\">\r\n    <div class=\"field\">\r\n      <p\r\n        class=\"control\"\r\n        [ngClass]=\"{ 'has-icons-right': textError || success || error, 'has-icons-left': icon !== '', 'has-input-group': textAppend || textPrepend }\"\r\n      >\r\n        <!-- Text Prepend -->\r\n        <span *ngIf=\"textPrepend\" class=\"has-input-group\">\r\n          <span class=\"has-input-group-text prepend\">{{ textPrepend }}</span>\r\n          <span *ngIf=\"icon !== ''\" class=\"icon is-small is-left\">\r\n            <i [class]=\"icon\"></i>\r\n          </span>\r\n        </span>\r\n\r\n        <!-- Input -->\r\n        <input\r\n          [class]=\"'input ' + extraClasses\"\r\n          [id]=\"id\"\r\n          [ngClass]=\"{\r\n            'is-danger': (textError || error) && !disabled,\r\n            'is-empty': value === '',\r\n            'is-large': big,\r\n            'is-number': isNumber,\r\n            'remove-margin': disableMargin,\r\n            'text-append': textAppend\r\n          }\"\r\n          [type]=\"type\"\r\n          [placeholder]=\"placeholder\"\r\n          [attr.size]=\"size\"\r\n          [(ngModel)]=\"value\"\r\n          (ngModelChange)=\"onChange($event)\"\r\n          (blur)=\"onBlur()\"\r\n          [disabled]=\"disabled\"\r\n          (focusout)=\"onFocusOut()\"\r\n          [min]=\"min\"\r\n          [max]=\"max\"\r\n          [maxlength]=\"maxlength ? maxlength : 524288\"\r\n          [minlength]=\"minlength ? minlength : 0\"\r\n          (keypress)=\"keyPress($event)\"\r\n        />\r\n\r\n        <!-- Indication at the end of the input -->\r\n        <span class=\"indication\" *ngIf=\"indication\" [ngClass]=\"{'reverse': indicationLeft}\">\r\n          <span [innerHTML]=\"indication\"></span>\r\n        </span>\r\n\r\n        <!-- Text Append -->\r\n        <span *ngIf=\"textAppend && !indicationLeft\" class=\"has-input-group\">\r\n          <span class=\"has-input-group-text append\">{{ textAppend }}</span>\r\n          <!-- error if text append not empty -->\r\n          <span *ngIf=\"textError\" class=\"icon is-small is-right\">\r\n            <i class=\"fal fa-times has-text-danger\"></i>\r\n          </span>\r\n        </span>\r\n\r\n        <!-- Icon Left -->\r\n        <span *ngIf=\"icon !== '' && !textPrepend && !indicationLeft\" class=\"icon is-small is-left\">\r\n          <i [class]=\"icon\"></i>\r\n        </span>\r\n\r\n        <!-- Icon error if textAppend empty -->\r\n        <span *ngIf=\"(textError || error) && !textAppend && !indicationLeft  && !disabled\" class=\"icon is-small is-right\">\r\n          <i class=\"fal fa-times has-text-danger\"></i>\r\n        </span>\r\n\r\n        <!-- Icon success -->\r\n        <span *ngIf=\"success && !disabled\" class=\"icon is-small is-right\">\r\n          <i class=\"fas fa-check has-text-success\"></i>\r\n        </span>\r\n\r\n        <!-- Text Info -->\r\n        <span\r\n          *ngIf=\"textInfo && (textError === null || textError === '') && !progressBar && !indicationLeft\"\r\n          class=\"is-size-7 wac-input__info text-info\"\r\n          [innerHtml]=\"textInfo\"\r\n        ></span>\r\n\r\n        <!-- Text Error -->\r\n        <span *ngIf=\"textError && !progressBar && !indicationLeft\" class=\"is-size-7 wac-input__error has-text-danger\" [innerHtml]=\"textError\"></span>\r\n      </p>\r\n\r\n      <!-- Progress Bar -->\r\n      <wac-progress-bar *ngIf=\"progressBar && !indicationLeft\" [min]=\"min\" [max]=\"max\" [valueLength]=\"value.length\"></wac-progress-bar>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MinLengthValidator, selector: "[minlength][formControlName],[minlength][formControl],[minlength][ngModel]", inputs: ["minlength"] }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "ngmodule", type: SharedDirectives }, { kind: "ngmodule", type: TooltipModule }, { kind: "component", type: TooltipComponent, selector: "wac-tooltip", inputs: ["tooltipIcon", "tooltipText", "tooltipLink", "tooltipUrl"] }, { kind: "component", type: ProgressBarComponent, selector: "wac-progress-bar", inputs: ["valueLength", "min", "max"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: InputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-input', standalone: true, imports: [
                        CommonModule,
                        FormsModule,
                        SharedDirectives,
                        TooltipModule,
                        ProgressBarComponent
                    ], providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: InputComponent, multi: true }], template: "<div\r\n  class=\"field wac-input\"\r\n  [ngClass]=\"{ 'has-no-block': withoutBlock, 'is-big': big, 'is-medium': medium, 'with-padding': padding, 'indication-left': indicationLeft, 'with-progress-bar': progressBar }\"\r\n>\r\n  <div class=\"field-label is-normal has-text-left\" *ngIf=\"!withoutBlock\">\r\n    <label\r\n      [ngClass]=\"[boldLabel === 'true' ? 'label has-text-weight-bold' : 'label has-text-weight-normal', showTooltip ? 'label-inline' : '', size && !progressBar ? 'has-padding-right-mobile' : '']\"\r\n      [innerHTML]=\"label\"\r\n      [for]=\"id\"\r\n    ></label>\r\n    <wac-tooltip\r\n      *ngIf=\"showTooltip\"\r\n      [tooltipIcon]=\"iconTooltip\"\r\n      [tooltipText]=\"textTooltip\"\r\n      [tooltipLink]=\"linkTooltip\"\r\n      [tooltipUrl]=\"urlTooltip\"\r\n    ></wac-tooltip>\r\n    <!-- Size -->\r\n    <span *ngIf=\"size && !progressBar\" class=\"is-size-7 wac-input__size\">\r\n      <strong>{{ !value ? 0 : value.toString().length }}</strong> / {{ size }}\r\n    </span>\r\n  </div>\r\n  <div class=\"field-body\">\r\n    <div class=\"field\">\r\n      <p\r\n        class=\"control\"\r\n        [ngClass]=\"{ 'has-icons-right': textError || success || error, 'has-icons-left': icon !== '', 'has-input-group': textAppend || textPrepend }\"\r\n      >\r\n        <!-- Text Prepend -->\r\n        <span *ngIf=\"textPrepend\" class=\"has-input-group\">\r\n          <span class=\"has-input-group-text prepend\">{{ textPrepend }}</span>\r\n          <span *ngIf=\"icon !== ''\" class=\"icon is-small is-left\">\r\n            <i [class]=\"icon\"></i>\r\n          </span>\r\n        </span>\r\n\r\n        <!-- Input -->\r\n        <input\r\n          [class]=\"'input ' + extraClasses\"\r\n          [id]=\"id\"\r\n          [ngClass]=\"{\r\n            'is-danger': (textError || error) && !disabled,\r\n            'is-empty': value === '',\r\n            'is-large': big,\r\n            'is-number': isNumber,\r\n            'remove-margin': disableMargin,\r\n            'text-append': textAppend\r\n          }\"\r\n          [type]=\"type\"\r\n          [placeholder]=\"placeholder\"\r\n          [attr.size]=\"size\"\r\n          [(ngModel)]=\"value\"\r\n          (ngModelChange)=\"onChange($event)\"\r\n          (blur)=\"onBlur()\"\r\n          [disabled]=\"disabled\"\r\n          (focusout)=\"onFocusOut()\"\r\n          [min]=\"min\"\r\n          [max]=\"max\"\r\n          [maxlength]=\"maxlength ? maxlength : 524288\"\r\n          [minlength]=\"minlength ? minlength : 0\"\r\n          (keypress)=\"keyPress($event)\"\r\n        />\r\n\r\n        <!-- Indication at the end of the input -->\r\n        <span class=\"indication\" *ngIf=\"indication\" [ngClass]=\"{'reverse': indicationLeft}\">\r\n          <span [innerHTML]=\"indication\"></span>\r\n        </span>\r\n\r\n        <!-- Text Append -->\r\n        <span *ngIf=\"textAppend && !indicationLeft\" class=\"has-input-group\">\r\n          <span class=\"has-input-group-text append\">{{ textAppend }}</span>\r\n          <!-- error if text append not empty -->\r\n          <span *ngIf=\"textError\" class=\"icon is-small is-right\">\r\n            <i class=\"fal fa-times has-text-danger\"></i>\r\n          </span>\r\n        </span>\r\n\r\n        <!-- Icon Left -->\r\n        <span *ngIf=\"icon !== '' && !textPrepend && !indicationLeft\" class=\"icon is-small is-left\">\r\n          <i [class]=\"icon\"></i>\r\n        </span>\r\n\r\n        <!-- Icon error if textAppend empty -->\r\n        <span *ngIf=\"(textError || error) && !textAppend && !indicationLeft  && !disabled\" class=\"icon is-small is-right\">\r\n          <i class=\"fal fa-times has-text-danger\"></i>\r\n        </span>\r\n\r\n        <!-- Icon success -->\r\n        <span *ngIf=\"success && !disabled\" class=\"icon is-small is-right\">\r\n          <i class=\"fas fa-check has-text-success\"></i>\r\n        </span>\r\n\r\n        <!-- Text Info -->\r\n        <span\r\n          *ngIf=\"textInfo && (textError === null || textError === '') && !progressBar && !indicationLeft\"\r\n          class=\"is-size-7 wac-input__info text-info\"\r\n          [innerHtml]=\"textInfo\"\r\n        ></span>\r\n\r\n        <!-- Text Error -->\r\n        <span *ngIf=\"textError && !progressBar && !indicationLeft\" class=\"is-size-7 wac-input__error has-text-danger\" [innerHtml]=\"textError\"></span>\r\n      </p>\r\n\r\n      <!-- Progress Bar -->\r\n      <wac-progress-bar *ngIf=\"progressBar && !indicationLeft\" [min]=\"min\" [max]=\"max\" [valueLength]=\"value.length\"></wac-progress-bar>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], propDecorators: { label: [{
                type: Input
            }], value: [{
                type: Input
            }], type: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], textInfo: [{
                type: Input
            }], textError: [{
                type: Input
            }], size: [{
                type: Input
            }], isNumber: [{
                type: Input
            }], withoutBlock: [{
                type: Input
            }], icon: [{
                type: Input
            }], big: [{
                type: Input
            }], medium: [{
                type: Input
            }], boldLabel: [{
                type: Input
            }], min: [{
                type: Input
            }], max: [{
                type: Input
            }], disableMargin: [{
                type: Input
            }], textPrepend: [{
                type: Input
            }], textAppend: [{
                type: Input
            }], progressBar: [{
                type: Input
            }], extraClasses: [{
                type: Input
            }], keyPreventDefault: [{
                type: Input
            }], showTooltip: [{
                type: Input
            }], textTooltip: [{
                type: Input
            }], iconTooltip: [{
                type: Input
            }], urlTooltip: [{
                type: Input
            }], linkTooltip: [{
                type: Input
            }], padding: [{
                type: Input
            }], disabled: [{
                type: Input
            }], indication: [{
                type: Input
            }], success: [{
                type: Input
            }], error: [{
                type: Input
            }], maxlength: [{
                type: Input
            }], minlength: [{
                type: Input
            }], indicationLeft: [{
                type: Input
            }], keypressEnter: [{
                type: Output
            }], blurred: [{
                type: Output
            }] } });

class InputSearchComponent {
    constructor() {
        this.placeholder = '';
        this.withoutgrey = false;
        this.smallPadding = false; // todo Try to be more flexible like changing type : export type PaddingConfig = "default" | "small" | "big" | "no-padding";
        this.innerValue = '';
        this.changeDebounced = new EventEmitter(); // debounced
        this.onTouchedCallback = () => { };
        this.onChangeCallback = () => { };
    }
    get value() {
        return this.innerValue;
    }
    set value(v) {
        if (v !== this.innerValue) {
            this.innerValue = v;
            this.onChangeCallback(v);
        }
    }
    writeValue(value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
        }
    }
    registerOnChange(fn) {
        this.onChangeCallback = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedCallback = fn;
    }
    handleDebouncedKeyUp() {
        this.changeDebounced.emit(this.value);
    }
}
InputSearchComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: InputSearchComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
InputSearchComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: InputSearchComponent, isStandalone: true, selector: "wac-input-search", inputs: { placeholder: "placeholder", withoutgrey: "withoutgrey", smallPadding: "smallPadding", id: "id" }, outputs: { changeDebounced: "changeDebounced" }, providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: InputSearchComponent, multi: true }], ngImport: i0, template: "<div class=\"wac-field-input-search\" [ngClass]=\"{'small-padding' : smallPadding, 'no-grey': withoutgrey}\">\r\n  <p class=\"control has-icons-left has-icons-right\">\r\n    <input\r\n      [placeholder]=\"placeholder\"\r\n      value=\"\"\r\n      class=\"input\"\r\n      type=\"text\"\r\n      [attr.id]=\"id\"\r\n      [(ngModel)]=\"value\"\r\n      debounceKeyUp\r\n      [debounceTime]=\"1000\"\r\n      (onEventChange)=\"handleDebouncedKeyUp()\"\r\n    />\r\n    <i class=\"icon fal fa-search\"></i>\r\n  </p>\r\n</div>\r\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "ngmodule", type: SharedDirectives }, { kind: "directive", type: DebounceKeyupDirective, selector: "input[debounceKeyUp]" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: InputSearchComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-input-search', standalone: true, imports: [
                        CommonModule,
                        FormsModule,
                        InputComponent,
                        SharedDirectives
                    ], providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: InputSearchComponent, multi: true }], template: "<div class=\"wac-field-input-search\" [ngClass]=\"{'small-padding' : smallPadding, 'no-grey': withoutgrey}\">\r\n  <p class=\"control has-icons-left has-icons-right\">\r\n    <input\r\n      [placeholder]=\"placeholder\"\r\n      value=\"\"\r\n      class=\"input\"\r\n      type=\"text\"\r\n      [attr.id]=\"id\"\r\n      [(ngModel)]=\"value\"\r\n      debounceKeyUp\r\n      [debounceTime]=\"1000\"\r\n      (onEventChange)=\"handleDebouncedKeyUp()\"\r\n    />\r\n    <i class=\"icon fal fa-search\"></i>\r\n  </p>\r\n</div>\r\n" }]
        }], propDecorators: { placeholder: [{
                type: Input
            }], withoutgrey: [{
                type: Input
            }], smallPadding: [{
                type: Input
            }], id: [{
                type: Input
            }], changeDebounced: [{
                type: Output
            }] } });

const inOutY = trigger('inOutYAnimation', [
    transition(':enter', [
        style({ transform: 'scaleY(0)', height: 0, opacity: 0 }),
        animate('.3s ease-out', style({ transform: 'scaleY(1)', height: 'auto', opacity: 1 }))
    ]),
    transition(':leave', [
        style({ transform: 'scaleY(1)', height: 'auto', opacity: 1 }),
        animate('.3s ease-in', style({ transform: 'scaleY(0)', height: 0, opacity: 0 }))
    ])
]);

class CheckboxComponent {
    set value(value) {
        this._value = value;
        this._onChange(value);
        this._onTouched();
    }
    get value() {
        return this._value;
    }
    constructor() {
        this.label = '';
        this.type = 'checkbox';
        this.alone = false;
        this.checked = false;
        this.hasInput = false; // todo remove from it ! That is not a part of a checkbox
        this.inputPlaceholder = ''; // todo remove from it ! That is not a part of a checkbox
        this.id = ''; // todo maybe create a static property for unique id
        this.whiteSpace = true;
        this.disabled = false;
        this.valueChange = new EventEmitter();
        this._onChange = (value) => { };
        this._onTouched = () => { };
    }
    registerOnChange(fn) {
        this._onChange = fn;
    }
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    writeValue(isChecked) {
        this._value = isChecked;
    }
    onChange(value) {
        this._onChange(value);
    }
    inputClick($event) {
        $event.stopPropagation();
    }
}
CheckboxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CheckboxComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CheckboxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: CheckboxComponent, selector: "wac-checkbox", inputs: { label: "label", value: "value", type: "type", alone: "alone", checked: "checked", hasInput: "hasInput", inputPlaceholder: "inputPlaceholder", id: "id", name: "name", whiteSpace: "whiteSpace", disabled: "disabled" }, outputs: { valueChange: "valueChange" }, providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: CheckboxComponent, multi: true }], ngImport: i0, template: "<div class=\"wac-field-checkbox\" [ngClass]=\"{ 'disable-wt' : !whiteSpace, alone: alone }\">\r\n  <div class=\"wac-field-checkbox__row\">\r\n    <!-- TODO handle radio styles -->\r\n    <input\r\n      [type]=\"type\"\r\n      [id]=\"id\"\r\n      [class]=\"'is-checkradio' + (value ? ' checked' : '')\"\r\n      [name]=\"name\"\r\n      [disabled]=\"disabled\"\r\n      [checked]=\"value\"\r\n      (change)=\"value = !value\"\r\n    />\r\n    <label [attr.for]=\"id\"><span [innerHTML]=\"label\"></span></label>\r\n  </div>\r\n  <input\r\n    *ngIf=\"hasInput && checked\"\r\n    [@inOutYAnimation]\r\n    type=\"text\"\r\n    [placeholder]=\"inputPlaceholder\"\r\n    (click)=\"inputClick($event)\"\r\n  />\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [inOutY], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CheckboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-checkbox', providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: CheckboxComponent, multi: true }], animations: [inOutY], encapsulation: ViewEncapsulation.None, template: "<div class=\"wac-field-checkbox\" [ngClass]=\"{ 'disable-wt' : !whiteSpace, alone: alone }\">\r\n  <div class=\"wac-field-checkbox__row\">\r\n    <!-- TODO handle radio styles -->\r\n    <input\r\n      [type]=\"type\"\r\n      [id]=\"id\"\r\n      [class]=\"'is-checkradio' + (value ? ' checked' : '')\"\r\n      [name]=\"name\"\r\n      [disabled]=\"disabled\"\r\n      [checked]=\"value\"\r\n      (change)=\"value = !value\"\r\n    />\r\n    <label [attr.for]=\"id\"><span [innerHTML]=\"label\"></span></label>\r\n  </div>\r\n  <input\r\n    *ngIf=\"hasInput && checked\"\r\n    [@inOutYAnimation]\r\n    type=\"text\"\r\n    [placeholder]=\"inputPlaceholder\"\r\n    (click)=\"inputClick($event)\"\r\n  />\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { label: [{
                type: Input
            }], value: [{
                type: Input
            }], type: [{
                type: Input
            }], alone: [{
                type: Input
            }], checked: [{
                type: Input
            }], hasInput: [{
                type: Input
            }], inputPlaceholder: [{
                type: Input
            }], id: [{
                type: Input
            }], name: [{
                type: Input
            }], whiteSpace: [{
                type: Input
            }], disabled: [{
                type: Input
            }], valueChange: [{
                type: Output
            }] } });

class HtmlContainer {
    constructor(hostElement, appRef, componentFactoryResolver, injector) {
        this.hostElement = hostElement;
        this.appRef = appRef;
        this.componentFactoryResolver = componentFactoryResolver;
        this.injector = injector;
        this.attached = false;
    }
    attach(component) {
        if (this.attached) {
            throw new Error('component has already been attached');
        }
        this.attached = true;
        const childComponentFactory = this.componentFactoryResolver.resolveComponentFactory(component);
        let componentRef = childComponentFactory.create(this.injector);
        this.appRef.attachView(componentRef.hostView);
        this.disposeFn = () => {
            this.appRef.detachView(componentRef.hostView);
            componentRef.destroy();
        };
        this.hostElement.appendChild(componentRef.hostView.rootNodes[0]);
        return componentRef;
    }
    dispose() {
        if (this.attached) {
            this.disposeFn();
        }
    }
}

class TableCheckboxIdService {
    constructor() {
        this.nbCheckboxInstances = 0;
        TableCheckboxIdService.tableInstance++;
        this.currentTableInstance = TableCheckboxIdService.tableInstance;
    }
    getUniqueId() {
        this.nbCheckboxInstances++;
        return `wac-table-${this.currentTableInstance}-${this.nbCheckboxInstances}`;
    }
}
TableCheckboxIdService.tableInstance = 0;
TableCheckboxIdService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableCheckboxIdService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
TableCheckboxIdService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableCheckboxIdService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableCheckboxIdService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return []; } });

class CheckBoxRow {
    set checkBoxValue(value) {
        this._value = value;
        if (this.checkboxComponentRef) {
            this.setCheckBoxValue();
        }
    }
    get checkBoxValue() {
        return this._value;
    }
    constructor(currentRow, appRef, renderer, document, resolver, injector, tableCheckboxIdService) {
        this.currentRow = currentRow;
        this.appRef = appRef;
        this.renderer = renderer;
        this.document = document;
        this.resolver = resolver;
        this.injector = injector;
        this.tableCheckboxIdService = tableCheckboxIdService;
        this.checkBoxValueChange = new EventEmitter();
    }
    ngOnInit() {
        this.createCheckBoxComponent();
        this.handleChecboxInputs();
        this.handleCheckboxOutputs();
    }
    createCheckBoxComponent() {
        // Create the container
        this.checkBoxElement = document.createElement('div');
        this.checkBoxElement.className = 'wac-table__body__line__cell wac-table__body__line__cell--checkbox';
        // Insert divCheckBox in the DOM as the first child of the row
        this.renderer.insertBefore(this.currentRow.nativeElement, this.checkBoxElement, this.currentRow.nativeElement.firstChild);
        // Insert the CheckBoxComponent inside the container (DOM and Angular DOM)
        this.htmlContainer = new HtmlContainer(this.checkBoxElement, this.appRef, this.resolver, this.injector);
        this.checkboxComponentRef = this.htmlContainer.attach(CheckboxComponent);
    }
    handleChecboxInputs() {
        this.checkboxComponentRef.instance.id = this.checkBoxId ? '' + this.checkBoxId : this.tableCheckboxIdService.getUniqueId();
        this.checkboxComponentRef.instance.name = this.checkBoxName ? this.checkBoxName : undefined;
        this.checkboxComponentRef.instance.alone = true;
        this.setCheckBoxValue();
    }
    setCheckBoxValue() {
        this.checkboxComponentRef.instance.value = this.checkBoxValue;
    }
    handleCheckboxOutputs() {
        // Detect checkbox changes
        this.checkboxComponentRef.instance.registerOnChange(() => {
            this._toggleCheckbox();
        });
    }
    _toggleCheckbox() {
        this.checkBoxValueChange.emit(this.checkBoxValue);
    }
    getElement() {
        return this.checkBoxElement.querySelector('.wac-field-checkbox');
    }
    isActive() {
        return !!this.checkboxComponentRef.instance.value;
    }
    setActive(isActive) {
        this.checkboxComponentRef.instance.value = isActive; //? does not trigger output
    }
    ngOnDestroy() {
        this.htmlContainer.dispose();
    }
}
CheckBoxRow.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CheckBoxRow, deps: [{ token: i0.ElementRef }, { token: i0.ApplicationRef }, { token: i0.Renderer2 }, { token: DOCUMENT }, { token: i0.ComponentFactoryResolver }, { token: i0.Injector }, { token: TableCheckboxIdService }], target: i0.ɵɵFactoryTarget.Directive });
CheckBoxRow.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: CheckBoxRow, selector: "[checkBoxRow]", inputs: { checkBoxId: "checkBoxId", checkBoxName: "checkBoxName", checkBoxValue: "checkBoxValue" }, outputs: { checkBoxValueChange: "checkBoxValueChange" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CheckBoxRow, decorators: [{
            type: Directive,
            args: [{
                    selector: '[checkBoxRow]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ApplicationRef }, { type: i0.Renderer2 }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: i0.ComponentFactoryResolver }, { type: i0.Injector }, { type: TableCheckboxIdService }]; }, propDecorators: { checkBoxId: [{
                type: Input
            }], checkBoxName: [{
                type: Input
            }], checkBoxValue: [{
                type: Input
            }], checkBoxValueChange: [{
                type: Output
            }] } });

class MultiSelectionService {
    constructor() {
        this.activeChanges = new Subject();
        this.activeChanges$ = this.activeChanges.asObservable();
    }
    handle(items, toggleSingleItem = false) {
        if (!items || !items.first) {
            this.destroy();
            return;
        }
        this.destroy(); // close previous subsciption
        this.items = items;
        const clicks$ = this.getListeners();
        this.subscription = merge(...clicks$).subscribe(({ component, isShift: isShiftKeyPressed, index }) => {
            if (!isShiftKeyPressed) {
                if (toggleSingleItem) {
                    component.setActive(!component.isActive());
                }
                this.activeChanges.next([index]);
                this.lastIndex = index;
                return;
            }
            const start = index;
            const end = this.lastIndex;
            const [first, last] = [Math.min(start, end), Math.max(start, end) + 1];
            const itemsSelection = this.items.toArray().slice(first, last);
            const isBeginnerItemActive = this.items.get(end).isActive();
            itemsSelection.forEach(current => current.setActive(isBeginnerItemActive));
            window.getSelection().removeAllRanges(); // remove text selection
            const indexInRange = Array.from({ length: last - first }, (x, i) => i + first);
            this.activeChanges.next(indexInRange);
        });
    }
    getListeners() {
        return this.items.map((item, index) => {
            return fromEvent(item.getElement(), 'click').pipe(map((event) => {
                return {
                    index,
                    isShift: event.shiftKey,
                    component: item
                };
            }))
                .pipe(debounceTime(100)); // debounced, because when clicking on a wac-checkbox it is emitted twice and can not find why
        });
    }
    getActives() {
        return this.items.filter(item => item.isActive());
    }
    destroy() {
        this.subscription?.unsubscribe();
    }
}
MultiSelectionService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MultiSelectionService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MultiSelectionService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MultiSelectionService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MultiSelectionService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return []; } });

class TableRow {
    constructor(currentCell, renderer, document) {
        this.currentCell = currentCell;
        this.renderer = renderer;
        this.document = document;
    }
    ngAfterViewInit() {
        this.applyCustomStylesOnCell();
    }
    applyCustomStylesOnCell() {
        this.renderer.addClass(this.currentCell.nativeElement, 'wac-table__body__line');
    }
}
TableRow.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableRow, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Directive });
TableRow.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: TableRow, selector: "[tableRow]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableRow, decorators: [{
            type: Directive,
            args: [{
                    // The selector has the same name as the tableRaw selector in table.component.html
                    selector: '[tableRow]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; } });

class FiltersTableService {
    constructor(filterRoutingBuilder) {
        this.filterRoutingBuilder = filterRoutingBuilder;
        this.filterGroups = new Map();
        this.sortSubject = new Subject();
    }
    getTableFilterGroup(dataTableName) {
        if (this.filterGroups.has(dataTableName)) {
            return this.filterGroups.get(dataTableName);
        }
        const dataTableFilters = {
            sort: undefined,
            order: undefined,
            searchValue: undefined,
            totalItems: 0,
            itemsPerPage: 0,
            currentPage: 0
        };
        const filterGroup = this.filterRoutingBuilder.group(dataTableFilters, dataTableName);
        filterGroup.tableFiltersValuesChange$ = new ReplaySubject(1);
        filterGroup.tableFiltersValuesDebouncedChange$ = filterGroup.tableFiltersValuesChange$.pipe(debounceTime(300));
        this.filterGroups.set(dataTableName, filterGroup);
        return filterGroup;
    }
    /**
     * Use to reset the others sorts of the table
     * @param dataTableName
     * @param sortName
     * @param order
     */
    emitSortChange(dataTableName, sortName, order) {
        this.sortSubject.next({ dataTableName, sortName, order });
    }
    getSortChangeListner() {
        return this.sortSubject.asObservable();
    }
    setPaginationFilters(dataTableName, totalItems, itemsPerPage, currentPage) {
        const filterGroup = this.getTableFilterGroup(dataTableName);
        filterGroup.setValues({
            itemsPerPage,
            currentPage
        });
    }
    /*
      Add defaults filters in the URL if they not exists.
    */
    setInitialPaginationFiltersIfNotExist(dataTableName, itemsPerPage, currentPage) {
        const filterGroup = this.getTableFilterGroup(dataTableName);
        filterGroup.setValues({
            itemsPerPage: filterGroup.get('itemsPerPage') ? parseInt(filterGroup.get('itemsPerPage')) : itemsPerPage,
            currentPage: filterGroup.get('currentPage') ? parseInt(filterGroup.get('currentPage')) : currentPage
        });
    }
}
FiltersTableService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FiltersTableService, deps: [{ token: i3.NwbFilterRoutingBuilder }], target: i0.ɵɵFactoryTarget.Injectable });
FiltersTableService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FiltersTableService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FiltersTableService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i3.NwbFilterRoutingBuilder }]; } });

class PagniationIsLastPage {
    /**
     * Return true, if the current page is the last page. Otherwise, return false.
     * @param currentPage
     * @param totalItems
     * @param itemsPerPage
     */
    transform(currentPage, totalItems, itemsPerPage) {
        if (!(currentPage >= 0 && totalItems >= 0 && itemsPerPage >= 0)) {
            throw new Error('currentPage or totalItems or itemsPerPage is/are missing in PagniationIsLastPage pipe.');
        }
        return currentPage === Math.ceil(totalItems / itemsPerPage);
    }
}
PagniationIsLastPage.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PagniationIsLastPage, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
PagniationIsLastPage.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: PagniationIsLastPage, name: "IsLastPage" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PagniationIsLastPage, decorators: [{
            type: Pipe,
            args: [{
                    name: 'IsLastPage'
                }]
        }] });

class PagniationArrayTotalPages {
    /**
     * Return an incremental array corresponding with the number page
     * [ 1, 2, 3 ..., last page number ]
     * @param totalItems
     * @param itemsPerPage
     */
    transform(totalItems, itemsPerPage) {
        if (!(totalItems >= 0 && itemsPerPage >= 0)) {
            throw new Error('totalItems or itemsPerPage missing in ArrayTotalPages pipe.');
        }
        const arrayLength = Math.ceil(totalItems / itemsPerPage);
        return Array.apply(null, { length: arrayLength })
            .map(Number.call, Number)
            .map(x => x + 1);
    }
}
PagniationArrayTotalPages.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PagniationArrayTotalPages, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
PagniationArrayTotalPages.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: PagniationArrayTotalPages, name: "ArrayTotalPages" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PagniationArrayTotalPages, decorators: [{
            type: Pipe,
            args: [{
                    name: 'ArrayTotalPages'
                }]
        }] });

class PagniationText {
    constructor(translateService) {
        this.translateService = translateService;
    }
    /**
     * Update pagination text if at least one entrie change
     * @param currentPage
     * @param totalItems
     * @param itemsPerPage
     */
    transform(currentPage, totalItems, itemsPerPage) {
        let currentItemsLow = 0, currentItemsHigh = 0;
        if (totalItems) {
            currentItemsLow = (parseInt(currentPage) - 1) * parseInt(itemsPerPage) + 1;
            currentItemsHigh = parseInt(currentPage) * parseInt(itemsPerPage);
        }
        if (currentItemsHigh > totalItems) {
            currentItemsHigh = totalItems;
        }
        return this.translateService.get('wac.PaginationComponent.on', { low: currentItemsLow, high: currentItemsHigh, total: totalItems });
    }
}
PagniationText.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PagniationText, deps: [{ token: i1$2.TranslateService }], target: i0.ɵɵFactoryTarget.Pipe });
PagniationText.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: PagniationText, name: "customPagniationText" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PagniationText, decorators: [{
            type: Pipe,
            args: [{
                    name: 'customPagniationText'
                }]
        }], ctorParameters: function () { return [{ type: i1$2.TranslateService }]; } });

class PaginationComponent {
    set pagination(pagination) {
        this._pagination = pagination;
    }
    get pagination() {
        return this._pagination;
    }
    constructor() {
        this.pageChange = new EventEmitter();
    }
    decrementPage() {
        if (this.pagination.currentPage <= 1) {
            return;
        }
        this.pagination.currentPage--;
        this.pageChange.emit(this.pagination);
    }
    incrementPage() {
        const isLastPage = new PagniationIsLastPage().transform(this.pagination.currentPage, this.pagination.totalItems, this.pagination.itemsPerPage);
        if (isLastPage) {
            return;
        }
        this.pagination.currentPage++;
        this.pageChange.emit(this.pagination);
    }
    onGotoPageChange(event) {
        this.pagination.currentPage = parseInt(event.target.value);
        this.pageChange.emit(this.pagination);
    }
}
PaginationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PaginationComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
PaginationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: PaginationComponent, selector: "wac-pagination", inputs: { pagination: "pagination" }, outputs: { pageChange: "pageChange" }, ngImport: i0, template: "<div class=\"wac-pagination\" *ngIf=\"pagination && pagination.itemsPerPage\">\r\n  <div class=\"wac-pagination__wrapper\">\r\n    <div class=\"wac-pagination__wrapper__page\">\r\n      <p>{{ 'wac.PaginationComponent.page' | translate }}</p>\r\n\r\n      <select name=\"page\" (change)=\"onGotoPageChange($event)\">\r\n        <ng-container *ngFor=\"let pageIndex of pagination.totalItems | ArrayTotalPages: pagination.itemsPerPage\">\r\n          <option [selected]=\"pageIndex === pagination.currentPage\" [value]=\"pageIndex\">\r\n            {{ pageIndex }}\r\n          </option>\r\n        </ng-container>\r\n      </select>\r\n    </div>\r\n\r\n    <div class=\"wac-pagination__wrapper__elements\">\r\n      <p>{{ pagination.currentPage | customPagniationText: pagination.totalItems:pagination.itemsPerPage | async}}</p>\r\n    </div>\r\n\r\n    <div class=\"wac-pagination__wrapper__arrows\">\r\n      <div\r\n        (click)=\"decrementPage()\"\r\n        class=\"wac-pagination__wrapper__arrows__arrow wac-pagination__wrapper__arrows__arrow--left\"\r\n        [ngClass]=\"{ 'wac-pagination__wrapper__arrows__arrow--disabled': pagination.currentPage === 1 }\"\r\n      >\r\n        <span class=\"wac-pagination__wrapper__arrows__arrow__icon\"></span>\r\n      </div>\r\n      <div\r\n        (click)=\"incrementPage()\"\r\n        class=\"wac-pagination__wrapper__arrows__arrow wac-pagination__wrapper__arrows__arrow--right\"\r\n        [ngClass]=\"{\r\n          'wac-pagination__wrapper__arrows__arrow--disabled':\r\n            pagination.currentPage | IsLastPage: pagination.totalItems:pagination.itemsPerPage\r\n        }\"\r\n      >\r\n        <span class=\"wac-pagination__wrapper__arrows__arrow__icon\"></span>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "pipe", type: i1.AsyncPipe, name: "async" }, { kind: "pipe", type: i1$2.TranslatePipe, name: "translate" }, { kind: "pipe", type: PagniationArrayTotalPages, name: "ArrayTotalPages" }, { kind: "pipe", type: PagniationIsLastPage, name: "IsLastPage" }, { kind: "pipe", type: PagniationText, name: "customPagniationText" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PaginationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-pagination', template: "<div class=\"wac-pagination\" *ngIf=\"pagination && pagination.itemsPerPage\">\r\n  <div class=\"wac-pagination__wrapper\">\r\n    <div class=\"wac-pagination__wrapper__page\">\r\n      <p>{{ 'wac.PaginationComponent.page' | translate }}</p>\r\n\r\n      <select name=\"page\" (change)=\"onGotoPageChange($event)\">\r\n        <ng-container *ngFor=\"let pageIndex of pagination.totalItems | ArrayTotalPages: pagination.itemsPerPage\">\r\n          <option [selected]=\"pageIndex === pagination.currentPage\" [value]=\"pageIndex\">\r\n            {{ pageIndex }}\r\n          </option>\r\n        </ng-container>\r\n      </select>\r\n    </div>\r\n\r\n    <div class=\"wac-pagination__wrapper__elements\">\r\n      <p>{{ pagination.currentPage | customPagniationText: pagination.totalItems:pagination.itemsPerPage | async}}</p>\r\n    </div>\r\n\r\n    <div class=\"wac-pagination__wrapper__arrows\">\r\n      <div\r\n        (click)=\"decrementPage()\"\r\n        class=\"wac-pagination__wrapper__arrows__arrow wac-pagination__wrapper__arrows__arrow--left\"\r\n        [ngClass]=\"{ 'wac-pagination__wrapper__arrows__arrow--disabled': pagination.currentPage === 1 }\"\r\n      >\r\n        <span class=\"wac-pagination__wrapper__arrows__arrow__icon\"></span>\r\n      </div>\r\n      <div\r\n        (click)=\"incrementPage()\"\r\n        class=\"wac-pagination__wrapper__arrows__arrow wac-pagination__wrapper__arrows__arrow--right\"\r\n        [ngClass]=\"{\r\n          'wac-pagination__wrapper__arrows__arrow--disabled':\r\n            pagination.currentPage | IsLastPage: pagination.totalItems:pagination.itemsPerPage\r\n        }\"\r\n      >\r\n        <span class=\"wac-pagination__wrapper__arrows__arrow__icon\"></span>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { pagination: [{
                type: Input
            }], pageChange: [{
                type: Output
            }] } });

class TableComponent {
    constructor(filtersTableService, tableCheckboxIdService, multiSelectionService) {
        this.filtersTableService = filtersTableService;
        this.tableCheckboxIdService = tableCheckboxIdService;
        this.multiSelectionService = multiSelectionService;
        this.tableFiltersChange = new EventEmitter();
        this.placeholder = '';
        /// Input/Output of checkbox ///
        /** Pass to true to display checkbox in the header table */
        this.checkbox = false;
        this.toggleAllCheckBox = new EventEmitter(); // todo replace by checkBoxSelectionChange
        this.checkBoxSelectionChange = new EventEmitter(); // todo add to doc
        /// Input to disable section ///
        /** Pass to true to hide search input */
        this.disableSearch = false;
        /** Pass to true to hide the pagniator */
        this.disablePagniation = false;
        /// Input for loader on table body ///
        this.isLoading = false;
    }
    ngOnInit() {
        this.headerCheckBoxId = this.tableCheckboxIdService.getUniqueId(); // Create checkbox unique id
        /* Handle routing filters */
        if (this.tableRoutingName) {
            this.filtersTableService.setInitialPaginationFiltersIfNotExist(this.tableRoutingName, this.tableFilters.itemsPerPage, this.tableFilters.currentPage);
            this._tableFiltersGroup = this.filtersTableService.getTableFilterGroup(this.tableRoutingName);
            this.setTablesFilters();
            // Listen to filters changes with debounced time to limit multiple api calls
            this.filterGroupChangeSub = this._tableFiltersGroup.valuesChange$.subscribe(() => {
                this.setTablesFilters();
            });
        }
        this.multiSelectionService.activeChanges$.subscribe(selectionIndexRawCheckChange => {
            this.checkBoxSelectionChange.emit(selectionIndexRawCheckChange);
        });
    }
    ngAfterViewInit() {
        this.multiSelectionService.handle(this.checkBoxRows);
        this.checkBoxRows.changes.subscribe(() => {
            this.multiSelectionService.handle(this.checkBoxRows);
        });
    }
    onToggleAllCheckBox(event) {
        this.toggleAllCheckBox.emit(event.target.checked);
    }
    searchChange() {
        // Reset table filters
        this.tableFilters.sort = undefined;
        this.tableFilters.order = undefined;
        this.tableFilters.currentPage = 1;
        this.tableFiltersChange.emit(this.tableFilters);
        // Reset routing filters
        if (this._tableFiltersGroup) {
            this._tableFiltersGroup.setValues({
                searchValue: this.tableFilters.searchValue,
                sort: undefined,
                order: undefined,
                currentPage: 1
            });
        }
    }
    pageChange() {
        this.tableFiltersChange.emit(this.tableFilters);
        if (this._tableFiltersGroup) {
            this._tableFiltersGroup.setValues({
                itemsPerPage: this.tableFilters.itemsPerPage,
                currentPage: this.tableFilters.currentPage
            });
        }
    }
    /**
     *  Set tableFilters from routing data existing in the url
     * */
    setTablesFilters() {
        this.tableFilters = {
            sort: this._tableFiltersGroup.get('sort'),
            order: this._tableFiltersGroup.get('order') ? this._tableFiltersGroup.get('order') === 'true' : undefined,
            searchValue: this._tableFiltersGroup.get('searchValue'),
            itemsPerPage: this._tableFiltersGroup.get('itemsPerPage') ? parseInt(this._tableFiltersGroup.get('itemsPerPage')) : 0,
            currentPage: this._tableFiltersGroup.get('currentPage') ? parseInt(this._tableFiltersGroup.get('currentPage')) : 0,
            totalItems: this.tableFilters.totalItems
        };
        this.tableFiltersChange.emit(this.tableFilters);
        this._tableFiltersGroup.tableFiltersValuesChange$.next(this.tableFilters);
    }
    ngOnDestroy() {
        if (this.filterGroupChangeSub) {
            this.filterGroupChangeSub.unsubscribe();
        }
        this.multiSelectionService.destroy();
    }
}
TableComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableComponent, deps: [{ token: FiltersTableService }, { token: TableCheckboxIdService }, { token: MultiSelectionService }], target: i0.ɵɵFactoryTarget.Component });
TableComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TableComponent, selector: "wac-table", inputs: { tableFilters: "tableFilters", tableRoutingName: "tableRoutingName", placeholder: "placeholder", checkbox: "checkbox", disableSearch: "disableSearch", disablePagniation: "disablePagniation", isLoading: "isLoading" }, outputs: { tableFiltersChange: "tableFiltersChange", toggleAllCheckBox: "toggleAllCheckBox", checkBoxSelectionChange: "checkBoxSelectionChange" }, providers: [
        TableCheckboxIdService,
        MultiSelectionService
    ], queries: [{ propertyName: "checkBoxRows", predicate: CheckBoxRow }, { propertyName: "tableRows", predicate: TableRow }], ngImport: i0, template: "<div class=\"wac-table\">\r\n  <!-- Header section -->\r\n  <div class=\"wac-table__head\" id=\"headerTable\">\r\n    <div *ngIf=\"checkbox\" class=\"wac-table__head__cell wac-table__head__cell--checkbox\">\r\n      <wac-checkbox [id]=\"headerCheckBoxId\" (change)=\"onToggleAllCheckBox($event)\" [alone]=\"true\"></wac-checkbox>\r\n    </div>\r\n\r\n    <!-- Header contents are added with the headerCell directive -->\r\n    <ng-content select=\"[headerCell]\"></ng-content>\r\n  </div>\r\n\r\n  <!-- Search section -->\r\n  <div *ngIf=\"!disableSearch\" class=\"wac-table__search\">\r\n    <wac-input-search\r\n      [(ngModel)]=\"tableFilters.searchValue\"\r\n      (changeDebounced)=\"searchChange()\"\r\n      [placeholder]=\"placeholder\"\r\n      [smallPadding]=\"true\"\r\n    ></wac-input-search>\r\n  </div>\r\n\r\n  <!-- Body section -->\r\n  <div class=\"wac-table__body\">\r\n    <!-- Loader on body -->\r\n    <div class=\"wac-table__body__loader\" *ngIf=\"isLoading\">\r\n      <wac-loader [small]=\"true\"></wac-loader>\r\n    </div>\r\n    <!-- Body contents are added with the tableRow directive -->\r\n    <ng-content select=\".complex-table\" *ngIf=\"!isLoading\"></ng-content>\r\n    <ng-content select=\"[tableRow]\" *ngIf=\"!isLoading\"></ng-content>\r\n  </div>\r\n\r\n  <!-- Pagination section -->\r\n  <wac-pagination *ngIf=\"!disablePagniation\" [pagination]=\"tableFilters\" (pageChange)=\"pageChange()\"></wac-pagination>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: InputSearchComponent, selector: "wac-input-search", inputs: ["placeholder", "withoutgrey", "smallPadding", "id"], outputs: ["changeDebounced"] }, { kind: "component", type: LoaderComponent, selector: "wac-loader", inputs: ["text", "small"] }, { kind: "component", type: CheckboxComponent, selector: "wac-checkbox", inputs: ["label", "value", "type", "alone", "checked", "hasInput", "inputPlaceholder", "id", "name", "whiteSpace", "disabled"], outputs: ["valueChange"] }, { kind: "component", type: PaginationComponent, selector: "wac-pagination", inputs: ["pagination"], outputs: ["pageChange"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-table', encapsulation: ViewEncapsulation.None, providers: [
                        TableCheckboxIdService,
                        MultiSelectionService
                    ], template: "<div class=\"wac-table\">\r\n  <!-- Header section -->\r\n  <div class=\"wac-table__head\" id=\"headerTable\">\r\n    <div *ngIf=\"checkbox\" class=\"wac-table__head__cell wac-table__head__cell--checkbox\">\r\n      <wac-checkbox [id]=\"headerCheckBoxId\" (change)=\"onToggleAllCheckBox($event)\" [alone]=\"true\"></wac-checkbox>\r\n    </div>\r\n\r\n    <!-- Header contents are added with the headerCell directive -->\r\n    <ng-content select=\"[headerCell]\"></ng-content>\r\n  </div>\r\n\r\n  <!-- Search section -->\r\n  <div *ngIf=\"!disableSearch\" class=\"wac-table__search\">\r\n    <wac-input-search\r\n      [(ngModel)]=\"tableFilters.searchValue\"\r\n      (changeDebounced)=\"searchChange()\"\r\n      [placeholder]=\"placeholder\"\r\n      [smallPadding]=\"true\"\r\n    ></wac-input-search>\r\n  </div>\r\n\r\n  <!-- Body section -->\r\n  <div class=\"wac-table__body\">\r\n    <!-- Loader on body -->\r\n    <div class=\"wac-table__body__loader\" *ngIf=\"isLoading\">\r\n      <wac-loader [small]=\"true\"></wac-loader>\r\n    </div>\r\n    <!-- Body contents are added with the tableRow directive -->\r\n    <ng-content select=\".complex-table\" *ngIf=\"!isLoading\"></ng-content>\r\n    <ng-content select=\"[tableRow]\" *ngIf=\"!isLoading\"></ng-content>\r\n  </div>\r\n\r\n  <!-- Pagination section -->\r\n  <wac-pagination *ngIf=\"!disablePagniation\" [pagination]=\"tableFilters\" (pageChange)=\"pageChange()\"></wac-pagination>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: FiltersTableService }, { type: TableCheckboxIdService }, { type: MultiSelectionService }]; }, propDecorators: { checkBoxRows: [{
                type: ContentChildren,
                args: [CheckBoxRow]
            }], tableRows: [{
                type: ContentChildren,
                args: [TableRow]
            }], tableFilters: [{
                type: Input
            }], tableFiltersChange: [{
                type: Output
            }], tableRoutingName: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], checkbox: [{
                type: Input
            }], toggleAllCheckBox: [{
                type: Output
            }], checkBoxSelectionChange: [{
                type: Output
            }], disableSearch: [{
                type: Input
            }], disablePagniation: [{
                type: Input
            }], isLoading: [{
                type: Input
            }] } });

class TagComponent {
    constructor() {
        this.label = '';
        this.hasClose = false;
        this.draggable = false;
        this.big = false;
        this.isOpen = true;
        this.isOpenChange = new EventEmitter();
    }
    toggleTag() {
        this.isOpen = !this.isOpen;
        this.isOpenChange.next(this.isOpen);
    }
}
TagComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TagComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TagComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TagComponent, selector: "wac-tag", inputs: { label: "label", class: "class", hasClose: "hasClose", draggable: "draggable", big: "big", isOpen: "isOpen" }, outputs: { isOpenChange: "isOpenChange" }, ngImport: i0, template: "<div class=\"wac-tag\" [classList]=\"'wac-tag--' + class\" [ngClass]=\"{ hover: hasClose, 'big': big , draggable: draggable}\">\r\n    <div *ngIf=\"draggable\" class=\"wac-tag__draggable\">\r\n      <span>\r\n        <span></span>\r\n      </span>\r\n    </div>\r\n    {{ label }}\r\n    <span class=\"wac-tag__close\" *ngIf=\"hasClose\" (click)=\"toggleTag()\"><i class=\"fas fa-times\"></i></span>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TagComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-tag', template: "<div class=\"wac-tag\" [classList]=\"'wac-tag--' + class\" [ngClass]=\"{ hover: hasClose, 'big': big , draggable: draggable}\">\r\n    <div *ngIf=\"draggable\" class=\"wac-tag__draggable\">\r\n      <span>\r\n        <span></span>\r\n      </span>\r\n    </div>\r\n    {{ label }}\r\n    <span class=\"wac-tag__close\" *ngIf=\"hasClose\" (click)=\"toggleTag()\"><i class=\"fas fa-times\"></i></span>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { label: [{
                type: Input
            }], class: [{
                type: Input
            }], hasClose: [{
                type: Input
            }], draggable: [{
                type: Input
            }], big: [{
                type: Input
            }], isOpen: [{
                type: Input
            }], isOpenChange: [{
                type: Output
            }] } });

class TabComponent {
    set selected(value) {
        this._selected = value;
        this.changeDetectorRef.markForCheck();
    }
    get selected() {
        return this._selected;
    }
    get content() {
        return this.contentPortal;
    }
    constructor(changeDetectorRef, viewContainerRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.viewContainerRef = viewContainerRef;
        this._selected = false;
        this.contentPortal = null;
        this._explicitContent = undefined;
    }
    ngOnInit() {
        this.contentPortal = new TemplatePortal(this._explicitContent || this._implicitContent, this.viewContainerRef);
    }
}
TabComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TabComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Component });
TabComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TabComponent, isStandalone: true, selector: "wac-tab", inputs: { label: "label", selected: "selected" }, queries: [{ propertyName: "_explicitContent", first: true, predicate: TabComponent, descendants: true, read: TemplateRef, static: true }], viewQueries: [{ propertyName: "_implicitContent", first: true, predicate: TemplateRef, descendants: true, static: true }], ngImport: i0, template: "<ng-template><ng-content></ng-content></ng-template>", dependencies: [{ kind: "ngmodule", type: CommonModule }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TabComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-tab', encapsulation: ViewEncapsulation.None, standalone: true, imports: [CommonModule], changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-template><ng-content></ng-content></ng-template>" }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i0.ViewContainerRef }]; }, propDecorators: { label: [{
                type: Input
            }], selected: [{
                type: Input
            }], _explicitContent: [{
                type: ContentChild,
                args: [TabComponent, { read: TemplateRef, static: true }]
            }], _implicitContent: [{
                type: ViewChild,
                args: [TemplateRef, { static: true }]
            }] } });

class TabBodyDirective extends CdkPortalOutlet {
    constructor(componentFactoryResolver, viewContainerRef, document, host) {
        super(componentFactoryResolver, viewContainerRef, document);
        this.componentFactoryResolver = componentFactoryResolver;
        this.viewContainerRef = viewContainerRef;
        this.document = document;
        this.host = host;
    }
    ngOnInit() {
        super.ngOnInit();
        this.attach(this.host.content);
    }
}
TabBodyDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TabBodyDirective, deps: [{ token: i0.ComponentFactoryResolver }, { token: i0.ViewContainerRef }, { token: DOCUMENT }, { token: forwardRef(() => TabBodyComponent) }], target: i0.ɵɵFactoryTarget.Directive });
TabBodyDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: TabBodyDirective, isStandalone: true, selector: "[wacTabBody]", exportAs: ["wacTabBody"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TabBodyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacTabBody]',
                    exportAs: 'wacTabBody',
                    standalone: true,
                }]
        }], ctorParameters: function () { return [{ type: i0.ComponentFactoryResolver }, { type: i0.ViewContainerRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: TabBodyComponent, decorators: [{
                    type: Inject,
                    args: [forwardRef(() => TabBodyComponent)]
                }] }]; } });

class TabBodyComponent {
    get display() {
        return (this.active ? 'initial' : 'none');
    }
}
TabBodyComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TabBodyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TabBodyComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TabBodyComponent, isStandalone: true, selector: "wac-tab-body", inputs: { content: "content", active: "active" }, host: { properties: { "style.display": "this.display" } }, ngImport: i0, template: "<div class=\"wac-tab-body\" #content>\r\n  <ng-template wacTabBody></ng-template>\r\n</div>", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: TabBodyDirective, selector: "[wacTabBody]", exportAs: ["wacTabBody"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TabBodyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-tab-body', encapsulation: ViewEncapsulation.None, standalone: true, imports: [CommonModule, TabBodyDirective], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"wac-tab-body\" #content>\r\n  <ng-template wacTabBody></ng-template>\r\n</div>" }]
        }], propDecorators: { content: [{
                type: Input
            }], active: [{
                type: Input
            }], display: [{
                type: HostBinding,
                args: ['style.display']
            }] } });

class TabsComponent {
    get defaultViewModel() {
        return { index: 0, tabList: [], listIsOpen: false, selected: null };
    }
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.disabled = false;
        this.index$ = new BehaviorSubject(0);
        this.tabList$ = new ReplaySubject(1);
        this.listIsOpen$ = new BehaviorSubject(false);
        this.onChange = (selectedIndex) => { };
        this.onTouched = () => { };
        this.viewModel$ = combineLatest({
            index: this.index$,
            tabList: this.tabList$.pipe(switchMap((tabList) => {
                return tabList.changes.pipe(startWith(tabList));
            })),
            listIsOpen: this.listIsOpen$.pipe(distinctUntilChanged$1())
        }).pipe(delay(0), map$1((data) => {
            let selected = this.setIndex(data.index, data.tabList);
            this.changeDetectorRef.markForCheck();
            return { ...data, selected };
        }));
        this.underline = false;
        this.button = false;
        this.right = false;
        this.marginBottom = '30px';
        this.column = false;
    }
    ngAfterViewInit() {
        this.tabList$.next(this.tabList);
    }
    writeValue(selectedIndex) {
        if (!selectedIndex) {
            return;
        }
        this.index$.next(selectedIndex);
    }
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    onBlur() {
        this.onTouched();
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    setDisabledState(disabled) {
        this.disabled = disabled;
        this.changeDetectorRef.markForCheck();
    }
    selectTab(index) {
        this.index$.next(index);
    }
    setIndex(currentIndex, tabList) {
        let selected = null;
        tabList.forEach((tab, index) => {
            tab.selected = currentIndex === index;
            selected = (currentIndex === index ? tab : selected);
        });
        this.onChange(currentIndex);
        return selected;
    }
    openList($event) {
        $event?.stopPropagation();
        this.listIsOpen$.next(!this.listIsOpen$.getValue());
    }
}
TabsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TabsComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
TabsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TabsComponent, isStandalone: true, selector: "wac-tabs", inputs: { underline: "underline", button: "button", right: "right", marginBottom: "marginBottom", column: "column" }, providers: [
        { provide: NG_VALUE_ACCESSOR, useExisting: TabsComponent, multi: true },
    ], queries: [{ propertyName: "tabList", predicate: TabComponent }], ngImport: i0, template: "<div class=\"wac-tabs\"\r\n     *ngIf=\"((viewModel$ | async) || defaultViewModel ) as viewModel\"\r\n     [ngClass]=\"{'wac-tabs--underline': underline, 'wac-tabs--button' : button, 'wac-tabs--right' : right, 'wac-tabs--column' : column}\"\r\n     wzAutoHide\r\n     (clickOutside)=\"listIsOpen$.next(false)\"\r\n     [triggerElement]=\"'wac-select__header__selection'\"\r\n>\r\n  <div *ngIf=\"tabList.length > 1\" class=\"wac-tabs__mobile\" (click)=\"openList($event)\">\r\n    <div>{{ viewModel.selected?.label }}</div><i [class]=\"'fa-solid fa-caret-' + (viewModel.listIsOpen ? 'up' : 'down')\"></i>\r\n  </div>\r\n  <div *ngIf=\"tabList.length > 1\" class=\"wac-tabs__wrapper\" [ngClass]=\"{ 'open' : viewModel.listIsOpen }\" [ngStyle]=\"{'margin-bottom': marginBottom}\">\r\n    <a\r\n      *ngFor=\"let tab of tabList; let i = index\"\r\n      class=\"wac-tabs__wrapper__tab\"\r\n      [ngClass]=\"{'wac-tabs__wrapper__tab--selected': i === viewModel.index}\"\r\n      (click)=\"index$.next(i); listIsOpen$.next(false)\"\r\n    >\r\n      {{ tab.label }}\r\n    </a>\r\n  </div>\r\n  <wac-tab-body\r\n    *ngFor=\"let tab of tabList; let i = index\"\r\n    [content]=\"tab.content\"\r\n    [active]=\"i === viewModel.index\"\r\n  ></wac-tab-body>\r\n</div>\r\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "pipe", type: i1.AsyncPipe, name: "async" }, { kind: "ngmodule", type: FormsModule }, { kind: "ngmodule", type: SharedDirectives }, { kind: "directive", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: ["triggerElement", "forceOn"], outputs: ["clickOutside"] }, { kind: "component", type: TabBodyComponent, selector: "wac-tab-body", inputs: ["content", "active"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TabsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-tabs', encapsulation: ViewEncapsulation.None, standalone: true, imports: [CommonModule, FormsModule, TabComponent, SharedDirectives, TabBodyComponent], providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: TabsComponent, multi: true },
                    ], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"wac-tabs\"\r\n     *ngIf=\"((viewModel$ | async) || defaultViewModel ) as viewModel\"\r\n     [ngClass]=\"{'wac-tabs--underline': underline, 'wac-tabs--button' : button, 'wac-tabs--right' : right, 'wac-tabs--column' : column}\"\r\n     wzAutoHide\r\n     (clickOutside)=\"listIsOpen$.next(false)\"\r\n     [triggerElement]=\"'wac-select__header__selection'\"\r\n>\r\n  <div *ngIf=\"tabList.length > 1\" class=\"wac-tabs__mobile\" (click)=\"openList($event)\">\r\n    <div>{{ viewModel.selected?.label }}</div><i [class]=\"'fa-solid fa-caret-' + (viewModel.listIsOpen ? 'up' : 'down')\"></i>\r\n  </div>\r\n  <div *ngIf=\"tabList.length > 1\" class=\"wac-tabs__wrapper\" [ngClass]=\"{ 'open' : viewModel.listIsOpen }\" [ngStyle]=\"{'margin-bottom': marginBottom}\">\r\n    <a\r\n      *ngFor=\"let tab of tabList; let i = index\"\r\n      class=\"wac-tabs__wrapper__tab\"\r\n      [ngClass]=\"{'wac-tabs__wrapper__tab--selected': i === viewModel.index}\"\r\n      (click)=\"index$.next(i); listIsOpen$.next(false)\"\r\n    >\r\n      {{ tab.label }}\r\n    </a>\r\n  </div>\r\n  <wac-tab-body\r\n    *ngFor=\"let tab of tabList; let i = index\"\r\n    [content]=\"tab.content\"\r\n    [active]=\"i === viewModel.index\"\r\n  ></wac-tab-body>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { tabList: [{
                type: ContentChildren,
                args: [TabComponent]
            }], underline: [{
                type: Input
            }], button: [{
                type: Input
            }], right: [{
                type: Input
            }], marginBottom: [{
                type: Input
            }], column: [{
                type: Input
            }] } });

class ButtonComponent {
    set isLoading(isLoading) {
        this._isLoading = isLoading;
        this.isLoadingChange.next(isLoading);
        this.toggleLoading();
    }
    get isLoading() {
        return this._isLoading;
    }
    constructor(type, formGroup) {
        this.type = type;
        this.formGroup = formGroup;
        // todo add button type (ex: for submit and check if it works with template driven forms)
        this.extraClasses = 'is-info'; // todo make a list of existing class
        this.label = '';
        this.icon = '';
        this.isLoadingSvg = false;
        this.textcolor = null;
        this.widthAuto = false;
        this.contentHorizontalPosition = 'center';
        this.iconFontSize = 12;
        this.hasLoader = false;
        this.disabled = false;
        this.whiteSpaceNowrap = false;
        this.opacity = false;
        // TODO MAKE ANNIMATION AVAILABLE FOR MOBILE as CONFIRM DELETE DO (because, its doeant show the text and trigger click)
        this.animation = false;
        this.animationRight = false;
        this.animationText = '';
        this.confirmDelete = false;
        this.confirmDeleteText = '';
        this.noPadding = false;
        this.tooltipPosition = 'top-center';
        this.tooltipOneline = false;
        this.confirmDeletePosition = 'right';
        // eslint-disable-next-line @angular-eslint/no-output-native
        this.click = new EventEmitter();
        this.isLoadingChange = new EventEmitter();
        this._isLoading = false;
        this.interval = null;
        this.waitForConfirmDelete = false;
        this.buttonMaxWidth = '0px';
        this.buttonWidth = '0px';
        this.buttonMaxWidthDelete = '0px';
        this.buttonWidthDelete = '0px';
        this.currentLoading = 0;
    }
    ngOnInit() {
        if (this.confirmDelete) {
            this.waitForConfirmDelete = true;
        }
    }
    toggleLoading() {
        this.currentLoading = this.isLoading ? 10 : 100;
        interval(200).pipe(takeWhile(time => this.isLoading)).subscribe(() => {
            if (this.currentLoading < 85) {
                this.currentLoading += Math.floor(Math.random() * 15);
            }
        });
    }
    onButtonClickLoader() {
        this.isLoadingSvg = true;
    }
    addMaxWidth() {
        this.buttonMaxWidth = this.buttonWidth + 'px';
    }
    resetMaxWidth() {
        this.buttonMaxWidth = '0px';
    }
    addMaxWidthDelete() {
        this.buttonMaxWidthDelete = this.buttonWidthDelete + 'px';
    }
    resetMaxWidthDelete() {
        this.buttonMaxWidthDelete = '0px';
        this.waitForConfirmDelete = true;
    }
    onButtonClick(event) {
        event.stopPropagation();
        if (this.disabled) {
            return;
        }
        if (this.type === 'submit' && this.formGroup) { // Maybe there is a better way to handle submit
            this.formGroup.onSubmit(this.formGroup.value);
        }
        if (this.hasLoader) {
            this.isLoading = false;
            setTimeout(() => {
                this.isLoading = true;
            }, 0);
        }
        if (!this.waitForConfirmDelete) {
            this.click.emit(event);
            if (this.confirmDelete) {
                this.resetMaxWidthDelete();
            }
        }
        else {
            this.waitForConfirmDelete = false;
        }
    }
    ngAfterViewInit() {
        setTimeout(() => {
            if (this.animation) {
                this.buttonWidth = this.calculWidth.nativeElement.offsetWidth;
            }
            if (this.confirmDelete) {
                this.buttonWidthDelete = this.calculWidthDelete.nativeElement.offsetWidth;
            }
        }, 1000);
    }
}
ButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ButtonComponent, deps: [{ token: 'type', attribute: true }, { token: FormGroupDirective, optional: true }], target: i0.ɵɵFactoryTarget.Component });
ButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ButtonComponent, selector: "wac-button", inputs: { extraClasses: "extraClasses", label: "label", icon: "icon", isLoadingSvg: "isLoadingSvg", iconNext: "iconNext", textcolor: "textcolor", colorIcon: "colorIcon", widthAuto: "widthAuto", contentHorizontalPosition: "contentHorizontalPosition", iconFontSize: "iconFontSize", hasLoader: "hasLoader", disabled: "disabled", whiteSpaceNowrap: "whiteSpaceNowrap", opacity: "opacity", animation: "animation", animationRight: "animationRight", animationText: "animationText", confirmDelete: "confirmDelete", confirmDeleteText: "confirmDeleteText", coin: "coin", tooltip: "tooltip", tooltipWidth: "tooltipWidth", borderColor: "borderColor", noPadding: "noPadding", tooltipPosition: "tooltipPosition", tooltipOneline: "tooltipOneline", confirmDeletePosition: "confirmDeletePosition", isLoading: "isLoading" }, outputs: { click: "click", isLoadingChange: "isLoadingChange" }, viewQueries: [{ propertyName: "calculWidth", first: true, predicate: ["calculWidth"], descendants: true }, { propertyName: "calculWidthDelete", first: true, predicate: ["calculWidthDelete"], descendants: true }], ngImport: i0, template: "<a\r\n  [class]=\"'wac-button ' + extraClasses\"\r\n  [style.borderColor]=\"borderColor ? borderColor + '!important' : ''\"\r\n  (click)=\"confirmDelete && waitForConfirmDelete ? addMaxWidthDelete() : '';onButtonClick($event);\"\r\n  (mouseleave)=\"animation ? resetMaxWidth() : '';\"\r\n  (mouseenter)=\"animation ? addMaxWidth() : '';\"\r\n  wzAutoHide (clickOutside)=\"confirmDelete && !waitForConfirmDelete ? resetMaxWidthDelete() : ''\"\r\n  [ngClass]=\"[\r\n    label === '' ? 'alone' : '',\r\n    coin ? 'has-coin width-auto' : '',\r\n    animationRight ? 'animation-right' : '',\r\n    animation ? 'animationText' : '',\r\n    isLoading ? 'is-loading' : '',\r\n    opacity ? 'opacity' : '',\r\n    disabled ? 'disabled' : '',\r\n    widthAuto ? 'width-auto' : '',\r\n    noPadding ? 'no-padding' : '',\r\n    whiteSpaceNowrap ? 'white-space-no-wrap' : '',\r\n    !waitForConfirmDelete && confirmDelete ? 'step-delete' : '',\r\n    confirmDelete ? 'deletePosition-' + confirmDeletePosition : ''\r\n    ]\"\r\n    [ngStyle]=\"{\r\n      'text-align': contentHorizontalPosition\r\n    }\"\r\n>\r\n  <span class=\"wac-button__wrapper\" [style.color]=\"textcolor ? textcolor : ''\" [ngClass]=\"{'loading-class': isLoadingSvg}\">\r\n    <svg *ngIf=\"isLoadingSvg; else iconTemplate\" version=\"1.1\" id=\"loader-1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" x=\"0px\" y=\"0px\"\r\n     width=\"20px\" height=\"20px\" viewBox=\"0 0 50 50\" style=\"enable-background:new 0 0 50 50;\" xml:space=\"preserve\">\r\n      <path fill=\"#fff\" d=\"M43.935,25.145c0-10.318-8.364-18.683-18.683-18.683c-10.318,0-18.683,8.365-18.683,18.683h4.068c0-8.071,6.543-14.615,14.615-14.615c8.072,0,14.615,6.543,14.615,14.615H43.935z\">\r\n        <animateTransform attributeType=\"xml\"\r\n          attributeName=\"transform\"\r\n          type=\"rotate\"\r\n          from=\"0 25 25\"\r\n          to=\"360 25 25\"\r\n          dur=\"0.6s\"\r\n          repeatCount=\"indefinite\"/>\r\n      </path>\r\n    </svg>\r\n    <ng-template #iconTemplate>\r\n      <i *ngIf=\"icon\" [ngClass]=\"icon\" [style.color]=\"colorIcon\" [style.font-size.px]=\"iconFontSize\"></i>\r\n    </ng-template>\r\n    {{ label }}\r\n    <i *ngIf=\"iconNext\" [style.color]=\"colorIcon\" [ngClass]=\"iconNext\" [style.font-size.px]=\"iconFontSize\"></i>\r\n  </span>\r\n  <span class=\"wac-button__animation\" [style.maxWidth]=\"buttonMaxWidth\" [style.width]=\"buttonWidth + 'px'\">\r\n    <span #calculWidth class=\"wac-button__animation__text\" [innerHTML]=\"animationText\"></span>\r\n  </span>\r\n  <span class=\"wac-button__confirmDelete\" [style.maxWidth]=\"buttonMaxWidthDelete\" [style.width]=\"buttonWidthDelete + 'px'\">\r\n    <span #calculWidthDelete class=\"wac-button__confirmDelete__text\" [innerHTML]=\"confirmDeleteText\"></span>\r\n  </span>\r\n  <span *ngIf=\"coin\" class=\"wac-button__coin\"><i class=\"fa-solid fa-coin-front\"></i><span [innerHTML]=\"coin\"></span></span>\r\n  <span\r\n    class=\"wac-button__loader\"\r\n    [ngClass]=\"extraClasses.includes('is-outlined') ? 'outlined' : ''\"\r\n    *ngIf=\"isLoading\"\r\n    [style.width]=\"currentLoading + '%'\"\r\n  >\r\n  </span>\r\n  <span class=\"wac-button__tooltips {{ tooltipPosition }}\" [ngClass]=\"{'oneline': tooltipOneline}\" [style.minWidth]=\"tooltipWidth\" *ngIf=\"tooltip\">\r\n    {{ tooltip }}\r\n  </span>\r\n</a>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: ["triggerElement", "forceOn"], outputs: ["clickOutside"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-button', template: "<a\r\n  [class]=\"'wac-button ' + extraClasses\"\r\n  [style.borderColor]=\"borderColor ? borderColor + '!important' : ''\"\r\n  (click)=\"confirmDelete && waitForConfirmDelete ? addMaxWidthDelete() : '';onButtonClick($event);\"\r\n  (mouseleave)=\"animation ? resetMaxWidth() : '';\"\r\n  (mouseenter)=\"animation ? addMaxWidth() : '';\"\r\n  wzAutoHide (clickOutside)=\"confirmDelete && !waitForConfirmDelete ? resetMaxWidthDelete() : ''\"\r\n  [ngClass]=\"[\r\n    label === '' ? 'alone' : '',\r\n    coin ? 'has-coin width-auto' : '',\r\n    animationRight ? 'animation-right' : '',\r\n    animation ? 'animationText' : '',\r\n    isLoading ? 'is-loading' : '',\r\n    opacity ? 'opacity' : '',\r\n    disabled ? 'disabled' : '',\r\n    widthAuto ? 'width-auto' : '',\r\n    noPadding ? 'no-padding' : '',\r\n    whiteSpaceNowrap ? 'white-space-no-wrap' : '',\r\n    !waitForConfirmDelete && confirmDelete ? 'step-delete' : '',\r\n    confirmDelete ? 'deletePosition-' + confirmDeletePosition : ''\r\n    ]\"\r\n    [ngStyle]=\"{\r\n      'text-align': contentHorizontalPosition\r\n    }\"\r\n>\r\n  <span class=\"wac-button__wrapper\" [style.color]=\"textcolor ? textcolor : ''\" [ngClass]=\"{'loading-class': isLoadingSvg}\">\r\n    <svg *ngIf=\"isLoadingSvg; else iconTemplate\" version=\"1.1\" id=\"loader-1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" x=\"0px\" y=\"0px\"\r\n     width=\"20px\" height=\"20px\" viewBox=\"0 0 50 50\" style=\"enable-background:new 0 0 50 50;\" xml:space=\"preserve\">\r\n      <path fill=\"#fff\" d=\"M43.935,25.145c0-10.318-8.364-18.683-18.683-18.683c-10.318,0-18.683,8.365-18.683,18.683h4.068c0-8.071,6.543-14.615,14.615-14.615c8.072,0,14.615,6.543,14.615,14.615H43.935z\">\r\n        <animateTransform attributeType=\"xml\"\r\n          attributeName=\"transform\"\r\n          type=\"rotate\"\r\n          from=\"0 25 25\"\r\n          to=\"360 25 25\"\r\n          dur=\"0.6s\"\r\n          repeatCount=\"indefinite\"/>\r\n      </path>\r\n    </svg>\r\n    <ng-template #iconTemplate>\r\n      <i *ngIf=\"icon\" [ngClass]=\"icon\" [style.color]=\"colorIcon\" [style.font-size.px]=\"iconFontSize\"></i>\r\n    </ng-template>\r\n    {{ label }}\r\n    <i *ngIf=\"iconNext\" [style.color]=\"colorIcon\" [ngClass]=\"iconNext\" [style.font-size.px]=\"iconFontSize\"></i>\r\n  </span>\r\n  <span class=\"wac-button__animation\" [style.maxWidth]=\"buttonMaxWidth\" [style.width]=\"buttonWidth + 'px'\">\r\n    <span #calculWidth class=\"wac-button__animation__text\" [innerHTML]=\"animationText\"></span>\r\n  </span>\r\n  <span class=\"wac-button__confirmDelete\" [style.maxWidth]=\"buttonMaxWidthDelete\" [style.width]=\"buttonWidthDelete + 'px'\">\r\n    <span #calculWidthDelete class=\"wac-button__confirmDelete__text\" [innerHTML]=\"confirmDeleteText\"></span>\r\n  </span>\r\n  <span *ngIf=\"coin\" class=\"wac-button__coin\"><i class=\"fa-solid fa-coin-front\"></i><span [innerHTML]=\"coin\"></span></span>\r\n  <span\r\n    class=\"wac-button__loader\"\r\n    [ngClass]=\"extraClasses.includes('is-outlined') ? 'outlined' : ''\"\r\n    *ngIf=\"isLoading\"\r\n    [style.width]=\"currentLoading + '%'\"\r\n  >\r\n  </span>\r\n  <span class=\"wac-button__tooltips {{ tooltipPosition }}\" [ngClass]=\"{'oneline': tooltipOneline}\" [style.minWidth]=\"tooltipWidth\" *ngIf=\"tooltip\">\r\n    {{ tooltip }}\r\n  </span>\r\n</a>\r\n" }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Attribute,
                    args: ['type']
                }] }, { type: i2.FormGroupDirective, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [FormGroupDirective]
                }] }]; }, propDecorators: { extraClasses: [{
                type: Input
            }], label: [{
                type: Input
            }], icon: [{
                type: Input
            }], isLoadingSvg: [{
                type: Input
            }], iconNext: [{
                type: Input
            }], textcolor: [{
                type: Input
            }], colorIcon: [{
                type: Input
            }], widthAuto: [{
                type: Input
            }], contentHorizontalPosition: [{
                type: Input
            }], iconFontSize: [{
                type: Input
            }], hasLoader: [{
                type: Input
            }], disabled: [{
                type: Input
            }], whiteSpaceNowrap: [{
                type: Input
            }], opacity: [{
                type: Input
            }], animation: [{
                type: Input
            }], animationRight: [{
                type: Input
            }], animationText: [{
                type: Input
            }], confirmDelete: [{
                type: Input
            }], confirmDeleteText: [{
                type: Input
            }], coin: [{
                type: Input
            }], tooltip: [{
                type: Input
            }], tooltipWidth: [{
                type: Input
            }], borderColor: [{
                type: Input
            }], noPadding: [{
                type: Input
            }], tooltipPosition: [{
                type: Input
            }], tooltipOneline: [{
                type: Input
            }], confirmDeletePosition: [{
                type: Input
            }], click: [{
                type: Output
            }], isLoading: [{
                type: Input
            }], isLoadingChange: [{
                type: Output
            }], calculWidth: [{
                type: ViewChild,
                args: ['calculWidth']
            }], calculWidthDelete: [{
                type: ViewChild,
                args: ['calculWidthDelete']
            }] } });

class InfoComponent {
    get isColorPickerEnabled() {
        return this.colorPicker === true || this.colorPicker === 'true';
    }
    constructor() {
        this.colorPicker = false;
    }
}
InfoComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: InfoComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
InfoComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: InfoComponent, selector: "wac-info", inputs: { colorPicker: "colorPicker" }, ngImport: i0, template: "<div class=\"wac-info\" [ngClass]=\"{'wac-info__color-picker': isColorPickerEnabled}\">\r\n  <div class=\"wac-info__wrapper\">\r\n    <i class=\"fas fa-info-circle\"></i>\r\n    <div class=\"wac-info__wrapper__sublevel\">\r\n      <div class=\"wac-info__wrapper__sublevel__container\">\r\n        <ng-content></ng-content>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: InfoComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-info', template: "<div class=\"wac-info\" [ngClass]=\"{'wac-info__color-picker': isColorPickerEnabled}\">\r\n  <div class=\"wac-info__wrapper\">\r\n    <i class=\"fas fa-info-circle\"></i>\r\n    <div class=\"wac-info__wrapper__sublevel\">\r\n      <div class=\"wac-info__wrapper__sublevel__container\">\r\n        <ng-content></ng-content>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { colorPicker: [{
                type: Input
            }] } });

class SettingsComponent {
    constructor() { }
}
SettingsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SettingsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SettingsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SettingsComponent, selector: "wac-settings", ngImport: i0, template: "<div class=\"wac-settings\">\r\n  <div class=\"wac-settings__wrapper\">\r\n    <i class=\"fas fa-cog\"></i>\r\n  </div>\r\n</div>\r\n", encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SettingsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-settings', encapsulation: ViewEncapsulation.None, template: "<div class=\"wac-settings\">\r\n  <div class=\"wac-settings__wrapper\">\r\n    <i class=\"fas fa-cog\"></i>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; } });

class DeleteComponent {
    constructor() { }
}
DeleteComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DeleteComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DeleteComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: DeleteComponent, selector: "wac-delete", ngImport: i0, template: "<div class=\"wac-delete\">\r\n  <div class=\"wac-delete__wrapper\">\r\n    <i class=\"fas fa-trash\"></i>\r\n  </div>\r\n</div>\r\n" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DeleteComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-delete', template: "<div class=\"wac-delete\">\r\n  <div class=\"wac-delete__wrapper\">\r\n    <i class=\"fas fa-trash\"></i>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; } });

class DropdownComponent {
    constructor() {
        this.hasIcons = false;
        this.items = [];
        this.userInput = new EventEmitter();
    }
    onUserInput(itemIndex) {
        this.userInput.emit(itemIndex);
    }
}
DropdownComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DropdownComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DropdownComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: DropdownComponent, selector: "wac-dropdown", inputs: { hasIcons: "hasIcons", items: "items" }, outputs: { userInput: "userInput" }, ngImport: i0, template: "<div class=\"wac-dropdown\">\r\n  <div class=\"wac-dropdown__wrapper\">\r\n    <i class=\"wac-dropdown__wrapper__icon far fa-ellipsis-v\"></i>\r\n    <div class=\"wac-dropdown__wrapper__sublevel\">\r\n      <ul class=\"wac-dropdown__wrapper__sublevel__container\">\r\n        <li\r\n          *ngFor=\"let item of items\"\r\n          class=\"wac-dropdown__wrapper__sublevel__container__item\"\r\n          (click)=\"onUserInput(item.index)\"\r\n        >\r\n          <i\r\n            *ngIf=\"hasIcons\"\r\n            [class]=\"item.icon\"\r\n            [style.font-size.px]=\"item.iconFontSize ? item.iconFontSize : '14'\"\r\n          ></i>\r\n          <span>{{ item.label }}</span>\r\n        </li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DropdownComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-dropdown', template: "<div class=\"wac-dropdown\">\r\n  <div class=\"wac-dropdown__wrapper\">\r\n    <i class=\"wac-dropdown__wrapper__icon far fa-ellipsis-v\"></i>\r\n    <div class=\"wac-dropdown__wrapper__sublevel\">\r\n      <ul class=\"wac-dropdown__wrapper__sublevel__container\">\r\n        <li\r\n          *ngFor=\"let item of items\"\r\n          class=\"wac-dropdown__wrapper__sublevel__container__item\"\r\n          (click)=\"onUserInput(item.index)\"\r\n        >\r\n          <i\r\n            *ngIf=\"hasIcons\"\r\n            [class]=\"item.icon\"\r\n            [style.font-size.px]=\"item.iconFontSize ? item.iconFontSize : '14'\"\r\n          ></i>\r\n          <span>{{ item.label }}</span>\r\n        </li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { hasIcons: [{
                type: Input
            }], items: [{
                type: Input
            }], userInput: [{
                type: Output
            }] } });

class ImageComponent {
    constructor() {
        this.src = '';
    }
}
ImageComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ImageComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ImageComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ImageComponent, selector: "wac-image", inputs: { src: "src" }, ngImport: i0, template: "<div class=\"wac-image\">\r\n  <div class=\"wac-image__wrapper\" [ngClass]=\"src === '' ? 'empty' : ''\" [style.background-image]=\"'url(' + src + ')'\">\r\n    <i class=\"fal fa-images\" *ngIf=\"src === ''\"></i>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ImageComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-image', template: "<div class=\"wac-image\">\r\n  <div class=\"wac-image__wrapper\" [ngClass]=\"src === '' ? 'empty' : ''\" [style.background-image]=\"'url(' + src + ')'\">\r\n    <i class=\"fal fa-images\" *ngIf=\"src === ''\"></i>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { src: [{
                type: Input
            }] } });

class BackComponent {
    constructor() { }
}
BackComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BackComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BackComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: BackComponent, selector: "wac-back", ngImport: i0, template: "<div class=\"wac-back\">\r\n  <div class=\"wac-back__wrapper\">\r\n    <i class=\"fas fa-chevron-left\"></i>\r\n  </div>\r\n</div>\r\n" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BackComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-back', template: "<div class=\"wac-back\">\r\n  <div class=\"wac-back__wrapper\">\r\n    <i class=\"fas fa-chevron-left\"></i>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; } });

class SeparatorComponent {
    constructor() {
        this.dashed = false;
    }
}
SeparatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SeparatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SeparatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SeparatorComponent, selector: "wac-separator", inputs: { dashed: "dashed" }, ngImport: i0, template: "<div class=\"wac-separator\" [ngClass]=\"dashed ? 'dashed' : ''\"></div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SeparatorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-separator', encapsulation: ViewEncapsulation.None, template: "<div class=\"wac-separator\" [ngClass]=\"dashed ? 'dashed' : ''\"></div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { dashed: [{
                type: Input
            }] } });

class LogoComponent {
    constructor() {
        this.isDropizi = false;
        this.isWhite = false;
    }
}
LogoComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: LogoComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
LogoComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: LogoComponent, selector: "wac-logo", inputs: { isDropizi: "isDropizi", isWhite: "isWhite" }, ngImport: i0, template: "<div class=\"wac-logo\">\r\n  <div class=\"wac-logo__wrapper\" [ngClass]=\"isWhite ? 'white' : ''\" *ngIf=\"isDropizi\">\r\n    <svg id=\"Calque_1\" data-name=\"Calque 1\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 102.33 40\">\r\n      <defs>\r\n        <style>\r\n          .cls-0 {\r\n            fill: #fa096a;\r\n          }\r\n        </style>\r\n      </defs>\r\n      <title>Logo_Dropizi</title>\r\n      <path\r\n        id=\"Logo_Dropizi-2\"\r\n        data-name=\"Logo Dropizi-2\"\r\n        class=\"cls-0\"\r\n        d=\"M83,44.94a4.87,4.87,0,0,1-4.36-7,3.81,3.81,0,0,1-.72-2l-.3-5.69a9.61,9.61,0,0,1-3.43,2,13.51,13.51,0,0,1-3.34.63l-1.06,0L70,36.29a3.75,3.75,0,0,1-3.54,3.94l-2.25.11H64a3.69,3.69,0,0,1-3-1.56,12.82,12.82,0,0,1-7.68,2.61,13.45,13.45,0,0,1-5.37-1.14,3.67,3.67,0,0,1-2.46,1.09l-2.15.12h-.2a3.76,3.76,0,0,1-3.17-1.74l-3.29-5.25L36.84,38a3.78,3.78,0,0,1-1,2.7A3.74,3.74,0,0,1,33.28,42L31,42.09h-.19a3.77,3.77,0,0,1-3.06-1.58,12.62,12.62,0,0,1-1.62.87,15,15,0,0,1-5.35,1.24L13.49,43H13.3a3.76,3.76,0,0,1-3.74-3.54L8.5,19.3A3.75,3.75,0,0,1,12,15.36L19.37,15c.3,0,.59,0,.88,0a14.67,14.67,0,0,1,4.56.7,13.17,13.17,0,0,1,1.74.7,3.73,3.73,0,0,1,3.06-1.91l7.14-.37c.35,0,.69,0,1,0,3.65,0,6,1.12,7.41,2.57A13.29,13.29,0,0,1,49,14.33a12.05,12.05,0,0,1,4.44-.82c.23,0,.45,0,.69,0a13.63,13.63,0,0,1,5.2,1.35l.22.11a3.75,3.75,0,0,1,3.25-2.29l5.32-.27c.7,0,1.38-.06,2-.06.92,0,1.78,0,2.57.11a10.17,10.17,0,0,1,4.16,1.26l.37.24a3.78,3.78,0,0,1,3.22-2.2l2.18-.12h.2a3.89,3.89,0,0,1,2,.57,3.63,3.63,0,0,1,2.07-.79l12.9-.67h.11c0-.24-.07-.47-.09-.71a4.88,4.88,0,0,1,4.62-5.12h.25a4.86,4.86,0,0,1,4.88,4.62v.26A4.89,4.89,0,0,1,109,12a3.62,3.62,0,0,1,.72,2l1.06,20.14,0,0a3.75,3.75,0,0,1-3.54,3.94l-2.18.11h-.2a3.83,3.83,0,0,1-2-.57,3.54,3.54,0,0,1-2.06.78l-12.9.68h-.1c0,.24.07.47.09.71a4.87,4.87,0,0,1-1.25,3.51,4.82,4.82,0,0,1-3.37,1.6Zm-2-4.87v.11a2,2,0,0,0,2.1,1.9h0a2,2,0,0,0,1.9-2V40a2,2,0,0,0-2-1.9H83A2,2,0,0,0,81.05,40.07ZM19.54,17.84l-7.34.39a.89.89,0,0,0-.84.93l1.06,20.17a.89.89,0,0,0,.92.83l7.33-.39a11.89,11.89,0,0,0,4.32-1,9.7,9.7,0,0,0,3.3-2.36,8.91,8.91,0,0,0,1.46-2.14L30,38.4a.88.88,0,0,0,.92.84l2.25-.12A.88.88,0,0,0,34,38.2h0l-.34-6.38a.88.88,0,0,1,.84-.93h0l2.67-.14a.89.89,0,0,1,.8.41l4.41,7a.92.92,0,0,0,.8.42l2.17-.12a.88.88,0,0,0,.72-1.34l-4.25-7A.88.88,0,0,1,42,29c.22-.18.44-.37.64-.56a10.07,10.07,0,0,0,.5,3,9.65,9.65,0,0,0,2,3.45,11.39,11.39,0,0,0,3.45,2.5,10,10,0,0,0,8.09.47,11,11,0,0,0,6.08-6l.08-.18.26,4.91a.89.89,0,0,0,.92.84l2.25-.12a.89.89,0,0,0,.84-.92L66.86,31a.87.87,0,0,1,.83-.92h0l3-.16a10.49,10.49,0,0,0,2.6-.5A6.87,6.87,0,0,0,75.75,28a6.67,6.67,0,0,0,1.68-2.36l0-.12A8.77,8.77,0,0,0,78,21.73a9,9,0,0,0-.77-3.49,4.1,4.1,0,0,0-.22-.41,4.71,4.71,0,0,0-1.63-1.63,7.28,7.28,0,0,0-3-.87,28.9,28.9,0,0,0-4.16,0l-5.33.28a.86.86,0,0,0-.61.29.9.9,0,0,0-.22.63L62.33,21a10.85,10.85,0,0,0-.8-1A11.54,11.54,0,0,0,54,16.38,9.3,9.3,0,0,0,50,17a10.46,10.46,0,0,0-3.46,2.22,11.5,11.5,0,0,0-1.92,2.41q-1-5.05-7.73-4.7l-7.14.37a.88.88,0,0,0-.84.93l.22,4.15a9.5,9.5,0,0,0-5.19-4,12.2,12.2,0,0,0-3.65-.56C20.05,17.82,19.79,17.82,19.54,17.84Zm63.22-3.31-2.17.12a.9.9,0,0,0-.61.29.87.87,0,0,0-.23.64l1.06,20.15a.88.88,0,0,0,.93.84L84,36.45a.83.83,0,0,0,.61-.29.87.87,0,0,0,.23-.63l-1-20.09a1,1,0,0,0-1-.9Zm11.48,3.85a.9.9,0,0,1,.07.87L86.94,35a.88.88,0,0,0,.06.86.85.85,0,0,0,.76.4l12.9-.67h0a.76.76,0,0,0,.72-.8h0l-.13-2.48a.75.75,0,0,0-.8-.72l-6.21.33a.89.89,0,0,1-.84-1.26l7.37-15.74a.9.9,0,0,0-.07-.87.87.87,0,0,0-.78-.39L87,14.31a.75.75,0,0,0-.71.8l.13,2.49a.74.74,0,0,0,.25.52.75.75,0,0,0,.55.2L93.46,18h.05A.89.89,0,0,1,94.24,18.38ZM106,13.31l-2.24.12a.89.89,0,0,0-.85.93l.85,16.15v.1l.2,3.83a1,1,0,0,0,1,.91l2.18-.11h0a.9.9,0,0,0,.83-.93l-1.06-20.16a.88.88,0,0,0-.88-.84Zm-3.32-3.5v.1a2,2,0,0,0,4-.1V9.7a2,2,0,0,0-2-1.9h-.1a2,2,0,0,0-1.91,2ZM16.25,35.28l-.66-12.51a.87.87,0,0,1,.23-.64.83.83,0,0,1,.61-.29l3.3-.18a6,6,0,0,1,4.87,1.62,7.74,7.74,0,0,1,1.92,5.19,7.71,7.71,0,0,1-1.37,5.35A6,6,0,0,1,20.47,36l-3.31.17h0a.88.88,0,0,1-.88-.84Zm36.61-.55A6.9,6.9,0,0,1,48,32.44a5.3,5.3,0,0,1-1.12-2.17,6.7,6.7,0,0,1-.09-2.6,11,11,0,0,1,2.57-5.41,6.42,6.42,0,0,1,2.07-1.58,5.52,5.52,0,0,1,2.4-.52,6.36,6.36,0,0,1,2.64.66,5.45,5.45,0,0,1,3.3,3.78A8.32,8.32,0,0,1,59,30.1a10.69,10.69,0,0,1-1.66,2.54,6.76,6.76,0,0,1-2.07,1.57,5.42,5.42,0,0,1-2.31.52.27.27,0,0,1-.09,0Zm-19.2-7.84a.83.83,0,0,1-.29-.61l-.26-4.91a.87.87,0,0,1,.83-.92l2.22-.12a5.2,5.2,0,0,1,3.39.63,3.08,3.08,0,0,1,1,2.41,3.29,3.29,0,0,1-.8,2.6,5.23,5.23,0,0,1-3.43,1l-2.07.11h0a.89.89,0,0,1-.59-.23Zm32.93-1.41-.31-5.84a.9.9,0,0,1,.23-.64.86.86,0,0,1,.61-.29l2.4-.12a8.81,8.81,0,0,1,2,.09,3.1,3.1,0,0,1,1.33.57,2.58,2.58,0,0,1,.75,1.09A6.22,6.22,0,0,1,73.94,22a4.16,4.16,0,0,1-.79,3.14A4.63,4.63,0,0,1,70,26.19l-2.51.13h0a.9.9,0,0,1-.89-.84Z\"\r\n        transform=\"translate(-8.49 -4.94)\"\r\n      />\r\n    </svg>\r\n  </div>\r\n  <div class=\"wac-logo__wrapper\" [ngClass]=\"isWhite ? 'white' : ''\" *ngIf=\"!isDropizi\">\r\n    <svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 128.044 40\">\r\n      <defs>\r\n        <style>\r\n          .cls-1 {\r\n            fill: #a4c445;\r\n          }\r\n          .cls-2 {\r\n            fill: #52aecd;\r\n          }\r\n        </style>\r\n      </defs>\r\n      <g id=\"Logo_WiziShop\" transform=\"translate(0.024 0)\">\r\n        <path\r\n          id=\"Shop\"\r\n          class=\"cls-1\"\r\n          d=\"M50.812,38.431V12.3a2.468,2.468,0,0,1,2.452-1.643A2.307,2.307,0,0,1,55.446,12a7.058,7.058,0,0,1,4.107-1.348A5.245,5.245,0,0,1,63.218,12,6.1,6.1,0,0,1,64.7,16.365v7.208h-.012q0,7.282-5.835,7.282a8.453,8.453,0,0,1-3.224-.674v8.25A2.471,2.471,0,0,1,53.178,40,2.419,2.419,0,0,1,50.812,38.431Zm4.805-21.845V26a7.046,7.046,0,0,0,2.709.834c1.1-.012,1.655-1.091,1.655-3.248V15.912c0-.65-.4-.981-1.226-.981A3.59,3.59,0,0,0,55.617,16.586ZM33.858,19.614q0-9.727,7.159-9.721,4.1,0,5.762,3.065a15.8,15.8,0,0,1,1.067,6.656q0,4.56-1.226,6.8-1.655,3.144-6.031,3.138Q33.858,29.556,33.858,19.614Zm4.462,0c0,3.947.846,5.909,2.538,5.909,1.741.012,2.623-1.961,2.623-5.909q0-5.682-2.538-5.688Q38.315,13.926,38.321,19.614Zm-35.8,8.4A5.577,5.577,0,0,1,.172,23.917L0,22.262l4.536-.6a12.942,12.942,0,0,0,.613,2.317,1.976,1.976,0,0,0,2.01,1.189,1.375,1.375,0,0,0,1.226-.674A4.161,4.161,0,0,0,9,22.4c0-1.2-.736-2.623-2.219-4.266s-2.954-3.273-4.4-4.867A10,10,0,0,1,.025,7.2a9.322,9.322,0,0,1,.441-2.77Q1.955.012,6.84.012a7.629,7.629,0,0,1,4.585,1.5,5.555,5.555,0,0,1,2.317,4.131l.172,1.655-4.585.588a12.943,12.943,0,0,0-.613-2.317,1.976,1.976,0,0,0-2.01-1.189c-.7,0-1.189.429-1.483,1.275A3.756,3.756,0,0,0,4.965,7q0,2.537,4.622,7.416t4.622,8.017a7.691,7.691,0,0,1-1.876,4.72,6.225,6.225,0,0,1-5.185,2.39A7.665,7.665,0,0,1,2.525,28.011Zm23.488-.368V15.3c0-.552-.343-.821-1.042-.821a3.356,3.356,0,0,0-2.954,1.569v11.6a2.629,2.629,0,0,1-2.538,1.716,2.589,2.589,0,0,1-2.452-1.728V1.729A2.578,2.578,0,0,1,19.479,0a2.641,2.641,0,0,1,2.538,1.729v9.292a7.611,7.611,0,0,1,3.751-1.042,5.039,5.039,0,0,1,3.665,1.459,5.748,5.748,0,0,1,1.483,4.3V27.631a2.548,2.548,0,0,1-2.366,1.728l-.136,0A2.521,2.521,0,0,1,26.013,27.643Z\"\r\n          transform=\"translate(63.32 0)\"\r\n        />\r\n        <path\r\n          id=\"Wizi\"\r\n          class=\"cls-2\"\r\n          d=\"M13.341,28.661,12.2,22.617l-1.226,6.044a2.9,2.9,0,0,1-2.353,1.189,3.26,3.26,0,0,1-2.44-1.1L.064,2.55A1.793,1.793,0,0,1,.591.674,2.977,2.977,0,0,1,2.6,0c1.287,0,2.047.478,2.28,1.422L8.535,18.707l1.312-6.055a2.228,2.228,0,0,1,2.524-1.876,2.035,2.035,0,0,1,2.183,1.876l1.213,6.142Q16.816,12.6,18,6.3c.785-4.2,2.06-6.3,3.8-6.3a2.717,2.717,0,0,1,1.054.221,1.774,1.774,0,0,1,1.41,2.329l-6.032,26.1a2.881,2.881,0,0,1-2.354,1.2A3.247,3.247,0,0,1,13.341,28.661Zm39.816-.356V11.67c.293-.6,1.139-.895,2.537-.895,1.336,0,2.182.294,2.538.895V28.305c-.355.65-1.2.968-2.538.968C54.3,29.273,53.451,28.955,53.157,28.305Zm-15.667.968c-1.287-.147-1.924-.772-1.924-1.863a2.936,2.936,0,0,1,.343-1.5l7.16-10.984H37.33a2.307,2.307,0,0,1-1.765-2.182,2.226,2.226,0,0,1,1.778-2.182h10.1a2.144,2.144,0,0,1,1.679,2.1q0,1.8-2.574,5.529-2.483,3.366-4.879,6.73h5.7v-.013a2.235,2.235,0,0,1,0,4.364Zm-11.5-.968V11.67c.294-.6,1.14-.895,2.538-.895,1.336,0,2.182.294,2.537.895V28.305c-.355.65-1.2.968-2.537.968C27.131,29.273,26.285,28.955,25.991,28.305ZM53.9,8.054a2,2,0,0,1-.747-1.544A1.858,1.858,0,0,1,53.9,5a2.969,2.969,0,0,1,3.58,0,1.859,1.859,0,0,1,.748,1.508,1.962,1.962,0,0,1-.748,1.544,2.833,2.833,0,0,1-3.58,0Zm-27.165,0a2,2,0,0,1-.748-1.544A1.859,1.859,0,0,1,26.739,5a2.968,2.968,0,0,1,3.579,0,1.892,1.892,0,0,1,.748,1.508,1.959,1.959,0,0,1-.748,1.544,2.832,2.832,0,0,1-3.579,0Z\"\r\n          transform=\"translate(-0.024 0.086)\"\r\n        />\r\n      </g>\r\n    </svg>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: LogoComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-logo', encapsulation: ViewEncapsulation.None, template: "<div class=\"wac-logo\">\r\n  <div class=\"wac-logo__wrapper\" [ngClass]=\"isWhite ? 'white' : ''\" *ngIf=\"isDropizi\">\r\n    <svg id=\"Calque_1\" data-name=\"Calque 1\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 102.33 40\">\r\n      <defs>\r\n        <style>\r\n          .cls-0 {\r\n            fill: #fa096a;\r\n          }\r\n        </style>\r\n      </defs>\r\n      <title>Logo_Dropizi</title>\r\n      <path\r\n        id=\"Logo_Dropizi-2\"\r\n        data-name=\"Logo Dropizi-2\"\r\n        class=\"cls-0\"\r\n        d=\"M83,44.94a4.87,4.87,0,0,1-4.36-7,3.81,3.81,0,0,1-.72-2l-.3-5.69a9.61,9.61,0,0,1-3.43,2,13.51,13.51,0,0,1-3.34.63l-1.06,0L70,36.29a3.75,3.75,0,0,1-3.54,3.94l-2.25.11H64a3.69,3.69,0,0,1-3-1.56,12.82,12.82,0,0,1-7.68,2.61,13.45,13.45,0,0,1-5.37-1.14,3.67,3.67,0,0,1-2.46,1.09l-2.15.12h-.2a3.76,3.76,0,0,1-3.17-1.74l-3.29-5.25L36.84,38a3.78,3.78,0,0,1-1,2.7A3.74,3.74,0,0,1,33.28,42L31,42.09h-.19a3.77,3.77,0,0,1-3.06-1.58,12.62,12.62,0,0,1-1.62.87,15,15,0,0,1-5.35,1.24L13.49,43H13.3a3.76,3.76,0,0,1-3.74-3.54L8.5,19.3A3.75,3.75,0,0,1,12,15.36L19.37,15c.3,0,.59,0,.88,0a14.67,14.67,0,0,1,4.56.7,13.17,13.17,0,0,1,1.74.7,3.73,3.73,0,0,1,3.06-1.91l7.14-.37c.35,0,.69,0,1,0,3.65,0,6,1.12,7.41,2.57A13.29,13.29,0,0,1,49,14.33a12.05,12.05,0,0,1,4.44-.82c.23,0,.45,0,.69,0a13.63,13.63,0,0,1,5.2,1.35l.22.11a3.75,3.75,0,0,1,3.25-2.29l5.32-.27c.7,0,1.38-.06,2-.06.92,0,1.78,0,2.57.11a10.17,10.17,0,0,1,4.16,1.26l.37.24a3.78,3.78,0,0,1,3.22-2.2l2.18-.12h.2a3.89,3.89,0,0,1,2,.57,3.63,3.63,0,0,1,2.07-.79l12.9-.67h.11c0-.24-.07-.47-.09-.71a4.88,4.88,0,0,1,4.62-5.12h.25a4.86,4.86,0,0,1,4.88,4.62v.26A4.89,4.89,0,0,1,109,12a3.62,3.62,0,0,1,.72,2l1.06,20.14,0,0a3.75,3.75,0,0,1-3.54,3.94l-2.18.11h-.2a3.83,3.83,0,0,1-2-.57,3.54,3.54,0,0,1-2.06.78l-12.9.68h-.1c0,.24.07.47.09.71a4.87,4.87,0,0,1-1.25,3.51,4.82,4.82,0,0,1-3.37,1.6Zm-2-4.87v.11a2,2,0,0,0,2.1,1.9h0a2,2,0,0,0,1.9-2V40a2,2,0,0,0-2-1.9H83A2,2,0,0,0,81.05,40.07ZM19.54,17.84l-7.34.39a.89.89,0,0,0-.84.93l1.06,20.17a.89.89,0,0,0,.92.83l7.33-.39a11.89,11.89,0,0,0,4.32-1,9.7,9.7,0,0,0,3.3-2.36,8.91,8.91,0,0,0,1.46-2.14L30,38.4a.88.88,0,0,0,.92.84l2.25-.12A.88.88,0,0,0,34,38.2h0l-.34-6.38a.88.88,0,0,1,.84-.93h0l2.67-.14a.89.89,0,0,1,.8.41l4.41,7a.92.92,0,0,0,.8.42l2.17-.12a.88.88,0,0,0,.72-1.34l-4.25-7A.88.88,0,0,1,42,29c.22-.18.44-.37.64-.56a10.07,10.07,0,0,0,.5,3,9.65,9.65,0,0,0,2,3.45,11.39,11.39,0,0,0,3.45,2.5,10,10,0,0,0,8.09.47,11,11,0,0,0,6.08-6l.08-.18.26,4.91a.89.89,0,0,0,.92.84l2.25-.12a.89.89,0,0,0,.84-.92L66.86,31a.87.87,0,0,1,.83-.92h0l3-.16a10.49,10.49,0,0,0,2.6-.5A6.87,6.87,0,0,0,75.75,28a6.67,6.67,0,0,0,1.68-2.36l0-.12A8.77,8.77,0,0,0,78,21.73a9,9,0,0,0-.77-3.49,4.1,4.1,0,0,0-.22-.41,4.71,4.71,0,0,0-1.63-1.63,7.28,7.28,0,0,0-3-.87,28.9,28.9,0,0,0-4.16,0l-5.33.28a.86.86,0,0,0-.61.29.9.9,0,0,0-.22.63L62.33,21a10.85,10.85,0,0,0-.8-1A11.54,11.54,0,0,0,54,16.38,9.3,9.3,0,0,0,50,17a10.46,10.46,0,0,0-3.46,2.22,11.5,11.5,0,0,0-1.92,2.41q-1-5.05-7.73-4.7l-7.14.37a.88.88,0,0,0-.84.93l.22,4.15a9.5,9.5,0,0,0-5.19-4,12.2,12.2,0,0,0-3.65-.56C20.05,17.82,19.79,17.82,19.54,17.84Zm63.22-3.31-2.17.12a.9.9,0,0,0-.61.29.87.87,0,0,0-.23.64l1.06,20.15a.88.88,0,0,0,.93.84L84,36.45a.83.83,0,0,0,.61-.29.87.87,0,0,0,.23-.63l-1-20.09a1,1,0,0,0-1-.9Zm11.48,3.85a.9.9,0,0,1,.07.87L86.94,35a.88.88,0,0,0,.06.86.85.85,0,0,0,.76.4l12.9-.67h0a.76.76,0,0,0,.72-.8h0l-.13-2.48a.75.75,0,0,0-.8-.72l-6.21.33a.89.89,0,0,1-.84-1.26l7.37-15.74a.9.9,0,0,0-.07-.87.87.87,0,0,0-.78-.39L87,14.31a.75.75,0,0,0-.71.8l.13,2.49a.74.74,0,0,0,.25.52.75.75,0,0,0,.55.2L93.46,18h.05A.89.89,0,0,1,94.24,18.38ZM106,13.31l-2.24.12a.89.89,0,0,0-.85.93l.85,16.15v.1l.2,3.83a1,1,0,0,0,1,.91l2.18-.11h0a.9.9,0,0,0,.83-.93l-1.06-20.16a.88.88,0,0,0-.88-.84Zm-3.32-3.5v.1a2,2,0,0,0,4-.1V9.7a2,2,0,0,0-2-1.9h-.1a2,2,0,0,0-1.91,2ZM16.25,35.28l-.66-12.51a.87.87,0,0,1,.23-.64.83.83,0,0,1,.61-.29l3.3-.18a6,6,0,0,1,4.87,1.62,7.74,7.74,0,0,1,1.92,5.19,7.71,7.71,0,0,1-1.37,5.35A6,6,0,0,1,20.47,36l-3.31.17h0a.88.88,0,0,1-.88-.84Zm36.61-.55A6.9,6.9,0,0,1,48,32.44a5.3,5.3,0,0,1-1.12-2.17,6.7,6.7,0,0,1-.09-2.6,11,11,0,0,1,2.57-5.41,6.42,6.42,0,0,1,2.07-1.58,5.52,5.52,0,0,1,2.4-.52,6.36,6.36,0,0,1,2.64.66,5.45,5.45,0,0,1,3.3,3.78A8.32,8.32,0,0,1,59,30.1a10.69,10.69,0,0,1-1.66,2.54,6.76,6.76,0,0,1-2.07,1.57,5.42,5.42,0,0,1-2.31.52.27.27,0,0,1-.09,0Zm-19.2-7.84a.83.83,0,0,1-.29-.61l-.26-4.91a.87.87,0,0,1,.83-.92l2.22-.12a5.2,5.2,0,0,1,3.39.63,3.08,3.08,0,0,1,1,2.41,3.29,3.29,0,0,1-.8,2.6,5.23,5.23,0,0,1-3.43,1l-2.07.11h0a.89.89,0,0,1-.59-.23Zm32.93-1.41-.31-5.84a.9.9,0,0,1,.23-.64.86.86,0,0,1,.61-.29l2.4-.12a8.81,8.81,0,0,1,2,.09,3.1,3.1,0,0,1,1.33.57,2.58,2.58,0,0,1,.75,1.09A6.22,6.22,0,0,1,73.94,22a4.16,4.16,0,0,1-.79,3.14A4.63,4.63,0,0,1,70,26.19l-2.51.13h0a.9.9,0,0,1-.89-.84Z\"\r\n        transform=\"translate(-8.49 -4.94)\"\r\n      />\r\n    </svg>\r\n  </div>\r\n  <div class=\"wac-logo__wrapper\" [ngClass]=\"isWhite ? 'white' : ''\" *ngIf=\"!isDropizi\">\r\n    <svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 128.044 40\">\r\n      <defs>\r\n        <style>\r\n          .cls-1 {\r\n            fill: #a4c445;\r\n          }\r\n          .cls-2 {\r\n            fill: #52aecd;\r\n          }\r\n        </style>\r\n      </defs>\r\n      <g id=\"Logo_WiziShop\" transform=\"translate(0.024 0)\">\r\n        <path\r\n          id=\"Shop\"\r\n          class=\"cls-1\"\r\n          d=\"M50.812,38.431V12.3a2.468,2.468,0,0,1,2.452-1.643A2.307,2.307,0,0,1,55.446,12a7.058,7.058,0,0,1,4.107-1.348A5.245,5.245,0,0,1,63.218,12,6.1,6.1,0,0,1,64.7,16.365v7.208h-.012q0,7.282-5.835,7.282a8.453,8.453,0,0,1-3.224-.674v8.25A2.471,2.471,0,0,1,53.178,40,2.419,2.419,0,0,1,50.812,38.431Zm4.805-21.845V26a7.046,7.046,0,0,0,2.709.834c1.1-.012,1.655-1.091,1.655-3.248V15.912c0-.65-.4-.981-1.226-.981A3.59,3.59,0,0,0,55.617,16.586ZM33.858,19.614q0-9.727,7.159-9.721,4.1,0,5.762,3.065a15.8,15.8,0,0,1,1.067,6.656q0,4.56-1.226,6.8-1.655,3.144-6.031,3.138Q33.858,29.556,33.858,19.614Zm4.462,0c0,3.947.846,5.909,2.538,5.909,1.741.012,2.623-1.961,2.623-5.909q0-5.682-2.538-5.688Q38.315,13.926,38.321,19.614Zm-35.8,8.4A5.577,5.577,0,0,1,.172,23.917L0,22.262l4.536-.6a12.942,12.942,0,0,0,.613,2.317,1.976,1.976,0,0,0,2.01,1.189,1.375,1.375,0,0,0,1.226-.674A4.161,4.161,0,0,0,9,22.4c0-1.2-.736-2.623-2.219-4.266s-2.954-3.273-4.4-4.867A10,10,0,0,1,.025,7.2a9.322,9.322,0,0,1,.441-2.77Q1.955.012,6.84.012a7.629,7.629,0,0,1,4.585,1.5,5.555,5.555,0,0,1,2.317,4.131l.172,1.655-4.585.588a12.943,12.943,0,0,0-.613-2.317,1.976,1.976,0,0,0-2.01-1.189c-.7,0-1.189.429-1.483,1.275A3.756,3.756,0,0,0,4.965,7q0,2.537,4.622,7.416t4.622,8.017a7.691,7.691,0,0,1-1.876,4.72,6.225,6.225,0,0,1-5.185,2.39A7.665,7.665,0,0,1,2.525,28.011Zm23.488-.368V15.3c0-.552-.343-.821-1.042-.821a3.356,3.356,0,0,0-2.954,1.569v11.6a2.629,2.629,0,0,1-2.538,1.716,2.589,2.589,0,0,1-2.452-1.728V1.729A2.578,2.578,0,0,1,19.479,0a2.641,2.641,0,0,1,2.538,1.729v9.292a7.611,7.611,0,0,1,3.751-1.042,5.039,5.039,0,0,1,3.665,1.459,5.748,5.748,0,0,1,1.483,4.3V27.631a2.548,2.548,0,0,1-2.366,1.728l-.136,0A2.521,2.521,0,0,1,26.013,27.643Z\"\r\n          transform=\"translate(63.32 0)\"\r\n        />\r\n        <path\r\n          id=\"Wizi\"\r\n          class=\"cls-2\"\r\n          d=\"M13.341,28.661,12.2,22.617l-1.226,6.044a2.9,2.9,0,0,1-2.353,1.189,3.26,3.26,0,0,1-2.44-1.1L.064,2.55A1.793,1.793,0,0,1,.591.674,2.977,2.977,0,0,1,2.6,0c1.287,0,2.047.478,2.28,1.422L8.535,18.707l1.312-6.055a2.228,2.228,0,0,1,2.524-1.876,2.035,2.035,0,0,1,2.183,1.876l1.213,6.142Q16.816,12.6,18,6.3c.785-4.2,2.06-6.3,3.8-6.3a2.717,2.717,0,0,1,1.054.221,1.774,1.774,0,0,1,1.41,2.329l-6.032,26.1a2.881,2.881,0,0,1-2.354,1.2A3.247,3.247,0,0,1,13.341,28.661Zm39.816-.356V11.67c.293-.6,1.139-.895,2.537-.895,1.336,0,2.182.294,2.538.895V28.305c-.355.65-1.2.968-2.538.968C54.3,29.273,53.451,28.955,53.157,28.305Zm-15.667.968c-1.287-.147-1.924-.772-1.924-1.863a2.936,2.936,0,0,1,.343-1.5l7.16-10.984H37.33a2.307,2.307,0,0,1-1.765-2.182,2.226,2.226,0,0,1,1.778-2.182h10.1a2.144,2.144,0,0,1,1.679,2.1q0,1.8-2.574,5.529-2.483,3.366-4.879,6.73h5.7v-.013a2.235,2.235,0,0,1,0,4.364Zm-11.5-.968V11.67c.294-.6,1.14-.895,2.538-.895,1.336,0,2.182.294,2.537.895V28.305c-.355.65-1.2.968-2.537.968C27.131,29.273,26.285,28.955,25.991,28.305ZM53.9,8.054a2,2,0,0,1-.747-1.544A1.858,1.858,0,0,1,53.9,5a2.969,2.969,0,0,1,3.58,0,1.859,1.859,0,0,1,.748,1.508,1.962,1.962,0,0,1-.748,1.544,2.833,2.833,0,0,1-3.58,0Zm-27.165,0a2,2,0,0,1-.748-1.544A1.859,1.859,0,0,1,26.739,5a2.968,2.968,0,0,1,3.579,0,1.892,1.892,0,0,1,.748,1.508,1.959,1.959,0,0,1-.748,1.544,2.832,2.832,0,0,1-3.579,0Z\"\r\n          transform=\"translate(-0.024 0.086)\"\r\n        />\r\n      </g>\r\n    </svg>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { isDropizi: [{
                type: Input
            }], isWhite: [{
                type: Input
            }] } });

class RadioLegacyComponent {
    constructor() {
        // ! refacto
        this.label = '';
        this.id = '';
        this.alone = false;
        this.changeInput = new EventEmitter();
        this.disabled = false;
    }
    registerOnChange(fn) {
        this._onChange = fn;
    }
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    writeValue(obj) {
        this.value = obj;
    }
    onChange(value) {
        if (this._onChange) {
            this._onChange(value);
        }
    }
    valueInput(value) {
        this.changeInput.emit(value);
    }
}
RadioLegacyComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioLegacyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
RadioLegacyComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: RadioLegacyComponent, selector: "wac-radio-legacy", inputs: { label: "label", options: "options", value: "value", type: "type", id: "id", name: "name", alone: "alone" }, outputs: { changeInput: "changeInput" }, providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: RadioLegacyComponent, multi: true }], ngImport: i0, template: "<div class=\"wac-radio\" *ngFor=\"let option of options\" [ngClass]=\"{ 'wac-radio--nowrap': type === 'column', alone: alone }\">\r\n  <div class=\"wac-radio__row\">\r\n    <input\r\n      type=\"radio\"\r\n      [id]=\"option.id\"\r\n      class=\"is-checkradio\"\r\n      [name]=\"option.name\"\r\n      [value]=\"option.value\"\r\n      [disabled]=\"option.disabled\"\r\n      [(ngModel)]=\"value\"\r\n      (ngModelChange)=\"onChange($event)\"\r\n    />\r\n    <label [attr.for]=\"option.id\">{{ option.label }}</label>\r\n    <div class=\"wac-radio__input\" *ngIf=\"value && option.value && option.hasInput\">\r\n      <input type=\"text\" [placeholder]=\"option.placeholderInput\" (blur)=\"valueInput($event)\" />\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.RadioControlValueAccessor, selector: "input[type=radio][formControlName],input[type=radio][formControl],input[type=radio][ngModel]", inputs: ["name", "formControlName", "value"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioLegacyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-radio-legacy', encapsulation: ViewEncapsulation.None, providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: RadioLegacyComponent, multi: true }], template: "<div class=\"wac-radio\" *ngFor=\"let option of options\" [ngClass]=\"{ 'wac-radio--nowrap': type === 'column', alone: alone }\">\r\n  <div class=\"wac-radio__row\">\r\n    <input\r\n      type=\"radio\"\r\n      [id]=\"option.id\"\r\n      class=\"is-checkradio\"\r\n      [name]=\"option.name\"\r\n      [value]=\"option.value\"\r\n      [disabled]=\"option.disabled\"\r\n      [(ngModel)]=\"value\"\r\n      (ngModelChange)=\"onChange($event)\"\r\n    />\r\n    <label [attr.for]=\"option.id\">{{ option.label }}</label>\r\n    <div class=\"wac-radio__input\" *ngIf=\"value && option.value && option.hasInput\">\r\n      <input type=\"text\" [placeholder]=\"option.placeholderInput\" (blur)=\"valueInput($event)\" />\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { label: [{
                type: Input
            }], options: [{
                type: Input
            }], value: [{
                type: Input
            }], type: [{
                type: Input
            }], id: [{
                type: Input
            }], name: [{
                type: Input
            }], alone: [{
                type: Input
            }], changeInput: [{
                type: Output
            }] } });

class StateComponent {
    constructor() {
        this.state = 'success';
    }
}
StateComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: StateComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
StateComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: StateComponent, selector: "wac-state", inputs: { state: "state" }, ngImport: i0, template: "<div [class]=\"'wac-state ' + state\"></div>\r\n", encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: StateComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-state', encapsulation: ViewEncapsulation.None, template: "<div [class]=\"'wac-state ' + state\"></div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { state: [{
                type: Input
            }] } });

const inOutX = trigger('inOutXAnimation', [
    transition(':enter', [
        style({ zIndex: -1, transform: 'scaleX(0)', width: 0, opacity: 0 }),
        animate('.3s ease-out', style({ zIndex: 1, transform: 'scaleX(1)', width: 'auto', opacity: 1 }))
    ]),
    transition(':leave', [
        style({ zIndex: 1, transform: 'scaleX(1)', width: 'auto', opacity: 1 }),
        animate('.3s ease-in', style({ zIndex: -1, transform: 'scaleX(0)', width: 0, opacity: 0 }))
    ])
]);

class TagLabelComponent {
    constructor() {
        this.index = 0;
        this.label = '';
        this.deleted = false;
        this.onDeleteLabel = new EventEmitter();
    }
    deleteLabel() {
        this.deleted = true;
        this.onDeleteLabel.emit({
            index: this.index,
            label: this.label
        });
    }
}
TagLabelComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TagLabelComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TagLabelComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TagLabelComponent, selector: "wac-tag-label", inputs: { index: "index", label: "label", deleted: "deleted" }, outputs: { onDeleteLabel: "onDeleteLabel" }, ngImport: i0, template: "<div *ngIf=\"!deleted\" [@inOutXAnimation] class=\"wac-tag-label\">\r\n  <div class=\"wac-label__wrapper\">\r\n    {{ label }}\r\n    <i class=\"far fa-times\" (click)=\"deleteLabel()\"></i>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [inOutX], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TagLabelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-tag-label', encapsulation: ViewEncapsulation.None, animations: [inOutX], template: "<div *ngIf=\"!deleted\" [@inOutXAnimation] class=\"wac-tag-label\">\r\n  <div class=\"wac-label__wrapper\">\r\n    {{ label }}\r\n    <i class=\"far fa-times\" (click)=\"deleteLabel()\"></i>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { index: [{
                type: Input
            }], label: [{
                type: Input
            }], deleted: [{
                type: Input
            }], onDeleteLabel: [{
                type: Output
            }] } });

const opacityAnimation = trigger('opacityAnimation', [
    transition(':enter', [style({ opacity: 0 }), animate('0.4s ease-in-out', style({ opacity: 1 }))])
]);

class OptionalDisableContainerComponent {
    constructor() {
        this.disabled = false;
    }
}
OptionalDisableContainerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: OptionalDisableContainerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
OptionalDisableContainerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: OptionalDisableContainerComponent, selector: "wac-optional-disable-container", inputs: { disabled: "disabled" }, ngImport: i0, template: "<ng-content></ng-content>\r\n<div class=\"wac-optional-disable-container__disabledSection\" *ngIf=\"disabled\"></div>", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: OptionalDisableContainerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-optional-disable-container', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>\r\n<div class=\"wac-optional-disable-container__disabledSection\" *ngIf=\"disabled\"></div>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { disabled: [{
                type: Input
            }] } });

class CalendarComponent {
    set options(options) {
        this._options = options;
        if (this.isBulmaDatePickerExists()) {
            this.updateBulmaDatePickerOptions(options);
        }
    }
    get options() {
        return this._options;
    }
    set dateSelected(dateSelected) {
        if (this.disabled) {
            return;
        }
        this._dateSelected = new Date(dateSelected); // trigger change detection for pure pipe
    }
    get dateSelected() {
        return this._dateSelected;
    }
    set dateSelectedEnd(dateSelected) {
        if (this.disabled) {
            return;
        }
        this._dateSelectedEnd = new Date(dateSelected); // trigger change detection for pure pipe
    }
    get dateSelectedEnd() {
        return this._dateSelectedEnd;
    }
    set calendarMinutes(calendarMinutes) {
        if (!this.dateSelected) {
            this.dateSelected = new Date();
        }
        const minutes = this.formatTime(calendarMinutes, 0, 59);
        this.dateSelected.setMinutes(minutes);
        this.dateSelected = this.dateSelected; // trigger change detection
        this.minutes.nativeElement.value = this.datePipe.transform(this.dateSelected, 'mm'); // force to update the input value
        this.triggerDateSelectedChange();
    }
    get calendarMinutes() {
        return this.datePipe.transform(this.dateSelected ?? new Date(), 'mm');
    }
    set calendarHours(calendarHours) {
        if (!this.dateSelected) {
            this.dateSelected = new Date();
        }
        const hours = this.formatTime(calendarHours, 0, 23);
        this.dateSelected.setHours(hours);
        this.dateSelected = this.dateSelected; // trigger change detection
        this.hours.nativeElement.value = this.datePipe.transform(this.dateSelected, 'HH'); // force to update the input value
        this.triggerDateSelectedChange();
    }
    get calendarHours() {
        return this.datePipe.transform(this.dateSelected ?? new Date(), 'HH');
    }
    constructor(datePipe) {
        this.datePipe = datePipe;
        this.boldLabel = false; // todo remove when label will be a ng-content
        this.type = 'input';
        this.isRange = false;
        this._options = {
            displayMode: 'inline',
            showHeader: false,
            showFooter: true,
        };
        this.position = 'bottom';
        this.dateSelectedChange = new EventEmitter();
        this.typeDate = 'datetime-local';
        this.noMargin = false;
        this.disabled = false;
        this.changeData = new EventEmitter();
        this.open = false;
        this.startLabel = '';
        this.endLabel = '';
        // ControlValueAccessor methods
        this.onChange = () => { };
        this.onTouch = () => { };
    }
    ngOnChanges(changes) {
        if (changes.label || changes.type) {
            this.setCalendarLabel();
        }
    }
    onChangeDate(selectedDates) {
        if (this.disabled) {
            return;
        }
        if (!this.dateSelected) {
            this.dateSelected = new Date();
        }
        selectedDates.startDate.setHours(this.dateSelected.getHours());
        selectedDates.startDate.setMinutes(this.dateSelected.getMinutes());
        this.dateSelected = selectedDates.startDate;
        if (selectedDates.endDate && this.isRange) {
            selectedDates.endDate.setMinutes(this.dateSelectedEnd.getMinutes());
            selectedDates.endDate.setMinutes(this.dateSelectedEnd.getMinutes());
            this.dateSelectedEnd = selectedDates.endDate;
        }
        else {
            selectedDates.endDate = this.dateSelected;
            this.dateSelectedEnd = this.dateSelected;
        }
        this.triggerDateSelectedChange();
    }
    triggerDateSelectedChange() {
        this.onChange(this.dateSelected);
        this.dateSelectedChange.emit(this.dateSelected);
        this.triggerChange({
            startDate: this.dateSelected,
            endDate: this.dateSelectedEnd
        });
    }
    triggerChange(event) {
        console.log(event);
        this.changeData.emit(event);
    }
    openCalendar(value = null) {
        if (this.disabled) {
            return;
        }
        if (value === 'close') {
            if (this.open) {
                this.open = false;
                this.onTouch();
            }
        }
        else {
            this.open = !this.open;
        }
    }
    setCalendarLabel() {
        if (this.type === 'edit' && this.label) {
            const splitLabel = this.label.split('{x}');
            if (splitLabel.length > 1) {
                this.startLabel = splitLabel[0];
                this.endLabel = splitLabel[1];
            }
            else {
                this.startLabel = this.label;
            }
        }
    }
    incrementMinutes($event) {
        this.calendarMinutes = parseInt(this.calendarMinutes, 10) + 1 + '';
        $event.preventDefault();
    }
    decrementsMinutes($event) {
        this.calendarMinutes = parseInt(this.calendarMinutes, 10) - 1 + '';
        $event.preventDefault();
    }
    incrementHours($event) {
        this.calendarHours = parseInt(this.calendarHours, 10) + 1 + '';
        $event.preventDefault();
    }
    decrementHours($event) {
        this.calendarHours = parseInt(this.calendarHours, 10) - 1 + '';
        $event.preventDefault();
    }
    /*
      Ensure that the input value is a number and that it is between min and max
    */
    formatTime(time, min = 0, max = 59) {
        let timeNumber = typeof time === 'string' ? parseInt(time, 10) : time;
        timeNumber = timeNumber > max ? min : timeNumber;
        timeNumber = timeNumber < min ? max : timeNumber;
        timeNumber = parseInt(('' + timeNumber).slice(-2)); // keeps only the last 2 digits
        return timeNumber;
    }
    updateBulmaDatePickerOptions(options) {
        const bulmaCalendarDatePicker = this.datePicker['bulmaCalendar'].datePicker;
        bulmaCalendarDatePicker.min = options.minDate;
        bulmaCalendarDatePicker.max = options.maxDate;
        bulmaCalendarDatePicker.refresh();
    }
    isBulmaDatePickerExists() {
        return this.datePicker && this.datePicker['bulmaCalendar'] && this.datePicker['bulmaCalendar'].datePicker;
    }
    writeValue(date) {
        if (!date) {
            return;
        }
        this.dateSelected = date;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouch = fn;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
CalendarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CalendarComponent, deps: [{ token: i1.DatePipe }], target: i0.ɵɵFactoryTarget.Component });
CalendarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: CalendarComponent, selector: "wac-calendar", inputs: { label: "label", boldLabel: "boldLabel", type: "type", isRange: "isRange", options: "options", position: "position", dateSelected: "dateSelected", dateSelectedEnd: "dateSelectedEnd", typeDate: "typeDate", noMargin: "noMargin", disabled: "disabled" }, outputs: { dateSelectedChange: "dateSelectedChange", changeData: "changeData" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: CalendarComponent,
            multi: true
        },
        DatePipe
    ], viewQueries: [{ propertyName: "minutes", first: true, predicate: ["minutes"], descendants: true }, { propertyName: "hours", first: true, predicate: ["hours"], descendants: true }, { propertyName: "datePicker", first: true, predicate: ["datePicker"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div\r\n  class=\"wac-calendar\"\r\n  [ngClass]=\"{\r\n    'wac-calendar--input': type === 'input',\r\n    'wac-calendar--onlyDate': typeDate === 'date',\r\n    'wac-calendar--edit': type === 'edit',\r\n    'wac-calendar--select': type === 'select',\r\n    'wac-calendar--no-margin': noMargin,\r\n    'wac-calendar--open': open,\r\n    'wac-calendar--range': isRange\r\n  }\"\r\n  [zIndexToggle]=\"open\"\r\n>\r\n  <p [class]=\"'wac-calendar__label' + (boldLabel ? ' bold' : '')\" *ngIf=\"label && (type === 'input' || type === 'select')\" (click)=\"openCalendar()\">{{ label }}</p>\r\n  <p class=\"wac-calendar__startLabel\" *ngIf=\"type === 'edit'\">{{ startLabel }}</p>\r\n  <wac-optional-disable-container [disabled]=\"disabled\">\r\n    <div class=\"wac-calendar__autoHide\" wzAutoHide (clickOutside)=\"openCalendar('close')\">\r\n      <div class=\"wac-calendar__wrapper\">\r\n        <div class=\"wac-calendar__wrapper__input\" *ngIf=\"type === 'input'\" (click)=\"openCalendar()\">\r\n          <div class=\"wac-calendar__wrapper__input__icon\">\r\n            <i class=\"far fa-calendar-alt\"></i>\r\n          </div>\r\n          <div class=\"wac-calendar__wrapper__input__date\">\r\n            <span *ngIf=\"dateSelected\" @opacityAnimation>{{ dateSelected | date: 'dd/MM/yyyy'}}</span>\r\n            <span class=\"placeholder-date\" *ngIf=\"!dateSelected\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.dd/mm/yyyy' | translate }}</span>\r\n          </div>\r\n          <div class=\"wac-calendar__wrapper__input__time\">\r\n            <span *ngIf=\"dateSelected\" @opacityAnimation>{{ dateSelected | date: 'HH:mm' }}</span>\r\n            <span class=\"placeholder-date\" *ngIf=\"!dateSelected\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.HH:mm' | translate }}</span>\r\n          </div>\r\n          <ng-container *ngIf=\"isRange\">\r\n            <div class=\"wac-calendar__wrapper__input__separator\"><i class=\"fa-solid fa-chevron-right\"></i></div>\r\n            <div class=\"wac-calendar__wrapper__input__date\">\r\n              <span *ngIf=\"dateSelectedEnd\" @opacityAnimation>{{ dateSelectedEnd | date: 'dd/MM/yyyy'}}</span>\r\n              <span class=\"placeholder-date\" *ngIf=\"!dateSelectedEnd\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.dd/mm/yyyy' | translate }}</span>\r\n            </div>\r\n            <div class=\"wac-calendar__wrapper__input__time\">\r\n              <span *ngIf=\"dateSelectedEnd\" @opacityAnimation>{{ dateSelectedEnd | date: 'HH:mm' }}</span>\r\n              <span class=\"placeholder-date\" *ngIf=\"!dateSelectedEnd\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.HH:mm' | translate }}</span>\r\n            </div>\r\n          </ng-container>\r\n        </div>\r\n        <div class=\"wac-calendar__wrapper__editInPlace\" *ngIf=\"type === 'edit'\" (click)=\"openCalendar()\">\r\n          <div class=\"wac-calendar__wrapper__editInPlace__icon\">\r\n            <i class=\"fal fa-calendar-alt\"></i>\r\n          </div>\r\n          <div class=\"wac-calendar__wrapper__editInPlace__date\">\r\n            <div class=\"wac-calendar__wrapper__input__time\">\r\n              <span *ngIf=\"dateSelected\" @opacityAnimation>{{ dateSelected | date: 'dd/MM/yyyy HH:mm' }}</span>\r\n              <span class=\"placeholder-date\" *ngIf=\"!dateSelected\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.dd/MM/yyyy_HH:mm' | translate }}</span>\r\n            </div>\r\n          </div>\r\n        </div>\r\n        <div class=\"wac-calendar__wrapper__select\" *ngIf=\"type === 'select'\" (click)=\"openCalendar()\">\r\n          <div class=\"wac-calendar__wrapper__select__icon\">\r\n            <i class=\"fal fa-calendar-alt\"></i>\r\n          </div>\r\n          <div class=\"wac-calendar__wrapper__select__date\">\r\n            <span *ngIf=\"dateSelected\" @opacityAnimation>{{ dateSelected | date: 'dd/MM/yyyy HH:mm' }}</span>\r\n            <span class=\"placeholder-date\" *ngIf=\"!dateSelected\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.dd/MM/yyyy_HH:mm' | translate }}</span>\r\n          </div>\r\n        </div>\r\n      </div>\r\n      <div\r\n        class=\"wac-calendar__absolute\"\r\n        [ngClass]=\"{\r\n          top: position === 'top',\r\n          bottom: position === 'bottom',\r\n          left: position === 'left',\r\n          right: position === 'right',\r\n          'right-top': position === 'right-top',\r\n          'right-bottom': position === 'right-bottom',\r\n          'left-top': position === 'left-top',\r\n          'left-bottom': position === 'left-bottom',\r\n          'with-time': typeDate === 'datetime-local' || typeDate === 'datetime'\r\n        }\"\r\n      >\r\n\r\n        <!-- Solo nwbDatePicker -->\r\n        <ng-container *ngIf=\"!isRange\">\r\n          <nwb-date-picker #datePicker (change)=\"onChangeDate($event)\" [options]=\"options\">\r\n            <input [nwbDatepickerStart]=\"datePicker\" type=\"text\" [nwbDateType]=\"'date'\" [value]=\"dateSelected?.toISOString()\" />\r\n          </nwb-date-picker>\r\n        </ng-container>\r\n\r\n        <!-- Range nwbDatePicker -->\r\n        <ng-container *ngIf=\"isRange\">\r\n          <nwb-date-picker #datePicker (change)=\"onChangeDate($event)\" [options]=\"options\">\r\n            <input [nwbDatepickerStart]=\"datePicker\" type=\"text\" [nwbDateType]=\"'date'\" [value]=\"dateSelected?.toISOString()\" />\r\n            <input [nwbDatepickerEnd]=\"datePicker\" type=\"text\" [nwbDateType]=\"'date'\" [value]=\"dateSelectedEnd?.toISOString()\" />\r\n          </nwb-date-picker>\r\n        </ng-container>\r\n        <div class=\"wac-calendar__absolute__time\" *ngIf=\"typeDate === 'datetime-local' || typeDate === 'datetime'\">\r\n          <div class=\"wac-calendar__absolute__time__wrapper\">\r\n            <div class=\"wac-calendar__absolute__time__wrapper__hours\">\r\n              <div class=\"wac-calendar__absolute__time__wrapper__hours__left\">\r\n                <button class=\"wac-calendar__absolute__time__wrapper__hours__btn\" (click)=\"incrementHours($event)\">\r\n                  <i class=\"fas fa-plus\"></i>\r\n                </button>\r\n                <button class=\"wac-calendar__absolute__time__wrapper__hours__btn\" (click)=\"decrementHours($event)\">\r\n                  <i class=\"fas fa-minus\"></i>\r\n                </button>\r\n              </div>\r\n              <div class=\"wac-calendar__absolute__time__wrapper__hours__right\">\r\n                <input #hours type=\"text\" [(ngModel)]=\"calendarHours\" [wacOnlyNumber]=\"true\"/>\r\n              </div>\r\n            </div>\r\n            <div class=\"wac-calendar__absolute__time__wrapper__minutes\">\r\n              <div class=\"wac-calendar__absolute__time__wrapper__minutes__left\">\r\n                <input #minutes type=\"text\" [(ngModel)]=\"calendarMinutes\" [wacOnlyNumber]=\"true\"/>\r\n              </div>\r\n              <div class=\"wac-calendar__absolute__time__wrapper__minutes__right\">\r\n                <button class=\"wac-calendar__absolute__time__wrapper__minutes__btn\" (click)=\"incrementMinutes($event)\">\r\n                  <i class=\"fas fa-plus\"></i>\r\n                </button>\r\n                <button class=\"wac-calendar__absolute__time__wrapper__minutes__btn\" (click)=\"decrementsMinutes($event)\">\r\n                  <i class=\"fas fa-minus\"></i>\r\n                </button>\r\n              </div>\r\n            </div>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </wac-optional-disable-container>\r\n  <p class=\"wac-calendar__endLabel\" *ngIf=\"type === 'edit'\">{{ endLabel }}</p>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3.NwbDatePickerComponent, selector: "nwb-date-picker", inputs: ["options"], outputs: ["change", "clear"] }, { kind: "directive", type: i3.NwbDatePickerInputStartDirective, selector: "input[nwbDatepickerStart]", inputs: ["nwbDatepickerStart"] }, { kind: "directive", type: i3.NwbDatePickerInputEndDirective, selector: "input[nwbDatepickerEnd]", inputs: ["nwbDatepickerEnd", "nwbDateType"] }, { kind: "directive", type: i3.NwbDatePickerInputDateTypeDirective, selector: "input[nwbDateType]", inputs: ["nwbDateType"] }, { kind: "directive", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: ["triggerElement", "forceOn"], outputs: ["clickOutside"] }, { kind: "directive", type: ZindexToggleDirective, selector: "[zIndexToggle]", inputs: ["zIndexToggle"], outputs: ["onEventChange"] }, { kind: "directive", type: OnlyNumberDirective, selector: "[wacOnlyNumber]", inputs: ["wacOnlyNumber"] }, { kind: "component", type: OptionalDisableContainerComponent, selector: "wac-optional-disable-container", inputs: ["disabled"] }, { kind: "pipe", type: i1.DatePipe, name: "date" }, { kind: "pipe", type: i1$2.TranslatePipe, name: "translate" }], animations: [opacityAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CalendarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-calendar', providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: CalendarComponent,
                            multi: true
                        },
                        DatePipe
                    ], changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, animations: [opacityAnimation], template: "<div\r\n  class=\"wac-calendar\"\r\n  [ngClass]=\"{\r\n    'wac-calendar--input': type === 'input',\r\n    'wac-calendar--onlyDate': typeDate === 'date',\r\n    'wac-calendar--edit': type === 'edit',\r\n    'wac-calendar--select': type === 'select',\r\n    'wac-calendar--no-margin': noMargin,\r\n    'wac-calendar--open': open,\r\n    'wac-calendar--range': isRange\r\n  }\"\r\n  [zIndexToggle]=\"open\"\r\n>\r\n  <p [class]=\"'wac-calendar__label' + (boldLabel ? ' bold' : '')\" *ngIf=\"label && (type === 'input' || type === 'select')\" (click)=\"openCalendar()\">{{ label }}</p>\r\n  <p class=\"wac-calendar__startLabel\" *ngIf=\"type === 'edit'\">{{ startLabel }}</p>\r\n  <wac-optional-disable-container [disabled]=\"disabled\">\r\n    <div class=\"wac-calendar__autoHide\" wzAutoHide (clickOutside)=\"openCalendar('close')\">\r\n      <div class=\"wac-calendar__wrapper\">\r\n        <div class=\"wac-calendar__wrapper__input\" *ngIf=\"type === 'input'\" (click)=\"openCalendar()\">\r\n          <div class=\"wac-calendar__wrapper__input__icon\">\r\n            <i class=\"far fa-calendar-alt\"></i>\r\n          </div>\r\n          <div class=\"wac-calendar__wrapper__input__date\">\r\n            <span *ngIf=\"dateSelected\" @opacityAnimation>{{ dateSelected | date: 'dd/MM/yyyy'}}</span>\r\n            <span class=\"placeholder-date\" *ngIf=\"!dateSelected\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.dd/mm/yyyy' | translate }}</span>\r\n          </div>\r\n          <div class=\"wac-calendar__wrapper__input__time\">\r\n            <span *ngIf=\"dateSelected\" @opacityAnimation>{{ dateSelected | date: 'HH:mm' }}</span>\r\n            <span class=\"placeholder-date\" *ngIf=\"!dateSelected\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.HH:mm' | translate }}</span>\r\n          </div>\r\n          <ng-container *ngIf=\"isRange\">\r\n            <div class=\"wac-calendar__wrapper__input__separator\"><i class=\"fa-solid fa-chevron-right\"></i></div>\r\n            <div class=\"wac-calendar__wrapper__input__date\">\r\n              <span *ngIf=\"dateSelectedEnd\" @opacityAnimation>{{ dateSelectedEnd | date: 'dd/MM/yyyy'}}</span>\r\n              <span class=\"placeholder-date\" *ngIf=\"!dateSelectedEnd\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.dd/mm/yyyy' | translate }}</span>\r\n            </div>\r\n            <div class=\"wac-calendar__wrapper__input__time\">\r\n              <span *ngIf=\"dateSelectedEnd\" @opacityAnimation>{{ dateSelectedEnd | date: 'HH:mm' }}</span>\r\n              <span class=\"placeholder-date\" *ngIf=\"!dateSelectedEnd\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.HH:mm' | translate }}</span>\r\n            </div>\r\n          </ng-container>\r\n        </div>\r\n        <div class=\"wac-calendar__wrapper__editInPlace\" *ngIf=\"type === 'edit'\" (click)=\"openCalendar()\">\r\n          <div class=\"wac-calendar__wrapper__editInPlace__icon\">\r\n            <i class=\"fal fa-calendar-alt\"></i>\r\n          </div>\r\n          <div class=\"wac-calendar__wrapper__editInPlace__date\">\r\n            <div class=\"wac-calendar__wrapper__input__time\">\r\n              <span *ngIf=\"dateSelected\" @opacityAnimation>{{ dateSelected | date: 'dd/MM/yyyy HH:mm' }}</span>\r\n              <span class=\"placeholder-date\" *ngIf=\"!dateSelected\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.dd/MM/yyyy_HH:mm' | translate }}</span>\r\n            </div>\r\n          </div>\r\n        </div>\r\n        <div class=\"wac-calendar__wrapper__select\" *ngIf=\"type === 'select'\" (click)=\"openCalendar()\">\r\n          <div class=\"wac-calendar__wrapper__select__icon\">\r\n            <i class=\"fal fa-calendar-alt\"></i>\r\n          </div>\r\n          <div class=\"wac-calendar__wrapper__select__date\">\r\n            <span *ngIf=\"dateSelected\" @opacityAnimation>{{ dateSelected | date: 'dd/MM/yyyy HH:mm' }}</span>\r\n            <span class=\"placeholder-date\" *ngIf=\"!dateSelected\" @opacityAnimation>{{ 'wac.Date.PlaceHolder.dd/MM/yyyy_HH:mm' | translate }}</span>\r\n          </div>\r\n        </div>\r\n      </div>\r\n      <div\r\n        class=\"wac-calendar__absolute\"\r\n        [ngClass]=\"{\r\n          top: position === 'top',\r\n          bottom: position === 'bottom',\r\n          left: position === 'left',\r\n          right: position === 'right',\r\n          'right-top': position === 'right-top',\r\n          'right-bottom': position === 'right-bottom',\r\n          'left-top': position === 'left-top',\r\n          'left-bottom': position === 'left-bottom',\r\n          'with-time': typeDate === 'datetime-local' || typeDate === 'datetime'\r\n        }\"\r\n      >\r\n\r\n        <!-- Solo nwbDatePicker -->\r\n        <ng-container *ngIf=\"!isRange\">\r\n          <nwb-date-picker #datePicker (change)=\"onChangeDate($event)\" [options]=\"options\">\r\n            <input [nwbDatepickerStart]=\"datePicker\" type=\"text\" [nwbDateType]=\"'date'\" [value]=\"dateSelected?.toISOString()\" />\r\n          </nwb-date-picker>\r\n        </ng-container>\r\n\r\n        <!-- Range nwbDatePicker -->\r\n        <ng-container *ngIf=\"isRange\">\r\n          <nwb-date-picker #datePicker (change)=\"onChangeDate($event)\" [options]=\"options\">\r\n            <input [nwbDatepickerStart]=\"datePicker\" type=\"text\" [nwbDateType]=\"'date'\" [value]=\"dateSelected?.toISOString()\" />\r\n            <input [nwbDatepickerEnd]=\"datePicker\" type=\"text\" [nwbDateType]=\"'date'\" [value]=\"dateSelectedEnd?.toISOString()\" />\r\n          </nwb-date-picker>\r\n        </ng-container>\r\n        <div class=\"wac-calendar__absolute__time\" *ngIf=\"typeDate === 'datetime-local' || typeDate === 'datetime'\">\r\n          <div class=\"wac-calendar__absolute__time__wrapper\">\r\n            <div class=\"wac-calendar__absolute__time__wrapper__hours\">\r\n              <div class=\"wac-calendar__absolute__time__wrapper__hours__left\">\r\n                <button class=\"wac-calendar__absolute__time__wrapper__hours__btn\" (click)=\"incrementHours($event)\">\r\n                  <i class=\"fas fa-plus\"></i>\r\n                </button>\r\n                <button class=\"wac-calendar__absolute__time__wrapper__hours__btn\" (click)=\"decrementHours($event)\">\r\n                  <i class=\"fas fa-minus\"></i>\r\n                </button>\r\n              </div>\r\n              <div class=\"wac-calendar__absolute__time__wrapper__hours__right\">\r\n                <input #hours type=\"text\" [(ngModel)]=\"calendarHours\" [wacOnlyNumber]=\"true\"/>\r\n              </div>\r\n            </div>\r\n            <div class=\"wac-calendar__absolute__time__wrapper__minutes\">\r\n              <div class=\"wac-calendar__absolute__time__wrapper__minutes__left\">\r\n                <input #minutes type=\"text\" [(ngModel)]=\"calendarMinutes\" [wacOnlyNumber]=\"true\"/>\r\n              </div>\r\n              <div class=\"wac-calendar__absolute__time__wrapper__minutes__right\">\r\n                <button class=\"wac-calendar__absolute__time__wrapper__minutes__btn\" (click)=\"incrementMinutes($event)\">\r\n                  <i class=\"fas fa-plus\"></i>\r\n                </button>\r\n                <button class=\"wac-calendar__absolute__time__wrapper__minutes__btn\" (click)=\"decrementsMinutes($event)\">\r\n                  <i class=\"fas fa-minus\"></i>\r\n                </button>\r\n              </div>\r\n            </div>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </wac-optional-disable-container>\r\n  <p class=\"wac-calendar__endLabel\" *ngIf=\"type === 'edit'\">{{ endLabel }}</p>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: i1.DatePipe }]; }, propDecorators: { minutes: [{
                type: ViewChild,
                args: ['minutes']
            }], hours: [{
                type: ViewChild,
                args: ['hours']
            }], datePicker: [{
                type: ViewChild,
                args: ['datePicker']
            }], label: [{
                type: Input
            }], boldLabel: [{
                type: Input
            }], type: [{
                type: Input
            }], isRange: [{
                type: Input
            }], options: [{
                type: Input
            }], position: [{
                type: Input
            }], dateSelected: [{
                type: Input
            }], dateSelectedEnd: [{
                type: Input
            }], dateSelectedChange: [{
                type: Output
            }], typeDate: [{
                type: Input
            }], noMargin: [{
                type: Input
            }], disabled: [{
                type: Input
            }], changeData: [{
                type: Output
            }] } });

class WzEditInPlaceComponent {
    constructor() {
        this.config = {};
        this.customChange = new EventEmitter();
        this.objectKeys = Object.keys;
        this.editing = false;
        this.onChange = Function.prototype;
        this.onTouched = Function.prototype;
    }
    get value() {
        return this.currentValue;
    }
    set value(v) {
        if (v !== this.currentValue) {
            this.currentValue = v;
        }
    }
    writeValue(value) {
        if (value !== null) {
            if (this.config.currency) {
                this.currentValue = this.parseValueToNumber(value);
                if (this.config.separator !== '.') {
                    this.currentValue = this.parseValueToSeparator(this.currentValue);
                }
                this.currentValue += this.config.currency;
            }
            else {
                this.currentValue = value;
            }
        }
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    _setValue(v) {
        if (this.type === 'select') {
            this.onChange(v);
        }
        else if (typeof this.config.currency === 'string') {
            v = this.parseValueToNumber(v);
            this.onChange(v);
            if (this.config.separator !== '.') {
                v = this.parseValueToSeparator(v);
            }
            v = v + this.config.currency;
            this.customChange.emit(v);
        }
        else {
            this.onChange(v);
        }
        this.writeValue(v);
        this.value = v;
    }
    ngAfterViewChecked() {
        if (this.input && this.editing) {
            this.input.nativeElement.focus();
            if (this.config.selectTextUponClick && this.firstEdit && this.preValue && this.input.nativeElement.value) {
                this.input.nativeElement.select();
                this.firstEdit = false;
            }
        }
        this.initialized = true;
    }
    startEditing() {
        if (!this.editing) {
            this.editing = true;
            this.currentValue = this.checkAndRemoveCurrency(this.currentValue);
            this.firstEdit = true;
        }
    }
    edit() {
        this.preValue = this.currentValue;
        this.editing = true;
    }
    onSubmit() {
        this.editing = false;
        if (this.currentValue !== this.preValue) {
            if (typeof this.config.handler === 'function') {
                this.isLoading = true;
                this.config.handler(this.currentValue, this.config.data).subscribe(data => {
                    let hasChanged;
                    this.isLoading = false;
                    if (typeof data !== 'boolean') {
                        this.currentValue = data.value;
                        hasChanged = data.success;
                    }
                    else {
                        hasChanged = data;
                    }
                    if (hasChanged) {
                        this._setValue(this.currentValue);
                    }
                    else {
                        this._setValue(this.preValue);
                    }
                }, () => {
                    this.isLoading = false;
                    this._setValue(this.preValue);
                });
            }
            else {
                this._setValue(this.currentValue);
            }
        }
        else {
            if (typeof this.config.currency === 'string') {
                this.currentValue = this.currentValue + this.config.currency;
            }
        }
    }
    checkAndRemoveCurrency(value) {
        if (typeof this.config.currency === 'string') {
            return value.slice(0, -1);
        }
        return value;
    }
    parseValueToNumber(value) {
        if (!isNaN(value) && value !== '') {
            return parseFloat(value);
        }
        if (typeof this.config.currency === 'string') {
            const indexComma = value.indexOf(',');
            const indexDot = value.indexOf('.');
            if (indexComma > 0 && indexDot === -1) {
                const parsedValue = value.replace(',', '.');
                if (!isNaN(parsedValue)) {
                    return parseFloat(parsedValue);
                }
            }
            if (indexDot > 0 && indexComma === -1) {
                if (!isNaN(value)) {
                    return parseFloat(value);
                }
            }
            return 0;
        }
    }
    parseValueToSeparator(value) {
        if (typeof this.config.separator === 'string') {
            value = parseFloat(value).toFixed(2);
            return value.replace('.', this.config.separator);
        }
        return value;
    }
    ngOnChanges(changes) {
        if (this.initialized) {
            this.currentValue = this.checkAndRemoveCurrency(this.currentValue) + this.config.currency;
            this.customChange.emit(this.value);
        }
    }
    selectOption(event) {
        this.currentValue = event.target.innerText;
        this.closeSelect(event);
        event.stopPropagation();
        this.customChange.emit(event.target.value);
    }
    closeSelect(event) {
        this.editing = false;
        this.isLoading = false;
        event.stopPropagation();
    }
}
WzEditInPlaceComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WzEditInPlaceComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
WzEditInPlaceComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: WzEditInPlaceComponent, selector: "wac-edit-in-place", inputs: { type: "type", nwbOptions: "nwbOptions", config: "config", label: "label" }, outputs: { customChange: "customChange" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: WzEditInPlaceComponent,
            multi: true
        }
    ], viewQueries: [{ propertyName: "input", first: true, predicate: ["input"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div [class.nwb-wrapper--editable]=\"type === 'select' || (!editing && !isLoading)\" class=\"wac-edit-in-place nwb-wrapper\" (click)=\"startEditing()\">\r\n  <span\r\n    data-text=\"dd\"\r\n    [class.nwb-is-loading]=\"type === 'select' ? '' : isLoading\"\r\n    [class.nwb-editing]=\"type === 'select' ? '' : editing\"\r\n    [ngClass]=\"type === 'select' ? 'nwbSelect' : ''\"\r\n  >\r\n    {{ currentValue }}\r\n  </span>\r\n\r\n  <input\r\n    #input\r\n    *ngIf=\"type !== 'select' && editing\"\r\n    [class.nwb-editable]=\"!editing\"\r\n    [class.nwb-editing]=\"editing\"\r\n    [class.nwb-is-loading]=\"isLoading\"\r\n    type=\"text\"\r\n    [(ngModel)]=\"value\"\r\n    (focus)=\"edit()\"\r\n    (blur)=\"onSubmit()\"\r\n    (keyup.enter)=\"onSubmit()\"\r\n    [ngStyle]=\"{ 'width.px': inputWidth }\"\r\n  />\r\n  <div class=\"nwbSelect__container\" *ngIf=\"type === 'select' && editing\">\r\n    <div class=\"nwbSelect__background\" (click)=\"closeSelect($event)\"></div>\r\n    <ng-container *ngFor=\"let nwbOption of objectKeys(nwbOptions)\">\r\n      <button\r\n        *ngIf=\"nwbOptions[nwbOption]\"\r\n        [ngClass]=\"\r\n          nwbOptions[nwbOption].label === currentValue\r\n            ? 'nwbSelect__container__item nwbSelect__container__item--selected'\r\n            : 'nwbSelect__container__item'\r\n        \"\r\n        (click)=\"selectOption($event)\"\r\n        [value]=\"nwbOptions[nwbOption].value\"\r\n      >\r\n        {{ nwbOptions[nwbOption].label ? nwbOptions[nwbOption].label : nwbOptions[nwbOption].value }}\r\n      </button>\r\n    </ng-container>\r\n  </div>\r\n\r\n  <span class=\"nwb-loader\" [class.nwb-is-loading]=\"type === 'select' ? '' : isLoading\"></span>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WzEditInPlaceComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-edit-in-place', encapsulation: ViewEncapsulation.None, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: WzEditInPlaceComponent,
                            multi: true
                        }
                    ], template: "<div [class.nwb-wrapper--editable]=\"type === 'select' || (!editing && !isLoading)\" class=\"wac-edit-in-place nwb-wrapper\" (click)=\"startEditing()\">\r\n  <span\r\n    data-text=\"dd\"\r\n    [class.nwb-is-loading]=\"type === 'select' ? '' : isLoading\"\r\n    [class.nwb-editing]=\"type === 'select' ? '' : editing\"\r\n    [ngClass]=\"type === 'select' ? 'nwbSelect' : ''\"\r\n  >\r\n    {{ currentValue }}\r\n  </span>\r\n\r\n  <input\r\n    #input\r\n    *ngIf=\"type !== 'select' && editing\"\r\n    [class.nwb-editable]=\"!editing\"\r\n    [class.nwb-editing]=\"editing\"\r\n    [class.nwb-is-loading]=\"isLoading\"\r\n    type=\"text\"\r\n    [(ngModel)]=\"value\"\r\n    (focus)=\"edit()\"\r\n    (blur)=\"onSubmit()\"\r\n    (keyup.enter)=\"onSubmit()\"\r\n    [ngStyle]=\"{ 'width.px': inputWidth }\"\r\n  />\r\n  <div class=\"nwbSelect__container\" *ngIf=\"type === 'select' && editing\">\r\n    <div class=\"nwbSelect__background\" (click)=\"closeSelect($event)\"></div>\r\n    <ng-container *ngFor=\"let nwbOption of objectKeys(nwbOptions)\">\r\n      <button\r\n        *ngIf=\"nwbOptions[nwbOption]\"\r\n        [ngClass]=\"\r\n          nwbOptions[nwbOption].label === currentValue\r\n            ? 'nwbSelect__container__item nwbSelect__container__item--selected'\r\n            : 'nwbSelect__container__item'\r\n        \"\r\n        (click)=\"selectOption($event)\"\r\n        [value]=\"nwbOptions[nwbOption].value\"\r\n      >\r\n        {{ nwbOptions[nwbOption].label ? nwbOptions[nwbOption].label : nwbOptions[nwbOption].value }}\r\n      </button>\r\n    </ng-container>\r\n  </div>\r\n\r\n  <span class=\"nwb-loader\" [class.nwb-is-loading]=\"type === 'select' ? '' : isLoading\"></span>\r\n</div>\r\n" }]
        }], propDecorators: { type: [{
                type: Input
            }], nwbOptions: [{
                type: Input
            }], config: [{
                type: Input
            }], label: [{
                type: Input
            }], customChange: [{
                type: Output
            }], input: [{
                type: ViewChild,
                args: ['input']
            }] } });

class TextAreaComponent {
    constructor() {
        // todo simplify and improve progress bar
        this.label = '';
        this.value = '';
        this.placeholder = '';
        this.textInfo = '';
        this.textError = '';
        this.size = null;
        this.min = null;
        this.max = null;
        this.dynamicSize = false;
        this.progressBar = false;
        this.disabled = false;
        this.disableResize = false;
        this.id = 'wac-textarea__' +
            Math.random()
                .toString(36)
                .substr(2, 9);
    }
    registerOnChange(fn) {
        this._onChange = fn;
    }
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    writeValue(obj) {
        this.value = obj;
    }
    onChange(value) {
        if (this._onChange) {
            this._onChange(value);
            this.writeValue(value);
        }
    }
    onBlur() {
        if (this._onTouched) {
            this._onTouched();
        }
    }
}
TextAreaComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TextAreaComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TextAreaComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TextAreaComponent, isStandalone: true, selector: "wac-text-area", inputs: { label: "label", value: "value", placeholder: "placeholder", textInfo: "textInfo", textError: "textError", error: "error", success: "success", size: "size", min: "min", max: "max", minHeight: "minHeight", dynamicSize: "dynamicSize", progressBar: "progressBar", disabled: "disabled", maxlength: "maxlength", minlength: "minlength", disableResize: "disableResize" }, providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: TextAreaComponent, multi: true }], ngImport: i0, template: "<div class=\"field wac-text-area\" [ngClass]=\"{'dynamic': dynamicSize}\">\r\n  <div class=\"field-label is-normal has-text-left\">\r\n    <label class=\"label has-text-weight-normal\" [innerHTML]=\"label\" [for]=\"id\"></label>\r\n  </div>\r\n  <div class=\"field-body\">\r\n    <div class=\"field\">\r\n      <p class=\"control\" [ngClass]=\"{ 'has-icons-right': (textError || error || success) && !disabled }\">\r\n        <textarea\r\n          [class]=\"'textarea' + (disableResize ? ' no-resize' : '')\"\r\n          [id]=\"id\"\r\n          [ngClass]=\"{ 'is-danger': (textError || error) && !disabled, 'is-empty': value === '', 'is-success': success && !disabled, 'has-help-text': textInfo !== '' || size }\"\r\n          [placeholder]=\"placeholder\"\r\n          [attr.size]=\"size\"\r\n          [style.minHeight]=\"minHeight\"\r\n          [(ngModel)]=\"value\"\r\n          (ngModelChange)=\"onChange($event)\"\r\n          (blur)=\"onBlur()\"\r\n          [disabled]=\"disabled\"\r\n          [autosize]=\"dynamicSize\"\r\n          [maxlength]=\"maxlength ? maxlength : 524288\"\r\n          [minlength]=\"minlength ? minlength : 0\"\r\n        ></textarea>\r\n        <!-- Icon error -->\r\n        <span *ngIf=\"(textError || error) && !disabled\" class=\"icon is-small is-right\">\r\n          <i class=\"fal fa-times has-text-danger\"></i>\r\n        </span>\r\n        <!-- Icon success -->\r\n        <span *ngIf=\"success && !disabled\" class=\"icon is-small is-right\">\r\n          <i class=\"fas fa-check has-text-success\"></i>\r\n        </span>\r\n        <span\r\n          *ngIf=\"textInfo && (textError === null || textError === '')\"\r\n          class=\"is-size-7 wac-text-area__info text-info\"\r\n          [innerHtml]=\"textInfo\"\r\n        ></span>\r\n        <span *ngIf=\"textError\" class=\"is-size-7 wac-text-area__error has-text-danger\" [innerHtml]=\"textError\"></span>\r\n        <span\r\n          *ngIf=\"size && !progressBar\"\r\n          class=\"is-size-7 wac-text-area__size\"\r\n          [ngClass]=\"value && value.length > size ? 'has-text-danger' : ''\"\r\n          ><strong>{{ value ? value.length : 0 }}</strong> / {{ size }}</span\r\n        >\r\n      </p>\r\n      <wac-progress-bar *ngIf=\"progressBar && value\" [min]=\"min\" [max]=\"max\" [valueLength]=\"value.length\"></wac-progress-bar>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MinLengthValidator, selector: "[minlength][formControlName],[minlength][formControl],[minlength][ngModel]", inputs: ["minlength"] }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: ProgressBarComponent, selector: "wac-progress-bar", inputs: ["valueLength", "min", "max"] }, { kind: "ngmodule", type: AutosizeModule }, { kind: "directive", type: i3$1.AutosizeDirective, selector: "[autosize]", inputs: ["minRows", "autosize", "maxRows", "onlyGrow", "useImportant"], outputs: ["resized"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TextAreaComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-text-area', standalone: true, imports: [
                        CommonModule,
                        FormsModule,
                        ProgressBarComponent,
                        AutosizeModule
                    ], providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: TextAreaComponent, multi: true }], template: "<div class=\"field wac-text-area\" [ngClass]=\"{'dynamic': dynamicSize}\">\r\n  <div class=\"field-label is-normal has-text-left\">\r\n    <label class=\"label has-text-weight-normal\" [innerHTML]=\"label\" [for]=\"id\"></label>\r\n  </div>\r\n  <div class=\"field-body\">\r\n    <div class=\"field\">\r\n      <p class=\"control\" [ngClass]=\"{ 'has-icons-right': (textError || error || success) && !disabled }\">\r\n        <textarea\r\n          [class]=\"'textarea' + (disableResize ? ' no-resize' : '')\"\r\n          [id]=\"id\"\r\n          [ngClass]=\"{ 'is-danger': (textError || error) && !disabled, 'is-empty': value === '', 'is-success': success && !disabled, 'has-help-text': textInfo !== '' || size }\"\r\n          [placeholder]=\"placeholder\"\r\n          [attr.size]=\"size\"\r\n          [style.minHeight]=\"minHeight\"\r\n          [(ngModel)]=\"value\"\r\n          (ngModelChange)=\"onChange($event)\"\r\n          (blur)=\"onBlur()\"\r\n          [disabled]=\"disabled\"\r\n          [autosize]=\"dynamicSize\"\r\n          [maxlength]=\"maxlength ? maxlength : 524288\"\r\n          [minlength]=\"minlength ? minlength : 0\"\r\n        ></textarea>\r\n        <!-- Icon error -->\r\n        <span *ngIf=\"(textError || error) && !disabled\" class=\"icon is-small is-right\">\r\n          <i class=\"fal fa-times has-text-danger\"></i>\r\n        </span>\r\n        <!-- Icon success -->\r\n        <span *ngIf=\"success && !disabled\" class=\"icon is-small is-right\">\r\n          <i class=\"fas fa-check has-text-success\"></i>\r\n        </span>\r\n        <span\r\n          *ngIf=\"textInfo && (textError === null || textError === '')\"\r\n          class=\"is-size-7 wac-text-area__info text-info\"\r\n          [innerHtml]=\"textInfo\"\r\n        ></span>\r\n        <span *ngIf=\"textError\" class=\"is-size-7 wac-text-area__error has-text-danger\" [innerHtml]=\"textError\"></span>\r\n        <span\r\n          *ngIf=\"size && !progressBar\"\r\n          class=\"is-size-7 wac-text-area__size\"\r\n          [ngClass]=\"value && value.length > size ? 'has-text-danger' : ''\"\r\n          ><strong>{{ value ? value.length : 0 }}</strong> / {{ size }}</span\r\n        >\r\n      </p>\r\n      <wac-progress-bar *ngIf=\"progressBar && value\" [min]=\"min\" [max]=\"max\" [valueLength]=\"value.length\"></wac-progress-bar>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], propDecorators: { label: [{
                type: Input
            }], value: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], textInfo: [{
                type: Input
            }], textError: [{
                type: Input
            }], error: [{
                type: Input
            }], success: [{
                type: Input
            }], size: [{
                type: Input
            }], min: [{
                type: Input
            }], max: [{
                type: Input
            }], minHeight: [{
                type: Input
            }], dynamicSize: [{
                type: Input
            }], progressBar: [{
                type: Input
            }], disabled: [{
                type: Input
            }], maxlength: [{
                type: Input
            }], minlength: [{
                type: Input
            }], disableResize: [{
                type: Input
            }] } });

class H1Component {
    get noMargin() {
        return this._noMargin;
    }
    set noMargin(value) {
        this._noMargin = value === '' || value === 'noMargin' || value === true;
    }
    constructor() {
        this.annotation = '';
        this.withImg = false;
        this.center = false;
        this.color = null;
        this._noMargin = false;
    }
}
H1Component.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: H1Component, deps: [], target: i0.ɵɵFactoryTarget.Component });
H1Component.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: H1Component, selector: "wac-h1", inputs: { annotation: "annotation", withImg: "withImg", center: "center", color: "color", noMargin: "noMargin" }, ngImport: i0, template: "<h1 class=\"wac-h1\" [ngClass]=\"{'with-img': withImg, 'center': center}\" [style.color]=\"color?color:''\" [class.no-margin]=\"noMargin\">\r\n    <ng-content></ng-content><small *ngIf=\"annotation !== ''\">{{ annotation }}</small>\r\n</h1>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: H1Component, decorators: [{
            type: Component,
            args: [{ selector: 'wac-h1', template: "<h1 class=\"wac-h1\" [ngClass]=\"{'with-img': withImg, 'center': center}\" [style.color]=\"color?color:''\" [class.no-margin]=\"noMargin\">\r\n    <ng-content></ng-content><small *ngIf=\"annotation !== ''\">{{ annotation }}</small>\r\n</h1>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { annotation: [{
                type: Input
            }], withImg: [{
                type: Input
            }], center: [{
                type: Input
            }], color: [{
                type: Input
            }], noMargin: [{
                type: Input
            }] } });

class H2Component {
    get noMargin() {
        return this._noMargin;
    }
    set noMargin(value) {
        this._noMargin = value === '' || value === 'noMargin' || value === true;
    }
    constructor() {
        this._noMargin = false;
    }
    ngOnInit() { }
}
H2Component.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: H2Component, deps: [], target: i0.ɵɵFactoryTarget.Component });
H2Component.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: H2Component, selector: "wac-h2", inputs: { noMargin: "noMargin" }, ngImport: i0, template: "<h2 class=\"wac-h2\" [class.no-margin]=\"noMargin\">\r\n    <ng-content></ng-content>\r\n</h2>\r\n" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: H2Component, decorators: [{
            type: Component,
            args: [{ selector: 'wac-h2', template: "<h2 class=\"wac-h2\" [class.no-margin]=\"noMargin\">\r\n    <ng-content></ng-content>\r\n</h2>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { noMargin: [{
                type: Input
            }] } });

class H3Component {
    get noMargin() {
        return this._noMargin;
    }
    set noMargin(value) {
        this._noMargin = value === '' || value === 'noMargin' || value === true;
    }
    constructor() {
        this.grey = false;
        this._noMargin = false;
    }
    ngOnInit() { }
}
H3Component.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: H3Component, deps: [], target: i0.ɵɵFactoryTarget.Component });
H3Component.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: H3Component, selector: "wac-h3", inputs: { grey: "grey", noMargin: "noMargin" }, ngImport: i0, template: "<h3 class=\"wac-h3\" [ngClass]=\"{ grey: grey }\" [class.no-margin]=\"noMargin\">\r\n    <ng-content></ng-content>\r\n</h3>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: H3Component, decorators: [{
            type: Component,
            args: [{ selector: 'wac-h3', template: "<h3 class=\"wac-h3\" [ngClass]=\"{ grey: grey }\" [class.no-margin]=\"noMargin\">\r\n    <ng-content></ng-content>\r\n</h3>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { grey: [{
                type: Input
            }], noMargin: [{
                type: Input
            }] } });

class HistoryService {
    constructor(router) {
        this.router = router;
        this.history = [];
    }
    registerHistory() {
        this.router.events.subscribe((event) => {
            if (event instanceof NavigationStart) {
                if (this.history.length > 0 && this.history[this.history.length - 1] === event.url.split('?')[0]) {
                    return;
                }
                this.history.push(event.url.split('?')[0]);
            }
        });
    }
    back(link) {
        this.history.pop();
        if (this.history.length > 0) {
            const lastlink = this.history[this.history.length - 1];
            this.router.navigate(lastlink.split('/'));
        }
        else {
            this.redirect(link);
        }
    }
    redirect(link) {
        if (link[0].indexOf('http') !== -1) {
            this.redirectToExternalLink(link);
        }
        else {
            this.redirectToInternalLink(link);
        }
    }
    redirectToExternalLink(link) {
        window.location.href = link[0];
    }
    redirectToInternalLink(link) {
        this.router.navigate(link);
    }
}
HistoryService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: HistoryService, deps: [{ token: i1$3.Router }], target: i0.ɵɵFactoryTarget.Injectable });
HistoryService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: HistoryService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: HistoryService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$3.Router }]; } });

class HeaderPageComponent {
    constructor(historyService, location) {
        this.historyService = historyService;
        this.location = location;
        this.withImg = false;
        this.center = false;
        this.useHistory = false;
    }
    back() {
        if (this.useHistory && !this.linkBack) {
            window.history.back();
            return;
        }
        else if (!this.useHistory) {
            this.historyService.redirect(this.linkBack);
            return;
        }
        this.historyService.back(this.linkBack);
    }
}
HeaderPageComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: HeaderPageComponent, deps: [{ token: HistoryService }, { token: i1.Location }], target: i0.ɵɵFactoryTarget.Component });
HeaderPageComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: HeaderPageComponent, selector: "wac-header-page", inputs: { title: "title", linkBack: "linkBack", withImg: "withImg", center: "center", useHistory: "useHistory" }, ngImport: i0, template: "<div class=\"wac-header-page\">\r\n  <div class=\"wac-header-page__maxWidth\">\r\n    <div class=\"wac-header-page__maxWidth__top\" [ngClass]=\"{'center':center}\">\r\n      <div class=\"wac-header-page__maxWidth__top__left\" [ngClass]=\"{'fullsize':center}\">\r\n        <div class=\"wac-header-page__maxWidth__top__left__nowrap\">\r\n          <a *ngIf=\"linkBack || useHistory\" (click)=\"back()\"><i class=\"fas fa-chevron-left\"></i></a>\r\n          <wac-h1 [center]=\"center\" [withImg]=\"withImg\">{{ title }}<ng-content select=\"[role=header]\"></ng-content></wac-h1>\r\n        </div>\r\n        <p class=\"subtitle\"><ng-content select=\"[role=subtitle]\"></ng-content></p>\r\n      </div>\r\n      <div class=\"wac-header-page__maxWidth__top__right\" *ngIf=\"!center\">\r\n        <ng-content></ng-content>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: H1Component, selector: "wac-h1", inputs: ["annotation", "withImg", "center", "color", "noMargin"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: HeaderPageComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-header-page', template: "<div class=\"wac-header-page\">\r\n  <div class=\"wac-header-page__maxWidth\">\r\n    <div class=\"wac-header-page__maxWidth__top\" [ngClass]=\"{'center':center}\">\r\n      <div class=\"wac-header-page__maxWidth__top__left\" [ngClass]=\"{'fullsize':center}\">\r\n        <div class=\"wac-header-page__maxWidth__top__left__nowrap\">\r\n          <a *ngIf=\"linkBack || useHistory\" (click)=\"back()\"><i class=\"fas fa-chevron-left\"></i></a>\r\n          <wac-h1 [center]=\"center\" [withImg]=\"withImg\">{{ title }}<ng-content select=\"[role=header]\"></ng-content></wac-h1>\r\n        </div>\r\n        <p class=\"subtitle\"><ng-content select=\"[role=subtitle]\"></ng-content></p>\r\n      </div>\r\n      <div class=\"wac-header-page__maxWidth__top__right\" *ngIf=\"!center\">\r\n        <ng-content></ng-content>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: HistoryService }, { type: i1.Location }]; }, propDecorators: { title: [{
                type: Input
            }], linkBack: [{
                type: Input
            }], withImg: [{
                type: Input
            }], center: [{
                type: Input
            }], useHistory: [{
                type: Input
            }] } });

class LinkComponent {
    set href(link) {
        this._link = link;
        this.setAttributesLink();
    }
    get href() {
        return this._link;
    }
    constructor(renderer2) {
        this.renderer2 = renderer2;
        this.target = '_self';
        this.fontSize = '14px';
    }
    ngAfterViewInit() {
        this.setAttributesLink();
    }
    setAttributesLink() {
        if (!this.linkComponent) {
            return;
        }
        if (this.href) {
            this.renderer2.setAttribute(this.linkComponent.nativeElement, "href", this.href);
            this.renderer2.setAttribute(this.linkComponent.nativeElement, "target", this.target);
        }
        else {
            this.renderer2.removeAttribute(this.linkComponent.nativeElement, "href");
            this.renderer2.removeAttribute(this.linkComponent.nativeElement, "target");
        }
    }
}
LinkComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: LinkComponent, deps: [{ token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
LinkComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: LinkComponent, selector: "wac-link", inputs: { href: "href", tooltip: "tooltip", tooltipWidth: "tooltipWidth", target: "target", id: "id", class: "class", fontSize: "fontSize" }, viewQueries: [{ propertyName: "linkComponent", first: true, predicate: ["linkComponent"], descendants: true }], ngImport: i0, template: "<a #linkComponent class=\"wac-link\" [style.fontSize]=\"fontSize\" [ngClass]=\"{ class: class }\" [id]=\"{ id: id }\">\r\n  <ng-content></ng-content>\r\n  <span class=\"wac-link__tooltip\" [ngStyle]=\"{'min-width': tooltipWidth + 'px'}\" *ngIf=\"tooltip\" [innerHTML]=\"tooltip\"></span>\r\n</a>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: LinkComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-link', template: "<a #linkComponent class=\"wac-link\" [style.fontSize]=\"fontSize\" [ngClass]=\"{ class: class }\" [id]=\"{ id: id }\">\r\n  <ng-content></ng-content>\r\n  <span class=\"wac-link__tooltip\" [ngStyle]=\"{'min-width': tooltipWidth + 'px'}\" *ngIf=\"tooltip\" [innerHTML]=\"tooltip\"></span>\r\n</a>\r\n" }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }]; }, propDecorators: { href: [{
                type: Input
            }], tooltip: [{
                type: Input
            }], tooltipWidth: [{
                type: Input
            }], target: [{
                type: Input
            }], id: [{
                type: Input
            }], class: [{
                type: Input
            }], fontSize: [{
                type: Input
            }], linkComponent: [{
                type: ViewChild,
                args: ['linkComponent']
            }] } });

class SwitchComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // todo add ngmodel and review texts display (textState is mandatory in order to display textStateEnable and textStateDisable)
        this.value = false;
        this.textState = '';
        this.textStateAfter = '';
        this.textStateEnable = '';
        this.textStateDisable = '';
        this.showInput = false; // todo should not be handle here, but in another component
        this.danger = false;
        this.whiteSpace = false;
        this.inverted = false;
        this.switchChange = new EventEmitter(); // todo set emitted type
        this.changeInput = new EventEmitter(); // todo set emitted type, should be removed
        this.onChange = (value) => { };
        this.onTouched = () => { };
    }
    ngOnInit() {
        this.id = 'switch-' + Math.floor(Math.random() * Math.floor(1000));
    }
    changeValue(event) {
        if (this.disabled) {
            return;
        }
        this.value = event.target.checked;
        this.switchChange.emit(this.value);
        this.onChange(this.value);
    }
    triggerInput() {
        this.changeInput.emit(this.valueInput);
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(onChange) {
        this.onChange = onChange;
    }
    onBlur() {
        this.onTouched();
    }
    registerOnTouched(onTouched) {
        this.onTouched = onTouched;
    }
    setDisabledState(disabled) {
        this.disabled = disabled;
        this.changeDetectorRef.markForCheck();
    }
}
SwitchComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SwitchComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
SwitchComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SwitchComponent, selector: "wac-switch", inputs: { value: "value", textState: "textState", textStateAfter: "textStateAfter", textStateEnable: "textStateEnable", textStateDisable: "textStateDisable", showInput: "showInput", placholderInput: "placholderInput", danger: "danger", whiteSpace: "whiteSpace", inverted: "inverted" }, outputs: { switchChange: "switchChange", changeInput: "changeInput" }, providers: [
        { provide: NG_VALUE_ACCESSOR, useExisting: SwitchComponent, multi: true },
    ], ngImport: i0, template: "<div class=\"wac-switch\" [ngClass]=\"{ inverted: inverted }\">\r\n  <input type=\"checkbox\" [checked]=\"value\" (change)=\"changeValue($event)\" [id]=\"id\" [ngClass]=\"{ danger: danger }\" [disabled]=\"disabled\"/>\r\n  <label [for]=\"id\" class=\"wac-switch__label\">\r\n    <span class=\"wac-switch__label__text\">\r\n      <ng-content></ng-content>\r\n      <span\r\n        *ngIf=\"textState\"\r\n        [ngStyle]=\"{'whiteSpace': whiteSpace ? 'nowrap' :'normal'}\"\r\n        >{{ textState }}\r\n        <strong class=\"disable\" *ngIf=\"textStateDisable\">{{ textStateDisable }}</strong>\r\n        <strong class=\"enable\" *ngIf=\"textStateEnable\">{{ textStateEnable }}</strong>\r\n        {{ textStateAfter }}\r\n      </span>\r\n    </span>\r\n  </label>\r\n</div>\r\n<div class=\"wac-show-input\" *ngIf=\"showInput && value\">\r\n  <input [placeholder]=\"placholderInput\" type=\"text\" [(ngModel)]=\"valueInput\" (blur)=\"triggerInput()\" />\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SwitchComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-switch', providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: SwitchComponent, multi: true },
                    ], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"wac-switch\" [ngClass]=\"{ inverted: inverted }\">\r\n  <input type=\"checkbox\" [checked]=\"value\" (change)=\"changeValue($event)\" [id]=\"id\" [ngClass]=\"{ danger: danger }\" [disabled]=\"disabled\"/>\r\n  <label [for]=\"id\" class=\"wac-switch__label\">\r\n    <span class=\"wac-switch__label__text\">\r\n      <ng-content></ng-content>\r\n      <span\r\n        *ngIf=\"textState\"\r\n        [ngStyle]=\"{'whiteSpace': whiteSpace ? 'nowrap' :'normal'}\"\r\n        >{{ textState }}\r\n        <strong class=\"disable\" *ngIf=\"textStateDisable\">{{ textStateDisable }}</strong>\r\n        <strong class=\"enable\" *ngIf=\"textStateEnable\">{{ textStateEnable }}</strong>\r\n        {{ textStateAfter }}\r\n      </span>\r\n    </span>\r\n  </label>\r\n</div>\r\n<div class=\"wac-show-input\" *ngIf=\"showInput && value\">\r\n  <input [placeholder]=\"placholderInput\" type=\"text\" [(ngModel)]=\"valueInput\" (blur)=\"triggerInput()\" />\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { value: [{
                type: Input
            }], textState: [{
                type: Input
            }], textStateAfter: [{
                type: Input
            }], textStateEnable: [{
                type: Input
            }], textStateDisable: [{
                type: Input
            }], showInput: [{
                type: Input
            }], placholderInput: [{
                type: Input
            }], danger: [{
                type: Input
            }], whiteSpace: [{
                type: Input
            }], inverted: [{
                type: Input
            }], switchChange: [{
                type: Output
            }], changeInput: [{
                type: Output
            }] } });

class AlertComponent {
    constructor() {
        this.icon = true;
        this.warning = false;
        this.success = false;
        this.alert = false;
        this.iconClass = 'fas fa-info';
        this.closeButton = false;
        this.isClose = false;
        this.isCloseChange = new EventEmitter();
    }
    ngOnInit() { }
    closeAlert(el) {
        el.remove();
        this.isClose = true;
        this.isCloseChange.next(this.isClose);
    }
}
AlertComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AlertComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
AlertComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: AlertComponent, selector: "wac-alert", inputs: { icon: "icon", warning: "warning", success: "success", alert: "alert", iconClass: "iconClass", closeButton: "closeButton" }, outputs: { isCloseChange: "isCloseChange" }, ngImport: i0, template: "<div #alertBlock class=\"wac-alert\" [ngClass]=\"{ success: success, warning: warning, alert: alert }\">\r\n  <i *ngIf=\"icon\" [ngClass]=\"iconClass\"></i>\r\n  <p><ng-content></ng-content></p> <!-- ! Refacto : Remove p tag, attention \u00E0 wizi-admin -->\r\n  <a *ngIf=\"closeButton\" (click)=\"closeAlert(this.alertBlock)\"><i [ngClass]=\"'closeAlert fal fa-circle-xmark'\"></i></a>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AlertComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-alert', template: "<div #alertBlock class=\"wac-alert\" [ngClass]=\"{ success: success, warning: warning, alert: alert }\">\r\n  <i *ngIf=\"icon\" [ngClass]=\"iconClass\"></i>\r\n  <p><ng-content></ng-content></p> <!-- ! Refacto : Remove p tag, attention \u00E0 wizi-admin -->\r\n  <a *ngIf=\"closeButton\" (click)=\"closeAlert(this.alertBlock)\"><i [ngClass]=\"'closeAlert fal fa-circle-xmark'\"></i></a>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { icon: [{
                type: Input
            }], warning: [{
                type: Input
            }], success: [{
                type: Input
            }], alert: [{
                type: Input
            }], iconClass: [{
                type: Input
            }], closeButton: [{
                type: Input
            }], isCloseChange: [{
                type: Output
            }] } });

class TextComponent {
    constructor() {
        this._noMargin = false;
    }
    get noMargin() {
        return this._noMargin;
    }
    set noMargin(value) {
        this._noMargin = value === '' || value === 'noMargin' || value === true;
    }
}
TextComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TextComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TextComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TextComponent, selector: "wac-text", inputs: { textClass: "textClass", noMargin: "noMargin" }, ngImport: i0, template: "<div class=\"wac-text\" [class]=\"textClass\" [class.no-margin]=\"noMargin\">\r\n    <p><ng-content></ng-content></p>\r\n</div>\r\n" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TextComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-text', template: "<div class=\"wac-text\" [class]=\"textClass\" [class.no-margin]=\"noMargin\">\r\n    <p><ng-content></ng-content></p>\r\n</div>\r\n" }]
        }], propDecorators: { textClass: [{
                type: Input
            }], noMargin: [{
                type: Input
            }] } });

const pipes$1 = [PagniationArrayTotalPages, PagniationIsLastPage, PagniationText];
class PaginationModule {
}
PaginationModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PaginationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
PaginationModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: PaginationModule, declarations: [PaginationComponent, PagniationArrayTotalPages, PagniationIsLastPage, PagniationText], imports: [CommonModule,
        FormsModule,
        TranslateModule], exports: [PaginationComponent] });
PaginationModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PaginationModule, imports: [CommonModule,
        FormsModule,
        TranslateModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PaginationModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        TranslateModule
                    ],
                    exports: [PaginationComponent],
                    declarations: [PaginationComponent, ...pipes$1],
                    providers: [],
                }]
        }] });

class CheckboxModule {
}
CheckboxModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CheckboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CheckboxModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: CheckboxModule, declarations: [CheckboxComponent], imports: [CommonModule,
        FormsModule], exports: [CheckboxComponent] });
CheckboxModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CheckboxModule, imports: [CommonModule,
        FormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CheckboxModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                    ],
                    exports: [CheckboxComponent],
                    declarations: [CheckboxComponent],
                    providers: [],
                }]
        }] });

class TableColumn {
    constructor(currentCell, renderer, document) {
        this.currentCell = currentCell;
        this.renderer = renderer;
        this.document = document;
        this.centerCellValue = ['left', 'center', 'right'];
    }
    ngAfterViewInit() {
        this.applyCustomStylesOnCell();
    }
    applyCustomStylesOnCell() {
        this.currentCell.nativeElement.style.flexGrow = typeof this.columnSize !== 'undefined' ? this.columnSize : '1';
        this.renderer.addClass(this.currentCell.nativeElement, 'wac-table__body__line__cell');
        if (this.centerCell) {
            if (this.centerCellValue.indexOf(this.centerCell) === -1) {
                throw 'Error : The centerCell directive has no matched value. The value must be one of the following : left, center, right.';
            }
            let className = 'wac-table__body__line__cell--center' + '--' + this.centerCell;
            this.renderer.addClass(this.currentCell.nativeElement, className);
        }
    }
}
TableColumn.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableColumn, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Directive });
TableColumn.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: TableColumn, selector: "[tableColumn]", inputs: { columnSize: "columnSize", centerCell: "centerCell" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableColumn, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tableColumn]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; }, propDecorators: { columnSize: [{
                type: Input
            }], centerCell: [{
                type: Input
            }] } });

class TableColumnHeader {
    set headerName(value) {
        this._headerName = value;
        this.setHeaderName();
    }
    get headerName() {
        return this._headerName;
    }
    constructor(currentCell, renderer, document, filtersTableService) {
        this.currentCell = currentCell;
        this.renderer = renderer;
        this.document = document;
        this.filtersTableService = filtersTableService;
        this._headerName = '';
        this.filterRouting = false; // Optional. Set to true to use Filter Routing.
        this.onSortChange = new EventEmitter(); // Emit the sort value (true, false, undefuned) of the current sort icon when clicking
        this.tableFiltersChange = new EventEmitter();
        this.centerCellValue = ['left', 'center', 'right'];
        this.subscriptions = [];
    }
    ngOnInit() {
        if (this.tableName && this.sortName) {
            if (this.filterRouting) {
                this.handleSortRouting();
            }
            else {
                this.handleSortBasic();
            }
        }
    }
    ngAfterViewInit() {
        this.applyCustomStylesOnCell();
        this.renderHeaderColumn();
    }
    handleSortRouting() {
        this.filterGroup = this.filtersTableService.getTableFilterGroup(this.tableName);
        const filterGroupChangeSub = this.filterGroup.valuesChange$.subscribe((filters) => {
            if (!filters || !filters.length) {
                return;
            }
            const filterSort = filters.filter(filter => filter.key === 'sort')[0];
            if (this.sortName !== filterSort.value) {
                this.resetSortIcon();
            }
        });
        this.subscriptions.push(filterGroupChangeSub);
    }
    handleSortBasic() {
        const sortChangeSub = this.filtersTableService.getSortChangeListner().subscribe(sort => {
            if (this.tableName === sort.dataTableName && this.sortName !== sort.sortName) {
                // Reset the current sort icon
                this.resetSortIcon();
            }
        });
        this.subscriptions.push(sortChangeSub);
    }
    resetSortIcon() {
        // Replace current icon with default icon
        this.contentHeader.className = this.contentHeader.className.replace(this.getCurrentSortIcon(), 'idle');
    }
    applyCustomStylesOnCell() {
        this.currentCell.nativeElement.style.flexGrow = typeof this.columnSize !== 'undefined' ? this.columnSize : '1';
        this.renderer.addClass(this.currentCell.nativeElement, 'wac-table__head__cell');
        if (this.centerCell) {
            if (this.centerCellValue.indexOf(this.centerCell) === -1) {
                throw 'Error : The centerCell directive has no matched value. The value must be one of the following : left, center, right.';
            }
            let className = 'wac-table__head__cell--center' + '--' + this.centerCell;
            this.renderer.addClass(this.currentCell.nativeElement, className);
        }
    }
    renderHeaderColumn() {
        this.createHeaderContent();
        this.renderer.appendChild(this.currentCell.nativeElement, this.contentHeader);
    }
    createHeaderContent() {
        this.contentHeader = document.createElement('a');
        this.contentHeader.className = 'wac-table__head__cell__search';
        this.setHeaderName();
        if (this.tableName && this.sortName) {
            this.handleSort();
        }
    }
    setHeaderName() {
        if (!this.contentHeader) {
            return;
        }
        this.contentHeader.innerHTML = this.headerName;
    }
    handleSort() {
        // Set icon in the header column cell
        this.contentHeader.className += ' wac-table__head__cell__search--' + this.getInitialSortIcon();
        // On click on the content header, change the icon and emit event
        this.renderer.listen(this.contentHeader, 'click', () => {
            const currentIcon = this.getCurrentSortIcon();
            let newIcon;
            let newSort, newOrder;
            switch (currentIcon) {
                case 'idle':
                    newIcon = 'up';
                    newSort = this.sortName;
                    newOrder = true;
                    break;
                case 'up':
                    newIcon = 'down';
                    newSort = this.sortName;
                    newOrder = false;
                    break;
                case 'down':
                    newIcon = 'idle';
                    break;
                default:
                    newIcon = 'idle';
                    break;
            }
            // Replace the icon
            this.contentHeader.className = this.contentHeader.className.replace(currentIcon, newIcon);
            this.emitEvents(newSort, newOrder);
        });
    }
    getInitialSortIcon() {
        if (!this.filterRouting) {
            return 'idle';
        }
        // Get Initial Sort Icon for Routing Filter
        let initialSortIcon = 'idle';
        if (this.filterGroup.get('sort') === this.sortName) {
            initialSortIcon = this.filterGroup.get('order') == 'true' ? 'up' : 'down';
        }
        return initialSortIcon;
    }
    getCurrentSortIcon() {
        const regexp = /wac-table__head__cell__search--(?<icon>\w+)/;
        const { groups } = regexp.exec(this.contentHeader.className);
        return groups.icon;
    }
    emitEvents(newSort, newOrder) {
        if (this.filterRouting) {
            // Will send the filter routing value has changes event
            this.filterGroup.setValues({
                sort: newSort,
                order: newOrder,
                currentPage: 1
            });
        }
        else {
            // Send the event sort change
            this.filtersTableService.emitSortChange(this.tableName, this.sortName, newOrder);
        }
        if (this.tableFilters) {
            this.tableFilters.sort = this.sortName;
            this.tableFilters.order = newOrder;
            this.tableFilters.currentPage = 1;
            this.tableFiltersChange.emit(this.tableFilters);
        }
        this.onSortChange.emit(newOrder);
    }
    ngOnDestroy() {
        this.subscriptions.forEach(subscription => {
            subscription.unsubscribe();
        });
    }
}
TableColumnHeader.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableColumnHeader, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }, { token: DOCUMENT }, { token: FiltersTableService }], target: i0.ɵɵFactoryTarget.Directive });
TableColumnHeader.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: TableColumnHeader, selector: "[headerCell]", inputs: { headerName: "headerName", columnSize: "columnSize", filterRouting: "filterRouting", tableName: "tableName", sortName: "sortName", centerCell: "centerCell", tableFilters: "tableFilters" }, outputs: { onSortChange: "onSortChange", tableFiltersChange: "tableFiltersChange" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableColumnHeader, decorators: [{
            type: Directive,
            args: [{
                    // The selector has the same name as the headerCell selector in table.component.html
                    selector: '[headerCell]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: FiltersTableService }]; }, propDecorators: { headerName: [{
                type: Input
            }], columnSize: [{
                type: Input
            }], filterRouting: [{
                type: Input
            }], tableName: [{
                type: Input
            }], sortName: [{
                type: Input
            }], centerCell: [{
                type: Input
            }], onSortChange: [{
                type: Output
            }], tableFilters: [{
                type: Input
            }], tableFiltersChange: [{
                type: Output
            }] } });

const directives$1 = [TableColumn, CheckBoxRow, TableColumnHeader, TableRow,];
class TableModule {
}
TableModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
TableModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: TableModule, declarations: [TableComponent, TableColumn, CheckBoxRow, TableColumnHeader, TableRow], imports: [CommonModule,
        FormsModule,
        InputSearchComponent,
        LoaderComponent,
        CheckboxModule,
        PaginationModule], exports: [TableComponent, TableColumn, CheckBoxRow, TableColumnHeader, TableRow] });
TableModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableModule, imports: [CommonModule,
        FormsModule,
        InputSearchComponent,
        LoaderComponent,
        CheckboxModule,
        PaginationModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TableModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        InputSearchComponent,
                        LoaderComponent,
                        CheckboxModule,
                        PaginationModule
                    ],
                    exports: [TableComponent, ...directives$1],
                    declarations: [TableComponent, ...directives$1],
                    providers: [],
                }]
        }] });

class UploadComponent {
    constructor() {
        this.label = 'Choisir les images à importer';
        this.type = 'button';
        this.icon = 'far fa-images';
        this.image = 'assets/angular-components/images/upload/icon_picture.svg';
        this.labelImage = 'Glisser-déposer votre image ici';
        this.open = new EventEmitter();
    }
    ngOnInit() { }
    triggerEvent(event) {
        this.open.emit(event);
    }
}
UploadComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: UploadComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
UploadComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: UploadComponent, selector: "wac-upload", inputs: { label: "label", type: "type", icon: "icon", image: "image", labelImage: "labelImage" }, outputs: { open: "open" }, ngImport: i0, template: "<div class=\"wac-upload\" [ngClass]=\"{ portrait: type === 'portrait', landscape: type === 'landscape' }\">\r\n  <div class=\"wac-upload__wrapper\">\r\n    <div *ngIf=\"(type === 'portrait' || type === 'landscape') && image\" class=\"wac-upload__wrapper__visual\">\r\n      <img [src]=\"image\" />\r\n      <strong [innerHTML]=\"labelImage\"></strong>\r\n    </div>\r\n    <span *ngIf=\"(type === 'portrait' || type === 'landscape') && image\">ou</span>\r\n    <button (click)=\"triggerEvent($event)\" type=\"button\">\r\n      <span *ngIf=\"icon\"><i [classList]=\"icon\"></i></span>\r\n      <span [innerHTML]=\"label\"></span>\r\n    </button>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: UploadComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-upload', template: "<div class=\"wac-upload\" [ngClass]=\"{ portrait: type === 'portrait', landscape: type === 'landscape' }\">\r\n  <div class=\"wac-upload__wrapper\">\r\n    <div *ngIf=\"(type === 'portrait' || type === 'landscape') && image\" class=\"wac-upload__wrapper__visual\">\r\n      <img [src]=\"image\" />\r\n      <strong [innerHTML]=\"labelImage\"></strong>\r\n    </div>\r\n    <span *ngIf=\"(type === 'portrait' || type === 'landscape') && image\">ou</span>\r\n    <button (click)=\"triggerEvent($event)\" type=\"button\">\r\n      <span *ngIf=\"icon\"><i [classList]=\"icon\"></i></span>\r\n      <span [innerHTML]=\"label\"></span>\r\n    </button>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { label: [{
                type: Input
            }], type: [{
                type: Input
            }], icon: [{
                type: Input
            }], image: [{
                type: Input
            }], labelImage: [{
                type: Input
            }], open: [{
                type: Output
            }] } });

class H4Component {
    get noMargin() {
        return this._noMargin;
    }
    set noMargin(value) {
        this._noMargin = value === '' || value === 'noMargin' || value === true;
    }
    constructor() {
        this.grey = false;
        this._noMargin = false;
    }
    ngOnInit() { }
}
H4Component.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: H4Component, deps: [], target: i0.ɵɵFactoryTarget.Component });
H4Component.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: H4Component, selector: "wac-h4", inputs: { grey: "grey", noMargin: "noMargin" }, ngImport: i0, template: "<h4 class=\"wac-h4\" [ngClass]=\"{ grey: grey }\" [class.no-margin]=\"noMargin\">\r\n    <ng-content></ng-content>\r\n</h4>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: H4Component, decorators: [{
            type: Component,
            args: [{ selector: 'wac-h4', template: "<h4 class=\"wac-h4\" [ngClass]=\"{ grey: grey }\" [class.no-margin]=\"noMargin\">\r\n    <ng-content></ng-content>\r\n</h4>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { grey: [{
                type: Input
            }], noMargin: [{
                type: Input
            }] } });

class SelectInTextComponent {
    set items(items) {
        this._items = items;
        this.setInitialValues();
    }
    get items() {
        return this._items;
    }
    constructor() {
        this.type = 'default';
        this.alwaysOpen = false;
        this.openCategories = false;
        this.currentLabel = '';
        this.currentLabelIcon = '';
        this.maxWidth = '100%';
        this.selectValue = new EventEmitter();
        this.clickOnCallToAction = new EventEmitter();
    }
    ngOnInit() {
        this.currentLabel = this.placeholder;
        this.setInitialValues();
    }
    setInitialValues() {
        if (!this.items.length) {
            return;
        }
        const itemSelected = this.getItemSelected();
        this.setCurrentItem(itemSelected);
    }
    onClose() {
        this.openCategories = false;
    }
    customTB(index, item) {
        return item.id;
    }
    onSelectItem(index) {
        this.unselectAll();
        const itemSelected = this.items[index];
        this.setCurrentItem(itemSelected);
        this.selectValue.emit(index);
    }
    onClickCallToAction() {
        this.clickOnCallToAction.emit(this.callToAction.value);
    }
    getItemSelected() {
        let itemSelected = null;
        this.items.forEach(item => {
            if (!item.selected) {
                return;
            }
            itemSelected = item;
        });
        return itemSelected;
    }
    setCurrentItem(itemSelected) {
        if (!itemSelected) {
            return;
        }
        itemSelected.selected = true;
        this.currentLabel = itemSelected.name;
        this.currentLabelIcon = itemSelected.icon;
    }
    unselectAll() {
        this.items.forEach(item => item.selected = false);
    }
}
SelectInTextComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectInTextComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SelectInTextComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SelectInTextComponent, selector: "wac-select-in-text", inputs: { items: "items", placeholder: "placeholder", label: "label", maxWidthItems: "maxWidthItems", type: "type", callToAction: "callToAction", preText: "preText", postText: "postText", alwaysOpen: "alwaysOpen", maxWidth: "maxWidth" }, outputs: { selectValue: "selectValue", clickOnCallToAction: "clickOnCallToAction" }, ngImport: i0, template: "<div class=\"wac-select-in-text\" wzAutoHide (clickOutside)=\"onClose()\" [ngStyle]=\"{ 'max-width': maxWidth }\" [zIndexToggle]=\"openCategories\">\r\n  <div class=\"wac-select-in-text__prepend\" [innerHTML]=\"preText\" *ngIf=\"preText\"></div>\r\n  <div #current class=\"wac-select-in-text__current\" (click)=\"openCategories = !openCategories\">\r\n    <span>{{ currentLabel }}</span>\r\n    <div\r\n      class=\"wac-select-in-text__content\"\r\n      [ngClass]=\"{ hidden: !openCategories && !alwaysOpen, open: type === 'open' }\"\r\n      [ngStyle]=\"{ 'max-width': maxWidthItems }\"\r\n    >\r\n      <perfect-scrollbar [config]=\"{ suppressScrollX: true }\" *ngIf=\"items.length > 0\">\r\n        <div class=\"wac-select-in-text__content__item\" *ngFor=\"let item of items; trackBy : customTB; let index = index;\">\r\n          <div [ngClass]=\"{ selected: item.selected }\" (click)=\"onSelectItem(index)\">\r\n            <span class=\"icon\" [innerHTML]=\"item.icon\" *ngIf=\"item.icon\"></span>{{ item.name }}\r\n          </div>\r\n        </div>\r\n      </perfect-scrollbar>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-select-in-text__after\" [innerHTML]=\"postText\" *ngIf=\"postText\"></div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: ["triggerElement", "forceOn"], outputs: ["clickOutside"] }, { kind: "directive", type: ZindexToggleDirective, selector: "[zIndexToggle]", inputs: ["zIndexToggle"], outputs: ["onEventChange"] }, { kind: "component", type: i4.PerfectScrollbarComponent, selector: "perfect-scrollbar", inputs: ["disabled", "usePSClass", "autoPropagation", "scrollIndicators", "config"], outputs: ["psScrollY", "psScrollX", "psScrollUp", "psScrollDown", "psScrollLeft", "psScrollRight", "psYReachEnd", "psYReachStart", "psXReachEnd", "psXReachStart"], exportAs: ["ngxPerfectScrollbar"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectInTextComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-select-in-text', template: "<div class=\"wac-select-in-text\" wzAutoHide (clickOutside)=\"onClose()\" [ngStyle]=\"{ 'max-width': maxWidth }\" [zIndexToggle]=\"openCategories\">\r\n  <div class=\"wac-select-in-text__prepend\" [innerHTML]=\"preText\" *ngIf=\"preText\"></div>\r\n  <div #current class=\"wac-select-in-text__current\" (click)=\"openCategories = !openCategories\">\r\n    <span>{{ currentLabel }}</span>\r\n    <div\r\n      class=\"wac-select-in-text__content\"\r\n      [ngClass]=\"{ hidden: !openCategories && !alwaysOpen, open: type === 'open' }\"\r\n      [ngStyle]=\"{ 'max-width': maxWidthItems }\"\r\n    >\r\n      <perfect-scrollbar [config]=\"{ suppressScrollX: true }\" *ngIf=\"items.length > 0\">\r\n        <div class=\"wac-select-in-text__content__item\" *ngFor=\"let item of items; trackBy : customTB; let index = index;\">\r\n          <div [ngClass]=\"{ selected: item.selected }\" (click)=\"onSelectItem(index)\">\r\n            <span class=\"icon\" [innerHTML]=\"item.icon\" *ngIf=\"item.icon\"></span>{{ item.name }}\r\n          </div>\r\n        </div>\r\n      </perfect-scrollbar>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-select-in-text__after\" [innerHTML]=\"postText\" *ngIf=\"postText\"></div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { items: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], label: [{
                type: Input
            }], maxWidthItems: [{
                type: Input
            }], type: [{
                type: Input
            }], callToAction: [{
                type: Input
            }], preText: [{
                type: Input
            }], postText: [{
                type: Input
            }], alwaysOpen: [{
                type: Input
            }], maxWidth: [{
                type: Input
            }], selectValue: [{
                type: Output
            }], clickOnCallToAction: [{
                type: Output
            }] } });

class MultipleSearchComponent {
    constructor(translateService) {
        this.translateService = translateService;
        this.options = [];
        this.alwaysOpen = false;
        this.label = '';
        this.placeholder = '';
        this.icon = '';
        this.query = '';
        this.search = '';
        this.openSelect = false;
        this.error = 'wac.simpleSearchComponent.error';
        this.showError = false;
    }
    ngOnInit() {
        this.setPlaceholder();
        this.setLabel();
        this.setQuery();
        this.setIcon();
    }
    setSearchValueToQuery(value) {
        if (value.code !== 'Enter') {
            this.search = encodeURI(value.target.value);
        }
        else {
            this.submitForm();
        }
    }
    submitForm() {
        if (this.search) {
            if (this.search.length > 0) {
                window.location.href = this.query.replace('{s}', this.search);
            }
            else {
                this.displayError();
            }
        }
        else {
            this.displayError();
        }
    }
    setPlaceholder(value) {
        if (value) {
            this.placeholder = this.options[value].placeholder;
        }
        else {
            this.placeholder = this.options[0].placeholder;
        }
    }
    setLabel(value) {
        if (value) {
            this.label = this.options[value].label;
        }
        else {
            this.label = this.options[0].label;
        }
    }
    setQuery(value) {
        if (value) {
            this.query = this.options[value].queries;
        }
        else {
            this.query = this.options[0].queries;
        }
    }
    displayError() {
        this.showError = true;
        setTimeout(() => {
            this.hideError();
        }, 2000);
    }
    hideError() {
        this.showError = false;
    }
    setIcon(value) {
        if (value) {
            this.icon = this.options[value].icon;
        }
        else {
            this.icon = this.options[0].icon;
        }
    }
    openFuncSelect() {
        this.openSelect = !this.openSelect;
    }
    closeSelect() {
        this.openSelect = false;
    }
    resetAllVue(value) {
        this.setPlaceholder(value);
        this.setLabel(value);
        this.setQuery(value);
        this.setIcon(value);
        this.search = '';
        this.closeSelect();
    }
}
MultipleSearchComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MultipleSearchComponent, deps: [{ token: i1$2.TranslateService }], target: i0.ɵɵFactoryTarget.Component });
MultipleSearchComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: MultipleSearchComponent, selector: "wac-multiple-search", inputs: { options: "options", alwaysOpen: "alwaysOpen" }, ngImport: i0, template: "<div class=\"wac-multiple-search\" [ngClass]=\"{ open: openSelect || alwaysOpen }\" [zIndexToggle]=\"openSelect\">\r\n  <div class=\"wac-multiple-search__wrapper\">\r\n    <div class=\"wac-multiple-search__wrapper__left\" [ngClass]=\"{ open: openSelect || alwaysOpen }\" wzAutoHide (clickOutside)=\"closeSelect()\">\r\n      <span>{{ label }}</span>\r\n      <i class=\"fal fa-chevron-down\"></i>\r\n      <div class=\"wac-multiple-search__wrapper__left__background\" (click)=\"openFuncSelect()\"></div>\r\n      <div class=\"wac-multiple-search__wrapper__left__select\" *ngIf=\"openSelect || alwaysOpen\">\r\n        <div\r\n          class=\"wac-multiple-search__wrapper__left__select__item\"\r\n          *ngFor=\"let option of options; let i = index\"\r\n          [attr.data-index]=\"i\"\r\n          (click)=\"resetAllVue(i); inputSearch.value = ''\"\r\n        >\r\n          <i [ngClass]=\"option.icon\"></i>\r\n          <span>{{ option.label }}</span>\r\n          <input type=\"hidden\" value=\"\" />\r\n        </div>\r\n      </div>\r\n    </div>\r\n    <div class=\"wac-multiple-search__wrapper__right\">\r\n      <form [action]=\"query\" method=\"get\">\r\n        <button type=\"submit\" (click)=\"submitForm()\"><i class=\"fal fa-search\"></i></button>\r\n        <input #inputSearch type=\"text\" required [placeholder]=\"placeholder\" (keyup)=\"setSearchValueToQuery($event)\" />\r\n      </form>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-multiple-search__error\" *ngIf=\"showError\">{{ error | translate}}</div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i2.NgForm, selector: "form:not([ngNoForm]):not([formGroup]),ng-form,[ngForm]", inputs: ["ngFormOptions"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: ["triggerElement", "forceOn"], outputs: ["clickOutside"] }, { kind: "directive", type: ZindexToggleDirective, selector: "[zIndexToggle]", inputs: ["zIndexToggle"], outputs: ["onEventChange"] }, { kind: "pipe", type: i1$2.TranslatePipe, name: "translate" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MultipleSearchComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-multiple-search', template: "<div class=\"wac-multiple-search\" [ngClass]=\"{ open: openSelect || alwaysOpen }\" [zIndexToggle]=\"openSelect\">\r\n  <div class=\"wac-multiple-search__wrapper\">\r\n    <div class=\"wac-multiple-search__wrapper__left\" [ngClass]=\"{ open: openSelect || alwaysOpen }\" wzAutoHide (clickOutside)=\"closeSelect()\">\r\n      <span>{{ label }}</span>\r\n      <i class=\"fal fa-chevron-down\"></i>\r\n      <div class=\"wac-multiple-search__wrapper__left__background\" (click)=\"openFuncSelect()\"></div>\r\n      <div class=\"wac-multiple-search__wrapper__left__select\" *ngIf=\"openSelect || alwaysOpen\">\r\n        <div\r\n          class=\"wac-multiple-search__wrapper__left__select__item\"\r\n          *ngFor=\"let option of options; let i = index\"\r\n          [attr.data-index]=\"i\"\r\n          (click)=\"resetAllVue(i); inputSearch.value = ''\"\r\n        >\r\n          <i [ngClass]=\"option.icon\"></i>\r\n          <span>{{ option.label }}</span>\r\n          <input type=\"hidden\" value=\"\" />\r\n        </div>\r\n      </div>\r\n    </div>\r\n    <div class=\"wac-multiple-search__wrapper__right\">\r\n      <form [action]=\"query\" method=\"get\">\r\n        <button type=\"submit\" (click)=\"submitForm()\"><i class=\"fal fa-search\"></i></button>\r\n        <input #inputSearch type=\"text\" required [placeholder]=\"placeholder\" (keyup)=\"setSearchValueToQuery($event)\" />\r\n      </form>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-multiple-search__error\" *ngIf=\"showError\">{{ error | translate}}</div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: i1$2.TranslateService }]; }, propDecorators: { options: [{
                type: Input
            }], alwaysOpen: [{
                type: Input
            }] } });

class MultipleSearchPlusComponent {
    constructor() {
        this.label = '';
        this.placeholder = '';
        this.openSelect = false;
        this.openSearchResults = false;
        this.isLoading = true;
        this.disabled = false;
        this.hideResults = false;
        this.searchValue = new EventEmitter();
        this.optionsChange = new EventEmitter();
    }
    ngOnInit() {
        this.setCurrentOption();
        this.setPlaceholder();
        this.setLabel();
    }
    setSearchValue(value) {
        if (value.target.value != '') {
            this.openSearchResults = true;
        }
        else {
            this.openSearchResults = false;
        }
        this.searchValue.emit({ currentOption: this.options[this.currentOption].code, value: value.target.value });
    }
    setCurrentOption(value) {
        this.currentOption = value || 0;
    }
    setPlaceholder(value) {
        this.placeholder = value ? this.options[value].placeholder : this.options[0].placeholder;
    }
    setLabel(value) {
        this.label = value ? this.options[value].label : this.options[0].label;
    }
    onToggleSelect() {
        this.openSelect = !this.openSelect;
    }
    closeSelect() {
        this.openSelect = false;
    }
    closeSearchResults() {
        this.openSearchResults = false;
    }
    resetAllVue(value) {
        this.searchResults = undefined;
        this.setCurrentOption(value);
        this.setPlaceholder(value);
        this.setLabel(value);
        this.openSearchResults = false;
        this.closeSelect();
    }
    addResult(index) {
        let alreadyExist = false;
        this.options[this.currentOption].table.forEach(elem => {
            if (elem.id == this.searchResults[index].id) {
                alreadyExist = true;
            }
        });
        if (!alreadyExist) {
            this.options[this.currentOption].table.push(this.searchResults[index]);
        }
        this.resetAllVue(this.currentOption);
        this.optionsChange.emit({ currentOption: this.options[this.currentOption].code, action: 'add' });
    }
    deleteResult(indexItem, index) {
        this.options[index].table.splice(indexItem, 1);
        this.optionsChange.emit({ currentOption: this.options[index].code, action: 'delete' });
    }
}
MultipleSearchPlusComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MultipleSearchPlusComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
MultipleSearchPlusComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: MultipleSearchPlusComponent, selector: "wac-multiple-search-plus", inputs: { options: "options", searchResults: "searchResults", disabled: "disabled", hideResults: "hideResults" }, outputs: { searchValue: "searchValue", optionsChange: "optionsChange" }, ngImport: i0, template: "<div class=\"wac-multiple-search-plus\" [zIndexToggle]=\"openSelect || openSearchResults\" [ngClass]=\"{ 'disabled': disabled }\">\r\n  <!-- Multiple select with search input -->\r\n  <div class=\"wac-multiple-search\" [ngClass]=\"{ open: openSelect }\">\r\n    <div class=\"wac-multiple-search__wrapper\">\r\n      <div class=\"wac-multiple-search__wrapper__left\" *ngIf=\"options.length > 1\" [ngClass]=\"{ open: openSelect }\" wzAutoHide (clickOutside)=\"closeSelect()\">\r\n        <span>{{ label }}</span>\r\n        <i class=\"fal fa-chevron-down\"></i>\r\n        <div class=\"wac-multiple-search__wrapper__left__background\" (click)=\"onToggleSelect()\"></div>\r\n        <div class=\"wac-multiple-search__wrapper__left__select\" *ngIf=\"openSelect\">\r\n          <div\r\n            class=\"wac-multiple-search__wrapper__left__select__item\"\r\n            *ngFor=\"let option of options; let i = index\"\r\n            [attr.data-index]=\"i\"\r\n            (click)=\"resetAllVue(i); inputSearch.value = ''\"\r\n          >\r\n            <span>{{ option.label }}</span>\r\n            <input type=\"hidden\" value=\"\" />\r\n          </div>\r\n        </div>\r\n      </div>\r\n      <div class=\"wac-multiple-search__wrapper__right\" wzAutoHide (clickOutside)=\"closeSearchResults()\">\r\n        <button><i class=\"fal fa-search\"></i></button>\r\n        <input\r\n          #inputSearch\r\n          type=\"text\"\r\n          [placeholder]=\"placeholder\"\r\n          debounceKeyUp\r\n          [debounceTime]=\"500\"\r\n          (onEventChange)=\"setSearchValue($event)\"\r\n        />\r\n        <div class=\"wac-multiple-search__wrapper__left__select\" *ngIf=\"openSearchResults\">\r\n          <div\r\n            class=\"wac-multiple-search__wrapper__left__select__item\"\r\n            *ngFor=\"let res of searchResults; let i = index\"\r\n            (click)=\"addResult(i); inputSearch.value = ''\"\r\n          >\r\n            <wac-image *ngIf=\"res.image\" [src]=\"res.image\"></wac-image>\r\n            <wac-text>#{{ res.id }} {{ res.name }}</wac-text>\r\n          </div>\r\n          <div class=\"wac-table__body__loader\" *ngIf=\"isLoading && !searchResults\">\r\n            <wac-loader [small]=\"true\"></wac-loader>\r\n          </div>\r\n          <div\r\n            class=\"wac-multiple-search__wrapper__left__select__item\"\r\n            *ngIf=\"!searchResults?.length\"\r\n          >\r\n            <span>{{'wac.datatable.noresult' | translate}}</span>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n\r\n  <!-- Results checked -->\r\n  <div *ngFor=\"let option of options; let i = index\">\r\n    <div class=\"wac-multiple-search-plus__wrapper\" *ngIf=\"option.table.length && !hideResults\">\r\n      <wac-h3>{{ option.title }}</wac-h3>\r\n      <div class=\"wac-multiple-search-plus__wrapper__block hover default\" *ngFor=\"let item of option.table; let indexItem = index\">\r\n        <wac-image *ngIf=\"item.image\" [src]=\"item.image\"></wac-image>\r\n        <wac-text>{{ item.name }}</wac-text>\r\n        <span (click)=\"deleteResult(indexItem, i)\"><i class=\"fas fa-times\"></i></span>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: DebounceKeyupDirective, selector: "input[debounceKeyUp]" }, { kind: "directive", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: ["triggerElement", "forceOn"], outputs: ["clickOutside"] }, { kind: "directive", type: ZindexToggleDirective, selector: "[zIndexToggle]", inputs: ["zIndexToggle"], outputs: ["onEventChange"] }, { kind: "component", type: LoaderComponent, selector: "wac-loader", inputs: ["text", "small"] }, { kind: "component", type: ImageComponent, selector: "wac-image", inputs: ["src"] }, { kind: "component", type: H3Component, selector: "wac-h3", inputs: ["grey", "noMargin"] }, { kind: "component", type: TextComponent, selector: "wac-text", inputs: ["textClass", "noMargin"] }, { kind: "pipe", type: i1$2.TranslatePipe, name: "translate" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MultipleSearchPlusComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-multiple-search-plus', template: "<div class=\"wac-multiple-search-plus\" [zIndexToggle]=\"openSelect || openSearchResults\" [ngClass]=\"{ 'disabled': disabled }\">\r\n  <!-- Multiple select with search input -->\r\n  <div class=\"wac-multiple-search\" [ngClass]=\"{ open: openSelect }\">\r\n    <div class=\"wac-multiple-search__wrapper\">\r\n      <div class=\"wac-multiple-search__wrapper__left\" *ngIf=\"options.length > 1\" [ngClass]=\"{ open: openSelect }\" wzAutoHide (clickOutside)=\"closeSelect()\">\r\n        <span>{{ label }}</span>\r\n        <i class=\"fal fa-chevron-down\"></i>\r\n        <div class=\"wac-multiple-search__wrapper__left__background\" (click)=\"onToggleSelect()\"></div>\r\n        <div class=\"wac-multiple-search__wrapper__left__select\" *ngIf=\"openSelect\">\r\n          <div\r\n            class=\"wac-multiple-search__wrapper__left__select__item\"\r\n            *ngFor=\"let option of options; let i = index\"\r\n            [attr.data-index]=\"i\"\r\n            (click)=\"resetAllVue(i); inputSearch.value = ''\"\r\n          >\r\n            <span>{{ option.label }}</span>\r\n            <input type=\"hidden\" value=\"\" />\r\n          </div>\r\n        </div>\r\n      </div>\r\n      <div class=\"wac-multiple-search__wrapper__right\" wzAutoHide (clickOutside)=\"closeSearchResults()\">\r\n        <button><i class=\"fal fa-search\"></i></button>\r\n        <input\r\n          #inputSearch\r\n          type=\"text\"\r\n          [placeholder]=\"placeholder\"\r\n          debounceKeyUp\r\n          [debounceTime]=\"500\"\r\n          (onEventChange)=\"setSearchValue($event)\"\r\n        />\r\n        <div class=\"wac-multiple-search__wrapper__left__select\" *ngIf=\"openSearchResults\">\r\n          <div\r\n            class=\"wac-multiple-search__wrapper__left__select__item\"\r\n            *ngFor=\"let res of searchResults; let i = index\"\r\n            (click)=\"addResult(i); inputSearch.value = ''\"\r\n          >\r\n            <wac-image *ngIf=\"res.image\" [src]=\"res.image\"></wac-image>\r\n            <wac-text>#{{ res.id }} {{ res.name }}</wac-text>\r\n          </div>\r\n          <div class=\"wac-table__body__loader\" *ngIf=\"isLoading && !searchResults\">\r\n            <wac-loader [small]=\"true\"></wac-loader>\r\n          </div>\r\n          <div\r\n            class=\"wac-multiple-search__wrapper__left__select__item\"\r\n            *ngIf=\"!searchResults?.length\"\r\n          >\r\n            <span>{{'wac.datatable.noresult' | translate}}</span>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n\r\n  <!-- Results checked -->\r\n  <div *ngFor=\"let option of options; let i = index\">\r\n    <div class=\"wac-multiple-search-plus__wrapper\" *ngIf=\"option.table.length && !hideResults\">\r\n      <wac-h3>{{ option.title }}</wac-h3>\r\n      <div class=\"wac-multiple-search-plus__wrapper__block hover default\" *ngFor=\"let item of option.table; let indexItem = index\">\r\n        <wac-image *ngIf=\"item.image\" [src]=\"item.image\"></wac-image>\r\n        <wac-text>{{ item.name }}</wac-text>\r\n        <span (click)=\"deleteResult(indexItem, i)\"><i class=\"fas fa-times\"></i></span>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { options: [{
                type: Input
            }], searchResults: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hideResults: [{
                type: Input
            }], searchValue: [{
                type: Output
            }], optionsChange: [{
                type: Output
            }] } });

class LabelComponent {
    constructor() { }
    ngOnInit() {
    }
}
LabelComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: LabelComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
LabelComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: LabelComponent, selector: "wac-label", host: { classAttribute: "wac-label" }, ngImport: i0, template: "<ng-content></ng-content>" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: LabelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-label', host: {
                        'class': 'wac-label'
                    }, template: "<ng-content></ng-content>" }]
        }], ctorParameters: function () { return []; } });

class InputWithSelectComponent {
}
InputWithSelectComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: InputWithSelectComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
InputWithSelectComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: InputWithSelectComponent, isStandalone: true, selector: "wac-input-with-select", queries: [{ propertyName: "label", first: true, predicate: LabelComponent, descendants: true }], ngImport: i0, template: "<p *ngIf=\"!!label\" class=\"wac-select__label\">\r\n  <ng-content select=\"wac-label, .wac-label\" ></ng-content>\r\n</p>\r\n\r\n<div class=\"wac-input-with-select\">\r\n  <div class=\"wac-input-with-select__wrapper\">\r\n    <div class=\"wac-input-with-select__wrapper__left\">\r\n      <ng-content select=\"input\"></ng-content>\r\n      <ng-content select=\"wac-select\"></ng-content>\r\n    </div>\r\n    <div class=\"wac-input-with-select__wrapper__right\">\r\n      <ng-content select=\"[text]\"></ng-content>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: InputWithSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-input-with-select', encapsulation: ViewEncapsulation.None, standalone: true, imports: [CommonModule], template: "<p *ngIf=\"!!label\" class=\"wac-select__label\">\r\n  <ng-content select=\"wac-label, .wac-label\" ></ng-content>\r\n</p>\r\n\r\n<div class=\"wac-input-with-select\">\r\n  <div class=\"wac-input-with-select__wrapper\">\r\n    <div class=\"wac-input-with-select__wrapper__left\">\r\n      <ng-content select=\"input\"></ng-content>\r\n      <ng-content select=\"wac-select\"></ng-content>\r\n    </div>\r\n    <div class=\"wac-input-with-select__wrapper__right\">\r\n      <ng-content select=\"[text]\"></ng-content>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], propDecorators: { label: [{
                type: ContentChild,
                args: [LabelComponent]
            }] } });

class PopinComponent {
    constructor(domService) {
        this.domService = domService;
        this.visible = false;
        this.visibleChange = new EventEmitter();
        this.response = new EventEmitter();
        this.background = true;
        this.closeOnBackgroundClick = true;
        this.firstOpen = false;
    }
    ngOnInit() {
        this.domService.setDocumentEventListener();
    }
    validatePopin() {
        this.response.emit(true);
        this.closePopin();
    }
    refusePopin() {
        this.response.emit(false);
        this.closePopin();
    }
    closePopin(clickOnBackground = false) {
        if (!this.closeOnBackgroundClick && clickOnBackground) {
            return;
        }
        if (!this.firstOpen) { //trick for auto-hide directive that close immediatly the pop-in
            this.visible = false;
            this.visibleChange.emit(this.visible);
            this.firstOpen = true;
        }
        else {
            this.firstOpen = false;
        }
    }
}
PopinComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PopinComponent, deps: [{ token: DomService }], target: i0.ɵɵFactoryTarget.Component });
PopinComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: PopinComponent, selector: "wac-popin", inputs: { title: "title", content: "content", imgSrc: "imgSrc", okButtonLabel: "okButtonLabel", koButtonLabel: "koButtonLabel", okButtonClass: "okButtonClass", koButtonClass: "koButtonClass", visible: "visible", background: "background", closeOnBackgroundClick: "closeOnBackgroundClick" }, outputs: { visibleChange: "visibleChange", response: "response" }, ngImport: i0, template: "<div class=\"wac-free\" *ngIf=\"visible\">\r\n  <div class=\"wac-free__wrapper\" wzAutoHide (clickOutside)=\"closePopin(true)\">\r\n    <a class=\"wac-free__wrapper__button-close\" (click)=\"closePopin()\">\r\n      <i class=\"fas fa-times\"></i>\r\n    </a>\r\n    <div class=\"wac-free__wrapper__content\">\r\n      <perfect-scrollbar [config]=\"{ suppressScrollX: true }\">\r\n        <img *ngIf=\"imgSrc\" [src]=\"imgSrc\" alt=\"barre admin\" />\r\n\r\n        <h2 class=\"wac-popin__wrapper__title\" [innerHTML]=\"title\"></h2>\r\n\r\n        <p class=\"wac-popin__wrapper__text\" [innerHTML]=\"content\"></p>\r\n      </perfect-scrollbar>\r\n    </div>\r\n    <div class=\"wac-free__wrapper__buttons\">\r\n      <div class=\"wac-free__wrapper__buttons__button\" *ngIf=\"okButtonLabel\">\r\n        <wac-button [extraClasses]=\"'is-success'\" [label]=\"okButtonLabel\" [hasLoader]=\"true\" (click)=\"validatePopin()\"></wac-button>\r\n      </div>\r\n      <div class=\"wac-free__wrapper__buttons__button\" *ngIf=\"koButtonLabel\">\r\n        <wac-button [extraClasses]=\"'is-danger is-outlined'\" [label]=\"koButtonLabel\" [hasLoader]=\"true\" (click)=\"refusePopin()\"></wac-button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-free__background\" *ngIf=\"background\"></div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: ["triggerElement", "forceOn"], outputs: ["clickOutside"] }, { kind: "component", type: i4.PerfectScrollbarComponent, selector: "perfect-scrollbar", inputs: ["disabled", "usePSClass", "autoPropagation", "scrollIndicators", "config"], outputs: ["psScrollY", "psScrollX", "psScrollUp", "psScrollDown", "psScrollLeft", "psScrollRight", "psYReachEnd", "psYReachStart", "psXReachEnd", "psXReachStart"], exportAs: ["ngxPerfectScrollbar"] }, { kind: "component", type: ButtonComponent, selector: "wac-button", inputs: ["extraClasses", "label", "icon", "isLoadingSvg", "iconNext", "textcolor", "colorIcon", "widthAuto", "contentHorizontalPosition", "iconFontSize", "hasLoader", "disabled", "whiteSpaceNowrap", "opacity", "animation", "animationRight", "animationText", "confirmDelete", "confirmDeleteText", "coin", "tooltip", "tooltipWidth", "borderColor", "noPadding", "tooltipPosition", "tooltipOneline", "confirmDeletePosition", "isLoading"], outputs: ["click", "isLoadingChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PopinComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-popin', template: "<div class=\"wac-free\" *ngIf=\"visible\">\r\n  <div class=\"wac-free__wrapper\" wzAutoHide (clickOutside)=\"closePopin(true)\">\r\n    <a class=\"wac-free__wrapper__button-close\" (click)=\"closePopin()\">\r\n      <i class=\"fas fa-times\"></i>\r\n    </a>\r\n    <div class=\"wac-free__wrapper__content\">\r\n      <perfect-scrollbar [config]=\"{ suppressScrollX: true }\">\r\n        <img *ngIf=\"imgSrc\" [src]=\"imgSrc\" alt=\"barre admin\" />\r\n\r\n        <h2 class=\"wac-popin__wrapper__title\" [innerHTML]=\"title\"></h2>\r\n\r\n        <p class=\"wac-popin__wrapper__text\" [innerHTML]=\"content\"></p>\r\n      </perfect-scrollbar>\r\n    </div>\r\n    <div class=\"wac-free__wrapper__buttons\">\r\n      <div class=\"wac-free__wrapper__buttons__button\" *ngIf=\"okButtonLabel\">\r\n        <wac-button [extraClasses]=\"'is-success'\" [label]=\"okButtonLabel\" [hasLoader]=\"true\" (click)=\"validatePopin()\"></wac-button>\r\n      </div>\r\n      <div class=\"wac-free__wrapper__buttons__button\" *ngIf=\"koButtonLabel\">\r\n        <wac-button [extraClasses]=\"'is-danger is-outlined'\" [label]=\"koButtonLabel\" [hasLoader]=\"true\" (click)=\"refusePopin()\"></wac-button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-free__background\" *ngIf=\"background\"></div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: DomService }]; }, propDecorators: { title: [{
                type: Input
            }], content: [{
                type: Input
            }], imgSrc: [{
                type: Input
            }], okButtonLabel: [{
                type: Input
            }], koButtonLabel: [{
                type: Input
            }], okButtonClass: [{
                type: Input
            }], koButtonClass: [{
                type: Input
            }], visible: [{
                type: Input
            }], visibleChange: [{
                type: Output
            }], response: [{
                type: Output
            }], background: [{
                type: Input
            }], closeOnBackgroundClick: [{
                type: Input
            }] } });

class FreePopinComponent {
    constructor(domService) {
        this.domService = domService;
        this.visible = false;
        this.disableCloseOutside = false;
        this.visibleChange = new EventEmitter();
        this.response = new EventEmitter();
        this.background = true;
        this.zIndex = 9999;
        this.firstOpen = true;
    }
    ngOnInit() {
        if (this.visible) {
            this.firstOpen = false;
        }
        this.domService.setDocumentEventListener();
    }
    validatePopin() {
        this.response.emit(true);
        this.closePopin();
    }
    refusePopin() {
        this.response.emit(false);
        this.closePopin();
    }
    closePopin() {
        if (!this.firstOpen || this.disableCloseOutside) {
            this.visible = false;
            this.visibleChange.emit(this.visible);
            this.firstOpen = true;
        }
        else {
            this.firstOpen = false;
        }
    }
}
FreePopinComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FreePopinComponent, deps: [{ token: DomService }], target: i0.ɵɵFactoryTarget.Component });
FreePopinComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: FreePopinComponent, selector: "wac-free-popin", inputs: { okButtonLabel: "okButtonLabel", koButtonLabel: "koButtonLabel", visible: "visible", disableCloseOutside: "disableCloseOutside", background: "background", zIndex: "zIndex" }, outputs: { visibleChange: "visibleChange", response: "response" }, ngImport: i0, template: "<div class=\"wac-free-popin\" *ngIf=\"visible\" [ngStyle]=\"{'z-index': zIndex}\">\r\n    <div class=\"wac-free-popin__wrapper\" wzAutoHide (clickOutside)=\"!disableCloseOutside ? closePopin() : ''\">\r\n      <a class=\"wac-free-popin__wrapper__button-close\" (click)=\"closePopin()\">\r\n        <i class=\"fas fa-times\"></i>\r\n      </a>\r\n      <div class=\"wac-free-popin__wrapper__content\">\r\n        <perfect-scrollbar [config]=\"{ suppressScrollX: true }\">\r\n          <ng-content></ng-content>\r\n        </perfect-scrollbar>\r\n      </div>\r\n      <div class=\"wac-free-popin__wrapper__buttons\">\r\n        <div class=\"wac-free-popin__wrapper__buttons__button\" *ngIf=\"okButtonLabel\">\r\n          <wac-button [extraClasses]=\"'is-success'\" [label]=\"okButtonLabel\" [hasLoader]=\"true\" (click)=\"validatePopin()\"></wac-button>\r\n        </div>\r\n        <div class=\"wac-free-popin__wrapper__buttons__button\" *ngIf=\"koButtonLabel\">\r\n          <wac-button [extraClasses]=\"'is-danger is-outlined'\" [label]=\"koButtonLabel\" [hasLoader]=\"true\" (click)=\"refusePopin()\"></wac-button>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  <div class=\"wac-free-popin__background\" *ngIf=\"background\"></div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: ["triggerElement", "forceOn"], outputs: ["clickOutside"] }, { kind: "component", type: i4.PerfectScrollbarComponent, selector: "perfect-scrollbar", inputs: ["disabled", "usePSClass", "autoPropagation", "scrollIndicators", "config"], outputs: ["psScrollY", "psScrollX", "psScrollUp", "psScrollDown", "psScrollLeft", "psScrollRight", "psYReachEnd", "psYReachStart", "psXReachEnd", "psXReachStart"], exportAs: ["ngxPerfectScrollbar"] }, { kind: "component", type: ButtonComponent, selector: "wac-button", inputs: ["extraClasses", "label", "icon", "isLoadingSvg", "iconNext", "textcolor", "colorIcon", "widthAuto", "contentHorizontalPosition", "iconFontSize", "hasLoader", "disabled", "whiteSpaceNowrap", "opacity", "animation", "animationRight", "animationText", "confirmDelete", "confirmDeleteText", "coin", "tooltip", "tooltipWidth", "borderColor", "noPadding", "tooltipPosition", "tooltipOneline", "confirmDeletePosition", "isLoading"], outputs: ["click", "isLoadingChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FreePopinComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-free-popin', template: "<div class=\"wac-free-popin\" *ngIf=\"visible\" [ngStyle]=\"{'z-index': zIndex}\">\r\n    <div class=\"wac-free-popin__wrapper\" wzAutoHide (clickOutside)=\"!disableCloseOutside ? closePopin() : ''\">\r\n      <a class=\"wac-free-popin__wrapper__button-close\" (click)=\"closePopin()\">\r\n        <i class=\"fas fa-times\"></i>\r\n      </a>\r\n      <div class=\"wac-free-popin__wrapper__content\">\r\n        <perfect-scrollbar [config]=\"{ suppressScrollX: true }\">\r\n          <ng-content></ng-content>\r\n        </perfect-scrollbar>\r\n      </div>\r\n      <div class=\"wac-free-popin__wrapper__buttons\">\r\n        <div class=\"wac-free-popin__wrapper__buttons__button\" *ngIf=\"okButtonLabel\">\r\n          <wac-button [extraClasses]=\"'is-success'\" [label]=\"okButtonLabel\" [hasLoader]=\"true\" (click)=\"validatePopin()\"></wac-button>\r\n        </div>\r\n        <div class=\"wac-free-popin__wrapper__buttons__button\" *ngIf=\"koButtonLabel\">\r\n          <wac-button [extraClasses]=\"'is-danger is-outlined'\" [label]=\"koButtonLabel\" [hasLoader]=\"true\" (click)=\"refusePopin()\"></wac-button>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  <div class=\"wac-free-popin__background\" *ngIf=\"background\"></div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: DomService }]; }, propDecorators: { okButtonLabel: [{
                type: Input
            }], koButtonLabel: [{
                type: Input
            }], visible: [{
                type: Input
            }], disableCloseOutside: [{
                type: Input
            }], visibleChange: [{
                type: Output
            }], response: [{
                type: Output
            }], background: [{
                type: Input
            }], zIndex: [{
                type: Input
            }] } });

class BlockSeparatorComponent {
    constructor() { }
}
BlockSeparatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BlockSeparatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BlockSeparatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: BlockSeparatorComponent, isStandalone: true, selector: "wac-block-separator", ngImport: i0, template: ``, isInline: true, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BlockSeparatorComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'wac-block-separator',
                    template: ``,
                    encapsulation: ViewEncapsulation.None,
                    standalone: true
                }]
        }], ctorParameters: function () { return []; } });

class BlockComponent {
    get borderRadius() {
        return `--wac-block-border-radius: ${this.config.borderRadius ? this.config.borderRadius : '3px'};`;
    }
    constructor(renderer2, wacBlockElementRef) {
        this.renderer2 = renderer2;
        this.wacBlockElementRef = wacBlockElementRef;
        this.config = {
            borderRadius: '3px'
        };
        this.destroy$ = new Subject();
    }
    ngAfterViewInit() {
        const groupedNodesList = this.getSeparatedGroupedOfNodes(this.wacBlockElementRef.nativeElement.childNodes);
        this.attachSeparatedBlocksToTheDom(groupedNodesList, this.wacBlockElementRef.nativeElement);
        this.blockSeparators
            .changes.pipe(takeUntil$1(this.destroy$))
            .subscribe(() => {
            this.handleAddedSeparator();
            setTimeout(() => {
                this.handleRemovedSeparator();
            }, 0);
        });
    }
    handleRemovedSeparator() {
        const wacBlockComponentChildNodes = this.wacBlockElementRef.nativeElement.childNodes;
        for (let i = 0; i < wacBlockComponentChildNodes.length; i++) {
            const childNode = wacBlockComponentChildNodes[i];
            const nextChild = wacBlockComponentChildNodes[i + 1];
            const areWacBlockSideBySide = nextChild && childNode.classList.contains('wac-block') && nextChild.classList.contains('wac-block');
            if (!areWacBlockSideBySide) {
                continue;
            }
            const parentElement = this.wacBlockElementRef.nativeElement;
            this.fusionNextBlockWithCurrentBlock(parentElement, nextChild, childNode);
            i--; // we remove a child, so we need to go back to the previous index
        }
    }
    fusionNextBlockWithCurrentBlock(parentElement, nextChild, childNode) {
        parentElement.removeChild(nextChild); // not working with renderer2, it just freeze the app
        childNode.append(...nextChild.childNodes);
    }
    handleAddedSeparator() {
        const wacBlockComponentChildNodes = [...this.wacBlockElementRef.nativeElement.childNodes];
        for (let i = 0; i < wacBlockComponentChildNodes.length; i++) {
            const childNode = wacBlockComponentChildNodes[i];
            if (childNode.nodeName === 'WAC-BLOCK-SEPARATOR') {
                continue;
            }
            if (!this.hasBlockSeparator(childNode.childNodes)) {
                continue;
            }
            const groupedNodesList = this.getSeparatedGroupedOfNodes(childNode.childNodes);
            groupedNodesList.shift(); // remove first group, it's the current block
            this.attachSeparatedBlocksToTheDom(groupedNodesList, this.wacBlockElementRef.nativeElement, wacBlockComponentChildNodes[i + 1]);
        }
    }
    hasBlockSeparator(childNodes) {
        return [...childNodes].some(groupedNodes => groupedNodes?.nodeName === 'WAC-BLOCK-SEPARATOR');
    }
    attachSeparatedBlocksToTheDom(groupedNodesList, parentElement, nextElement) {
        for (let index = 0; index < groupedNodesList.length; index++) {
            const groupedNodes = groupedNodesList[index];
            if (groupedNodes[0]?.nodeName === 'WAC-BLOCK-SEPARATOR') {
                this.attachToTheDom(groupedNodes[0], parentElement, nextElement);
                continue;
            }
            const separatedWacBlock = document.createElement('div');
            separatedWacBlock.classList.add('wac-block');
            groupedNodes.forEach(node => {
                separatedWacBlock.appendChild(node);
            });
            this.attachToTheDom(separatedWacBlock, parentElement, nextElement);
        }
    }
    attachToTheDom(child, parentElement, nextElement) {
        if (nextElement) {
            this.renderer2.insertBefore(parentElement, child, nextElement, true);
        }
        else {
            this.renderer2.appendChild(parentElement, child);
        }
    }
    getSeparatedGroupedOfNodes(childNodes) {
        const groupedNodesList = [];
        let followingNodes = [];
        for (const node of childNodes) {
            if (node.nodeName === 'WAC-BLOCK-SEPARATOR') {
                groupedNodesList.push(followingNodes, [node]); // close a group and start a new one
                followingNodes = [];
                continue;
            }
            followingNodes.push(node);
        }
        if (followingNodes.length) {
            groupedNodesList.push(followingNodes);
        }
        return groupedNodesList;
    }
    ngOnDesTroy() {
        this.destroy$.next();
        this.destroy$.complete();
    }
}
BlockComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BlockComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
BlockComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: BlockComponent, isStandalone: true, selector: "wac-block", inputs: { config: "config" }, host: { properties: { "style": "this.borderRadius" } }, queries: [{ propertyName: "blockSeparators", predicate: BlockSeparatorComponent }], ngImport: i0, template: "<ng-content></ng-content>", dependencies: [{ kind: "ngmodule", type: CommonModule }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BlockComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-block', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [CommonModule], template: "<ng-content></ng-content>" }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ElementRef }]; }, propDecorators: { blockSeparators: [{
                type: ContentChildren,
                args: [BlockSeparatorComponent]
            }], config: [{
                type: Input
            }], borderRadius: [{
                type: HostBinding,
                args: ['style']
            }] } });

class WrapperComponent {
    constructor() {
        this.size = 'fullsize';
    }
    ngOnInit() { }
}
WrapperComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WrapperComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
WrapperComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: WrapperComponent, selector: "wac-wrapper", inputs: { size: "size" }, ngImport: i0, template: "<div class=\"wac-wrapper\" [ngClass]=\"{ fullsize: size === 'fullsize', 'max-width': size === 'max-width' }\">\r\n  <ng-content></ng-content>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WrapperComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-wrapper', template: "<div class=\"wac-wrapper\" [ngClass]=\"{ fullsize: size === 'fullsize', 'max-width': size === 'max-width' }\">\r\n  <ng-content></ng-content>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { size: [{
                type: Input
            }] } });

class FiltersComponent {
    constructor() {
        this.labelRestart = 'Afficher toutes les catégories';
        this.filterChange = new EventEmitter();
    }
    ngOnInit() {
        this.options.forEach((item, index) => {
            if (item.active) {
                this.filterActiveIndex = '' + index;
            }
        });
    }
    activeFilter(index) {
        this.options[index].active = true;
        this.filterActiveIndex = '' + index;
        this.filterChange.emit(index);
    }
    resetFilter() {
        this.options.forEach((item) => {
            item.active = false;
        });
        this.filterActiveIndex = null;
        this.filterChange.emit(-1);
    }
}
FiltersComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FiltersComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
FiltersComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: FiltersComponent, selector: "wac-filters", inputs: { options: "options", labelRestart: "labelRestart" }, outputs: { filterChange: "filterChange" }, ngImport: i0, template: "<div class=\"wac-filters\">\r\n  <div class=\"wac-filters__wrapper\" *ngIf=\"!filterActiveIndex\">\r\n    <button *ngFor=\"let option of options; let i = index\">\r\n      <span class=\"event\" (click)=\"activeFilter(i)\"></span><span [innerHTML]=\"option.name\"></span>\r\n    </button>\r\n  </div>\r\n  <div class=\"wac-filters__wrapper\" *ngIf=\"filterActiveIndex\">\r\n    <button (click)=\"resetFilter()\" class=\"active\">\r\n      <i class=\"fas fa-times\"></i><span [innerHTML]=\"options[filterActiveIndex].name\"></span>\r\n    </button>\r\n    <span (click)=\"resetFilter()\">{{ labelRestart }}</span>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FiltersComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-filters', template: "<div class=\"wac-filters\">\r\n  <div class=\"wac-filters__wrapper\" *ngIf=\"!filterActiveIndex\">\r\n    <button *ngFor=\"let option of options; let i = index\">\r\n      <span class=\"event\" (click)=\"activeFilter(i)\"></span><span [innerHTML]=\"option.name\"></span>\r\n    </button>\r\n  </div>\r\n  <div class=\"wac-filters__wrapper\" *ngIf=\"filterActiveIndex\">\r\n    <button (click)=\"resetFilter()\" class=\"active\">\r\n      <i class=\"fas fa-times\"></i><span [innerHTML]=\"options[filterActiveIndex].name\"></span>\r\n    </button>\r\n    <span (click)=\"resetFilter()\">{{ labelRestart }}</span>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { options: [{
                type: Input
            }], labelRestart: [{
                type: Input
            }], filterChange: [{
                type: Output
            }] } });

class WrapperBlocsComponent {
    constructor() {
        this.sidebar = false;
    }
    ngOnInit() {
    }
}
WrapperBlocsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WrapperBlocsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
WrapperBlocsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: WrapperBlocsComponent, selector: "wac-wrapper-blocs", inputs: { sidebar: "sidebar" }, ngImport: i0, template: "<div class=\"wac-wrapper-blocs\" [ngClass]=\"{'sidebar': sidebar}\">\r\n  <ng-content></ng-content>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WrapperBlocsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-wrapper-blocs', template: "<div class=\"wac-wrapper-blocs\" [ngClass]=\"{'sidebar': sidebar}\">\r\n  <ng-content></ng-content>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { sidebar: [{
                type: Input
            }] } });

class SnackbarComponent {
    constructor() {
        this.visible = false;
        this.visibleChange = new EventEmitter();
        this.response = new EventEmitter();
        this.manualClose = false;
    }
    ngOnInit() {
        if (this.duration > 0) {
            this.timer = setTimeout(() => this.manualClose = true, this.duration);
        }
    }
    validate() {
        this.response.emit(true);
        this.closeSnackbar();
        this.manualClose = true;
    }
    refuse() {
        this.response.emit(false);
        this.closeSnackbar();
        this.manualClose = true;
    }
    closeSnackbar() {
        this.visible = false;
        this.visibleChange.emit(this.visible);
    }
}
SnackbarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SnackbarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SnackbarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SnackbarComponent, isStandalone: true, selector: "wac-snackbar", inputs: { message: "message", textButtonOk: "textButtonOk", textButtonKo: "textButtonKo", duration: "duration", color: "color", buttonColor: "buttonColor", visible: "visible" }, outputs: { visibleChange: "visibleChange", response: "response" }, ngImport: i0, template: "<div class=\"wac-snackbar\">\r\n  <div [class]=\"'notification is-active ' + ((color) ? color : 'is-transparent')\"\r\n    [@state]=\"visible ? 'active': 'inactive'\"\r\n  >\r\n    <div class=\"columns\">\r\n      <div class=\"column notification--message\" [ngClass]=\"{'is-half': textButtonOk}\"\r\n            [innerHTML]=\"message\">\r\n      </div>\r\n      <div class=\"column is-half\">\r\n        <button [class]=\"'button ' + ((buttonColor) ? buttonColor : 'is-success')\"\r\n                (click)=\"validate()\">{{textButtonOk}}\r\n        </button>\r\n        <button [class]=\"'button ' + ((buttonColor) ? buttonColor : 'is-success')\"\r\n                (click)=\"refuse()\">{{textButtonKo}}\r\n        </button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], animations: [
        trigger('state', [
            state('void', style({
                bottom: '-100px'
            })),
            state('inactive', style({
                bottom: '-100px'
            })),
            state('active', style({
                bottom: '0px'
            })),
            transition('void => active', animate(300)),
            transition('active => inactive', animate(300))
        ])
    ], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SnackbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-snackbar', encapsulation: ViewEncapsulation.None, animations: [
                        trigger('state', [
                            state('void', style({
                                bottom: '-100px'
                            })),
                            state('inactive', style({
                                bottom: '-100px'
                            })),
                            state('active', style({
                                bottom: '0px'
                            })),
                            transition('void => active', animate(300)),
                            transition('active => inactive', animate(300))
                        ])
                    ], standalone: true, imports: [CommonModule], template: "<div class=\"wac-snackbar\">\r\n  <div [class]=\"'notification is-active ' + ((color) ? color : 'is-transparent')\"\r\n    [@state]=\"visible ? 'active': 'inactive'\"\r\n  >\r\n    <div class=\"columns\">\r\n      <div class=\"column notification--message\" [ngClass]=\"{'is-half': textButtonOk}\"\r\n            [innerHTML]=\"message\">\r\n      </div>\r\n      <div class=\"column is-half\">\r\n        <button [class]=\"'button ' + ((buttonColor) ? buttonColor : 'is-success')\"\r\n                (click)=\"validate()\">{{textButtonOk}}\r\n        </button>\r\n        <button [class]=\"'button ' + ((buttonColor) ? buttonColor : 'is-success')\"\r\n                (click)=\"refuse()\">{{textButtonKo}}\r\n        </button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], propDecorators: { message: [{
                type: Input
            }], textButtonOk: [{
                type: Input
            }], textButtonKo: [{
                type: Input
            }], duration: [{
                type: Input
            }], color: [{
                type: Input
            }], buttonColor: [{
                type: Input
            }], visible: [{
                type: Input
            }], visibleChange: [{
                type: Output
            }], response: [{
                type: Output
            }] } });

class AlertPopupComponent {
    constructor() {
        /** Subject for notifying the user that the dialog has finished closing. */
        this.afterClosedPopup = new Subject();
        this.open = false;
    }
    ngAfterViewInit() {
        setTimeout(() => {
            this.open = true;
        }, 50);
        if (this.config.duration > 0) {
            this.timer = setTimeout(() => this.dismiss(), this.config.duration);
        }
    }
    dismiss() {
        this.open = false;
        setTimeout(() => {
            this.afterClosedPopup.next(true);
            this.afterClosedPopup.complete();
        }, 200);
    }
    /**
     * Gets an observable that is notified when the dialog is finished closing.
     */
    afterClosed() {
        return this.afterClosedPopup.asObservable();
    }
}
AlertPopupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AlertPopupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
AlertPopupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: AlertPopupComponent, selector: "wac-alert-popup", host: { classAttribute: "wac-alert-popup" }, ngImport: i0, template: "<div\r\n  [class]=\"'alert ' + ((config.color) ? config.color : ' is-primary') + ((config.extraClasses) ? ' ' + config.extraClasses : '') + ((config.position) ? ' ' + config.position : '') + ((config.fullsize) ? ' fullsize' : '') + ((config.opacity) ? ' opacity-active' : '') + ((config.small) ? ' small' : '') + ((config.icon) ? ' with-icon' : '') + ((config.duration) ? '' : ' no-duration')\"\r\n  [ngClass]=\"{'is-active': open, 'has-close': config.closeButton}\"\r\n>\r\n  <div class=\"alert--message\">\r\n    <span class=\"icon\" *ngIf=\"config.icon\">\r\n        <i [class]=\"config.icon\"></i>\r\n    </span>\r\n    <span (click)=\"dismiss()\" class=\"wac-alert-popup__close\" *ngIf=\"!config.small || (config.small && config.closeButton)\"><i class=\"far fa-times\"></i></span>\r\n    <p *ngIf=\"config.title\" class=\"wac-alert-popup__title\" [innerHTML]=\"config.title\"></p>\r\n    <p *ngIf=\"config.message\" class=\"wac-alert-popup__text\" [innerHTML]=\"config.message\"></p>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AlertPopupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-alert-popup', host: {
                        class: 'wac-alert-popup'
                    }, encapsulation: ViewEncapsulation.None, template: "<div\r\n  [class]=\"'alert ' + ((config.color) ? config.color : ' is-primary') + ((config.extraClasses) ? ' ' + config.extraClasses : '') + ((config.position) ? ' ' + config.position : '') + ((config.fullsize) ? ' fullsize' : '') + ((config.opacity) ? ' opacity-active' : '') + ((config.small) ? ' small' : '') + ((config.icon) ? ' with-icon' : '') + ((config.duration) ? '' : ' no-duration')\"\r\n  [ngClass]=\"{'is-active': open, 'has-close': config.closeButton}\"\r\n>\r\n  <div class=\"alert--message\">\r\n    <span class=\"icon\" *ngIf=\"config.icon\">\r\n        <i [class]=\"config.icon\"></i>\r\n    </span>\r\n    <span (click)=\"dismiss()\" class=\"wac-alert-popup__close\" *ngIf=\"!config.small || (config.small && config.closeButton)\"><i class=\"far fa-times\"></i></span>\r\n    <p *ngIf=\"config.title\" class=\"wac-alert-popup__title\" [innerHTML]=\"config.title\"></p>\r\n    <p *ngIf=\"config.message\" class=\"wac-alert-popup__text\" [innerHTML]=\"config.message\"></p>\r\n  </div>\r\n</div>\r\n" }]
        }] });

class AlertPopupService {
    constructor(domService) {
        this.domService = domService;
    }
    open(config) {
        const componentRef = this.getComponentRef(config);
        return componentRef.instance;
    }
    getComponentRef(config) {
        const componentRef = this.domService.attachComponentPortal(AlertPopupComponent);
        config = Object.assign({
            position: 'is-top'
        }, config);
        componentRef.instance.config = config;
        componentRef.instance.afterClosed().subscribe(() => {
            componentRef.destroy();
        });
        return componentRef;
    }
}
AlertPopupService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AlertPopupService, deps: [{ token: DomService }], target: i0.ɵɵFactoryTarget.Injectable });
AlertPopupService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AlertPopupService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AlertPopupService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: DomService }]; } });

class AlertPopupModule {
}
AlertPopupModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AlertPopupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
AlertPopupModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: AlertPopupModule, declarations: [AlertPopupComponent], imports: [CommonModule], exports: [AlertPopupComponent] });
AlertPopupModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AlertPopupModule, providers: [AlertPopupService], imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AlertPopupModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    providers: [AlertPopupService],
                    entryComponents: [AlertPopupComponent],
                    declarations: [AlertPopupComponent],
                    exports: [AlertPopupComponent]
                }]
        }] });

class SearchComponent {
    constructor() {
        this.alwaysOpen = false;
        this.disableSearchIn = false;
        this.emptyResult = '';
        this.search = '';
        this.openSelect = false;
        this.selectValue = new EventEmitter();
        this.searchKeyUp = new EventEmitter();
        this.searchFocusOut = new EventEmitter();
    }
    ngOnInit() {
        this.triggerOptions = this.options;
    }
    onClose() {
        this.openSelect = false;
    }
    setSearchValueToQuery(value) {
        this.search = value.target.value;
        if (this.disableSearchIn) {
            this.triggerOptions = this.options;
        }
        else {
            if (this.search.length > 0) {
                this.openSelect = true;
                this.triggerOptions = this.options.filter(element => element.label.toLowerCase().indexOf(this.search.toLowerCase()) !== -1);
            }
            else {
                this.triggerOptions = this.options;
            }
        }
        this.searchKeyUp.emit(this.search);
    }
    sendEventFocusOut() {
        this.searchFocusOut.emit(this.search);
    }
    closeSelect() {
        this.openSelect = false;
    }
    onSelectItem(index, value, label) {
        this.search = '';
        this.openSelect = false;
        if (this.disableSearchIn) {
            this.selectValue.emit(index);
        }
        else {
            const findInOption = this.options.findIndex(element => element.label === label && element.id === value);
            this.selectValue.emit(findInOption);
        }
    }
    resetAllVue() {
        this.search = '';
        this.closeSelect();
    }
}
SearchComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SearchComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SearchComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SearchComponent, selector: "wac-search", inputs: { placeholder: "placeholder", alwaysOpen: "alwaysOpen", label: "label", options: "options", disableSearchIn: "disableSearchIn", emptyResult: "emptyResult" }, outputs: { selectValue: "selectValue", searchKeyUp: "searchKeyUp", searchFocusOut: "searchFocusOut" }, ngImport: i0, template: "<div class=\"wac-search\" [ngClass]=\"{ open: openSelect || alwaysOpen }\" [zIndexToggle]=\"openSelect\" wzAutoHide (clickOutside)=\"closeSelect()\">\r\n  <div class=\"wac-search__wrapper\">\r\n    <button><i class=\"fal fa-search\"></i></button>\r\n    <input [value]=\"search\" type=\"text\" required [placeholder]=\"placeholder\" (focus)=\"openSelect = true;\" (focusout)=\"sendEventFocusOut()\" (keyup)=\"setSearchValueToQuery($event)\" />\r\n  </div>\r\n  <div class=\"wac-search__absolute\" *ngIf=\"triggerOptions\" [ngClass]=\"{'hidden': !openSelect}\">\r\n    <perfect-scrollbar [config]=\"{ suppressScrollX: true }\" *ngIf=\"triggerOptions.length > 0\">\r\n      <div (click)=\"onClose()\" class=\"wac-select__content__item\" *ngFor=\"let item of triggerOptions; let index = index;\">\r\n        <div [ngClass]=\"{ selected: item.checked }\" (click)=\"onSelectItem(index, item.id, item.label)\">\r\n          {{ item.label }}\r\n        </div>\r\n      </div>\r\n    </perfect-scrollbar>\r\n    <div class=\"wac-select__content__empty\" *ngIf=\"triggerOptions.length === 0\">\r\n      <span *ngIf=\"emptyResult\">{{emptyResult}}</span>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: ["triggerElement", "forceOn"], outputs: ["clickOutside"] }, { kind: "directive", type: ZindexToggleDirective, selector: "[zIndexToggle]", inputs: ["zIndexToggle"], outputs: ["onEventChange"] }, { kind: "component", type: i4.PerfectScrollbarComponent, selector: "perfect-scrollbar", inputs: ["disabled", "usePSClass", "autoPropagation", "scrollIndicators", "config"], outputs: ["psScrollY", "psScrollX", "psScrollUp", "psScrollDown", "psScrollLeft", "psScrollRight", "psYReachEnd", "psYReachStart", "psXReachEnd", "psXReachStart"], exportAs: ["ngxPerfectScrollbar"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SearchComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-search', template: "<div class=\"wac-search\" [ngClass]=\"{ open: openSelect || alwaysOpen }\" [zIndexToggle]=\"openSelect\" wzAutoHide (clickOutside)=\"closeSelect()\">\r\n  <div class=\"wac-search__wrapper\">\r\n    <button><i class=\"fal fa-search\"></i></button>\r\n    <input [value]=\"search\" type=\"text\" required [placeholder]=\"placeholder\" (focus)=\"openSelect = true;\" (focusout)=\"sendEventFocusOut()\" (keyup)=\"setSearchValueToQuery($event)\" />\r\n  </div>\r\n  <div class=\"wac-search__absolute\" *ngIf=\"triggerOptions\" [ngClass]=\"{'hidden': !openSelect}\">\r\n    <perfect-scrollbar [config]=\"{ suppressScrollX: true }\" *ngIf=\"triggerOptions.length > 0\">\r\n      <div (click)=\"onClose()\" class=\"wac-select__content__item\" *ngFor=\"let item of triggerOptions; let index = index;\">\r\n        <div [ngClass]=\"{ selected: item.checked }\" (click)=\"onSelectItem(index, item.id, item.label)\">\r\n          {{ item.label }}\r\n        </div>\r\n      </div>\r\n    </perfect-scrollbar>\r\n    <div class=\"wac-select__content__empty\" *ngIf=\"triggerOptions.length === 0\">\r\n      <span *ngIf=\"emptyResult\">{{emptyResult}}</span>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { placeholder: [{
                type: Input
            }], alwaysOpen: [{
                type: Input
            }], label: [{
                type: Input
            }], options: [{
                type: Input
            }], disableSearchIn: [{
                type: Input
            }], emptyResult: [{
                type: Input
            }], selectValue: [{
                type: Output
            }], searchKeyUp: [{
                type: Output
            }], searchFocusOut: [{
                type: Output
            }] } });

class AreAllOptionsSelectedPipe {
    transform(options) {
        return !options.some(option => !option.checked);
    }
}
AreAllOptionsSelectedPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AreAllOptionsSelectedPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
AreAllOptionsSelectedPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: AreAllOptionsSelectedPipe, name: "areAllOptionsSelected", pure: false });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AreAllOptionsSelectedPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'areAllOptionsSelected',
                    pure: false
                }]
        }] });

class SelectedListComponent {
    constructor() {
        this.options = [];
        this.enableSelectAll = true;
        this.selectedItemsIndex = new EventEmitter();
        this.selectedItemsAll = new EventEmitter();
        this.unSelectedItemsAll = new EventEmitter();
        this.selectedOptionIndex = [];
    }
    ngOnInit() {
    }
    onSelectAll() {
        this.selectedOptionIndex = this.options.map((option, index) => {
            option.checked = true;
            return index;
        });
        this.selectedItemsAll.emit(this.selectedOptionIndex);
    }
    onUnSelectAll() {
        this.selectedOptionIndex = this.options.map((option, index) => {
            option.checked = false;
            return index;
        });
        this.unSelectedItemsAll.emit(this.selectedOptionIndex);
    }
    onSelectItem(index) {
        this.options[index].checked = !this.options[index].checked;
        this.selectedItemsIndex.emit(index);
    }
    areAllOptionsChecked() {
        return !this.options.some(option => !option.checked);
    }
}
SelectedListComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectedListComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SelectedListComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SelectedListComponent, selector: "wac-selected-list", inputs: { options: "options", label: "label", textSelectAll: "textSelectAll", textUnSelectAll: "textUnSelectAll", enableSelectAll: "enableSelectAll" }, outputs: { selectedItemsIndex: "selectedItemsIndex", selectedItemsAll: "selectedItemsAll", unSelectedItemsAll: "unSelectedItemsAll" }, ngImport: i0, template: "<div class=\"selected-list\">\r\n  <div class=\"selected-list__wrapper\">\r\n    <div class=\"selected-list__wrapper__head\">\r\n      <p *ngIf=\"label\" [innerHTML]=\"label\"></p>\r\n      <ng-container *ngVar=\"(options | areAllOptionsSelected) as areAllOptionsSelected\">\r\n        <ng-container *ngIf=\"textSelectAll && !areAllOptionsSelected\">\r\n\r\n          <div class=\"selected-list__wrapper__head__button\">\r\n\r\n            <div class=\"selected-list__wrapper__head__button__notMobile\">\r\n              <wac-button\r\n                [label]=\"textSelectAll\"\r\n                (click)=\"onSelectAll()\"\r\n              >\r\n              </wac-button>\r\n            </div>\r\n\r\n            <div class=\"selected-list__wrapper__head__button__mobile\">\r\n              <wac-button\r\n                [extraClasses]=\"'is-grey'\"\r\n                [icon]=\"'fad fa-check-double'\"\r\n                (click)=\"onSelectAll()\"\r\n              >\r\n              </wac-button>\r\n            </div>\r\n\r\n          </div>\r\n\r\n        </ng-container>\r\n\r\n        <ng-container *ngIf=\"textUnSelectAll && areAllOptionsSelected\">\r\n\r\n          <div class=\"selected-list__wrapper__head__button\">\r\n\r\n            <div class=\"selected-list__wrapper__head__button__notMobile\">\r\n              <wac-button\r\n                [extraClasses]=\"'is-info'\"\r\n                [label]=\"textUnSelectAll\"\r\n                (click)=\"onUnSelectAll()\"\r\n              >\r\n              </wac-button>\r\n            </div>\r\n\r\n            <div class=\"selected-list__wrapper__head__button__mobile\">\r\n              <wac-button\r\n                [extraClasses]=\"'is-grey'\"\r\n                [icon]=\"'fad fa-check-double'\"\r\n                (click)=\"onUnSelectAll()\"\r\n              >\r\n              </wac-button>\r\n            </div>\r\n\r\n          </div>\r\n\r\n        </ng-container>\r\n\r\n      </ng-container>\r\n\r\n    </div>\r\n    <div class=\"selected-list__wrapper__content\">\r\n      <div class=\"selected-list__wrapper__content__item\" *ngFor=\"let item of options;let i = index;\" [ngClass]=\"{'active': item.checked}\" (click)=\"onSelectItem(i)\">\r\n        <span [innerHTML]=\"item.label\"></span>\r\n        <i class=\"fas fa-check\"></i>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: VarDirective, selector: "[ngVar]", inputs: ["ngVar"] }, { kind: "component", type: ButtonComponent, selector: "wac-button", inputs: ["extraClasses", "label", "icon", "isLoadingSvg", "iconNext", "textcolor", "colorIcon", "widthAuto", "contentHorizontalPosition", "iconFontSize", "hasLoader", "disabled", "whiteSpaceNowrap", "opacity", "animation", "animationRight", "animationText", "confirmDelete", "confirmDeleteText", "coin", "tooltip", "tooltipWidth", "borderColor", "noPadding", "tooltipPosition", "tooltipOneline", "confirmDeletePosition", "isLoading"], outputs: ["click", "isLoadingChange"] }, { kind: "pipe", type: AreAllOptionsSelectedPipe, name: "areAllOptionsSelected" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectedListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-selected-list', template: "<div class=\"selected-list\">\r\n  <div class=\"selected-list__wrapper\">\r\n    <div class=\"selected-list__wrapper__head\">\r\n      <p *ngIf=\"label\" [innerHTML]=\"label\"></p>\r\n      <ng-container *ngVar=\"(options | areAllOptionsSelected) as areAllOptionsSelected\">\r\n        <ng-container *ngIf=\"textSelectAll && !areAllOptionsSelected\">\r\n\r\n          <div class=\"selected-list__wrapper__head__button\">\r\n\r\n            <div class=\"selected-list__wrapper__head__button__notMobile\">\r\n              <wac-button\r\n                [label]=\"textSelectAll\"\r\n                (click)=\"onSelectAll()\"\r\n              >\r\n              </wac-button>\r\n            </div>\r\n\r\n            <div class=\"selected-list__wrapper__head__button__mobile\">\r\n              <wac-button\r\n                [extraClasses]=\"'is-grey'\"\r\n                [icon]=\"'fad fa-check-double'\"\r\n                (click)=\"onSelectAll()\"\r\n              >\r\n              </wac-button>\r\n            </div>\r\n\r\n          </div>\r\n\r\n        </ng-container>\r\n\r\n        <ng-container *ngIf=\"textUnSelectAll && areAllOptionsSelected\">\r\n\r\n          <div class=\"selected-list__wrapper__head__button\">\r\n\r\n            <div class=\"selected-list__wrapper__head__button__notMobile\">\r\n              <wac-button\r\n                [extraClasses]=\"'is-info'\"\r\n                [label]=\"textUnSelectAll\"\r\n                (click)=\"onUnSelectAll()\"\r\n              >\r\n              </wac-button>\r\n            </div>\r\n\r\n            <div class=\"selected-list__wrapper__head__button__mobile\">\r\n              <wac-button\r\n                [extraClasses]=\"'is-grey'\"\r\n                [icon]=\"'fad fa-check-double'\"\r\n                (click)=\"onUnSelectAll()\"\r\n              >\r\n              </wac-button>\r\n            </div>\r\n\r\n          </div>\r\n\r\n        </ng-container>\r\n\r\n      </ng-container>\r\n\r\n    </div>\r\n    <div class=\"selected-list__wrapper__content\">\r\n      <div class=\"selected-list__wrapper__content__item\" *ngFor=\"let item of options;let i = index;\" [ngClass]=\"{'active': item.checked}\" (click)=\"onSelectItem(i)\">\r\n        <span [innerHTML]=\"item.label\"></span>\r\n        <i class=\"fas fa-check\"></i>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], propDecorators: { options: [{
                type: Input
            }], label: [{
                type: Input
            }], textSelectAll: [{
                type: Input
            }], textUnSelectAll: [{
                type: Input
            }], enableSelectAll: [{
                type: Input
            }], selectedItemsIndex: [{
                type: Output
            }], selectedItemsAll: [{
                type: Output
            }], unSelectedItemsAll: [{
                type: Output
            }] } });

class TreeComponent {
    // https://indepth.dev/posts/1405/ngtemplateoutlet
    constructor() {
        this.treeDepth = 0;
        this.trackByFn = (index, item) => item;
    }
}
TreeComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TreeComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TreeComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TreeComponent, selector: "wac-tree", inputs: { items: "items", treeDepth: "treeDepth", optionTemplate: "optionTemplate", trackByFn: "trackByFn" }, ngImport: i0, template: "<ul [ngClass]=\"['treeDepth-' + treeDepth]\">\r\n   <li *ngFor=\"let item of items; let index = index; trackBy: trackByFn\">\r\n\r\n    <ng-template #defaultItem>\r\n      {{ item?.treeLabel }}\r\n    </ng-template>\r\n\r\n    <ng-container\r\n      [ngTemplateOutlet]=\"optionTemplate || defaultItem\"\r\n      [ngTemplateOutletContext]=\"{ $implicit: item, index: index }\"\r\n    >\r\n    </ng-container>\r\n\r\n    <wac-tree [optionTemplate]=\"optionTemplate\" [items]=\"item.treeChildren\" *ngIf=\"item.treeChildren?.length\" [treeDepth]=\"treeDepth + 1\"></wac-tree>\r\n   </li>\r\n</ul>", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: TreeComponent, selector: "wac-tree", inputs: ["items", "treeDepth", "optionTemplate", "trackByFn"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TreeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-tree', changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, template: "<ul [ngClass]=\"['treeDepth-' + treeDepth]\">\r\n   <li *ngFor=\"let item of items; let index = index; trackBy: trackByFn\">\r\n\r\n    <ng-template #defaultItem>\r\n      {{ item?.treeLabel }}\r\n    </ng-template>\r\n\r\n    <ng-container\r\n      [ngTemplateOutlet]=\"optionTemplate || defaultItem\"\r\n      [ngTemplateOutletContext]=\"{ $implicit: item, index: index }\"\r\n    >\r\n    </ng-container>\r\n\r\n    <wac-tree [optionTemplate]=\"optionTemplate\" [items]=\"item.treeChildren\" *ngIf=\"item.treeChildren?.length\" [treeDepth]=\"treeDepth + 1\"></wac-tree>\r\n   </li>\r\n</ul>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { items: [{
                type: Input
            }], treeDepth: [{
                type: Input
            }], optionTemplate: [{
                type: Input
            }], trackByFn: [{
                type: Input
            }] } });

class FormatObjectToRecursifTreePipe {
    constructor() {
        this.childrenProperties = [];
    }
    transform(objectList, childrenProperties) {
        this.childrenProperties = childrenProperties;
        const treeDepth = 0;
        objectList.forEach(object => this.recursiveFormatObjectToRecursifTree(object, treeDepth));
        return objectList;
    }
    recursiveFormatObjectToRecursifTree(object, treeDepth) {
        for (const childrenProperty of this.childrenProperties) {
            object.hasTreeChildren = true;
            if (!object.hasOwnProperty(childrenProperty)) {
                // No more chrildren
                object.hasTreeChildren = false;
                continue;
            }
            if (!Array.isArray(object[childrenProperty])) {
                throw `Property : "${childrenProperty}", is not an array. it could not be transform to a recursive list.`;
            }
            // Add treeChildren property filled with name children property
            object.treeChildren = object[childrenProperty];
            // call this function recursively until no children can be generated
            this.recursiveFormatObjectToRecursifTree(object.treeChildren, treeDepth++);
            break;
        }
        object.treeDepth = treeDepth;
    }
}
FormatObjectToRecursifTreePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FormatObjectToRecursifTreePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
FormatObjectToRecursifTreePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: FormatObjectToRecursifTreePipe, name: "formatObjectToRecursifTree" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FormatObjectToRecursifTreePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'formatObjectToRecursifTree'
                }]
        }] });

class FormatObjectToSimpleTreePipe {
    constructor() {
        this.childrenProperties = [];
        this.labelProperties = [];
    }
    transform(objectList, childrenProperties, labelProperties) {
        this.childrenProperties = childrenProperties;
        this.labelProperties = labelProperties;
        const treeDepth = 0;
        objectList.forEach(object => this.recursiveFormatObjectToSimpleTree(object, treeDepth));
        return objectList;
    }
    recursiveFormatObjectToSimpleTree(object, treeDepth) {
        for (const property in object) {
            if (!Object.prototype.hasOwnProperty.call(object, property)) {
                continue;
            }
            if (this.labelProperties.includes(property)) {
                object.treeLabel = object[property];
                continue;
            }
            object.hasTreeChildren = true;
            if (!this.childrenProperties.includes(property)) {
                // No more chrildren
                object.hasTreeChildren = false;
                continue;
            }
            if (!Array.isArray(object[property])) {
                throw `Property : "${property}", is not an array. it could not be transform to a recursive list.`;
            }
            // Add treeChildren property filled with name children property
            object.treeChildren = object[property];
            // call this function recursively until no children can be generated
            this.recursiveFormatObjectToSimpleTree(object.treeChildren, treeDepth++);
            break;
        }
    }
}
FormatObjectToSimpleTreePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FormatObjectToSimpleTreePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
FormatObjectToSimpleTreePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: FormatObjectToSimpleTreePipe, name: "formatObjectToSimpleTree" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FormatObjectToSimpleTreePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'formatObjectToSimpleTree'
                }]
        }] });

class SelectFiltersPipe {
    transform(items, filterName) {
        return items.filter(item => {
            const regexp = new RegExp(filterName, 'i');
            return regexp.test(item.name);
        });
    }
}
SelectFiltersPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectFiltersPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
SelectFiltersPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: SelectFiltersPipe, name: "selectFilters" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectFiltersPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'selectFilters'
                }]
        }] });

class FilterOptionsPipe {
    transform(options, searchValue, ...args) {
        const regexp = new RegExp(searchValue, 'i');
        return options.filter(option => {
            return args.some(arg => regexp.test(option[arg]));
        });
    }
}
FilterOptionsPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FilterOptionsPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
FilterOptionsPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: FilterOptionsPipe, name: "filterOptions" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FilterOptionsPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'filterOptions'
                }]
        }] });

class FindOptionSelectedPipe {
    transform(options, field) {
        const isFieldArray = Array.isArray(field);
        if (!options) {
            return isFieldArray ? [] : '';
        }
        const optionSelected = options.find((item) => item.active);
        if (!optionSelected) {
            return isFieldArray ? [] : '';
        }
        if (isFieldArray) {
            return field.reduce((acc, curr) => {
                return acc[curr];
            }, optionSelected);
        }
        return optionSelected[field];
    }
}
FindOptionSelectedPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FindOptionSelectedPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
FindOptionSelectedPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: FindOptionSelectedPipe, name: "wacFindOptionSelectedField" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: FindOptionSelectedPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'wacFindOptionSelectedField'
                }]
        }] });

class CallComponentFunctionPipe {
    /**
     * Maps object to an arbitrary result through a plan-name function
     *
     * @param value an item to transform
     * @param mapper a mapping function
     * @param args arbitrary number of additional arguments
     */
    transform(value, mapper, ...args) {
        return mapper(value, ...args);
    }
}
CallComponentFunctionPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CallComponentFunctionPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
CallComponentFunctionPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: CallComponentFunctionPipe, isStandalone: true, name: "wacFn" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CallComponentFunctionPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'wacFn',
                    standalone: true,
                }]
        }] });

const exportedPipes = [
    FormatObjectToRecursifTreePipe,
    FormatObjectToSimpleTreePipe,
    FilterOptionsPipe,
    FindOptionSelectedPipe
];
const pipes = [
    SelectFiltersPipe,
    AreAllOptionsSelectedPipe
];
class SharedPipes {
}
SharedPipes.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SharedPipes, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
SharedPipes.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: SharedPipes, declarations: [FormatObjectToRecursifTreePipe,
        FormatObjectToSimpleTreePipe,
        FilterOptionsPipe,
        FindOptionSelectedPipe, SelectFiltersPipe,
        AreAllOptionsSelectedPipe], imports: [CommonModule, FormsModule, CallComponentFunctionPipe], exports: [FormatObjectToRecursifTreePipe,
        FormatObjectToSimpleTreePipe,
        FilterOptionsPipe,
        FindOptionSelectedPipe, SelectFiltersPipe,
        AreAllOptionsSelectedPipe, CallComponentFunctionPipe] });
SharedPipes.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SharedPipes, imports: [CommonModule, FormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SharedPipes, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, FormsModule, CallComponentFunctionPipe],
                    declarations: [...exportedPipes, ...pipes],
                    exports: [...exportedPipes, ...pipes, CallComponentFunctionPipe]
                }]
        }] });

class TreeModule {
}
TreeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TreeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
TreeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: TreeModule, declarations: [TreeComponent], imports: [CommonModule,
        FormsModule,
        SharedPipes], exports: [TreeComponent] });
TreeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TreeModule, imports: [CommonModule,
        FormsModule,
        SharedPipes] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TreeModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        SharedPipes
                    ],
                    exports: [TreeComponent],
                    declarations: [TreeComponent],
                    providers: [],
                }]
        }] });

const uuid = () => {
    if (typeof window !== "undefined" && typeof window.crypto.randomUUID === "function") {
        return window.crypto.randomUUID();
    }
    // https://developer.mozilla.org/en-US/docs/Web/API/Crypto/getRandomValues
    return window.crypto.getRandomValues(new Uint32Array(5)).join("-");
};

class OptionComponent extends SelectOptionDirective {
    constructor(contentRef, changeDetectorRef) {
        super(contentRef, changeDetectorRef);
        this.contentRef = contentRef;
        this.changeDetectorRef = changeDetectorRef;
        this.checkBoxId = `wac-option-${uuid()}`;
    }
    getContentRef() {
        return this.contentOption;
    }
}
OptionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: OptionComponent, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
OptionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: OptionComponent, selector: "wac-option", providers: [{ provide: OPTION_SELECTION_HANDLER, useExisting: OptionComponent }], viewQueries: [{ propertyName: "contentOption", first: true, predicate: ["contentWrapper"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<div\r\n    [ngClass]=\"{ 'disabled': disabled }\"\r\n    class=\"wac-option\"\r\n  >\r\n    <div [ngClass]=\"{ 'selected': !disabled && selected, 'disabled': disabled }\" #contentWrapper>\r\n      <wac-checkbox *ngIf=\"multiple\" [id]=\"checkBoxId\" [value]=\"selected\"></wac-checkbox>\r\n      <ng-content></ng-content>\r\n    </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: CheckboxComponent, selector: "wac-checkbox", inputs: ["label", "value", "type", "alone", "checked", "hasInput", "inputPlaceholder", "id", "name", "whiteSpace", "disabled"], outputs: ["valueChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: OptionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-option', encapsulation: ViewEncapsulation.None, providers: [{ provide: OPTION_SELECTION_HANDLER, useExisting: OptionComponent }], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\r\n    [ngClass]=\"{ 'disabled': disabled }\"\r\n    class=\"wac-option\"\r\n  >\r\n    <div [ngClass]=\"{ 'selected': !disabled && selected, 'disabled': disabled }\" #contentWrapper>\r\n      <wac-checkbox *ngIf=\"multiple\" [id]=\"checkBoxId\" [value]=\"selected\"></wac-checkbox>\r\n      <ng-content></ng-content>\r\n    </div>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { contentOption: [{
                type: ViewChild,
                args: ['contentWrapper']
            }] } });

class OptionGroupComponent {
}
OptionGroupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: OptionGroupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
OptionGroupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: OptionGroupComponent, selector: "wac-option-group", inputs: { title: "title" }, ngImport: i0, template: "<div class=\"wac-option-group\">\r\n    <div class=\"wac-option-group__title\">{{ title }}</div>\r\n    <div class=\"wac-option-group__content\">\r\n      <ng-content select=\"wac-option, option, .option, [selectOption]\"></ng-content>\r\n    </div>\r\n  </div>", styles: [".wac-option-group{width:100%}.wac-option-group:first-child{padding-top:rem(10)}.wac-option-group:last-child{padding-bottom:rem(10)}.wac-option-group:not(:last-child):after{content:\"\";display:block;width:100%;height:1px;border-bottom:1px dashed #dee2de}.wac-option-group__title{padding:0 20px 10px;font-size:12px;font-weight:500;color:#526384}\n"], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: OptionGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-option-group', encapsulation: ViewEncapsulation.None, template: "<div class=\"wac-option-group\">\r\n    <div class=\"wac-option-group__title\">{{ title }}</div>\r\n    <div class=\"wac-option-group__content\">\r\n      <ng-content select=\"wac-option, option, .option, [selectOption]\"></ng-content>\r\n    </div>\r\n  </div>", styles: [".wac-option-group{width:100%}.wac-option-group:first-child{padding-top:rem(10)}.wac-option-group:last-child{padding-bottom:rem(10)}.wac-option-group:not(:last-child):after{content:\"\";display:block;width:100%;height:1px;border-bottom:1px dashed #dee2de}.wac-option-group__title{padding:0 20px 10px;font-size:12px;font-weight:500;color:#526384}\n"] }]
        }], propDecorators: { title: [{
                type: Input
            }] } });

class SelectSearchTriggerComponent {
    constructor() {
        this.searchValue = '';
        this.searchValueChange = new EventEmitter();
        this.searchInputKeyEnterPressed = new EventEmitter();
    }
    onSearchValueChange() {
        this.searchValueChange.emit(this.searchValue);
    }
    onKeypressEnter() {
        this.searchInputKeyEnterPressed.emit();
    }
    setFocus() {
        setTimeout(() => {
            this.searchInput.nativeElement.focus();
        }, 0);
    }
}
SelectSearchTriggerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectSearchTriggerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SelectSearchTriggerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SelectSearchTriggerComponent, selector: "wac-select-search-trigger", inputs: { searchValue: "searchValue" }, outputs: { searchValueChange: "searchValueChange", searchInputKeyEnterPressed: "searchInputKeyEnterPressed" }, viewQueries: [{ propertyName: "searchInput", first: true, predicate: ["searchInput"], descendants: true }], ngImport: i0, template: "<div class=\"wac-select-seacrh-trigger\">\r\n  <i class=\"far fa-search\"></i>\r\n  <input #searchInput type=\"text\" (click)=\"$event.stopPropagation()\" [(ngModel)]=\"searchValue\" (ngModelChange)=\"onSearchValueChange()\" (keypressEnter)=\"onKeypressEnter()\"/>\r\n</div>", dependencies: [{ kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: KeypressEnterDirective, selector: "[keypressEnter]", outputs: ["keypressEnter"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectSearchTriggerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-select-search-trigger', encapsulation: ViewEncapsulation.None, template: "<div class=\"wac-select-seacrh-trigger\">\r\n  <i class=\"far fa-search\"></i>\r\n  <input #searchInput type=\"text\" (click)=\"$event.stopPropagation()\" [(ngModel)]=\"searchValue\" (ngModelChange)=\"onSearchValueChange()\" (keypressEnter)=\"onKeypressEnter()\"/>\r\n</div>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { searchValue: [{
                type: Input
            }], searchValueChange: [{
                type: Output
            }], searchInputKeyEnterPressed: [{
                type: Output
            }], searchInput: [{
                type: ViewChild,
                args: ['searchInput']
            }] } });

class SelectComponent extends SelectDirective {
    /** Whether the component is required. */
    get required() {
        return this._required ?? false;
    }
    set required(value) {
        this._required = value;
    }
    get selectedOptionContent() {
        return this.valueChangeService.selectedOptionContent;
    }
    ;
    set keepPanelOpen(keepPanelOpen) {
        this.openPanel = keepPanelOpen;
        this._keepPanelOpen = keepPanelOpen;
    }
    get keepPanelOpen() {
        return this._keepPanelOpen;
    }
    set openPanel(openPanel) {
        const wasOpen = this._openPanel;
        this._openPanel = this.keepPanelOpen || openPanel;
        if (openPanel) {
            this.customSearchTrigger?.setFocus();
        }
        if (wasOpen) {
            this.onSelectTouch(this.value);
        }
    }
    get openPanel() {
        return this._openPanel;
    }
    constructor(valueChangeService) {
        super(valueChangeService);
        this.valueChangeService = valueChangeService;
        //! Refacto improve sroll on mobile, see with Pauline
        // angular material select https://github.com/angular/components/blob/main/src/material/select/select.ts
        this.role = 'combobox';
        this.small = false;
        this._openPanel = false;
        this.openPanelChange = new EventEmitter();
        this.tabIndex = -1;
        this._searchByTyping = true;
        this.isDestroyed$ = new Subject();
        this.isKeyBoardAction = false;
        this.skipIfTriggeredByKeyboardAction = () => {
            if (!this.isKeyBoardAction) {
                return true;
            }
            this.isKeyBoardAction = false;
            return false;
        };
        this.onSelectTouch = () => { };
    }
    ngOnInit() {
        super.ngOnInit();
        this.closeTabOnValueChange();
    }
    closeTabOnValueChange() {
        this.valueChangeService.valueChange$.pipe(takeUntil(this.isDestroyed$), filter(this.skipIfTriggeredByKeyboardAction)).subscribe(() => {
            this.onClosePanel();
        });
    }
    onTogglePanel() {
        this.openPanel = !this.openPanel;
        this.openPanelChange.emit(this.openPanel);
    }
    onClosePanel() {
        this.openPanel = false;
        this.openPanelChange.emit(this.openPanel);
    }
    onKeydown(event) {
        const keyCode = event.keyCode;
        if (event.keyCode === TAB) {
            // go to the next element with tabindex
            if (this.openPanel) {
                this.openPanel = false;
            }
            return;
        }
        if (this.disabled) {
            return;
        }
        const actionTriggered = this.openPanel ? this._handleOpenKeydown(event) : this._handleClosedKeydown(event);
        if (actionTriggered) {
            return;
        }
        this.isKeyBoardAction = true;
        super.onKeydown(event);
    }
    handleKeyboardActionWithSearch(event) {
        const keyCode = event.keyCode;
        if (keyCode === DOWN_ARROW) {
            this.isKeyBoardAction = true;
            this.valueChangeService.selectNextOption();
            return true;
        }
        if (keyCode === UP_ARROW) {
            this.isKeyBoardAction = true;
            this.valueChangeService.selectPreviousOption();
            return true;
        }
        return false;
    }
    /** Handles keyboard events while the select is closed. */
    _handleClosedKeydown(event) {
        const keyCode = event.keyCode;
        const isArrowKey = keyCode === DOWN_ARROW ||
            keyCode === UP_ARROW ||
            keyCode === LEFT_ARROW ||
            keyCode === RIGHT_ARROW;
        const isOpenKey = keyCode === ENTER;
        // Open the select on ALT + arrow key to match the native <select>
        if ((isOpenKey && !hasModifierKey(event)) ||
            (event.altKey && isArrowKey)) {
            this.openPanel = true;
            return true;
        }
        return false;
    }
    /** Handles keyboard events when the selected is open. */
    _handleOpenKeydown(event) {
        const keyCode = event.keyCode;
        const isArrowKey = keyCode === DOWN_ARROW ||
            keyCode === UP_ARROW ||
            keyCode === LEFT_ARROW ||
            keyCode === RIGHT_ARROW;
        const isEscapeKey = keyCode === ESCAPE || keyCode === ENTER || keyCode === TAB;
        if ((isArrowKey && event.altKey) || isEscapeKey) {
            // Close the select on ALT + arrow key to match the native <select>
            this.openPanel = false;
            if (this.customSearchTrigger && keyCode !== TAB) {
                // If a escape key is used with the search, the focus on the select is loosed. And we can not interact with the select anymore.
                this.selectHeader.nativeElement.focus();
            }
            return true;
        }
        return false;
    }
    registerOnTouched(fn) {
        this.onSelectTouch = fn;
    }
    ngOnDestroy() {
        this.isDestroyed$.next();
        this.isDestroyed$.complete();
    }
}
SelectComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectComponent, deps: [{ token: ValueChangeService }], target: i0.ɵɵFactoryTarget.Component });
SelectComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SelectComponent, selector: "wac-select", inputs: { required: "required", small: "small", keepPanelOpen: "keepPanelOpen", openPanel: "openPanel" }, outputs: { openPanelChange: "openPanelChange" }, host: { properties: { "attr.role": "this.role" } }, providers: [
        { provide: NG_VALUE_ACCESSOR, useExisting: SelectComponent, multi: true },
        ValueChangeService
    ], queries: [{ propertyName: "customSearchTrigger", first: true, predicate: SelectSearchTriggerComponent, descendants: true }, { propertyName: "label", first: true, predicate: LabelComponent, descendants: true }], viewQueries: [{ propertyName: "selectHeader", first: true, predicate: ["selectHeader"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<p *ngIf=\"!!label\" class=\"wac-select__label\">\r\n  <ng-content select=\"wac-label, .wac-label\" ></ng-content>\r\n</p>\r\n\r\n<div\r\n  class=\"wac-select\"\r\n  wzAutoHide\r\n  (clickOutside)=\"onClosePanel()\"\r\n  [triggerElement]=\"'wac-select__header__selection'\"\r\n  [zIndexToggle]=\"openPanel\"\r\n  [ngClass]=\"{'small': small}\"\r\n  >\r\n\r\n    <div #selectHeader class=\"wac-select__header\" [ngClass]=\"{ 'select-disabled' : disabled, 'open': openPanel }\" (click)=\"!disabled && onTogglePanel()\" tabindex=\"0\">\r\n\r\n      <ng-container [ngTemplateOutlet]=\"openPanel ? openPanelTrigger : closePanelTrigger\" >\r\n\r\n        <ng-template #closePanelTrigger>\r\n          <ng-container [ngTemplateOutlet]=\"defaultTrigger\"></ng-container>\r\n        </ng-template>\r\n\r\n        <ng-template #openPanelTrigger>\r\n          <ng-content *ngIf=\"!!customSearchTrigger; else defaultTrigger\" select=\"wac-select-search-trigger\" ></ng-content>\r\n        </ng-template>\r\n\r\n        <ng-template #defaultTrigger>\r\n          <ng-content *ngIf=\"!selectedOptionContent\" select=\"wac-placeholder,[role=placeholder]\"></ng-content>\r\n          <div\r\n            class=\"wac-select__header__selection wac-option__placeholder\"\r\n            *ngIf=\"!!selectedOptionContent\"\r\n            [innerHtml]=\"selectedOptionContent\">\r\n          </div>\r\n        </ng-template>\r\n\r\n      </ng-container>\r\n\r\n      <span class=\"wac-select__header__chevron\"><i class=\"fas fa-chevron-down\"></i></span>\r\n\r\n    </div>\r\n\r\n\r\n    <div class=\"wac-select__content\" *ngIf=\"!disabled\" [ngClass]=\"{ hidden: !openPanel, open: openPanel }\">\r\n\r\n      <perfect-scrollbar [config]=\"{ suppressScrollX: true }\">\r\n        <ng-content\r\n          select=\"wac-option-group, wac-option-call-to-action, wac-option, option, .option, [selectOption]\">\r\n        </ng-content>\r\n      </perfect-scrollbar>\r\n\r\n      <div *ngIf=\"!optionChildren?.length\" class=\"wac-select__content__empty\">\r\n        <span>{{'wac.datatable.noresult' | translate}}</span>\r\n      </div>\r\n\r\n    </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: AutoHideDirective, selector: "[wzAutoHide]", inputs: ["triggerElement", "forceOn"], outputs: ["clickOutside"] }, { kind: "directive", type: ZindexToggleDirective, selector: "[zIndexToggle]", inputs: ["zIndexToggle"], outputs: ["onEventChange"] }, { kind: "component", type: i4.PerfectScrollbarComponent, selector: "perfect-scrollbar", inputs: ["disabled", "usePSClass", "autoPropagation", "scrollIndicators", "config"], outputs: ["psScrollY", "psScrollX", "psScrollUp", "psScrollDown", "psScrollLeft", "psScrollRight", "psYReachEnd", "psYReachStart", "psXReachEnd", "psXReachStart"], exportAs: ["ngxPerfectScrollbar"] }, { kind: "pipe", type: i1$2.TranslatePipe, name: "translate" }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-select', providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: SelectComponent, multi: true },
                        ValueChangeService
                    ], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, template: "<p *ngIf=\"!!label\" class=\"wac-select__label\">\r\n  <ng-content select=\"wac-label, .wac-label\" ></ng-content>\r\n</p>\r\n\r\n<div\r\n  class=\"wac-select\"\r\n  wzAutoHide\r\n  (clickOutside)=\"onClosePanel()\"\r\n  [triggerElement]=\"'wac-select__header__selection'\"\r\n  [zIndexToggle]=\"openPanel\"\r\n  [ngClass]=\"{'small': small}\"\r\n  >\r\n\r\n    <div #selectHeader class=\"wac-select__header\" [ngClass]=\"{ 'select-disabled' : disabled, 'open': openPanel }\" (click)=\"!disabled && onTogglePanel()\" tabindex=\"0\">\r\n\r\n      <ng-container [ngTemplateOutlet]=\"openPanel ? openPanelTrigger : closePanelTrigger\" >\r\n\r\n        <ng-template #closePanelTrigger>\r\n          <ng-container [ngTemplateOutlet]=\"defaultTrigger\"></ng-container>\r\n        </ng-template>\r\n\r\n        <ng-template #openPanelTrigger>\r\n          <ng-content *ngIf=\"!!customSearchTrigger; else defaultTrigger\" select=\"wac-select-search-trigger\" ></ng-content>\r\n        </ng-template>\r\n\r\n        <ng-template #defaultTrigger>\r\n          <ng-content *ngIf=\"!selectedOptionContent\" select=\"wac-placeholder,[role=placeholder]\"></ng-content>\r\n          <div\r\n            class=\"wac-select__header__selection wac-option__placeholder\"\r\n            *ngIf=\"!!selectedOptionContent\"\r\n            [innerHtml]=\"selectedOptionContent\">\r\n          </div>\r\n        </ng-template>\r\n\r\n      </ng-container>\r\n\r\n      <span class=\"wac-select__header__chevron\"><i class=\"fas fa-chevron-down\"></i></span>\r\n\r\n    </div>\r\n\r\n\r\n    <div class=\"wac-select__content\" *ngIf=\"!disabled\" [ngClass]=\"{ hidden: !openPanel, open: openPanel }\">\r\n\r\n      <perfect-scrollbar [config]=\"{ suppressScrollX: true }\">\r\n        <ng-content\r\n          select=\"wac-option-group, wac-option-call-to-action, wac-option, option, .option, [selectOption]\">\r\n        </ng-content>\r\n      </perfect-scrollbar>\r\n\r\n      <div *ngIf=\"!optionChildren?.length\" class=\"wac-select__content__empty\">\r\n        <span>{{'wac.datatable.noresult' | translate}}</span>\r\n      </div>\r\n\r\n    </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: ValueChangeService }]; }, propDecorators: { role: [{
                type: HostBinding,
                args: ['attr.role']
            }], customSearchTrigger: [{
                type: ContentChild,
                args: [SelectSearchTriggerComponent]
            }], label: [{
                type: ContentChild,
                args: [LabelComponent]
            }], selectHeader: [{
                type: ViewChild,
                args: ['selectHeader']
            }], required: [{
                type: Input
            }], small: [{
                type: Input
            }], keepPanelOpen: [{
                type: Input
            }], openPanel: [{
                type: Input
            }], openPanelChange: [{
                type: Output
            }] } });

class OptionCallToActionComponent {
    constructor() { }
}
OptionCallToActionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: OptionCallToActionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
OptionCallToActionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: OptionCallToActionComponent, selector: "wac-option-call-to-action", ngImport: i0, template: "\r\n<div class=\"wac-option-call-to-action\">\r\n  <div>\r\n    <ng-content></ng-content>\r\n  </div>\r\n</div>\r\n\r\n" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: OptionCallToActionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-option-call-to-action', template: "\r\n<div class=\"wac-option-call-to-action\">\r\n  <div>\r\n    <ng-content></ng-content>\r\n  </div>\r\n</div>\r\n\r\n" }]
        }], ctorParameters: function () { return []; } });

class PlaceholderComponent {
    constructor() { }
    ngOnInit() {
    }
}
PlaceholderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PlaceholderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
PlaceholderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: PlaceholderComponent, selector: "wac-placeholder", host: { classAttribute: "wac-placeholder" }, ngImport: i0, template: "<ng-content></ng-content>" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: PlaceholderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-placeholder', host: {
                        'class': 'wac-placeholder'
                    }, template: "<ng-content></ng-content>" }]
        }], ctorParameters: function () { return []; } });

class WrapperSidebarComponent {
    constructor() {
        this.reverse = false;
        this.hideBackground = false;
        this.stickySidebar = false;
        this.transparentSidebar = false;
    }
}
WrapperSidebarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WrapperSidebarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
WrapperSidebarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: WrapperSidebarComponent, selector: "wac-wrapper-sidebar", inputs: { reverse: "reverse", hideBackground: "hideBackground", backgroundGrey: "backgroundGrey", backgroundWidth: "backgroundWidth", stickySidebar: "stickySidebar", transparentSidebar: "transparentSidebar" }, ngImport: i0, template: "<div class=\"wac-wrapper-sidebar\" [ngClass]=\"{'reverse': reverse}\">\r\n  <div class=\"wac-wrapper-sidebar__left\" [ngClass]=\"{'sticky': stickySidebar, 'transparent': transparentSidebar}\">\r\n    <ng-content select=\"[sidebar]\"></ng-content>\r\n  </div>\r\n  <div class=\"wac-wrapper-sidebar__right\" [style.backgroundImage]=\"!hideBackground && backgroundGrey !== '' ? 'url(' + backgroundGrey + ')' : ''\" [style.backgroundSize]=\"backgroundWidth\">\r\n    <ng-content select=\"[content]\"></ng-content>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WrapperSidebarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-wrapper-sidebar', template: "<div class=\"wac-wrapper-sidebar\" [ngClass]=\"{'reverse': reverse}\">\r\n  <div class=\"wac-wrapper-sidebar__left\" [ngClass]=\"{'sticky': stickySidebar, 'transparent': transparentSidebar}\">\r\n    <ng-content select=\"[sidebar]\"></ng-content>\r\n  </div>\r\n  <div class=\"wac-wrapper-sidebar__right\" [style.backgroundImage]=\"!hideBackground && backgroundGrey !== '' ? 'url(' + backgroundGrey + ')' : ''\" [style.backgroundSize]=\"backgroundWidth\">\r\n    <ng-content select=\"[content]\"></ng-content>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { reverse: [{
                type: Input
            }], hideBackground: [{
                type: Input
            }], backgroundGrey: [{
                type: Input
            }], backgroundWidth: [{
                type: Input
            }], stickySidebar: [{
                type: Input
            }], transparentSidebar: [{
                type: Input
            }] } });

class BreadcrumbsComponent {
    constructor() {
        this.noResponsive = false;
        this.index = 0;
        this.indexChange = new EventEmitter();
    }
    valueChanged(i) {
        this.index = i;
        this.indexChange.emit(this.index);
    }
}
BreadcrumbsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BreadcrumbsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BreadcrumbsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: BreadcrumbsComponent, selector: "wac-breadcrumbs", inputs: { breadcrumbs: "breadcrumbs", noResponsive: "noResponsive" }, outputs: { indexChange: "indexChange" }, ngImport: i0, template: "<div class=\"wac-breadcrumbs\" [ngClass]=\"{'no-responsive': noResponsive}\">\r\n  <div class=\"wac-breadcrumbs__wrapper\">\r\n    <div class=\"wac-breadcrumbs__item\" *ngFor=\"let b of breadcrumbs; let i = index;\" [ngClass]=\"{'valid': b.valid, 'current': b['current']}\" (click)=\"valueChanged(i)\">\r\n      <div class=\"round\" [ngClass]=\"{'valid': b.valid, 'current': b['current']}\"><span *ngIf=\"!b.valid\"><span *ngIf=\"i < 9\">0</span>{{ i + 1 }}</span><i class=\"fas fa-check\" *ngIf=\"b.valid\"></i></div>\r\n      <div class=\"name\" [ngClass]=\"{'valid': b.valid, 'current': b['current']}\">{{ b.name }}</div>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BreadcrumbsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-breadcrumbs', template: "<div class=\"wac-breadcrumbs\" [ngClass]=\"{'no-responsive': noResponsive}\">\r\n  <div class=\"wac-breadcrumbs__wrapper\">\r\n    <div class=\"wac-breadcrumbs__item\" *ngFor=\"let b of breadcrumbs; let i = index;\" [ngClass]=\"{'valid': b.valid, 'current': b['current']}\" (click)=\"valueChanged(i)\">\r\n      <div class=\"round\" [ngClass]=\"{'valid': b.valid, 'current': b['current']}\"><span *ngIf=\"!b.valid\"><span *ngIf=\"i < 9\">0</span>{{ i + 1 }}</span><i class=\"fas fa-check\" *ngIf=\"b.valid\"></i></div>\r\n      <div class=\"name\" [ngClass]=\"{'valid': b.valid, 'current': b['current']}\">{{ b.name }}</div>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { breadcrumbs: [{
                type: Input
            }], noResponsive: [{
                type: Input
            }], indexChange: [{
                type: Output
            }] } });

class CardPriceComponent {
    constructor() {
        this.selected = false;
        this.disabled = false;
        this.btnTextcolor = '#ffffff';
        this.extraClasses = 'is-success';
        this.extraClassesSelected = 'is-success is-outlined';
        this.hideButton = false;
        this.darkMode = false;
        this.isEvolup = false;
        this.confirm = new EventEmitter();
        this.cancel = new EventEmitter();
    }
    triggerClick() {
        this.confirm.emit(true);
    }
    removePackageTrigger() {
        this.cancel.emit(true);
    }
}
CardPriceComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CardPriceComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CardPriceComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: CardPriceComponent, selector: "wac-card-price", inputs: { amount: "amount", promo: "promo", title: "title", selected: "selected", btnLabelSelected: "btnLabelSelected", price: "price", currency: "currency", priceWording: "priceWording", subtitle: "subtitle", btnLabel: "btnLabel", packageSubtitle: "packageSubtitle", linkPackageLabel: "linkPackageLabel", listFeatures: "listFeatures", disabled: "disabled", btnTextcolor: "btnTextcolor", extraClasses: "extraClasses", extraClassesSelected: "extraClassesSelected", hideButton: "hideButton", darkMode: "darkMode", isEvolup: "isEvolup" }, outputs: { confirm: "confirm", cancel: "cancel" }, ngImport: i0, template: "<div class=\"wac-card-price\" [ngClass]=\"{'selected': selected, 'is-evolup': isEvolup, 'is-dark': darkMode}\">\r\n  <div class=\"promo\" *ngIf=\"promo\">\r\n      <p [innerHTML]=\"promo\"></p>\r\n  </div>\r\n  <strong>{{amount}} <span>{{title}}</span></strong>\r\n  <div class=\"price\">\r\n    <span class=\"amount\">{{price}} <span>{{currency}}</span></span><span class=\"month\" [innerHTML]=\"priceWording\"></span>\r\n  </div>\r\n  <div class=\"subtitle\">{{subtitle}}</div>\r\n  <div class=\"list-features\" *ngIf=\"listFeatures\">\r\n    <div *ngFor=\"let feat of listFeatures;\" class=\"list-features__item\"><span>{{feat}}</span></div>\r\n  </div>\r\n  <div class=\"cta\" *ngIf=\"!selected && !hideButton\">\r\n    <wac-button [noPadding]=\"true\" [label]=\"btnLabel\" [extraClasses]=\"extraClasses\" (click)=\"triggerClick()\" [disabled]=\"disabled\" [whiteSpaceNowrap]=\"true\" [textcolor]=\"btnTextcolor\"></wac-button>\r\n  </div>\r\n  <div class=\"cta\" *ngIf=\"selected && !hideButton\">\r\n    <wac-button [noPadding]=\"true\" [icon]=\"'fa-solid fa-check'\" [label]=\"btnLabelSelected\" [extraClasses]=\"extraClassesSelected\" [whiteSpaceNowrap]=\"true\"></wac-button>\r\n  </div>\r\n  <div class=\"package-subtitle\" *ngIf=\"selected\">{{packageSubtitle}}</div>\r\n  <div class=\"link-bottom\" *ngIf=\"linkPackageLabel\">\r\n    <wac-link (click)=\"removePackageTrigger()\">{{linkPackageLabel}}</wac-link>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: ButtonComponent, selector: "wac-button", inputs: ["extraClasses", "label", "icon", "isLoadingSvg", "iconNext", "textcolor", "colorIcon", "widthAuto", "contentHorizontalPosition", "iconFontSize", "hasLoader", "disabled", "whiteSpaceNowrap", "opacity", "animation", "animationRight", "animationText", "confirmDelete", "confirmDeleteText", "coin", "tooltip", "tooltipWidth", "borderColor", "noPadding", "tooltipPosition", "tooltipOneline", "confirmDeletePosition", "isLoading"], outputs: ["click", "isLoadingChange"] }, { kind: "component", type: LinkComponent, selector: "wac-link", inputs: ["href", "tooltip", "tooltipWidth", "target", "id", "class", "fontSize"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CardPriceComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-card-price', template: "<div class=\"wac-card-price\" [ngClass]=\"{'selected': selected, 'is-evolup': isEvolup, 'is-dark': darkMode}\">\r\n  <div class=\"promo\" *ngIf=\"promo\">\r\n      <p [innerHTML]=\"promo\"></p>\r\n  </div>\r\n  <strong>{{amount}} <span>{{title}}</span></strong>\r\n  <div class=\"price\">\r\n    <span class=\"amount\">{{price}} <span>{{currency}}</span></span><span class=\"month\" [innerHTML]=\"priceWording\"></span>\r\n  </div>\r\n  <div class=\"subtitle\">{{subtitle}}</div>\r\n  <div class=\"list-features\" *ngIf=\"listFeatures\">\r\n    <div *ngFor=\"let feat of listFeatures;\" class=\"list-features__item\"><span>{{feat}}</span></div>\r\n  </div>\r\n  <div class=\"cta\" *ngIf=\"!selected && !hideButton\">\r\n    <wac-button [noPadding]=\"true\" [label]=\"btnLabel\" [extraClasses]=\"extraClasses\" (click)=\"triggerClick()\" [disabled]=\"disabled\" [whiteSpaceNowrap]=\"true\" [textcolor]=\"btnTextcolor\"></wac-button>\r\n  </div>\r\n  <div class=\"cta\" *ngIf=\"selected && !hideButton\">\r\n    <wac-button [noPadding]=\"true\" [icon]=\"'fa-solid fa-check'\" [label]=\"btnLabelSelected\" [extraClasses]=\"extraClassesSelected\" [whiteSpaceNowrap]=\"true\"></wac-button>\r\n  </div>\r\n  <div class=\"package-subtitle\" *ngIf=\"selected\">{{packageSubtitle}}</div>\r\n  <div class=\"link-bottom\" *ngIf=\"linkPackageLabel\">\r\n    <wac-link (click)=\"removePackageTrigger()\">{{linkPackageLabel}}</wac-link>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { amount: [{
                type: Input
            }], promo: [{
                type: Input
            }], title: [{
                type: Input
            }], selected: [{
                type: Input
            }], btnLabelSelected: [{
                type: Input
            }], price: [{
                type: Input
            }], currency: [{
                type: Input
            }], priceWording: [{
                type: Input
            }], subtitle: [{
                type: Input
            }], btnLabel: [{
                type: Input
            }], packageSubtitle: [{
                type: Input
            }], linkPackageLabel: [{
                type: Input
            }], listFeatures: [{
                type: Input
            }], disabled: [{
                type: Input
            }], btnTextcolor: [{
                type: Input
            }], extraClasses: [{
                type: Input
            }], extraClassesSelected: [{
                type: Input
            }], hideButton: [{
                type: Input
            }], darkMode: [{
                type: Input
            }], isEvolup: [{
                type: Input
            }], confirm: [{
                type: Output
            }], cancel: [{
                type: Output
            }] } });

class TokenCheckComponent {
    constructor() {
        this.warning = false;
    }
}
TokenCheckComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TokenCheckComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TokenCheckComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TokenCheckComponent, selector: "wac-token-check", inputs: { label: "label", value: "value", max: "max" }, ngImport: i0, template: "<div class=\"wac-token-check\">\r\n  <span [innerHTML]=\"label\"></span> : <span [innerHTML]=\"value\" [ngClass]=\"{'warning': value > max}\"></span>/<strong [innerHTML]=\"max\"></strong>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TokenCheckComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-token-check', template: "<div class=\"wac-token-check\">\r\n  <span [innerHTML]=\"label\"></span> : <span [innerHTML]=\"value\" [ngClass]=\"{'warning': value > max}\"></span>/<strong [innerHTML]=\"max\"></strong>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { label: [{
                type: Input
            }], value: [{
                type: Input
            }], max: [{
                type: Input
            }] } });

class BlockWithCheckboxComponent {
    constructor() {
        this.selected = false;
        this.disabled = false;
        this.checkboxAction = new EventEmitter();
        this.randomLabelName = uuid();
        this.nameRadio = 'wacBlockCheckboxRadio';
        this.isFirst = false;
        this.opacity = '.45';
    }
    eventSelected(event) {
        if (!this.disabled) {
            this.selected = event.target.checked;
            this.checkboxAction.emit(this.selected);
            this.isFirst = false;
        }
    }
    removeFirstClass() {
        if (typeof document.querySelectorAll('.firstWacRadioBLock')[0] !== typeof undefined) {
            document.querySelectorAll('.firstWacRadioBLock')[0].classList.remove('firstWacRadioBLock');
        }
    }
}
BlockWithCheckboxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BlockWithCheckboxComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BlockWithCheckboxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: BlockWithCheckboxComponent, selector: "wac-block-with-checkbox", inputs: { selected: "selected", disabled: "disabled", nameRadio: "nameRadio", isFirst: "isFirst", opacity: "opacity" }, outputs: { checkboxAction: "checkboxAction" }, ngImport: i0, template: "<div class=\"block-with-checkbox\" (click)=\"disabled && $event.target['className'] !== 'wac-link' && $event.target['localName'] !== 'a' ? $event.preventDefault() : ''\" [ngClass]=\"{'selected': inputRadioA.checked || selected, 'firstWacRadioBLock': isFirst, 'disabled': disabled}\" [style.opacity]=\"opacity\" (mouseover)=\"removeFirstClass()\">\r\n  <div class=\"block-with-checkbox__left\" (click)=\"inputRadioA.click()\">\r\n    <div class=\"wac-radio-block\">\r\n      <div class=\"wac-radio__row\">\r\n        <input #inputRadioA [name]=\"nameRadio\" type=\"radio\" [checked]=\"selected\" [value]=\"selected\" (change)=\"eventSelected($event)\" [id]=\"randomLabelName\">\r\n        <label [for]=\"randomLabelName\"></label>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class=\"block-with-checkbox__center\" (click)=\"$event.target['className'] !== 'wac-link' && $event.target['localName'] !== 'a' ? inputRadioA.click() : '';\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BlockWithCheckboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-block-with-checkbox', template: "<div class=\"block-with-checkbox\" (click)=\"disabled && $event.target['className'] !== 'wac-link' && $event.target['localName'] !== 'a' ? $event.preventDefault() : ''\" [ngClass]=\"{'selected': inputRadioA.checked || selected, 'firstWacRadioBLock': isFirst, 'disabled': disabled}\" [style.opacity]=\"opacity\" (mouseover)=\"removeFirstClass()\">\r\n  <div class=\"block-with-checkbox__left\" (click)=\"inputRadioA.click()\">\r\n    <div class=\"wac-radio-block\">\r\n      <div class=\"wac-radio__row\">\r\n        <input #inputRadioA [name]=\"nameRadio\" type=\"radio\" [checked]=\"selected\" [value]=\"selected\" (change)=\"eventSelected($event)\" [id]=\"randomLabelName\">\r\n        <label [for]=\"randomLabelName\"></label>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class=\"block-with-checkbox__center\" (click)=\"$event.target['className'] !== 'wac-link' && $event.target['localName'] !== 'a' ? inputRadioA.click() : '';\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { selected: [{
                type: Input
            }], disabled: [{
                type: Input
            }], checkboxAction: [{
                type: Output
            }], nameRadio: [{
                type: Input
            }], isFirst: [{
                type: Input
            }], opacity: [{
                type: Input
            }] } });

class ConfirmDeleteComponent {
    constructor() {
        this.open = false;
        this.confirm = new EventEmitter();
        this.backgroundColor = '#fff';
        this.borderRadius = '0px';
        this.hideText = false;
    }
    eventCancel(event) {
        this.confirm.emit(false);
        this.open = false;
    }
    eventConfirm(event) {
        this.confirm.emit(true);
        this.open = false;
    }
    responsiveControl(size) {
        if (size < 342) {
            this.hideText = true;
        }
        else {
            this.hideText = false;
        }
    }
    onResize() {
        this.responsiveControl(this.container.nativeElement.offsetWidth);
    }
    ngAfterViewInit() {
        setTimeout(() => {
            this.responsiveControl(this.container.nativeElement.offsetWidth);
        }, 100);
    }
}
ConfirmDeleteComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ConfirmDeleteComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ConfirmDeleteComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ConfirmDeleteComponent, selector: "wac-confirm-delete", inputs: { open: "open", label: "label", labelCancel: "labelCancel", labelConfirm: "labelConfirm", backgroundColor: "backgroundColor", borderRadius: "borderRadius" }, outputs: { confirm: "confirm" }, host: { listeners: { "window:resize": "onResize()" } }, viewQueries: [{ propertyName: "container", first: true, predicate: ["container"], descendants: true }], ngImport: i0, template: "<div class=\"wac-confirm-delete\" #container [ngClass]=\"{'is-open': open, 'hide-text': hideText}\" [style.backgroundColor]=\"backgroundColor\" [style.borderRadius]=\"borderRadius\">\r\n  <div>\r\n    <span [innerHTML]=\"label\"></span>\r\n  </div>\r\n  <div>\r\n    <div><wac-button [label]=\"labelCancel\" [extraClasses]=\"'is-outlined is-grey'\" (click)=\"eventCancel($event)\"></wac-button></div>\r\n    <div><wac-button [label]=\"labelConfirm\" [extraClasses]=\"'is-danger'\" (click)=\"eventConfirm($event)\"></wac-button></div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "component", type: ButtonComponent, selector: "wac-button", inputs: ["extraClasses", "label", "icon", "isLoadingSvg", "iconNext", "textcolor", "colorIcon", "widthAuto", "contentHorizontalPosition", "iconFontSize", "hasLoader", "disabled", "whiteSpaceNowrap", "opacity", "animation", "animationRight", "animationText", "confirmDelete", "confirmDeleteText", "coin", "tooltip", "tooltipWidth", "borderColor", "noPadding", "tooltipPosition", "tooltipOneline", "confirmDeletePosition", "isLoading"], outputs: ["click", "isLoadingChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ConfirmDeleteComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-confirm-delete', template: "<div class=\"wac-confirm-delete\" #container [ngClass]=\"{'is-open': open, 'hide-text': hideText}\" [style.backgroundColor]=\"backgroundColor\" [style.borderRadius]=\"borderRadius\">\r\n  <div>\r\n    <span [innerHTML]=\"label\"></span>\r\n  </div>\r\n  <div>\r\n    <div><wac-button [label]=\"labelCancel\" [extraClasses]=\"'is-outlined is-grey'\" (click)=\"eventCancel($event)\"></wac-button></div>\r\n    <div><wac-button [label]=\"labelConfirm\" [extraClasses]=\"'is-danger'\" (click)=\"eventConfirm($event)\"></wac-button></div>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { open: [{
                type: Input
            }], label: [{
                type: Input
            }], labelCancel: [{
                type: Input
            }], labelConfirm: [{
                type: Input
            }], confirm: [{
                type: Output
            }], backgroundColor: [{
                type: Input
            }], borderRadius: [{
                type: Input
            }], container: [{
                type: ViewChild,
                args: ['container']
            }], onResize: [{
                type: HostListener,
                args: ['window:resize']
            }] } });

class MosaicComponent {
    constructor() {
        this.imagesList = [];
        this.isLoading = false;
        this.numberOfColumn = 3;
        this.importImageSrc = new EventEmitter();
        this.loadMoreImages = new EventEmitter();
    }
    trackColumn(index) {
        return index;
    }
    trackImage(index, image) {
        return image.src;
    }
    ngOnChanges(changes) {
        const imagesListChange = changes.imagesList;
        const isNumberOfColumnChange = changes.numberOfColumn && (changes.numberOfColumn.currentValue !== changes.numberOfColumn.previousValue);
        if (imagesListChange && imagesListChange.currentValue !== imagesListChange.previousValue) {
            this.generateColumns(imagesListChange.previousValue, imagesListChange.currentValue, isNumberOfColumnChange);
            return;
        }
        if (isNumberOfColumnChange) {
            this.generateColumns(null, this.imagesList, isNumberOfColumnChange);
        }
    }
    generateColumns(previousList, currentList, isNumberOfColumnChange) {
        const isNewListSmaller = (currentList && previousList) && (currentList.length < previousList.length);
        const resetColumns = isNumberOfColumnChange || isNewListSmaller;
        const isPreviousListExisting = previousList?.length;
        const newImagesToDisplay = !isPreviousListExisting || resetColumns ? currentList : currentList.slice(previousList.length);
        let columns = this.separateImagesIntoColumns(newImagesToDisplay);
        if (isPreviousListExisting && !resetColumns) {
            const existingColumns = this.columns;
            columns = this.concatColumns(existingColumns, columns);
        }
        this.columns = columns;
    }
    separateImagesIntoColumns(newImagesToDisplay) {
        const columns = Array.from({ length: this.numberOfColumn }, () => []);
        newImagesToDisplay.forEach((image, index) => {
            columns[index % this.numberOfColumn].push(image);
        });
        return columns;
    }
    concatColumns(oldColumns, newColumns) {
        return oldColumns.map((oldColumn, columnIndex) => {
            return [...oldColumn, ...newColumns[columnIndex]];
        });
    }
    onBottomReached() {
        if (!this.isLoading) {
            this.loadMoreImages.emit();
        }
    }
    onImportImage(src) {
        this.importImageSrc.emit(src);
    }
}
MosaicComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MosaicComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
MosaicComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: MosaicComponent, selector: "wac-mosaic", inputs: { imagesList: "imagesList", isLoading: "isLoading", numberOfColumn: "numberOfColumn", hoverImageTemplate: "hoverImageTemplate" }, outputs: { importImageSrc: "importImageSrc", loadMoreImages: "loadMoreImages" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"wac-mosaic\"  [ngClass]=\"{'is-loading': isLoading}\">\r\n  <ng-scrollbar (reachedBottom)=\"onBottomReached()\" [reachedOffset]=\"200\" class=\"wac-mosaic__wrapper__scrollbar\">\r\n    <div class=\"wac-mosaic__wrapper\">\r\n      <div class=\"wac-mosaic__wrapper__column\" *ngFor=\"let column of columns; trackBy : trackColumn;\">\r\n        <div class=\"wac-mosaic__wrapper__column__image\" *ngFor=\"let image of column; let i = index; trackBy : trackImage\">\r\n          <img [src]=\"image.src\" [alt]=\"image.alt\"/>\r\n          <div class=\"hover\">\r\n            <ng-container\r\n              [ngTemplateOutlet]=\"hoverImageTemplate || defaultImportButton\"\r\n              [ngTemplateOutletContext]=\"{ $implicit: image }\"\r\n            >\r\n            </ng-container>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </div>\r\n    <div class=\"wac-mosaic__wrapper load\">\r\n      <div class=\"wac-mosaic__wrapper__column\" *ngFor=\"let column of columns; trackBy : trackColumn;\">\r\n        <div class=\"load-img\">\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </ng-scrollbar>\r\n</div>\r\n\r\n<ng-template #defaultImportButton let-image>\r\n  <wac-button [icon]=\"'fa-solid fa-image'\" [label]=\"'wac.MosaicComponent.import' | translate\" [extraClasses]=\"'is-success'\" (click)=\"onImportImage(image.src)\"></wac-button>\r\n</ng-template>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i2$1.NgScrollbar, selector: "ng-scrollbar", inputs: ["disabled", "sensorDisabled", "pointerEventsDisabled", "viewportPropagateMouseMove", "autoHeightDisabled", "autoWidthDisabled", "viewClass", "trackClass", "thumbClass", "minThumbSize", "trackClickScrollDuration", "pointerEventsMethod", "track", "visibility", "appearance", "position", "sensorDebounce", "scrollAuditTime"], outputs: ["updated"], exportAs: ["ngScrollbar"] }, { kind: "directive", type: i3$2.NgScrollbarReachedBottom, selector: "[reachedBottom], [reached-bottom]", outputs: ["reachedBottom"] }, { kind: "component", type: ButtonComponent, selector: "wac-button", inputs: ["extraClasses", "label", "icon", "isLoadingSvg", "iconNext", "textcolor", "colorIcon", "widthAuto", "contentHorizontalPosition", "iconFontSize", "hasLoader", "disabled", "whiteSpaceNowrap", "opacity", "animation", "animationRight", "animationText", "confirmDelete", "confirmDeleteText", "coin", "tooltip", "tooltipWidth", "borderColor", "noPadding", "tooltipPosition", "tooltipOneline", "confirmDeletePosition", "isLoading"], outputs: ["click", "isLoadingChange"] }, { kind: "pipe", type: i1$2.TranslatePipe, name: "translate" }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MosaicComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-mosaic', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"wac-mosaic\"  [ngClass]=\"{'is-loading': isLoading}\">\r\n  <ng-scrollbar (reachedBottom)=\"onBottomReached()\" [reachedOffset]=\"200\" class=\"wac-mosaic__wrapper__scrollbar\">\r\n    <div class=\"wac-mosaic__wrapper\">\r\n      <div class=\"wac-mosaic__wrapper__column\" *ngFor=\"let column of columns; trackBy : trackColumn;\">\r\n        <div class=\"wac-mosaic__wrapper__column__image\" *ngFor=\"let image of column; let i = index; trackBy : trackImage\">\r\n          <img [src]=\"image.src\" [alt]=\"image.alt\"/>\r\n          <div class=\"hover\">\r\n            <ng-container\r\n              [ngTemplateOutlet]=\"hoverImageTemplate || defaultImportButton\"\r\n              [ngTemplateOutletContext]=\"{ $implicit: image }\"\r\n            >\r\n            </ng-container>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </div>\r\n    <div class=\"wac-mosaic__wrapper load\">\r\n      <div class=\"wac-mosaic__wrapper__column\" *ngFor=\"let column of columns; trackBy : trackColumn;\">\r\n        <div class=\"load-img\">\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </ng-scrollbar>\r\n</div>\r\n\r\n<ng-template #defaultImportButton let-image>\r\n  <wac-button [icon]=\"'fa-solid fa-image'\" [label]=\"'wac.MosaicComponent.import' | translate\" [extraClasses]=\"'is-success'\" (click)=\"onImportImage(image.src)\"></wac-button>\r\n</ng-template>\r\n" }]
        }], propDecorators: { imagesList: [{
                type: Input
            }], isLoading: [{
                type: Input
            }], numberOfColumn: [{
                type: Input
            }], hoverImageTemplate: [{
                type: Input
            }], importImageSrc: [{
                type: Output
            }], loadMoreImages: [{
                type: Output
            }] } });

class ContentWithButtonsComponent {
    constructor() {
        this.iconCopy = 'fa-duotone fa-copy';
        this.iconTranslate = 'fa-regular fa-globe';
        this.tooltipCopy = '';
        this.tooltipTranslate = '';
        this.tooltipLinkReport = '';
        this.count = true;
        this.countCharacterLabel = 'caractères';
        this.countWordsLabel = 'mots';
        this.copyAction = new EventEmitter();
        this.reportAction = new EventEmitter();
        this.translateAction = new EventEmitter();
        this.countIsReady = false;
    }
    ngOnInit() {
        this.randomLabelName = 'content-' + Math.random() * (900 - 700) + 700;
    }
    ngAfterViewInit() {
        setTimeout(() => {
            const content = document.getElementById(this.randomLabelName).innerHTML.replace(/(<([^>]+)>)/gi, '').replace(/[.,\/#!$%\^&\*;:{}=\-_`~()]/g, '');
            this.countCharacter = content.trim().split(' ').join('').length;
            this.countWords = content.trim().split(' ').length;
            this.countIsReady = true;
        });
    }
    eventCopy() {
        this.copyAction.emit(true);
    }
    eventTranslate() {
        this.translateAction.emit(true);
    }
    eventReport() {
        this.reportAction.emit(true);
    }
}
ContentWithButtonsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ContentWithButtonsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ContentWithButtonsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ContentWithButtonsComponent, selector: "wac-content-with-buttons", inputs: { iconCopy: "iconCopy", iconTranslate: "iconTranslate", tooltipCopy: "tooltipCopy", tooltipTranslate: "tooltipTranslate", tooltipLinkReport: "tooltipLinkReport", count: "count", countCharacterLabel: "countCharacterLabel", countWordsLabel: "countWordsLabel", reportLabel: "reportLabel" }, outputs: { copyAction: "copyAction", reportAction: "reportAction", translateAction: "translateAction" }, ngImport: i0, template: "<div class=\"wac-content-with-buttons\">\r\n  <div class=\"wac-content-with-buttons__text\">\r\n    <div id=\"{{randomLabelName}}\">\r\n      <ng-content></ng-content>\r\n    </div>\r\n    <div class=\"wac-content-with-buttons__text__count\" *ngIf=\"count && countIsReady\">\r\n      <span>{{ countWords }} {{ countWordsLabel }} - {{ countCharacter }} {{ countCharacterLabel }}</span>\r\n      <span><wac-link [tooltipWidth]=\"600\" [tooltip]=\"tooltipLinkReport\" (click)=\"$event.preventDefault();\" (mousedown)=\"$event.preventDefault();eventReport();\" fontSize=\"12px\">{{ reportLabel }}</wac-link></span>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-content-with-buttons__cta\">\r\n    <div><wac-button extraClasses=\"is-blue opacity static-width\"  [iconFontSize]=\"18\" [icon]=\"iconCopy\" (click)=\"eventCopy()\" [tooltip]=\"tooltipCopy\" [tooltipPosition]=\"'top-center'\" [tooltipOneline]=\"true\"></wac-button></div>\r\n    <div><wac-button extraClasses=\"is-green opacity static-width\" [iconFontSize]=\"18\" [icon]=\"iconTranslate\" [tooltip]=\"tooltipTranslate\" [tooltipPosition]=\"'top-center'\" [tooltipOneline]=\"true\" (click)=\"eventTranslate()\"></wac-button></div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: ButtonComponent, selector: "wac-button", inputs: ["extraClasses", "label", "icon", "isLoadingSvg", "iconNext", "textcolor", "colorIcon", "widthAuto", "contentHorizontalPosition", "iconFontSize", "hasLoader", "disabled", "whiteSpaceNowrap", "opacity", "animation", "animationRight", "animationText", "confirmDelete", "confirmDeleteText", "coin", "tooltip", "tooltipWidth", "borderColor", "noPadding", "tooltipPosition", "tooltipOneline", "confirmDeletePosition", "isLoading"], outputs: ["click", "isLoadingChange"] }, { kind: "component", type: LinkComponent, selector: "wac-link", inputs: ["href", "tooltip", "tooltipWidth", "target", "id", "class", "fontSize"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ContentWithButtonsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-content-with-buttons', template: "<div class=\"wac-content-with-buttons\">\r\n  <div class=\"wac-content-with-buttons__text\">\r\n    <div id=\"{{randomLabelName}}\">\r\n      <ng-content></ng-content>\r\n    </div>\r\n    <div class=\"wac-content-with-buttons__text__count\" *ngIf=\"count && countIsReady\">\r\n      <span>{{ countWords }} {{ countWordsLabel }} - {{ countCharacter }} {{ countCharacterLabel }}</span>\r\n      <span><wac-link [tooltipWidth]=\"600\" [tooltip]=\"tooltipLinkReport\" (click)=\"$event.preventDefault();\" (mousedown)=\"$event.preventDefault();eventReport();\" fontSize=\"12px\">{{ reportLabel }}</wac-link></span>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-content-with-buttons__cta\">\r\n    <div><wac-button extraClasses=\"is-blue opacity static-width\"  [iconFontSize]=\"18\" [icon]=\"iconCopy\" (click)=\"eventCopy()\" [tooltip]=\"tooltipCopy\" [tooltipPosition]=\"'top-center'\" [tooltipOneline]=\"true\"></wac-button></div>\r\n    <div><wac-button extraClasses=\"is-green opacity static-width\" [iconFontSize]=\"18\" [icon]=\"iconTranslate\" [tooltip]=\"tooltipTranslate\" [tooltipPosition]=\"'top-center'\" [tooltipOneline]=\"true\" (click)=\"eventTranslate()\"></wac-button></div>\r\n  </div>\r\n</div>\r\n" }]
        }], propDecorators: { iconCopy: [{
                type: Input
            }], iconTranslate: [{
                type: Input
            }], tooltipCopy: [{
                type: Input
            }], tooltipTranslate: [{
                type: Input
            }], tooltipLinkReport: [{
                type: Input
            }], count: [{
                type: Input
            }], countCharacterLabel: [{
                type: Input
            }], countWordsLabel: [{
                type: Input
            }], reportLabel: [{
                type: Input
            }], copyAction: [{
                type: Output
            }], reportAction: [{
                type: Output
            }], translateAction: [{
                type: Output
            }] } });

class WrapperMultipleBlockComponent {
    constructor() { }
}
WrapperMultipleBlockComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WrapperMultipleBlockComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
WrapperMultipleBlockComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: WrapperMultipleBlockComponent, selector: "wac-wrapper-multiple-block", ngImport: i0, template: "<div class=\"wac-wrapper-multiple-block\">\r\n  <div class=\"wac-wrapper-multiple-block__sidebar\">\r\n    <ng-content select=\"[sidebar]\"></ng-content>\r\n  </div>\r\n  <div class=\"wac-wrapper-multiple-block__content\">\r\n    <ng-content select=\"[content]\"></ng-content>\r\n  </div>\r\n</div>\r\n" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WrapperMultipleBlockComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-wrapper-multiple-block', template: "<div class=\"wac-wrapper-multiple-block\">\r\n  <div class=\"wac-wrapper-multiple-block__sidebar\">\r\n    <ng-content select=\"[sidebar]\"></ng-content>\r\n  </div>\r\n  <div class=\"wac-wrapper-multiple-block__content\">\r\n    <ng-content select=\"[content]\"></ng-content>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; } });

class DraganddropListComponent {
    constructor() {
        this.label = '';
        this.disabled = false;
        this.backgroundColor = '#fff';
        this.showTriggerSave = false;
        this.itemsChange = new EventEmitter();
    }
    drop(event) {
        if (!this.disabled) {
            moveItemInArray(this.items, event.previousIndex, event.currentIndex);
            this.itemsChange.emit(Object.values(this.items));
        }
    }
    delete(index) {
        if (!this.disabled) {
            this.items = this.items.filter((value, i) => i !== index);
            this.itemsChange.emit(Object.values(this.items));
        }
    }
    saveFieldEnd(index, event) {
        this.items[index] = event.target.value;
        this.itemsChange.emit(Object.values(this.items));
    }
    addField() {
        this.showTriggerSave = true;
    }
    saveNewField(event) {
        this.items.push(event.target.value);
        this.itemsChange.emit(Object.values(this.items));
        this.showTriggerSave = false;
    }
}
DraganddropListComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DraganddropListComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DraganddropListComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: DraganddropListComponent, selector: "wac-draganddrop-list", inputs: { label: "label", items: "items", disabled: "disabled", max: "max", labelBtnAdd: "labelBtnAdd", backgroundColor: "backgroundColor" }, outputs: { itemsChange: "itemsChange" }, ngImport: i0, template: "<div class=\"wac-draganddrop-list\" *ngIf=\"!disabled\" [style.backgroundColor]=\"backgroundColor\">\r\n  <div class=\"wac-draganddrop-list__label\" *ngIf=\"label\"><span [innerHTML]=\"label\"></span></div>\r\n  <div class=\"wac-draganddrop-list__wrapper\" [cdkDropListLockAxis]=\"'y'\" cdkDropList (cdkDropListDropped)=\"drop($event)\">\r\n    <div class=\"wac-draganddrop-list__wrapper__item\" [style.backgroundColor]=\"backgroundColor\" *ngFor=\"let item of items;let i = index;\" cdkDrag>\r\n      <div>\r\n        <span class=\"wac-draganddrop-list__wrapper__item__icon\">\r\n          <span></span>\r\n        </span>\r\n        <span (mousedown)=\"$event.stopPropagation()\" class=\"wac-draganddrop-list__wrapper__item__input\">\r\n          <wac-input [value]=\"item\" [extraClasses]=\"'transparent'\" (keyup.enter)=\"saveFieldEnd(i, $event)\" (focusout)=\"saveFieldEnd(i, $event)\"></wac-input>\r\n        </span>\r\n      </div>\r\n      <div (mousedown)=\"$event.stopPropagation()\">\r\n        <div>\r\n          <wac-button [iconFontSize]=\"14\" [opacity]=\"true\" [icon]=\"'fa-regular fa-trash-can'\" [extraClasses]=\"'is-danger'\" (click)=\"delete(i)\"></wac-button>\r\n        </div>\r\n        <div *ngIf=\"i === (items.length - 1) && max > items.length && !showTriggerSave\">\r\n          <wac-button [extraClasses]=\"'is-info'\" [iconFontSize]=\"18\" [opacity]=\"true\" [icon]=\"'fa-regular fa-plus'\" (click)=\"addField()\"></wac-button>\r\n        </div>\r\n      </div>\r\n    </div>\r\n    <div class=\"wac-draganddrop-list__wrapper__item wac-draganddrop-list__wrapper__item--trigger\" *ngIf=\"showTriggerSave\">\r\n      <div>\r\n        <span class=\"wac-draganddrop-list__wrapper__item__icon\">\r\n          <span></span>\r\n        </span>\r\n        <span class=\"wac-draganddrop-list__wrapper__item__input\">\r\n          <wac-input [extraClasses]=\"'transparent'\" (keyup.enter)=\"saveNewField($event)\" (focusout)=\"saveNewField($event)\"></wac-input>\r\n        </span>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class=\"wac-draganddrop-list wac-draganddrop-list--disabled\" *ngIf=\"disabled\">\r\n  <div class=\"wac-draganddrop-list__label\" *ngIf=\"label\"><span [innerHTML]=\"label\"></span></div>\r\n  <div class=\"wac-draganddrop-list__wrapper\">\r\n    <div class=\"wac-draganddrop-list__wrapper__item\" *ngFor=\"let item of items;let i = index;\">\r\n      <div>\r\n        <span class=\"wac-draganddrop-list__wrapper__item__label\" [innerHTML]=\"item\"></span>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2$2.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { kind: "directive", type: i2$2.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { kind: "component", type: InputComponent, selector: "wac-input", inputs: ["label", "value", "type", "placeholder", "textInfo", "textError", "size", "isNumber", "withoutBlock", "icon", "big", "medium", "boldLabel", "min", "max", "disableMargin", "textPrepend", "textAppend", "progressBar", "extraClasses", "keyPreventDefault", "showTooltip", "textTooltip", "iconTooltip", "urlTooltip", "linkTooltip", "padding", "disabled", "indication", "success", "error", "maxlength", "minlength", "indicationLeft"], outputs: ["keypressEnter", "blurred"] }, { kind: "component", type: ButtonComponent, selector: "wac-button", inputs: ["extraClasses", "label", "icon", "isLoadingSvg", "iconNext", "textcolor", "colorIcon", "widthAuto", "contentHorizontalPosition", "iconFontSize", "hasLoader", "disabled", "whiteSpaceNowrap", "opacity", "animation", "animationRight", "animationText", "confirmDelete", "confirmDeleteText", "coin", "tooltip", "tooltipWidth", "borderColor", "noPadding", "tooltipPosition", "tooltipOneline", "confirmDeletePosition", "isLoading"], outputs: ["click", "isLoadingChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DraganddropListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-draganddrop-list', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"wac-draganddrop-list\" *ngIf=\"!disabled\" [style.backgroundColor]=\"backgroundColor\">\r\n  <div class=\"wac-draganddrop-list__label\" *ngIf=\"label\"><span [innerHTML]=\"label\"></span></div>\r\n  <div class=\"wac-draganddrop-list__wrapper\" [cdkDropListLockAxis]=\"'y'\" cdkDropList (cdkDropListDropped)=\"drop($event)\">\r\n    <div class=\"wac-draganddrop-list__wrapper__item\" [style.backgroundColor]=\"backgroundColor\" *ngFor=\"let item of items;let i = index;\" cdkDrag>\r\n      <div>\r\n        <span class=\"wac-draganddrop-list__wrapper__item__icon\">\r\n          <span></span>\r\n        </span>\r\n        <span (mousedown)=\"$event.stopPropagation()\" class=\"wac-draganddrop-list__wrapper__item__input\">\r\n          <wac-input [value]=\"item\" [extraClasses]=\"'transparent'\" (keyup.enter)=\"saveFieldEnd(i, $event)\" (focusout)=\"saveFieldEnd(i, $event)\"></wac-input>\r\n        </span>\r\n      </div>\r\n      <div (mousedown)=\"$event.stopPropagation()\">\r\n        <div>\r\n          <wac-button [iconFontSize]=\"14\" [opacity]=\"true\" [icon]=\"'fa-regular fa-trash-can'\" [extraClasses]=\"'is-danger'\" (click)=\"delete(i)\"></wac-button>\r\n        </div>\r\n        <div *ngIf=\"i === (items.length - 1) && max > items.length && !showTriggerSave\">\r\n          <wac-button [extraClasses]=\"'is-info'\" [iconFontSize]=\"18\" [opacity]=\"true\" [icon]=\"'fa-regular fa-plus'\" (click)=\"addField()\"></wac-button>\r\n        </div>\r\n      </div>\r\n    </div>\r\n    <div class=\"wac-draganddrop-list__wrapper__item wac-draganddrop-list__wrapper__item--trigger\" *ngIf=\"showTriggerSave\">\r\n      <div>\r\n        <span class=\"wac-draganddrop-list__wrapper__item__icon\">\r\n          <span></span>\r\n        </span>\r\n        <span class=\"wac-draganddrop-list__wrapper__item__input\">\r\n          <wac-input [extraClasses]=\"'transparent'\" (keyup.enter)=\"saveNewField($event)\" (focusout)=\"saveNewField($event)\"></wac-input>\r\n        </span>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<div class=\"wac-draganddrop-list wac-draganddrop-list--disabled\" *ngIf=\"disabled\">\r\n  <div class=\"wac-draganddrop-list__label\" *ngIf=\"label\"><span [innerHTML]=\"label\"></span></div>\r\n  <div class=\"wac-draganddrop-list__wrapper\">\r\n    <div class=\"wac-draganddrop-list__wrapper__item\" *ngFor=\"let item of items;let i = index;\">\r\n      <div>\r\n        <span class=\"wac-draganddrop-list__wrapper__item__label\" [innerHTML]=\"item\"></span>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], propDecorators: { label: [{
                type: Input
            }], items: [{
                type: Input
            }], disabled: [{
                type: Input
            }], max: [{
                type: Input
            }], labelBtnAdd: [{
                type: Input
            }], backgroundColor: [{
                type: Input
            }], itemsChange: [{
                type: Output
            }] } });

const ACCORDION_ITEM = new InjectionToken('ACCORDION_ITEM');

class AccordionComponent {
    constructor() {
        this.class = 'wac-accordion';
        this.keepOnlyOnePanelOpen = false;
        // Inputs: hideToggle (hide the arrow) // togglePosition
        this.isDestroyed$ = new Subject();
        this.resetListeners$ = new Subject();
    }
    openAll() {
        this.expansionItems?.forEach((item) => {
            item.isExpanded = true;
        });
    }
    closeAll() {
        this.expansionItems?.forEach((item) => {
            item.isExpanded = false;
        });
    }
    ngAfterViewInit() {
        this.expansionItems.changes
            .pipe(takeUntil$1(this.isDestroyed$), startWith(this.expansionItems))
            .subscribe(() => {
            this.resetListeners$.next();
            this.panelExpansionChanges().subscribe(expandedItem => {
                if (this.keepOnlyOnePanelOpen) {
                    this.keepOnlyOnePanelOpenHandler(expandedItem.index);
                }
            });
        });
    }
    panelExpansionChanges() {
        const panelExpansionChange$ = this.expansionItems.map((expansionItem, index) => {
            return expansionItem.expandChange.pipe(map$1(() => {
                return {
                    index,
                    expansionItem
                };
            }));
        });
        return merge(...panelExpansionChange$).pipe(takeUntil$1(this.resetListeners$));
    }
    keepOnlyOnePanelOpenHandler(index) {
        this.expansionItems.forEach((expansionItem, i) => {
            if (i !== index) {
                expansionItem.isExpanded = false;
            }
        });
    }
    ngOnDestroy() {
        this.isDestroyed$.next();
        this.isDestroyed$.complete();
        this.resetListeners$.next();
        this.resetListeners$.complete();
    }
}
AccordionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AccordionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
AccordionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: AccordionComponent, selector: "wac-accordion", inputs: { keepOnlyOnePanelOpen: "keepOnlyOnePanelOpen" }, host: { properties: { "class": "this.class" } }, queries: [{ propertyName: "expansionItems", predicate: ACCORDION_ITEM, descendants: true }], ngImport: i0, template: "<ng-content></ng-content>" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AccordionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-accordion', template: "<ng-content></ng-content>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { class: [{
                type: HostBinding,
                args: ['class']
            }], expansionItems: [{
                type: ContentChildren,
                args: [ACCORDION_ITEM, { descendants: true }]
            }], keepOnlyOnePanelOpen: [{
                type: Input
            }] } });

const EXPANSION_PANEL_HEADER = new InjectionToken('EXPANSION_PANEL_HEADER');

class ExpansionPanelHeaderDirective {
    onClick() {
        this.toggle();
    }
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.disabled = false;
        this.disabledChange = new EventEmitter();
        this.hideToggle = false;
        this.hideToggleChange = new EventEmitter();
        this.isExpanded = false;
        this.isExpandedChange = new EventEmitter();
    }
    onToggle() {
        if (this.disabled) {
            return;
        }
        this.isExpanded = !this.isExpanded;
        this.toggle();
    }
}
ExpansionPanelHeaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionPanelHeaderDirective, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive });
ExpansionPanelHeaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: ExpansionPanelHeaderDirective, selector: "[wacExpansionPanelHeader]", inputs: { disabled: "disabled", hideToggle: "hideToggle", isExpanded: "isExpanded" }, outputs: { disabledChange: "disabledChange", hideToggleChange: "hideToggleChange", isExpandedChange: "isExpandedChange" }, host: { listeners: { "click": "onClick()" } }, providers: [{ provide: EXPANSION_PANEL_HEADER, useExisting: ExpansionPanelHeaderDirective }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionPanelHeaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacExpansionPanelHeader]',
                    providers: [{ provide: EXPANSION_PANEL_HEADER, useExisting: ExpansionPanelHeaderDirective }],
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { onClick: [{
                type: HostListener,
                args: ['click']
            }], disabled: [{
                type: Input
            }], disabledChange: [{
                type: Output
            }], hideToggle: [{
                type: Input
            }], hideToggleChange: [{
                type: Output
            }], isExpanded: [{
                type: Input
            }], isExpandedChange: [{
                type: Output
            }] } });

class ExpansionPanelHeaderComponent extends ExpansionPanelHeaderDirective {
    get isDisabled() {
        return this.disabled;
    }
    constructor(changeDetectorRef) {
        super(changeDetectorRef);
        this.changeDetectorRef = changeDetectorRef;
        this.class = 'wac-expansion-panel-header';
    }
}
ExpansionPanelHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionPanelHeaderComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
ExpansionPanelHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ExpansionPanelHeaderComponent, selector: "wac-expansion-panel-header", host: { properties: { "class": "this.class", "class.wac-expansion-panel-header--disabled": "this.isDisabled" } }, providers: [{ provide: EXPANSION_PANEL_HEADER, useExisting: ExpansionPanelHeaderComponent }], usesInheritance: true, ngImport: i0, template: "<ng-content></ng-content>\r\n<i class=\"wac-expansion-panel-header__icon\" [class]=\"isExpanded ? 'fas fa-angle-down' : 'fas fa-angle-up'\"></i>", encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionPanelHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-expansion-panel-header', encapsulation: ViewEncapsulation.None, providers: [{ provide: EXPANSION_PANEL_HEADER, useExisting: ExpansionPanelHeaderComponent }], template: "<ng-content></ng-content>\r\n<i class=\"wac-expansion-panel-header__icon\" [class]=\"isExpanded ? 'fas fa-angle-down' : 'fas fa-angle-up'\"></i>" }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { class: [{
                type: HostBinding,
                args: ['class']
            }], isDisabled: [{
                type: HostBinding,
                args: ['class.wac-expansion-panel-header--disabled']
            }] } });

class ExpansionPanelDirective {
    set disabled(disabled) {
        this._disabled = disabled;
        if (this.header) {
            this.header.disabled = disabled;
        }
    }
    get disabled() {
        return this._disabled;
    }
    set hideToggle(hideToggle) {
        this._hideToggle = hideToggle;
        if (this.header) {
            this.header.hideToggle = hideToggle;
        }
    }
    get hideToggle() {
        return this._hideToggle;
    }
    set isExpanded(isExpanded) {
        if (this.disabled) {
            return;
        }
        this._isExpanded = isExpanded;
        if (this.header) {
            this.header.isExpanded = isExpanded;
        }
        this.isExpandedChange.emit(isExpanded);
    }
    get isExpanded() {
        return this._isExpanded;
    }
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this._disabled = false;
        this._hideToggle = false;
        this._isExpanded = false;
        this.isExpandedChange = new EventEmitter();
        this.expandChange = new EventEmitter(); // used by the accordion component if exists
    }
    ngAfterViewInit() {
        setTimeout(() => {
            this.header.isExpanded = this.isExpanded;
            this.header.hideToggle = this.hideToggle;
            this.header.disabled = this.disabled;
            this.header.close = () => this.close();
            this.header.open = () => this.open();
            this.header.toggle = () => this.toggle();
        }, 0);
    }
    close() {
        this.isExpanded = false;
        this.expandChange.emit();
    }
    open() {
        this.isExpanded = true;
        this.expandChange.emit();
    }
    toggle() {
        this.isExpanded = !this.isExpanded;
        this.expandChange.emit();
    }
}
ExpansionPanelDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionPanelDirective, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive });
ExpansionPanelDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: ExpansionPanelDirective, selector: "[wacExpansionPanel]", inputs: { disabled: "disabled", hideToggle: "hideToggle", isExpanded: "isExpanded" }, outputs: { isExpandedChange: "isExpandedChange" }, providers: [{ provide: ACCORDION_ITEM, useExisting: ExpansionPanelDirective }], queries: [{ propertyName: "header", first: true, predicate: EXPANSION_PANEL_HEADER, descendants: true }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionPanelDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacExpansionPanel]',
                    providers: [{ provide: ACCORDION_ITEM, useExisting: ExpansionPanelDirective }]
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { header: [{
                type: ContentChild,
                args: [EXPANSION_PANEL_HEADER]
            }], disabled: [{
                type: Input
            }], hideToggle: [{
                type: Input
            }], isExpanded: [{
                type: Input
            }], isExpandedChange: [{
                type: Output
            }] } });

// https://material.angular.io/components/expansion/api
class ExpansionPanelComponent extends ExpansionPanelDirective {
    get isDisabled() {
        return this.disabled;
    }
    constructor(changeDetectorRef) {
        super(changeDetectorRef);
        this.changeDetectorRef = changeDetectorRef;
        this.class = 'wac-expansion-panel';
    }
}
ExpansionPanelComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionPanelComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
ExpansionPanelComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ExpansionPanelComponent, selector: "wac-expansion-panel", host: { properties: { "class": "this.class", "class.wac-expansion-panel--disabled": "this.isDisabled" } }, providers: [{ provide: ACCORDION_ITEM, useExisting: ExpansionPanelComponent }], usesInheritance: true, ngImport: i0, template: "<ng-content select=\"wac-expansion-panel-header, wacExpansionPanelHeader\"></ng-content>\r\n<div *ngIf=\"isExpanded\">\r\n    <ng-content></ng-content>\r\n</div>", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionPanelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-expansion-panel', providers: [{ provide: ACCORDION_ITEM, useExisting: ExpansionPanelComponent }], template: "<ng-content select=\"wac-expansion-panel-header, wacExpansionPanelHeader\"></ng-content>\r\n<div *ngIf=\"isExpanded\">\r\n    <ng-content></ng-content>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { class: [{
                type: HostBinding,
                args: ['class']
            }], isDisabled: [{
                type: HostBinding,
                args: ['class.wac-expansion-panel--disabled']
            }] } });

const components$1 = [
    ExpansionPanelComponent,
    ExpansionPanelHeaderComponent,
    AccordionComponent
];
const directives = [
    ExpansionPanelDirective,
    ExpansionPanelHeaderDirective
];
const ExpansionExport = [
    ...components$1,
    ...directives
];
class ExpansionModule {
}
ExpansionModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ExpansionModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: ExpansionModule, declarations: [ExpansionPanelComponent,
        ExpansionPanelHeaderComponent,
        AccordionComponent, ExpansionPanelDirective,
        ExpansionPanelHeaderDirective], imports: [CommonModule], exports: [ExpansionPanelComponent,
        ExpansionPanelHeaderComponent,
        AccordionComponent, ExpansionPanelDirective,
        ExpansionPanelHeaderDirective] });
ExpansionModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpansionModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                    ],
                    exports: [
                        ...ExpansionExport
                    ],
                    declarations: [
                        ...ExpansionExport
                    ],
                    providers: [],
                }]
        }] });

class BlockTitleLegacyComponent {
    constructor() {
        this.simple = false;
        this.icon = '';
    }
}
BlockTitleLegacyComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BlockTitleLegacyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BlockTitleLegacyComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: BlockTitleLegacyComponent, isStandalone: true, selector: "wac-block-title-legacy", inputs: { simple: "simple", icon: "icon" }, ngImport: i0, template: "<h2 class=\"wac-block__title\" [ngClass]=\"{ 'is-simple': simple }\">\r\n    <ng-content></ng-content> <i *ngIf=\"icon\" [ngClass]=\"icon\"></i>\r\n</h2>", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BlockTitleLegacyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-block-title-legacy', encapsulation: ViewEncapsulation.None, standalone: true, imports: [CommonModule], template: "<h2 class=\"wac-block__title\" [ngClass]=\"{ 'is-simple': simple }\">\r\n    <ng-content></ng-content> <i *ngIf=\"icon\" [ngClass]=\"icon\"></i>\r\n</h2>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { simple: [{
                type: Input
            }], icon: [{
                type: Input
            }] } });

;
class SummaryComponent {
    set activeItem(activeItem) {
        this._activeItem = activeItem;
    }
    get activeItem() {
        return this._activeItem;
    }
    constructor() {
        this._activeItem = 0;
        this.itemChanged = new EventEmitter();
    }
    scrollToItem(i) {
        this._activeItem = i;
        this.itemChanged.emit(i);
        if (this.items[i].href) {
            const yOffset = -20;
            const element = window.document.getElementById(this.items[i].href);
            if (element) {
                const y = element.getBoundingClientRect().top + window.pageYOffset + yOffset;
                window.scrollTo({ top: y, behavior: 'smooth' });
            }
        }
    }
}
SummaryComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SummaryComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SummaryComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SummaryComponent, selector: "wac-summary", inputs: { activeItem: "activeItem", items: "items" }, outputs: { itemChanged: "itemChanged" }, ngImport: i0, template: "<div class=\"wac-summary\">\r\n    <ng-container *ngFor=\"let item of items; let i = index\">\r\n      <p [ngClass]=\"{'active' : activeItem === i, 'item-link': item.href}\" (click)=\"scrollToItem(i)\">{{ item.label }}</p>\r\n    </ng-container>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SummaryComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-summary', encapsulation: ViewEncapsulation.None, template: "<div class=\"wac-summary\">\r\n    <ng-container *ngFor=\"let item of items; let i = index\">\r\n      <p [ngClass]=\"{'active' : activeItem === i, 'item-link': item.href}\" (click)=\"scrollToItem(i)\">{{ item.label }}</p>\r\n    </ng-container>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { activeItem: [{
                type: Input
            }], items: [{
                type: Input
            }], itemChanged: [{
                type: Output
            }] } });

class GooglePreviewComponent {
    constructor() { }
    ngOnInit() {
    }
}
GooglePreviewComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: GooglePreviewComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
GooglePreviewComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: GooglePreviewComponent, selector: "wac-google-preview", inputs: { title: "title", url: "url", description: "description" }, ngImport: i0, template: "<div class=\"wac-google-preview\">\r\n  <div class=\"wac-google-preview__url\" [innerHTML]=\"url\"></div>\r\n  <div class=\"wac-google-preview__title\" [innerHTML]=\"title\"></div>\r\n  <div class=\"wac-google-preview__description\" [innerHTML]=\"description\"></div>\r\n</div>\r\n" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: GooglePreviewComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-google-preview', template: "<div class=\"wac-google-preview\">\r\n  <div class=\"wac-google-preview__url\" [innerHTML]=\"url\"></div>\r\n  <div class=\"wac-google-preview__title\" [innerHTML]=\"title\"></div>\r\n  <div class=\"wac-google-preview__description\" [innerHTML]=\"description\"></div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { title: [{
                type: Input
            }], url: [{
                type: Input
            }], description: [{
                type: Input
            }] } });

class ChargingBarComponent {
    constructor() {
        this.value = 0;
    }
    ngOnInit() {
    }
}
ChargingBarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ChargingBarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ChargingBarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ChargingBarComponent, selector: "wac-charging-bar", inputs: { value: "value" }, ngImport: i0, template: "<div class=\"wac-charging-bar\">\r\n  <div class=\"wac-charging-bar__wrapLine\">\r\n    <div class=\"wac-charging-bar__wrapLine__line\">\r\n      <div class=\"wac-charging-bar__wrapLine__line__width\" [ngClass]=\"{'complete': value === 100}\" [ngStyle]=\"{'max-width': value + '%'}\"></div>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-charging-bar__number\" [innerHTML]=\"value + '%'\"></div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ChargingBarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-charging-bar', template: "<div class=\"wac-charging-bar\">\r\n  <div class=\"wac-charging-bar__wrapLine\">\r\n    <div class=\"wac-charging-bar__wrapLine__line\">\r\n      <div class=\"wac-charging-bar__wrapLine__line__width\" [ngClass]=\"{'complete': value === 100}\" [ngStyle]=\"{'max-width': value + '%'}\"></div>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-charging-bar__number\" [innerHTML]=\"value + '%'\"></div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { value: [{
                type: Input
            }] } });

class ExpandedPanelComponent {
    constructor() {
        this.section = false;
        this.open = false;
    }
    ngOnInit() {
    }
}
ExpandedPanelComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpandedPanelComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ExpandedPanelComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ExpandedPanelComponent, selector: "wac-expanded-panel", inputs: { label: "label", section: "section", open: "open" }, ngImport: i0, template: "<div class=\"wac-expanded-panel\">\r\n  <div class=\"wac-expanded-panel__top\" (click)=\"open = !open\">\r\n    <div class=\"wac-expanded-panel__top__label\" [ngClass]=\"{'big': section}\" [innerHTML]=\"label\"></div>\r\n    <div class=\"wac-expanded-panel__top__icon\" [ngClass]=\"{'is-open': open, 'big': section}\">\r\n      <i class=\"fa-regular fa-angle-down\"></i>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-expanded-panel__bottom\" [ngClass]=\"{'is-open': open}\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ExpandedPanelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-expanded-panel', template: "<div class=\"wac-expanded-panel\">\r\n  <div class=\"wac-expanded-panel__top\" (click)=\"open = !open\">\r\n    <div class=\"wac-expanded-panel__top__label\" [ngClass]=\"{'big': section}\" [innerHTML]=\"label\"></div>\r\n    <div class=\"wac-expanded-panel__top__icon\" [ngClass]=\"{'is-open': open, 'big': section}\">\r\n      <i class=\"fa-regular fa-angle-down\"></i>\r\n    </div>\r\n  </div>\r\n  <div class=\"wac-expanded-panel__bottom\" [ngClass]=\"{'is-open': open}\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { label: [{
                type: Input
            }], section: [{
                type: Input
            }], open: [{
                type: Input
            }] } });

class RowComponent {
    constructor() {
        this.id = '';
        this.childs = 0;
        this.classWidth = '';
        this.responsiveClass = '';
        this.responsiveAuto = false;
        this.childrensWidthAuto = false;
        this.marginChild = '';
        this.marginBottom = '';
        this.marginBottomChild = '';
        this.addWacBlock = false;
        this.lineDisplayContent = false;
        this.border = false;
        this.multipleLine = false;
        this.childrenByLine = 0;
        this.padding = '';
        this.gap = '';
        this.lastChildIsDown = false;
        this.addClass = '';
        this.halfMarginChild = '';
        this.nbChildsClass = '';
    }
    ngOnInit() {
        this.id = 'row-' + Math.floor(Math.random() * 100000);
        if (this.marginChild) {
            this.halfMarginChild = parseInt(this.marginChild) / 2 + 'px';
        }
    }
    responsiveControl(size) {
        if (size > 1024) {
            this.classWidth = '';
        }
        else if (size <= 480) {
            this.classWidth = 'low';
        }
        else {
            this.classWidth = 'medium';
        }
    }
    handleResponsiveAuto(size) {
        if (size < 500) {
            this.responsiveClass = 'mobile';
        }
        else {
            this.responsiveClass = '';
        }
    }
    onResize() {
        const size = this.container.nativeElement.offsetWidth;
        this.responsiveControl(size);
        if (this.responsiveAuto) {
            this.handleResponsiveAuto(size);
        }
    }
    actionsDom() {
        this.childs = this.container.nativeElement.childElementCount;
        if (this.width) {
            document.getElementById(this.id).parentElement.style.maxWidth = this.width;
        }
        if (this.height) {
            document.getElementById(this.id).parentElement.style.maxHeight = this.height;
        }
        if ((this.childs > 1 && this.marginChild) || this.multipleLine) {
            for (let i = 0; i < this.childs; i++) {
                const child = document.getElementById(this.id).children[i];
                child.style.marginLeft = this.halfMarginChild;
                child.style.marginRight = this.halfMarginChild;
                if (this.multipleLine) {
                    child.style.width = 'calc(' + (100 / this.childrenByLine) + '% - ' + this.marginChild + ')';
                }
            }
        }
        if (this.childs > 1 && this.marginBottomChild) {
            for (let i = 0; i < this.childs; i++) {
                const child = document.getElementById(this.id).children[i];
                child.style.marginBottom = this.marginBottomChild;
            }
        }
        this.nbChildsClass = 'nb-child-' + this.childs;
        this.onResize();
    }
    ngAfterContentInit() {
        setTimeout(() => {
            this.actionsDom();
        }, 1);
    }
    handleDomChange(event) {
        this.actionsDom();
    }
}
RowComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RowComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
RowComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: RowComponent, selector: "wac-row", inputs: { colPosition: "colPosition", rowPosition: "rowPosition", position: "position", width: "width", height: "height", responsiveAuto: "responsiveAuto", childrensWidthAuto: "childrensWidthAuto", visibility: "visibility", marginChild: "marginChild", marginBottom: "marginBottom", marginBottomChild: "marginBottomChild", addWacBlock: "addWacBlock", lineDisplayContent: "lineDisplayContent", border: "border", multipleLine: "multipleLine", childrenByLine: "childrenByLine", padding: "padding", gap: "gap", lastChildIsDown: "lastChildIsDown", addClass: "addClass" }, host: { listeners: { "window:resize": "onResize($event)" } }, viewQueries: [{ propertyName: "container", first: true, predicate: ["container"], descendants: true }], ngImport: i0, template: "<div [style.gridColumn]=\"colPosition\" [style.gridRow]=\"rowPosition\" watchDomTree (dom-changed)=\"handleDomChange($event)\" [ngStyle]=\"{'padding': padding,'margin-bottom': marginBottom,'transform': (childs > 1 || multipleLine ? 'translateX(-' + halfMarginChild + ')' : 'wrong'), 'width': ((childs > 1 && !addWacBlock) || multipleLine ? 'calc(100% + ' + marginChild  + ')' : 'wrong')}\" class=\"wac-row {{ addWacBlock ? 'white-block' : '' }} {{ multipleLine ? 'multiple-line' : '' }} {{ lineDisplayContent ? 'direction-column' : '' }} {{ border ? 'with-border' : '' }} {{ lastChildIsDown ? 'last-child-down' : '' }} {{ childrensWidthAuto ? 'childrens-width-auto' : '' }} {{ position ? position : '' }} {{ visibility ? visibility : '' }} {{ responsiveClass ? responsiveClass : '' }} {{addClass}} {{nbChildsClass}} {{classWidth}}\" #container [ngClass]=\"{\r\n  'multiple-child': childs > 3,\r\n  'five-or-more-child': childs > 4,\r\n  'alone': childs === 1\r\n}\" [id]=\"id\">\r\n  <ng-content></ng-content>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: DomChangedDirective, selector: "[watchDomTree]" }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RowComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-row', encapsulation: ViewEncapsulation.None, template: "<div [style.gridColumn]=\"colPosition\" [style.gridRow]=\"rowPosition\" watchDomTree (dom-changed)=\"handleDomChange($event)\" [ngStyle]=\"{'padding': padding,'margin-bottom': marginBottom,'transform': (childs > 1 || multipleLine ? 'translateX(-' + halfMarginChild + ')' : 'wrong'), 'width': ((childs > 1 && !addWacBlock) || multipleLine ? 'calc(100% + ' + marginChild  + ')' : 'wrong')}\" class=\"wac-row {{ addWacBlock ? 'white-block' : '' }} {{ multipleLine ? 'multiple-line' : '' }} {{ lineDisplayContent ? 'direction-column' : '' }} {{ border ? 'with-border' : '' }} {{ lastChildIsDown ? 'last-child-down' : '' }} {{ childrensWidthAuto ? 'childrens-width-auto' : '' }} {{ position ? position : '' }} {{ visibility ? visibility : '' }} {{ responsiveClass ? responsiveClass : '' }} {{addClass}} {{nbChildsClass}} {{classWidth}}\" #container [ngClass]=\"{\r\n  'multiple-child': childs > 3,\r\n  'five-or-more-child': childs > 4,\r\n  'alone': childs === 1\r\n}\" [id]=\"id\">\r\n  <ng-content></ng-content>\r\n</div>\r\n" }]
        }], propDecorators: { colPosition: [{
                type: Input
            }], rowPosition: [{
                type: Input
            }], position: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], responsiveAuto: [{
                type: Input
            }], childrensWidthAuto: [{
                type: Input
            }], visibility: [{
                type: Input
            }], marginChild: [{
                type: Input
            }], marginBottom: [{
                type: Input
            }], marginBottomChild: [{
                type: Input
            }], addWacBlock: [{
                type: Input
            }], lineDisplayContent: [{
                type: Input
            }], border: [{
                type: Input
            }], multipleLine: [{
                type: Input
            }], childrenByLine: [{
                type: Input
            }], padding: [{
                type: Input
            }], gap: [{
                type: Input
            }], lastChildIsDown: [{
                type: Input
            }], addClass: [{
                type: Input
            }], container: [{
                type: ViewChild,
                args: [`container`]
            }], onResize: [{
                type: HostListener,
                args: ['window:resize', ['$event']]
            }] } });

class ColumnComponent {
}
ColumnComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ColumnComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ColumnComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ColumnComponent, selector: "wac-column", ngImport: i0, template: "<p>column works!</p>\r\n" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ColumnComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-column', template: "<p>column works!</p>\r\n" }]
        }] });

class AiExpressComponent {
    constructor() {
        this.top = '28px';
        this.right = '1px';
        this.loading = false;
        this.disabled = false;
        this.tokenCost = 0;
        this.tokenLeft = 0;
        this.tokenCount = 0;
        this.isRegister = false;
        this.validAction = new EventEmitter();
        this.isOpen = false;
        this.hrefRegister = '/v3/ai/select-plan';
    }
    ngOnInit() { }
    showPopup() {
        if (!this.isOpen && (!this.disabled || (this.disabled && this.wordingDisabled))) {
            this.isOpen = true;
        }
    }
    validate() {
        if (!this.disabled) {
            if (!this.isRegister) {
                if (!this.isOpen) {
                    this.isOpen = true;
                }
                else {
                    this.isOpen = false;
                }
            }
            else {
                if (!this.loading) {
                    this.validAction.emit(true);
                }
            }
        }
    }
    hidePopup() {
        if (this.isOpen && (!this.disabled || (this.disabled && this.wordingDisabled))) {
            this.isOpen = false;
        }
    }
}
AiExpressComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AiExpressComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
AiExpressComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: AiExpressComponent, selector: "wac-ai-express", inputs: { top: "top", right: "right", loading: "loading", disabled: "disabled", wordingTop: "wordingTop", wordingToken: "wordingToken", wordingTokenLeft: "wordingTokenLeft", wordingRegisterTop: "wordingRegisterTop", wordingRegisterBtn: "wordingRegisterBtn", wordingDisabled: "wordingDisabled", tokenCost: "tokenCost", tokenLeft: "tokenLeft", tokenCount: "tokenCount", isRegister: "isRegister" }, outputs: { validAction: "validAction" }, ngImport: i0, template: "<div class=\"wac-ai-express\">\r\n  <ng-content></ng-content>\r\n  <div [style.top]=\"top\" [style.right]=\"right\" class=\"wac-ai-express__icon\" [ngClass]=\"{'disabled': disabled, 'loading': loading}\" (click)=\"validate();\">\r\n    <i class=\"fa-regular fa-wand-magic-sparkles\" *ngIf=\"!loading\"></i>\r\n    <svg *ngIf=\"loading\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" style=\"margin:auto;background:transparent;display:block;\" width=\"200px\" height=\"200px\" viewBox=\"0 0 100 100\" preserveAspectRatio=\"xMidYMid\">\r\n      <g transform=\"rotate(0 50 50)\">\r\n        <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n          <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.9166666666666666s\" repeatCount=\"indefinite\"></animate>\r\n        </rect>\r\n      </g><g transform=\"rotate(30 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.8333333333333334s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(60 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.75s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(90 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.6666666666666666s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(120 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.5833333333333334s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(150 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.5s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(180 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.4166666666666667s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(210 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.3333333333333333s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(240 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.25s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(270 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.16666666666666666s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(300 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.08333333333333333s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(330 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"0s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g>\r\n    </svg>\r\n  </div>\r\n  <div *ngIf=\"isRegister && !disabled\" class=\"wac-ai-express__wrapper\" [ngClass]=\"{'height-auto': (!tokenCost || tokenCost === 0)}\">\r\n    <div>\r\n      <span [innerHTML]=\"wordingTop\"></span>\r\n    </div>\r\n    <div [ngClass]=\"{'hide': (!tokenCost || tokenCost === 0)}\">\r\n      <div>\r\n        <div>\r\n          <i class=\"fa-solid fa-coin-front\"></i>\r\n          <span [innerHTML]=\"tokenCost\"></span>\r\n        </div>\r\n        <span [innerHTML]=\"wordingToken\"></span>\r\n      </div>\r\n      <div>\r\n        <div>\r\n          <strong [innerHTML]=\"tokenLeft\"></strong> / <span [innerHTML]=\"tokenCount\"></span>\r\n        </div>\r\n        <div>\r\n          <span [innerHTML]=\"wordingTokenLeft\"></span>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div  *ngIf=\"!isRegister && !disabled\" class=\"wac-ai-express__register\">\r\n    <p [innerHTML]=\"wordingRegisterTop\"></p>\r\n    <a [target]=\"'_blank'\" [href]=\"hrefRegister\"><i class=\"fa-regular fa-wand-magic-sparkles\"></i> <span [innerHTML]=\"wordingRegisterBtn\"></span></a>\r\n  </div>\r\n  <div *ngIf=\"disabled && wordingDisabled\" class=\"wac-ai-express__disabled\">\r\n    <p [innerHTML]=\"wordingDisabled\"></p>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: AiExpressComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-ai-express', template: "<div class=\"wac-ai-express\">\r\n  <ng-content></ng-content>\r\n  <div [style.top]=\"top\" [style.right]=\"right\" class=\"wac-ai-express__icon\" [ngClass]=\"{'disabled': disabled, 'loading': loading}\" (click)=\"validate();\">\r\n    <i class=\"fa-regular fa-wand-magic-sparkles\" *ngIf=\"!loading\"></i>\r\n    <svg *ngIf=\"loading\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" style=\"margin:auto;background:transparent;display:block;\" width=\"200px\" height=\"200px\" viewBox=\"0 0 100 100\" preserveAspectRatio=\"xMidYMid\">\r\n      <g transform=\"rotate(0 50 50)\">\r\n        <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n          <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.9166666666666666s\" repeatCount=\"indefinite\"></animate>\r\n        </rect>\r\n      </g><g transform=\"rotate(30 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.8333333333333334s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(60 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.75s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(90 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.6666666666666666s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(120 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.5833333333333334s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(150 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.5s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(180 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.4166666666666667s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(210 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.3333333333333333s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(240 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.25s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(270 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.16666666666666666s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(300 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"-0.08333333333333333s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g><g transform=\"rotate(330 50 50)\">\r\n      <rect x=\"47\" y=\"24\" rx=\"3\" ry=\"6\" width=\"6\" height=\"12\" fill=\"#59d0cf\">\r\n        <animate attributeName=\"opacity\" values=\"1;0\" keyTimes=\"0;1\" dur=\"1s\" begin=\"0s\" repeatCount=\"indefinite\"></animate>\r\n      </rect>\r\n    </g>\r\n    </svg>\r\n  </div>\r\n  <div *ngIf=\"isRegister && !disabled\" class=\"wac-ai-express__wrapper\" [ngClass]=\"{'height-auto': (!tokenCost || tokenCost === 0)}\">\r\n    <div>\r\n      <span [innerHTML]=\"wordingTop\"></span>\r\n    </div>\r\n    <div [ngClass]=\"{'hide': (!tokenCost || tokenCost === 0)}\">\r\n      <div>\r\n        <div>\r\n          <i class=\"fa-solid fa-coin-front\"></i>\r\n          <span [innerHTML]=\"tokenCost\"></span>\r\n        </div>\r\n        <span [innerHTML]=\"wordingToken\"></span>\r\n      </div>\r\n      <div>\r\n        <div>\r\n          <strong [innerHTML]=\"tokenLeft\"></strong> / <span [innerHTML]=\"tokenCount\"></span>\r\n        </div>\r\n        <div>\r\n          <span [innerHTML]=\"wordingTokenLeft\"></span>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div  *ngIf=\"!isRegister && !disabled\" class=\"wac-ai-express__register\">\r\n    <p [innerHTML]=\"wordingRegisterTop\"></p>\r\n    <a [target]=\"'_blank'\" [href]=\"hrefRegister\"><i class=\"fa-regular fa-wand-magic-sparkles\"></i> <span [innerHTML]=\"wordingRegisterBtn\"></span></a>\r\n  </div>\r\n  <div *ngIf=\"disabled && wordingDisabled\" class=\"wac-ai-express__disabled\">\r\n    <p [innerHTML]=\"wordingDisabled\"></p>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { top: [{
                type: Input
            }], right: [{
                type: Input
            }], loading: [{
                type: Input
            }], disabled: [{
                type: Input
            }], wordingTop: [{
                type: Input
            }], wordingToken: [{
                type: Input
            }], wordingTokenLeft: [{
                type: Input
            }], wordingRegisterTop: [{
                type: Input
            }], wordingRegisterBtn: [{
                type: Input
            }], wordingDisabled: [{
                type: Input
            }], tokenCost: [{
                type: Input
            }], tokenLeft: [{
                type: Input
            }], tokenCount: [{
                type: Input
            }], isRegister: [{
                type: Input
            }], validAction: [{
                type: Output
            }] } });

class RadioGroupDirective extends SelectDirective {
    get multiple() {
        return false;
    }
    set multiple(value) {
        throw new Error('RadioGroupDirective does not support multiple selection');
    }
    get searchByTyping() {
        return false;
    }
    set searchByTyping(value) {
        throw new Error('RadioGroupDirective does not support search by typing');
    }
    constructor(valueChangeService) {
        super(valueChangeService);
        this.valueChangeService = valueChangeService;
    }
}
RadioGroupDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioGroupDirective, deps: [{ token: ValueChangeService }], target: i0.ɵɵFactoryTarget.Directive });
RadioGroupDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: RadioGroupDirective, selector: "[wacRadioGroup]", providers: [
        { provide: NG_VALUE_ACCESSOR, useExisting: RadioGroupDirective, multi: true },
        ValueChangeService
    ], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioGroupDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[wacRadioGroup]',
                    providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: RadioGroupDirective, multi: true },
                        ValueChangeService
                    ],
                }]
        }], ctorParameters: function () { return [{ type: ValueChangeService }]; } });

class RadioComponent extends RadioGroupDirective {
    constructor(valueChangeService) {
        super(valueChangeService);
        this.valueChangeService = valueChangeService;
    }
}
RadioComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioComponent, deps: [{ token: ValueChangeService }], target: i0.ɵɵFactoryTarget.Component });
RadioComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: RadioComponent, selector: "wac-radio", providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: RadioComponent,
            multi: true
        },
        ValueChangeService
    ], queries: [{ propertyName: "label", first: true, predicate: LabelComponent, descendants: true }], usesInheritance: true, ngImport: i0, template: "<div class=\"wac-radio\">\r\n  <ng-container *ngIf=\"!!label\" class=\"wac-select__label\">\r\n    <ng-content select=\"wac-label, .wac-label\" ></ng-content>\r\n  </ng-container>\r\n  <div class=\"wac-radio__row\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-radio', providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: RadioComponent,
                            multi: true
                        },
                        ValueChangeService
                    ], encapsulation: ViewEncapsulation.None, template: "<div class=\"wac-radio\">\r\n  <ng-container *ngIf=\"!!label\" class=\"wac-select__label\">\r\n    <ng-content select=\"wac-label, .wac-label\" ></ng-content>\r\n  </ng-container>\r\n  <div class=\"wac-radio__row\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return [{ type: ValueChangeService }]; }, propDecorators: { label: [{
                type: ContentChild,
                args: [LabelComponent]
            }] } });

class RadioOptionComponent extends OptionComponent {
    constructor(contentRef, changeDetectorRef) {
        super(contentRef, changeDetectorRef);
        this.contentRef = contentRef;
        this.changeDetectorRef = changeDetectorRef;
        this.optionId = `wac-radio-option-${uuid()}`;
    }
    getContentRef() {
        return this.contentOption;
    }
}
RadioOptionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioOptionComponent, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
RadioOptionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: RadioOptionComponent, selector: "wac-radio-option", providers: [{ provide: OPTION_SELECTION_HANDLER, useExisting: RadioOptionComponent }], viewQueries: [{ propertyName: "contentOption", first: true, predicate: ["contentWrapper"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<div\r\n    [ngClass]=\"{ 'disabled': disabled }\"\r\n    class=\"wac-radio-option\"\r\n  >\r\n    <div [ngClass]=\"{ 'selected': selected, 'disabled': disabled }\" #contentWrapper>\r\n      <input type=\"checkbox\" [id]=\"optionId\" [checked]=\"selected\" />\r\n      <label [for]=\"optionId\">\r\n        <ng-content></ng-content>\r\n      </label>\r\n    </div>\r\n</div>", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: RadioOptionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-radio-option', encapsulation: ViewEncapsulation.None, providers: [{ provide: OPTION_SELECTION_HANDLER, useExisting: RadioOptionComponent }], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\r\n    [ngClass]=\"{ 'disabled': disabled }\"\r\n    class=\"wac-radio-option\"\r\n  >\r\n    <div [ngClass]=\"{ 'selected': selected, 'disabled': disabled }\" #contentWrapper>\r\n      <input type=\"checkbox\" [id]=\"optionId\" [checked]=\"selected\" />\r\n      <label [for]=\"optionId\">\r\n        <ng-content></ng-content>\r\n      </label>\r\n    </div>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { contentOption: [{
                type: ViewChild,
                args: ['contentWrapper']
            }] } });

class TagDropdownComponent {
    constructor() {
        this.hasIcons = false;
        this.items = [];
        this.label = '';
        this.class = 'default';
        this.icon = '';
        this.iconFontSize = 12;
        this.isDropdown = true;
        this.userInput = new EventEmitter();
    }
    onUserInput(itemIndex) {
        this.userInput.emit(itemIndex);
    }
}
TagDropdownComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TagDropdownComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TagDropdownComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: TagDropdownComponent, selector: "wac-tag-dropdown", inputs: { hasIcons: "hasIcons", items: "items", label: "label", class: "class", icon: "icon", iconNext: "iconNext", colorIcon: "colorIcon", iconFontSize: "iconFontSize", isDropdown: "isDropdown" }, outputs: { userInput: "userInput" }, ngImport: i0, template: "<div class=\"wac-tag-dropdown\">\r\n  <div class=\"wac-tag-dropdown__wrapper\" [ngClass]=\"{'hover': isDropdown}\">\r\n    <div class=\"wac-tag-dropdown__wrapper__firstlevel\">\r\n      <div [classList]=\"'wac-tag-dropdown__wrapper__firstlevel--' + class\">\r\n        <i *ngIf=\"icon\" [ngClass]=\"icon + ' i-primary'\" [style.color]=\"colorIcon\" [style.font-size.px]=\"iconFontSize\"></i>\r\n        {{ label }}\r\n        <i *ngIf=\"iconNext\" [style.color]=\"colorIcon\" [ngClass]=\"iconNext + ' i-next'\" [style.font-size.px]=\"iconFontSize\"></i>\r\n        <i *ngIf=\"isDropdown\" [ngClass]=\"'fas fa-angle-down i-dropdown'\" [style.font-size.px]=\"iconFontSize\"></i>\r\n      </div>\r\n    </div>\r\n    <div class=\"wac-tag-dropdown__wrapper__sublevel\" *ngIf=\"isDropdown\">\r\n      <ul class=\"wac-tag-dropdown__wrapper__sublevel__container\">\r\n        <li\r\n          *ngFor=\"let item of items\"\r\n          class=\"wac-tag-dropdown__wrapper__sublevel__container__item\"\r\n          (click)=\"onUserInput(item.index)\"\r\n        >\r\n          <i\r\n            *ngIf=\"hasIcons\"\r\n            [class]=\"item.icon\"\r\n            [style.font-size.px]=\"item.iconFontSize ? item.iconFontSize : '14'\"\r\n          ></i>\r\n          <span>{{ item.label }}</span>\r\n        </li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: TagDropdownComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-tag-dropdown', template: "<div class=\"wac-tag-dropdown\">\r\n  <div class=\"wac-tag-dropdown__wrapper\" [ngClass]=\"{'hover': isDropdown}\">\r\n    <div class=\"wac-tag-dropdown__wrapper__firstlevel\">\r\n      <div [classList]=\"'wac-tag-dropdown__wrapper__firstlevel--' + class\">\r\n        <i *ngIf=\"icon\" [ngClass]=\"icon + ' i-primary'\" [style.color]=\"colorIcon\" [style.font-size.px]=\"iconFontSize\"></i>\r\n        {{ label }}\r\n        <i *ngIf=\"iconNext\" [style.color]=\"colorIcon\" [ngClass]=\"iconNext + ' i-next'\" [style.font-size.px]=\"iconFontSize\"></i>\r\n        <i *ngIf=\"isDropdown\" [ngClass]=\"'fas fa-angle-down i-dropdown'\" [style.font-size.px]=\"iconFontSize\"></i>\r\n      </div>\r\n    </div>\r\n    <div class=\"wac-tag-dropdown__wrapper__sublevel\" *ngIf=\"isDropdown\">\r\n      <ul class=\"wac-tag-dropdown__wrapper__sublevel__container\">\r\n        <li\r\n          *ngFor=\"let item of items\"\r\n          class=\"wac-tag-dropdown__wrapper__sublevel__container__item\"\r\n          (click)=\"onUserInput(item.index)\"\r\n        >\r\n          <i\r\n            *ngIf=\"hasIcons\"\r\n            [class]=\"item.icon\"\r\n            [style.font-size.px]=\"item.iconFontSize ? item.iconFontSize : '14'\"\r\n          ></i>\r\n          <span>{{ item.label }}</span>\r\n        </li>\r\n      </ul>\r\n    </div>\r\n  </div>\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { hasIcons: [{
                type: Input
            }], items: [{
                type: Input
            }], label: [{
                type: Input
            }], class: [{
                type: Input
            }], icon: [{
                type: Input
            }], iconNext: [{
                type: Input
            }], colorIcon: [{
                type: Input
            }], iconFontSize: [{
                type: Input
            }], isDropdown: [{
                type: Input
            }], userInput: [{
                type: Output
            }] } });

class GridComponent {
    constructor() {
        this.cols = 12;
        this.gap = 10;
        this.justify = 'center';
        this.align = 'center';
    }
    ngOnInit() {
        this.gridTemplateColumns = `repeat(${this.cols}, 1fr)`;
    }
}
GridComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: GridComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
GridComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: GridComponent, selector: "wac-grid", inputs: { cols: "cols", gap: "gap", justify: "justify", align: "align" }, ngImport: i0, template: "<div \r\n    [style.gridTemplateColumns]=\"gridTemplateColumns\" \r\n    [style.gap]=\"gap + 'px'\" \r\n    [style.justifyContent]=\"justify\"\r\n    [style.alignItems]=\"align\"\r\n    class=\"wac-grid\">\r\n    <ng-content></ng-content>\r\n</div>", styles: ["wac-grid{width:100%}wac-grid .wac-grid{display:grid}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: GridComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-grid', template: "<div \r\n    [style.gridTemplateColumns]=\"gridTemplateColumns\" \r\n    [style.gap]=\"gap + 'px'\" \r\n    [style.justifyContent]=\"justify\"\r\n    [style.alignItems]=\"align\"\r\n    class=\"wac-grid\">\r\n    <ng-content></ng-content>\r\n</div>", styles: ["wac-grid{width:100%}wac-grid .wac-grid{display:grid}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { cols: [{
                type: Input
            }], gap: [{
                type: Input
            }], justify: [{
                type: Input
            }], align: [{
                type: Input
            }] } });

class ColorPickerComponent {
    constructor() {
        this.value = '';
        this.gap = '12px';
        this.fontSize = '14px';
        this.id = 'colorPicker';
        this.colorChange = new EventEmitter();
        this.onChange = () => { };
        this.onTouched = () => { };
    }
    writeValue(value) {
        if (value !== undefined) {
            this.value = value;
        }
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    setValue(event) {
        this.value = event.target.value;
        this.onChange(this.value);
        this.colorChange.emit(this.value);
    }
    changeColor(color) {
        // Check if it's an rgba color
        if (color.startsWith('rgba')) {
            this.value = color;
            this.onChange(this.value);
            this.colorChange.emit(this.value);
            return;
        }
        // Handle hex colors
        color = color.replace(/[^a-fA-F0-9]/g, '');
        // Add '#' if not present
        if (!color.startsWith('#')) {
            color = '#' + color;
        }
        // Validate and update color
        if (this.isValidColor(color)) {
            this.value = color;
            this.onChange(this.value);
            this.colorChange.emit(this.value);
        }
        else {
            this.colorChange.emit(this.value);
        }
    }
    isValidColor(color) {
        const s = new Option().style;
        s.color = color;
        return s.color !== '';
    }
}
ColorPickerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ColorPickerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ColorPickerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: ColorPickerComponent, selector: "wac-color-picker", inputs: { label: "label", value: "value", gap: "gap", fontSize: "fontSize", id: "id", info: "info" }, outputs: { colorChange: "colorChange" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => ColorPickerComponent),
            multi: true
        }
    ], ngImport: i0, template: "<div class=\"w-color-picker\" [ngStyle]=\"{'gap': gap}\">\r\n\r\n  <div class=\"w-label\">\r\n    <label class=\"cp-label\" [for]=\"id\" [ngStyle]=\"{'font-size': fontSize}\">{{ label }}</label>\r\n    <wac-info *ngIf=\"info\" [colorPicker]=\"'true'\">{{ info }}</wac-info>\r\n  </div>\r\n\r\n  <div class=\"w-input\">\r\n\r\n    <div\r\n      class=\"color-preview\"\r\n      [colorPicker]=\"value\"\r\n      (click)=\"colorPickerInput.openDialog()\"\r\n      [ngStyle]=\"{'background-color': value}\"\r\n      [cpPosition]=\"'bottom'\"\r\n      [cpPositionOffset]=\"'-35'\"\r\n    ></div>\r\n\r\n    <input\r\n      class=\"cp-input\"\r\n      [id]=\"id\"\r\n      #colorPickerInput=\"ngxColorPicker\"\r\n      maxlength=\"7\"\r\n      placeholder=\"#000000\"\r\n      [(ngModel)]=\"value\"\r\n      (ngModelChange)=\"changeColor($event)\"\r\n      [colorPicker]=\"value\"\r\n      (colorPickerChange)=\"changeColor($event)\"\r\n      [cpPosition]=\"'bottom'\"\r\n      [cpPositionOffset]=\"'-35'\"\r\n      (input)=\"setValue($event)\"\r\n    />\r\n\r\n  </div>\r\n\r\n</div>\r\n", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i3$3.ColorPickerDirective, selector: "[colorPicker]", inputs: ["colorPicker", "cpWidth", "cpHeight", "cpToggle", "cpDisabled", "cpIgnoredElements", "cpFallbackColor", "cpColorMode", "cpCmykEnabled", "cpOutputFormat", "cpAlphaChannel", "cpDisableInput", "cpDialogDisplay", "cpSaveClickOutside", "cpCloseClickOutside", "cpUseRootViewContainer", "cpPosition", "cpPositionOffset", "cpPositionRelativeToArrow", "cpOKButton", "cpOKButtonText", "cpOKButtonClass", "cpCancelButton", "cpCancelButtonText", "cpCancelButtonClass", "cpEyeDropper", "cpPresetLabel", "cpPresetColors", "cpPresetColorsClass", "cpMaxPresetColorsLength", "cpPresetEmptyMessage", "cpPresetEmptyMessageClass", "cpAddColorButton", "cpAddColorButtonText", "cpAddColorButtonClass", "cpRemoveColorButtonClass", "cpArrowPosition", "cpExtraTemplate"], outputs: ["cpInputChange", "cpToggleChange", "cpSliderChange", "cpSliderDragEnd", "cpSliderDragStart", "colorPickerOpen", "colorPickerClose", "colorPickerCancel", "colorPickerSelect", "colorPickerChange", "cpCmykColorChange", "cpPresetColorsChange"], exportAs: ["ngxColorPicker"] }, { kind: "component", type: InfoComponent, selector: "wac-info", inputs: ["colorPicker"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ColorPickerComponent, decorators: [{
            type: Component,
            args: [{ selector: "wac-color-picker", providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => ColorPickerComponent),
                            multi: true
                        }
                    ], template: "<div class=\"w-color-picker\" [ngStyle]=\"{'gap': gap}\">\r\n\r\n  <div class=\"w-label\">\r\n    <label class=\"cp-label\" [for]=\"id\" [ngStyle]=\"{'font-size': fontSize}\">{{ label }}</label>\r\n    <wac-info *ngIf=\"info\" [colorPicker]=\"'true'\">{{ info }}</wac-info>\r\n  </div>\r\n\r\n  <div class=\"w-input\">\r\n\r\n    <div\r\n      class=\"color-preview\"\r\n      [colorPicker]=\"value\"\r\n      (click)=\"colorPickerInput.openDialog()\"\r\n      [ngStyle]=\"{'background-color': value}\"\r\n      [cpPosition]=\"'bottom'\"\r\n      [cpPositionOffset]=\"'-35'\"\r\n    ></div>\r\n\r\n    <input\r\n      class=\"cp-input\"\r\n      [id]=\"id\"\r\n      #colorPickerInput=\"ngxColorPicker\"\r\n      maxlength=\"7\"\r\n      placeholder=\"#000000\"\r\n      [(ngModel)]=\"value\"\r\n      (ngModelChange)=\"changeColor($event)\"\r\n      [colorPicker]=\"value\"\r\n      (colorPickerChange)=\"changeColor($event)\"\r\n      [cpPosition]=\"'bottom'\"\r\n      [cpPositionOffset]=\"'-35'\"\r\n      (input)=\"setValue($event)\"\r\n    />\r\n\r\n  </div>\r\n\r\n</div>\r\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { label: [{
                type: Input
            }], value: [{
                type: Input
            }], gap: [{
                type: Input
            }], fontSize: [{
                type: Input
            }], id: [{
                type: Input
            }], info: [{
                type: Input
            }], colorChange: [{
                type: Output
            }] } });

class BorderPickerComponent {
    constructor() {
        this.gap = '12px';
        this.fontSize = '14px';
        this.disabled = false;
        this.value = '0px';
        this.maxPixels = 50; // Valeur maximale en pixels
        this.blurred = new EventEmitter();
        this.borderRadiusChange = new EventEmitter();
        this.sliderValue = 0;
        this.onChange = () => { };
        this.onTouched = () => { };
    }
    ngOnInit() {
        if (this.value) {
            const numericValue = parseInt(this.value.replace('px', ''), 10);
            if (!isNaN(numericValue)) {
                this.sliderValue = numericValue;
            }
        }
    }
    writeValue(value) {
        if (value !== undefined) {
            this.value = value || '0px'; // Default to '0px' if value is null
            if (this.value) {
                const numericValue = parseInt(this.value.replace('px', ''), 10);
                if (!isNaN(numericValue)) {
                    this.sliderValue = numericValue;
                    this.updateSliderPercentage();
                }
            }
            else {
                // Handle null value case
                this.sliderValue = 0;
                this.value = '0px';
                this.updateSliderPercentage();
            }
        }
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    setValue(event) {
        this.value = event.target.value || '0px';
        if (this.value) {
            const numericValue = parseInt(this.value.replace('px', ''), 10);
            if (!isNaN(numericValue)) {
                this.sliderValue = numericValue;
                this.updateSliderPercentage();
            }
        }
        else {
            this.sliderValue = 0;
        }
        this.onChange(this.value);
        this.borderRadiusChange.emit(this.value);
    }
    updateSliderPercentage() {
        const slider = document.querySelector('.bp-range');
        if (slider) {
            const percentage = (this.sliderValue / this.maxPixels) * 100;
            slider.style.setProperty('--slider-percentage', `${percentage}%`);
        }
    }
    ngAfterViewInit() {
        this.updateSliderPercentage();
    }
    onFocusOut() {
        if (!this.value.endsWith('px') && this.value) {
            this.value = this.value + 'px';
            this.onChange(this.value);
            this.borderRadiusChange.emit(this.value);
        }
    }
    updateBorderRadius(value) {
        this.value = value + 'px';
        this.updateSliderPercentage();
        this.onChange(this.value);
        this.borderRadiusChange.emit(this.value);
    }
    setBorderRadius(value) {
        this.sliderValue = value;
        this.updateBorderRadius(value);
    }
}
BorderPickerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BorderPickerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BorderPickerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: BorderPickerComponent, isStandalone: true, selector: "wac-border-picker", inputs: { label: "label", gap: "gap", fontSize: "fontSize", disabled: "disabled", value: "value", maxPixels: "maxPixels" }, outputs: { blurred: "blurred", borderRadiusChange: "borderRadiusChange" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => BorderPickerComponent),
            multi: true
        }
    ], ngImport: i0, template: "<div class=\"w-border-picker\" [ngStyle]=\"{'gap': gap}\">\r\n\r\n  <label class=\"bp-label\" for=\"borderPicker\" [ngStyle]=\"{'font-size': fontSize}\">{{ label }}</label>\r\n\r\n  <div class=\"w-input\">\r\n\r\n    <div class=\"border-preview\" [ngStyle]=\"{'border-radius': value}\">\r\n      <div class=\"mask1\"></div>\r\n      <div class=\"mask2\"></div>\r\n    </div>\r\n\r\n    <input\r\n      class=\"bp-range\"\r\n      type=\"range\"\r\n      min=\"0\"\r\n      [max]=\"maxPixels\"\r\n      [(ngModel)]=\"sliderValue\"\r\n      (ngModelChange)=\"updateBorderRadius($event)\"\r\n    />\r\n\r\n    <input\r\n      class=\"bp-input\"\r\n      id=\"borderPicker\"\r\n      [placeholder]=\"sliderValue\"\r\n      maxlength=\"5\"\r\n      [(ngModel)]=\"value\"\r\n      (ngModelChange)=\"onChange($event)\"\r\n      (focusout)=\"onFocusOut()\"\r\n      (input)=\"setValue($event)\"\r\n    />\r\n\r\n  </div>\r\n\r\n</div>", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.RangeValueAccessor, selector: "input[type=range][formControlName],input[type=range][formControl],input[type=range][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: BorderPickerComponent, decorators: [{
            type: Component,
            args: [{ selector: "wac-border-picker", standalone: true, imports: [
                        CommonModule,
                        FormsModule,
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => BorderPickerComponent),
                            multi: true
                        }
                    ], template: "<div class=\"w-border-picker\" [ngStyle]=\"{'gap': gap}\">\r\n\r\n  <label class=\"bp-label\" for=\"borderPicker\" [ngStyle]=\"{'font-size': fontSize}\">{{ label }}</label>\r\n\r\n  <div class=\"w-input\">\r\n\r\n    <div class=\"border-preview\" [ngStyle]=\"{'border-radius': value}\">\r\n      <div class=\"mask1\"></div>\r\n      <div class=\"mask2\"></div>\r\n    </div>\r\n\r\n    <input\r\n      class=\"bp-range\"\r\n      type=\"range\"\r\n      min=\"0\"\r\n      [max]=\"maxPixels\"\r\n      [(ngModel)]=\"sliderValue\"\r\n      (ngModelChange)=\"updateBorderRadius($event)\"\r\n    />\r\n\r\n    <input\r\n      class=\"bp-input\"\r\n      id=\"borderPicker\"\r\n      [placeholder]=\"sliderValue\"\r\n      maxlength=\"5\"\r\n      [(ngModel)]=\"value\"\r\n      (ngModelChange)=\"onChange($event)\"\r\n      (focusout)=\"onFocusOut()\"\r\n      (input)=\"setValue($event)\"\r\n    />\r\n\r\n  </div>\r\n\r\n</div>" }]
        }], ctorParameters: function () { return []; }, propDecorators: { label: [{
                type: Input
            }], gap: [{
                type: Input
            }], fontSize: [{
                type: Input
            }], disabled: [{
                type: Input
            }], value: [{
                type: Input
            }], maxPixels: [{
                type: Input
            }], blurred: [{
                type: Output
            }], borderRadiusChange: [{
                type: Output
            }] } });

class SlideInComponent {
    constructor() {
        this.title = '';
        this.subtitle = '';
        this.isOpen = false;
        this.hasButton = false;
        this.primaryButtonText = 'Valider';
        this.secondaryButtonText = 'Annuler';
        this.maxWidth = null;
        this.closed = new EventEmitter();
        this.primaryButtonClick = new EventEmitter();
        this.secondaryButtonClick = new EventEmitter();
    }
    /**
     * Ouvre le panneau coulissant
     */
    open() {
        this.isOpen = true;
        document.body.classList.add('slide-in-open');
    }
    /**
     * Ferme le panneau coulissant
     */
    close() {
        this.isOpen = false;
        document.body.classList.remove('slide-in-open');
        this.closed.emit();
    }
    /**
     * Gère le clic sur le bouton primaire
     */
    onPrimaryButtonClick() {
        this.primaryButtonClick.emit();
    }
    /**
     * Gère le clic sur le bouton secondaire
     */
    onSecondaryButtonClick() {
        this.secondaryButtonClick.emit();
    }
}
SlideInComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SlideInComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SlideInComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: SlideInComponent, selector: "wac-slide-in", inputs: { title: "title", subtitle: "subtitle", isOpen: "isOpen", hasButton: "hasButton", primaryButtonText: "primaryButtonText", secondaryButtonText: "secondaryButtonText", maxWidth: "maxWidth" }, outputs: { closed: "closed", primaryButtonClick: "primaryButtonClick", secondaryButtonClick: "secondaryButtonClick" }, ngImport: i0, template: "<ng-container class=\"slide-in\">\r\n    <div class=\"slide-in__overlay\" [class.is-visible]=\"isOpen\" (click)=\"close()\"></div>\r\n    \r\n    <div class=\"slide-in__panel\" [class.is-open]=\"isOpen\" [style.max-width]=\"maxWidth ? maxWidth : '534px'\">\r\n      \r\n        <div class=\"slide-in__panel__header\">\r\n            <div class=\"w-title\">\r\n                <wac-h1 noMargin class=\"slide-in__panel__header__title\">{{ title }}</wac-h1>\r\n                <wac-text *ngIf=\"subtitle\" noMargin [textClass]=\"'grey'\">{{ subtitle }}</wac-text>\r\n            </div>\r\n            <i class=\"slide-in__panel__header__close fa-regular fa-xmark\" (click)=\"close()\"></i>\r\n        </div>\r\n    \r\n        <div class=\"slide-in__panel__content\">\r\n            <ng-content></ng-content>\r\n        </div>\r\n\r\n        <div class=\"slide-in__panel__footer\" *ngIf=\"hasButton\">\r\n            <wac-button \r\n                [extraClasses]=\"'is-grey is-outlined'\" \r\n                [label]=\"secondaryButtonText\"\r\n                (click)=\"onSecondaryButtonClick()\"\r\n            ></wac-button>\r\n            <wac-button \r\n                [extraClasses]=\"'is-info'\" \r\n                [label]=\"primaryButtonText\"\r\n                (click)=\"onPrimaryButtonClick()\"\r\n            ></wac-button>\r\n        </div>\r\n    \r\n    </div>\r\n</ng-container>", dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: ButtonComponent, selector: "wac-button", inputs: ["extraClasses", "label", "icon", "isLoadingSvg", "iconNext", "textcolor", "colorIcon", "widthAuto", "contentHorizontalPosition", "iconFontSize", "hasLoader", "disabled", "whiteSpaceNowrap", "opacity", "animation", "animationRight", "animationText", "confirmDelete", "confirmDeleteText", "coin", "tooltip", "tooltipWidth", "borderColor", "noPadding", "tooltipPosition", "tooltipOneline", "confirmDeletePosition", "isLoading"], outputs: ["click", "isLoadingChange"] }, { kind: "component", type: H1Component, selector: "wac-h1", inputs: ["annotation", "withImg", "center", "color", "noMargin"] }, { kind: "component", type: TextComponent, selector: "wac-text", inputs: ["textClass", "noMargin"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SlideInComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-slide-in', template: "<ng-container class=\"slide-in\">\r\n    <div class=\"slide-in__overlay\" [class.is-visible]=\"isOpen\" (click)=\"close()\"></div>\r\n    \r\n    <div class=\"slide-in__panel\" [class.is-open]=\"isOpen\" [style.max-width]=\"maxWidth ? maxWidth : '534px'\">\r\n      \r\n        <div class=\"slide-in__panel__header\">\r\n            <div class=\"w-title\">\r\n                <wac-h1 noMargin class=\"slide-in__panel__header__title\">{{ title }}</wac-h1>\r\n                <wac-text *ngIf=\"subtitle\" noMargin [textClass]=\"'grey'\">{{ subtitle }}</wac-text>\r\n            </div>\r\n            <i class=\"slide-in__panel__header__close fa-regular fa-xmark\" (click)=\"close()\"></i>\r\n        </div>\r\n    \r\n        <div class=\"slide-in__panel__content\">\r\n            <ng-content></ng-content>\r\n        </div>\r\n\r\n        <div class=\"slide-in__panel__footer\" *ngIf=\"hasButton\">\r\n            <wac-button \r\n                [extraClasses]=\"'is-grey is-outlined'\" \r\n                [label]=\"secondaryButtonText\"\r\n                (click)=\"onSecondaryButtonClick()\"\r\n            ></wac-button>\r\n            <wac-button \r\n                [extraClasses]=\"'is-info'\" \r\n                [label]=\"primaryButtonText\"\r\n                (click)=\"onPrimaryButtonClick()\"\r\n            ></wac-button>\r\n        </div>\r\n    \r\n    </div>\r\n</ng-container>" }]
        }], propDecorators: { title: [{
                type: Input
            }], subtitle: [{
                type: Input
            }], isOpen: [{
                type: Input
            }], hasButton: [{
                type: Input
            }], primaryButtonText: [{
                type: Input
            }], secondaryButtonText: [{
                type: Input
            }], maxWidth: [{
                type: Input
            }], closed: [{
                type: Output
            }], primaryButtonClick: [{
                type: Output
            }], secondaryButtonClick: [{
                type: Output
            }] } });

class MenuTileComponent {
    get col() {
        return this._col;
    }
    set col(value) {
        // Ensure col is between 1-12 for a 12-column grid
        this._col = !isNaN(Number(value)) ? Math.min(Math.max(Math.round(Number(value)), 1), 12) : 1;
    }
    get hostClasses() {
        return `wac-menu-tile wac-menu-tile--col-${this.col}`;
    }
    constructor(router) {
        this.router = router;
        this._col = 1;
        this.iconPath = '';
        this.title = '';
        this.description = '';
        this.new = '';
        this.newElement = false;
        this.url = null;
        this.urlQueryParams = null;
        this.external = false;
    }
    ngOnInit() { }
    navigate() {
        const queryParams = this.urlQueryParams;
        this.router.navigate([this.url], {
            queryParams,
            queryParamsHandling: 'merge',
        });
    }
}
MenuTileComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MenuTileComponent, deps: [{ token: i1$3.Router }], target: i0.ɵɵFactoryTarget.Component });
MenuTileComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: MenuTileComponent, selector: "wac-menu-tile", inputs: { col: "col", iconPath: "iconPath", title: "title", description: "description", new: "new", newElement: "newElement", url: "url", urlQueryParams: "urlQueryParams", external: "external" }, host: { properties: { "class": "this.hostClasses" } }, ngImport: i0, template: "<div class=\"wac-menu-tile__new\" *ngIf=\"newElement\">\r\n  <wac-text noMargin><i class=\"fa-regular fa-wand-magic-sparkles\"></i>&nbsp;{{ new }}</wac-text>\r\n</div>\r\n<a class=\"wac-menu-tile__content\" [ngClass]=\"{'with-desc': description}\" *ngIf=\"url && url.startsWith('http')\" [href]=\"url\" [target]=\"external ? '_blank' : '_self'\">\r\n  <img [src]=\"iconPath\" />\r\n  <div class=\"w-text\">\r\n    <wac-text noMargin>{{ title }}</wac-text>\r\n    <wac-text *ngIf=\"description\" noMargin [textClass]=\"'grey'\">{{ description }}</wac-text>\r\n  </div>\r\n</a>\r\n<a class=\"wac-menu-tile__content\" [ngClass]=\"{'with-desc': description}\" *ngIf=\"url && !url.startsWith('http')\" (click)=\"navigate()\">\r\n  <img [src]=\"iconPath\" />\r\n  <div class=\"w-text\">\r\n    <wac-text noMargin>{{ title }}</wac-text>\r\n    <wac-text *ngIf=\"description\" noMargin [textClass]=\"'grey'\">{{ description }}</wac-text>\r\n  </div>\r\n</a>\r\n<div *ngIf=\"!url\" class=\"wac-menu-tile__content\" [ngClass]=\"{'with-desc': description}\">\r\n  <img [src]=\"iconPath\" />\r\n  <div class=\"w-text\">\r\n    <wac-text noMargin>{{ title }}</wac-text>\r\n    <wac-text *ngIf=\"description\" noMargin [textClass]=\"'grey'\">{{ description }}</wac-text>\r\n  </div>\r\n</div>\r\n", styles: [":host{height:100%;position:relative}:host.wac-menu-tile--col-1{grid-column:span 1}:host.wac-menu-tile--col-2{grid-column:span 2}:host.wac-menu-tile--col-3{grid-column:span 3}:host.wac-menu-tile--col-4{grid-column:span 4}:host.wac-menu-tile--col-5{grid-column:span 5}:host.wac-menu-tile--col-6{grid-column:span 6}:host.wac-menu-tile--col-7{grid-column:span 7}:host.wac-menu-tile--col-8{grid-column:span 8}:host.wac-menu-tile--col-9{grid-column:span 9}:host.wac-menu-tile--col-10{grid-column:span 10}:host.wac-menu-tile--col-11{grid-column:span 11}:host.wac-menu-tile--col-12{grid-column:span 12}.wac-menu-tile__new{position:absolute;background-color:#59d0cf;color:#fff;font-weight:500;font-size:12px;padding:6px;top:0;left:15px}.wac-menu-tile__content{display:flex;flex-direction:column;justify-content:center;align-items:center;gap:15px;height:100%;min-height:150px;background:#ffffff;width:100%;padding:20px;border:1px solid #ffffff;border-radius:3px;box-shadow:0 2px 6px #0000000d;transition:border-color .3s ease-in-out}.wac-menu-tile__content:hover,.wac-menu-tile__content:active,.wac-menu-tile__content:focus{border-color:#3ba6ec;transition:border-color .3s ease-in-out}.wac-menu-tile__content img{width:auto;height:35px}.wac-menu-tile__content .w-text{display:flex;flex-direction:column;align-items:center;gap:10px;text-align:center}.wac-menu-tile .with-desc{min-height:none!important}.wac-menu-tile a{cursor:pointer}\n"], dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: TextComponent, selector: "wac-text", inputs: ["textClass", "noMargin"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: MenuTileComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wac-menu-tile', template: "<div class=\"wac-menu-tile__new\" *ngIf=\"newElement\">\r\n  <wac-text noMargin><i class=\"fa-regular fa-wand-magic-sparkles\"></i>&nbsp;{{ new }}</wac-text>\r\n</div>\r\n<a class=\"wac-menu-tile__content\" [ngClass]=\"{'with-desc': description}\" *ngIf=\"url && url.startsWith('http')\" [href]=\"url\" [target]=\"external ? '_blank' : '_self'\">\r\n  <img [src]=\"iconPath\" />\r\n  <div class=\"w-text\">\r\n    <wac-text noMargin>{{ title }}</wac-text>\r\n    <wac-text *ngIf=\"description\" noMargin [textClass]=\"'grey'\">{{ description }}</wac-text>\r\n  </div>\r\n</a>\r\n<a class=\"wac-menu-tile__content\" [ngClass]=\"{'with-desc': description}\" *ngIf=\"url && !url.startsWith('http')\" (click)=\"navigate()\">\r\n  <img [src]=\"iconPath\" />\r\n  <div class=\"w-text\">\r\n    <wac-text noMargin>{{ title }}</wac-text>\r\n    <wac-text *ngIf=\"description\" noMargin [textClass]=\"'grey'\">{{ description }}</wac-text>\r\n  </div>\r\n</a>\r\n<div *ngIf=\"!url\" class=\"wac-menu-tile__content\" [ngClass]=\"{'with-desc': description}\">\r\n  <img [src]=\"iconPath\" />\r\n  <div class=\"w-text\">\r\n    <wac-text noMargin>{{ title }}</wac-text>\r\n    <wac-text *ngIf=\"description\" noMargin [textClass]=\"'grey'\">{{ description }}</wac-text>\r\n  </div>\r\n</div>\r\n", styles: [":host{height:100%;position:relative}:host.wac-menu-tile--col-1{grid-column:span 1}:host.wac-menu-tile--col-2{grid-column:span 2}:host.wac-menu-tile--col-3{grid-column:span 3}:host.wac-menu-tile--col-4{grid-column:span 4}:host.wac-menu-tile--col-5{grid-column:span 5}:host.wac-menu-tile--col-6{grid-column:span 6}:host.wac-menu-tile--col-7{grid-column:span 7}:host.wac-menu-tile--col-8{grid-column:span 8}:host.wac-menu-tile--col-9{grid-column:span 9}:host.wac-menu-tile--col-10{grid-column:span 10}:host.wac-menu-tile--col-11{grid-column:span 11}:host.wac-menu-tile--col-12{grid-column:span 12}.wac-menu-tile__new{position:absolute;background-color:#59d0cf;color:#fff;font-weight:500;font-size:12px;padding:6px;top:0;left:15px}.wac-menu-tile__content{display:flex;flex-direction:column;justify-content:center;align-items:center;gap:15px;height:100%;min-height:150px;background:#ffffff;width:100%;padding:20px;border:1px solid #ffffff;border-radius:3px;box-shadow:0 2px 6px #0000000d;transition:border-color .3s ease-in-out}.wac-menu-tile__content:hover,.wac-menu-tile__content:active,.wac-menu-tile__content:focus{border-color:#3ba6ec;transition:border-color .3s ease-in-out}.wac-menu-tile__content img{width:auto;height:35px}.wac-menu-tile__content .w-text{display:flex;flex-direction:column;align-items:center;gap:10px;text-align:center}.wac-menu-tile .with-desc{min-height:none!important}.wac-menu-tile a{cursor:pointer}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$3.Router }]; }, propDecorators: { col: [{
                type: Input
            }], hostClasses: [{
                type: HostBinding,
                args: ['class']
            }], iconPath: [{
                type: Input
            }], title: [{
                type: Input
            }], description: [{
                type: Input
            }], new: [{
                type: Input
            }], newElement: [{
                type: Input
            }], url: [{
                type: Input
            }], urlQueryParams: [{
                type: Input
            }], external: [{
                type: Input
            }] } });

const components = [
    GridComponent,
    TagComponent,
    ButtonComponent,
    InfoComponent,
    SettingsComponent,
    DeleteComponent,
    DropdownComponent,
    ImageComponent,
    BackComponent,
    SeparatorComponent,
    LogoComponent,
    RadioLegacyComponent,
    RadioComponent,
    StateComponent,
    TagLabelComponent,
    CalendarComponent,
    WzEditInPlaceComponent,
    AlertComponent,
    HeaderPageComponent,
    SwitchComponent,
    LinkComponent,
    H1Component,
    H2Component,
    H3Component,
    H4Component,
    TextComponent,
    UploadComponent,
    SelectInTextComponent,
    MultipleSearchComponent,
    MultipleSearchPlusComponent,
    PopinComponent,
    FreePopinComponent,
    WrapperComponent,
    FiltersComponent,
    WrapperBlocsComponent,
    SearchComponent,
    SelectedListComponent,
    OptionalDisableContainerComponent,
    SelectComponent,
    OptionComponent,
    OptionCallToActionComponent,
    PlaceholderComponent,
    LabelComponent,
    SelectSearchTriggerComponent,
    WrapperSidebarComponent,
    BreadcrumbsComponent,
    CardPriceComponent,
    TokenCheckComponent,
    BlockWithCheckboxComponent,
    ConfirmDeleteComponent,
    MosaicComponent,
    ContentWithButtonsComponent,
    WrapperMultipleBlockComponent,
    DraganddropListComponent,
    SummaryComponent,
    GooglePreviewComponent,
    DraganddropListComponent,
    ChargingBarComponent,
    ExpandedPanelComponent,
    RowComponent,
    ColumnComponent,
    AiExpressComponent,
    RadioOptionComponent,
    TagDropdownComponent,
    SlideInComponent,
    OptionGroupComponent,
    MenuTileComponent,
    ColorPickerComponent
];
const exportsFromModule = [
    PaginationComponent,
    TableComponent,
    TableColumn,
    CheckBoxRow,
    TableColumnHeader,
    TableRow,
    TooltipComponent,
    CheckboxComponent,
    LoaderComponent,
    TreeComponent,
    ...ExpansionExport
];
const standaloneComponents = [
    TabsComponent,
    TabComponent,
    SnackbarComponent,
    BlockComponent,
    LoaderComponent,
    TextAreaComponent,
    ProgressBarComponent,
    InputComponent,
    InputSearchComponent,
    InputWithSelectComponent,
    BlockTitleLegacyComponent,
    BlockSeparatorComponent,
    BorderPickerComponent
];
class SharedComponentsModule {
}
SharedComponentsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SharedComponentsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
SharedComponentsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: SharedComponentsModule, declarations: [GridComponent,
        TagComponent,
        ButtonComponent,
        InfoComponent,
        SettingsComponent,
        DeleteComponent,
        DropdownComponent,
        ImageComponent,
        BackComponent,
        SeparatorComponent,
        LogoComponent,
        RadioLegacyComponent,
        RadioComponent,
        StateComponent,
        TagLabelComponent,
        CalendarComponent,
        WzEditInPlaceComponent,
        AlertComponent,
        HeaderPageComponent,
        SwitchComponent,
        LinkComponent,
        H1Component,
        H2Component,
        H3Component,
        H4Component,
        TextComponent,
        UploadComponent,
        SelectInTextComponent,
        MultipleSearchComponent,
        MultipleSearchPlusComponent,
        PopinComponent,
        FreePopinComponent,
        WrapperComponent,
        FiltersComponent,
        WrapperBlocsComponent,
        SearchComponent,
        SelectedListComponent,
        OptionalDisableContainerComponent,
        SelectComponent,
        OptionComponent,
        OptionCallToActionComponent,
        PlaceholderComponent,
        LabelComponent,
        SelectSearchTriggerComponent,
        WrapperSidebarComponent,
        BreadcrumbsComponent,
        CardPriceComponent,
        TokenCheckComponent,
        BlockWithCheckboxComponent,
        ConfirmDeleteComponent,
        MosaicComponent,
        ContentWithButtonsComponent,
        WrapperMultipleBlockComponent,
        DraganddropListComponent,
        SummaryComponent,
        GooglePreviewComponent,
        DraganddropListComponent,
        ChargingBarComponent,
        ExpandedPanelComponent,
        RowComponent,
        ColumnComponent,
        AiExpressComponent,
        RadioOptionComponent,
        TagDropdownComponent,
        SlideInComponent,
        OptionGroupComponent,
        MenuTileComponent,
        ColorPickerComponent], imports: [CommonModule,
        FormsModule,
        NwbAllModule,
        TranslateModule,
        ReactiveFormsModule,
        SharedDirectives,
        SharedPipes,
        CdkTableModule,
        TagInputModule,
        DragDropModule,
        PaginationModule,
        TableModule,
        TooltipModule,
        CheckboxModule,
        PerfectScrollbarModule,
        AlertPopupModule,
        RouterModule,
        AutosizeModule,
        NgScrollbarModule,
        NgScrollbarReachedModule,
        TreeModule,
        ExpansionModule,
        ColorPickerModule, TabsComponent,
        TabComponent,
        SnackbarComponent,
        BlockComponent,
        LoaderComponent,
        TextAreaComponent,
        ProgressBarComponent,
        InputComponent,
        InputSearchComponent,
        InputWithSelectComponent,
        BlockTitleLegacyComponent,
        BlockSeparatorComponent,
        BorderPickerComponent], exports: [GridComponent,
        TagComponent,
        ButtonComponent,
        InfoComponent,
        SettingsComponent,
        DeleteComponent,
        DropdownComponent,
        ImageComponent,
        BackComponent,
        SeparatorComponent,
        LogoComponent,
        RadioLegacyComponent,
        RadioComponent,
        StateComponent,
        TagLabelComponent,
        CalendarComponent,
        WzEditInPlaceComponent,
        AlertComponent,
        HeaderPageComponent,
        SwitchComponent,
        LinkComponent,
        H1Component,
        H2Component,
        H3Component,
        H4Component,
        TextComponent,
        UploadComponent,
        SelectInTextComponent,
        MultipleSearchComponent,
        MultipleSearchPlusComponent,
        PopinComponent,
        FreePopinComponent,
        WrapperComponent,
        FiltersComponent,
        WrapperBlocsComponent,
        SearchComponent,
        SelectedListComponent,
        OptionalDisableContainerComponent,
        SelectComponent,
        OptionComponent,
        OptionCallToActionComponent,
        PlaceholderComponent,
        LabelComponent,
        SelectSearchTriggerComponent,
        WrapperSidebarComponent,
        BreadcrumbsComponent,
        CardPriceComponent,
        TokenCheckComponent,
        BlockWithCheckboxComponent,
        ConfirmDeleteComponent,
        MosaicComponent,
        ContentWithButtonsComponent,
        WrapperMultipleBlockComponent,
        DraganddropListComponent,
        SummaryComponent,
        GooglePreviewComponent,
        DraganddropListComponent,
        ChargingBarComponent,
        ExpandedPanelComponent,
        RowComponent,
        ColumnComponent,
        AiExpressComponent,
        RadioOptionComponent,
        TagDropdownComponent,
        SlideInComponent,
        OptionGroupComponent,
        MenuTileComponent,
        ColorPickerComponent, PaginationComponent,
        TableComponent,
        TableColumn,
        CheckBoxRow,
        TableColumnHeader,
        TableRow,
        TooltipComponent,
        CheckboxComponent,
        LoaderComponent,
        TreeComponent, ExpansionPanelComponent, ExpansionPanelHeaderComponent, AccordionComponent, ExpansionPanelDirective, ExpansionPanelHeaderDirective, TabsComponent,
        TabComponent,
        SnackbarComponent,
        BlockComponent,
        LoaderComponent,
        TextAreaComponent,
        ProgressBarComponent,
        InputComponent,
        InputSearchComponent,
        InputWithSelectComponent,
        BlockTitleLegacyComponent,
        BlockSeparatorComponent,
        BorderPickerComponent] });
SharedComponentsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SharedComponentsModule, imports: [CommonModule,
        FormsModule,
        NwbAllModule,
        TranslateModule,
        ReactiveFormsModule,
        SharedDirectives,
        SharedPipes,
        CdkTableModule,
        TagInputModule,
        DragDropModule,
        PaginationModule,
        TableModule,
        TooltipModule,
        CheckboxModule,
        PerfectScrollbarModule,
        AlertPopupModule,
        RouterModule,
        AutosizeModule,
        NgScrollbarModule,
        NgScrollbarReachedModule,
        TreeModule,
        ExpansionModule,
        ColorPickerModule, standaloneComponents] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: SharedComponentsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        NwbAllModule,
                        TranslateModule,
                        ReactiveFormsModule,
                        SharedDirectives,
                        SharedPipes,
                        CdkTableModule,
                        TagInputModule,
                        DragDropModule,
                        PaginationModule,
                        TableModule,
                        TooltipModule,
                        CheckboxModule,
                        PerfectScrollbarModule,
                        AlertPopupModule,
                        RouterModule,
                        AutosizeModule,
                        NgScrollbarModule,
                        NgScrollbarReachedModule,
                        TreeModule,
                        ExpansionModule,
                        ColorPickerModule,
                        ...standaloneComponents
                    ],
                    declarations: components,
                    exports: [...components, ...exportsFromModule, ...standaloneComponents]
                }]
        }] });

class WiziComponentsModule {
}
WiziComponentsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WiziComponentsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
WiziComponentsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: WiziComponentsModule, imports: [CommonModule,
        SharedComponentsModule,
        SharedDirectives,
        SharedPipes,
        NwbAllModule], exports: [SharedComponentsModule, SharedDirectives, SharedPipes] });
WiziComponentsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WiziComponentsModule, imports: [CommonModule,
        SharedComponentsModule,
        SharedDirectives,
        SharedPipes,
        NwbAllModule, SharedComponentsModule, SharedDirectives, SharedPipes] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: WiziComponentsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        SharedComponentsModule,
                        SharedDirectives,
                        SharedPipes,
                        NwbAllModule
                    ],
                    exports: [SharedComponentsModule, SharedDirectives, SharedPipes]
                }]
        }] });

class TableFiltersGroup extends NwbFilterGroup {
    set(key, value) {
        super.set(key, value);
    }
    resetToFirstPage() {
        this.set("currentPage", 1);
    }
}

/**
 * Avoid to fetch data when totalItems change
 * @returns
 */
function distinctUntilTableFiltersChanged() {
    return distinctUntilChanged$1((previousFilters, currentFilters) => {
        return previousFilters.searchValue === currentFilters.searchValue &&
            previousFilters.sort === currentFilters.sort &&
            previousFilters.order === currentFilters.order &&
            previousFilters.currentPage === currentFilters.currentPage &&
            previousFilters.itemsPerPage === currentFilters.itemsPerPage;
    });
}
function updateTableFiltersTotalItems(tableFilters$, totalItems) {
    return tap$1((response) => tableFilters$.next({
        ...tableFilters$.getValue(),
        totalItems: totalItems ?? response['totalItems']
    }));
}

const currentUsedSelectorForThisAnimation$3 = 'li, div';
const showFromBottom = trigger('showFromBottom', [
    transition('* => *', [
        animation([
            query(currentUsedSelectorForThisAnimation$3, style({
                opacity: 0,
                position: 'relative',
                bottom: -150
            }), { optional: true }),
            query(currentUsedSelectorForThisAnimation$3, [stagger('150ms', animate('100ms', style({ opacity: 1, bottom: 0 })))], { optional: true })
        ])
    ])
]);

const currentUsedSelectorForThisAnimation$2 = 'li, div';
const showFromTop = trigger('showFromTop', [
    transition('* => *', [
        animation([
            query(currentUsedSelectorForThisAnimation$2, style({
                opacity: 0,
                position: 'relative',
                top: -150
            }), { optional: true }),
            query(currentUsedSelectorForThisAnimation$2, [stagger('150ms', animate('100ms', style({ opacity: 1, top: 0 })))], { optional: true })
        ])
    ])
]);

const currentUsedSelectorForThisAnimation$1 = 'li, div';
const showFromLeft = trigger('showFromLeft', [
    transition('* => *', [
        animation([
            query(currentUsedSelectorForThisAnimation$1, style({
                opacity: 0,
                position: 'relative',
                left: -150
            }), { optional: true }),
            query(currentUsedSelectorForThisAnimation$1, [stagger('150ms', animate('100ms', style({ opacity: 1, left: 0 })))], { optional: true })
        ])
    ])
]);

const currentUsedSelectorForThisAnimation = 'li, div';
const showFromRight = trigger('showFromRight', [
    transition('* => *', [
        animation([
            query(currentUsedSelectorForThisAnimation, style({
                opacity: 0,
                position: 'relative',
                right: -150
            }), { optional: true }),
            query(currentUsedSelectorForThisAnimation, [stagger('150ms', animate('100ms', style({ opacity: 1, right: 0 })))], { optional: true })
        ])
    ])
]);

function animateListFromBottom(passedTime = '.3s ease') {
    return trigger('animateList', [
        transition('* => *', [
            animation([
                query(':enter', [style({ position: 'relative', opacity: 0, bottom: '-60px' })], { optional: true }),
                query(':leave', [
                    style({ position: 'relative', opacity: 1, bottom: 0 }),
                    animate('{{time}}', style({ position: 'relative', opacity: 0, bottom: '-60px' }))
                ], { optional: true }),
                query(':enter', stagger('100ms', [animate('{{time}}', style({ position: 'relative', opacity: 1, bottom: 0 }))]), {
                    optional: true
                })
            ], { params: { time: passedTime } })
        ])
    ]);
}

function animateListFromTop(passedTime = '.3s ease') {
    return trigger('animateList', [
        transition('* => *', [
            animation([
                query(':enter', [style({ position: 'relative', opacity: 0, top: '-60px' })], { optional: true }),
                query(':leave', [
                    style({ position: 'relative', opacity: 1, top: 0 }),
                    animate('{{time}}', style({ position: 'relative', opacity: 0, top: '-60px' }))
                ], { optional: true }),
                query(':enter', stagger('200ms', [animate('{{time}}', style({ position: 'relative', opacity: 1, top: 0 }))]), { optional: true })
            ], { params: { time: passedTime } })
        ])
    ]);
}

function animateListFromRight(passedTime = '.3s ease-in-out', staggerTime = '50ms') {
    return trigger('animateList', [
        transition('* => *', [
            animation([
                query(':enter', [style({ position: 'relative', opacity: 0, right: '-60px' })], { optional: true }),
                query(':leave', [
                    style({ position: 'relative', opacity: 1, right: 0 }),
                    animate('{{time}}', style({ position: 'relative', opacity: 0, right: '-60px' }))
                ], { optional: true }),
                query(':enter', stagger(staggerTime, [animate('{{time}}', style({ position: 'relative', opacity: 1, right: 0 }))]), {
                    optional: true
                })
            ], { params: { time: passedTime } })
        ])
    ]);
}

function animateListFromLeft(passedTime = '.3s ease') {
    return trigger('animateList', [
        transition('* => *', [
            animation([
                query(':enter', [style({ position: 'relative', opacity: 0, left: '-60px' })], { optional: true }),
                query(':leave', [
                    style({ position: 'relative', opacity: 1, left: 0 }),
                    animate('{{time}}', style({ position: 'relative', opacity: 0, left: '-60px' }))
                ], { optional: true }),
                query(':enter', stagger('{{time}}', [animate('{{time}}', style({ position: 'relative', opacity: 1, left: 0 }))]), {
                    optional: true
                })
            ], { params: { time: passedTime } })
        ])
    ]);
}

const switchInOut = trigger('switchInOut', [
    transition(':enter', [animation([style({ transform: 'translateX(100%)', opacity: 0 }), animate('200ms 200ms ease')])]),
    transition(':leave', [animation([animate('200ms ease', style({ transform: 'translateX(-100%)', opacity: 0 }))])])
]);

/*
 * Public API Surface of angular-components
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ACCORDION_ITEM, AbstractDebounceDirective, AccordionComponent, AiExpressComponent, AlertComponent, AlertPopupComponent, AlertPopupModule, AlertPopupService, AreAllOptionsSelectedPipe, AutoHideDirective, BackComponent, BlockComponent, BlockSeparatorComponent, BlockTitleLegacyComponent, BlockWithCheckboxComponent, BorderPickerComponent, BreadcrumbsComponent, ButtonComponent, CalendarComponent, CallComponentFunctionPipe, CardPriceComponent, ChargingBarComponent, CheckBoxRow, CheckboxComponent, ColorPickerComponent, ColumnComponent, ConfirmDeleteComponent, ContentWithButtonsComponent, CopyToClipBoardDirective, DebounceKeyupDirective, DeleteComponent, DomChangedDirective, DraganddropListComponent, DropdownComponent, EXPANSION_PANEL_HEADER, ExpandedPanelComponent, ExpansionExport, ExpansionModule, ExpansionPanelComponent, ExpansionPanelDirective, ExpansionPanelHeaderComponent, ExpansionPanelHeaderDirective, FilterOptionsPipe, FiltersComponent, FiltersTableService, FindOptionSelectedPipe, FormatObjectToRecursifTreePipe, FormatObjectToSimpleTreePipe, FreePopinComponent, GooglePreviewComponent, GridComponent, H1Component, H2Component, H3Component, H4Component, HeaderPageComponent, HistoryService, HtmlContainer, ImageComponent, InfoComponent, InputComponent, InputSearchComponent, InputWithSelectComponent, KeypressEnterDirective, LabelComponent, LinkComponent, LoaderComponent, LogoComponent, MenuTileComponent, MosaicComponent, MultipleSearchComponent, MultipleSearchPlusComponent, OnlyNumberDirective, OptionCallToActionComponent, OptionComponent, OptionGroupComponent, OptionalDisableContainerComponent, PaginationComponent, PlaceholderComponent, PopinComponent, ProgressBarComponent, RadioComponent, RadioGroupLegacyDirective, RadioLegacyComponent, RadioLegacyDirective, RadioOptionComponent, RowComponent, ScrollToDirective, SearchComponent, SelectComponent, SelectDirective, SelectFiltersPipe, SelectInTextComponent, SelectOptionDirective, SelectSearchTriggerComponent, SelectedListComponent, SeparatorComponent, SettingsComponent, SharedComponentsModule, SharedDirectives, SharedPipes, SlideInComponent, SnackbarComponent, StateComponent, SummaryComponent, SwitchComponent, TabComponent, TableColumn, TableColumnHeader, TableComponent, TableFiltersGroup, TableRow, TabsComponent, TagComponent, TagDropdownComponent, TagLabelComponent, TextAreaComponent, TextComponent, TokenCheckComponent, TooltipComponent, TreeComponent, TreeModule, TwoDigitDecimalNumberDirective, UploadComponent, ValueChangeService, VarDirective, WiziComponentsModule, WrapperBlocsComponent, WrapperComponent, WrapperMultipleBlockComponent, WrapperSidebarComponent, WzEditInPlaceComponent, ZindexToggleDirective, animateListFromBottom, animateListFromLeft, animateListFromRight, animateListFromTop, distinctUntilTableFiltersChanged, inOutX, inOutY, opacityAnimation, showFromBottom, showFromLeft, showFromRight, showFromTop, switchInOut, updateTableFiltersTotalItems, uuid };
//# sourceMappingURL=wizishop-angular-components.mjs.map
